/* THIS FILE IS AUTOGENERATED FROM BrowserElement.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "BrowserElementBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/ScriptSettings.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {

namespace BrowserFindCaseSensitivityValues {
  extern const EnumEntry strings[3] = {
    {"case-sensitive", 14},
    {"case-insensitive", 16},
    { nullptr, 0 }
  };
} // namespace BrowserFindCaseSensitivityValues


namespace BrowserFindDirectionValues {
  extern const EnumEntry strings[3] = {
    {"forward", 7},
    {"backward", 8},
    { nullptr, 0 }
  };
} // namespace BrowserFindDirectionValues



BrowserElementDownloadOptions::BrowserElementDownloadOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
BrowserElementDownloadOptions::InitIds(JSContext* cx, BrowserElementDownloadOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->referrer_id.init(cx, "referrer") ||
      !atomsCache->filename_id.init(cx, "filename")) {
    return false;
  }
  return true;
}

bool
BrowserElementDownloadOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  BrowserElementDownloadOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<BrowserElementDownloadOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->filename_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mFilename.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, (mFilename.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->referrer_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mReferrer.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, (mReferrer.Value()))) {
      return false;
    }
  }
  return true;
}

bool
BrowserElementDownloadOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
BrowserElementDownloadOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  BrowserElementDownloadOptionsAtoms* atomsCache = GetAtomCache<BrowserElementDownloadOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mFilename.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mFilename.InternalValue();
      if (!xpc::StringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->filename_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mReferrer.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mReferrer.InternalValue();
      if (!xpc::StringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->referrer_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
BrowserElementDownloadOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
BrowserElementDownloadOptions::TraceDictionary(JSTracer* trc)
{
}

void
BrowserElementDownloadOptions::operator=(const BrowserElementDownloadOptions& aOther)
{
  if (aOther.mFilename.WasPassed()) {
    mFilename.Construct();
    mFilename.Value() = aOther.mFilename.Value();
  } else {
    mFilename.Reset();
  }
  if (aOther.mReferrer.WasPassed()) {
    mReferrer.Construct();
    mReferrer.Value() = aOther.mReferrer.Value();
  } else {
    mReferrer.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



BrowserElementExecuteScriptOptions::BrowserElementExecuteScriptOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
BrowserElementExecuteScriptOptions::InitIds(JSContext* cx, BrowserElementExecuteScriptOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->url_id.init(cx, "url") ||
      !atomsCache->origin_id.init(cx, "origin")) {
    return false;
  }
  return true;
}

bool
BrowserElementExecuteScriptOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  BrowserElementExecuteScriptOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<BrowserElementExecuteScriptOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->origin_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mOrigin.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, (mOrigin.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->url_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mUrl.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, (mUrl.Value()))) {
      return false;
    }
  }
  return true;
}

bool
BrowserElementExecuteScriptOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
BrowserElementExecuteScriptOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  BrowserElementExecuteScriptOptionsAtoms* atomsCache = GetAtomCache<BrowserElementExecuteScriptOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mOrigin.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mOrigin.InternalValue();
      if (!xpc::StringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->origin_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mUrl.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mUrl.InternalValue();
      if (!xpc::StringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->url_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
BrowserElementExecuteScriptOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
BrowserElementExecuteScriptOptions::TraceDictionary(JSTracer* trc)
{
}

void
BrowserElementExecuteScriptOptions::operator=(const BrowserElementExecuteScriptOptions& aOther)
{
  if (aOther.mOrigin.WasPassed()) {
    mOrigin.Construct();
    mOrigin.Value() = aOther.mOrigin.Value();
  } else {
    mOrigin.Reset();
  }
  if (aOther.mUrl.WasPassed()) {
    mUrl.Construct();
    mUrl.Value() = aOther.mUrl.Value();
  } else {
    mUrl.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail


void
BrowserElementNextPaintEventCallback::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::empty(), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



} // namespace dom
} // namespace mozilla
