/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM CFStateChangeEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "CFStateChangeEvent.h"
#include "CFStateChangeEventBinding.h"
#include "EventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/CFStateChangeEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(CFStateChangeEvent)

NS_IMPL_ADDREF_INHERITED(CFStateChangeEvent, Event)
NS_IMPL_RELEASE_INHERITED(CFStateChangeEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(CFStateChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(CFStateChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(CFStateChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(CFStateChangeEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

CFStateChangeEvent::CFStateChangeEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

CFStateChangeEvent::~CFStateChangeEvent()
{
}

CFStateChangeEvent*
CFStateChangeEvent::AsCFStateChangeEvent()
{
  return this;
}

JSObject*
CFStateChangeEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return CFStateChangeEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<CFStateChangeEvent>
CFStateChangeEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const CFStateChangeEventInit& aEventInitDict)
{
  nsRefPtr<CFStateChangeEvent> e = new CFStateChangeEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mAction = aEventInitDict.mAction;
  e->mReason = aEventInitDict.mReason;
  e->mNumber = aEventInitDict.mNumber;
  e->mTimeSeconds = aEventInitDict.mTimeSeconds;
  e->mServiceClass = aEventInitDict.mServiceClass;
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<CFStateChangeEvent>
CFStateChangeEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const CFStateChangeEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

uint16_t
CFStateChangeEvent::Action() const
{
  return mAction;
}

uint16_t
CFStateChangeEvent::Reason() const
{
  return mReason;
}

void
CFStateChangeEvent::GetNumber(nsString& aRetVal) const
{
  aRetVal = mNumber;
}

uint16_t
CFStateChangeEvent::TimeSeconds() const
{
  return mTimeSeconds;
}

uint16_t
CFStateChangeEvent::ServiceClass() const
{
  return mServiceClass;
}


} // namespace dom
} // namespace mozilla
