/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM CameraConfigurationEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "CameraConfigurationEvent.h"
#include "CameraConfigurationEventBinding.h"
#include "EventBinding.h"
#include "Navigator.h"
#include "js/GCAPI.h"
#include "mozilla/dom/CameraConfigurationEvent.h"
#include "mozilla/dom/DOMRect.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(CameraConfigurationEvent)

NS_IMPL_ADDREF_INHERITED(CameraConfigurationEvent, Event)
NS_IMPL_RELEASE_INHERITED(CameraConfigurationEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(CameraConfigurationEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mPreviewSize)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mPictureSize)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(CameraConfigurationEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(CameraConfigurationEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mPreviewSize)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mPictureSize)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(CameraConfigurationEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

CameraConfigurationEvent::CameraConfigurationEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

CameraConfigurationEvent::~CameraConfigurationEvent()
{
}

CameraConfigurationEvent*
CameraConfigurationEvent::AsCameraConfigurationEvent()
{
  return this;
}

JSObject*
CameraConfigurationEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return CameraConfigurationEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<CameraConfigurationEvent>
CameraConfigurationEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const CameraConfigurationEventInit& aEventInitDict)
{
  nsRefPtr<CameraConfigurationEvent> e = new CameraConfigurationEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mMode = aEventInitDict.mMode;
  e->mRecorderProfile = aEventInitDict.mRecorderProfile;
  e->mPreviewSize = aEventInitDict.mPreviewSize;
  e->mPictureSize = aEventInitDict.mPictureSize;
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<CameraConfigurationEvent>
CameraConfigurationEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const CameraConfigurationEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

CameraMode
CameraConfigurationEvent::Mode() const
{
  return mMode;
}

void
CameraConfigurationEvent::GetRecorderProfile(nsString& aRetVal) const
{
  aRetVal = mRecorderProfile;
}

DOMRectReadOnly*
CameraConfigurationEvent::GetPreviewSize() const
{
  return mPreviewSize;
}

DOMRectReadOnly*
CameraConfigurationEvent::GetPictureSize() const
{
  return mPictureSize;
}


} // namespace dom
} // namespace mozilla
