/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM DOMTransactionEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "DOMTransactionEvent.h"
#include "DOMTransactionEventBinding.h"
#include "EventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/DOMTransactionEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(DOMTransactionEvent)

NS_IMPL_ADDREF_INHERITED(DOMTransactionEvent, Event)
NS_IMPL_RELEASE_INHERITED(DOMTransactionEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(DOMTransactionEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(DOMTransactionEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRACE_JSVAL_MEMBER_CALLBACK(mTransactions)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(DOMTransactionEvent, Event)
  tmp->mTransactions.setUndefined();
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(DOMTransactionEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

DOMTransactionEvent::DOMTransactionEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

DOMTransactionEvent::~DOMTransactionEvent()
{
  mTransactions = JS::UndefinedValue();
  mozilla::DropJSObjects(this);
}

DOMTransactionEvent*
DOMTransactionEvent::AsDOMTransactionEvent()
{
  return this;
}

JSObject*
DOMTransactionEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return DOMTransactionEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<DOMTransactionEvent>
DOMTransactionEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const DOMTransactionEventInit& aEventInitDict)
{
  nsRefPtr<DOMTransactionEvent> e = new DOMTransactionEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mTransactions = aEventInitDict.mTransactions;
  e->SetTrusted(trusted);
  mozilla::HoldJSObjects(e.get());
  return e.forget();
}

already_AddRefed<DOMTransactionEvent>
DOMTransactionEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const DOMTransactionEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
DOMTransactionEvent::GetTransactions(JSContext* cx, JS::MutableHandle<JS::Value> aRetVal) const
{
  JS::ExposeValueToActiveJS(mTransactions);
  aRetVal.set(mTransactions);
  return;
}


} // namespace dom
} // namespace mozilla
