/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM DataStoreChangeEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "DataStoreBinding.h"
#include "DataStoreChangeEvent.h"
#include "DataStoreChangeEventBinding.h"
#include "EventBinding.h"
#include "Navigator.h"
#include "js/GCAPI.h"
#include "mozilla/dom/DataStoreChangeEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/UnionConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(DataStoreChangeEvent)

NS_IMPL_ADDREF_INHERITED(DataStoreChangeEvent, Event)
NS_IMPL_RELEASE_INHERITED(DataStoreChangeEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(DataStoreChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(DataStoreChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(DataStoreChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(DataStoreChangeEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

DataStoreChangeEvent::DataStoreChangeEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

DataStoreChangeEvent::~DataStoreChangeEvent()
{
}

DataStoreChangeEvent*
DataStoreChangeEvent::AsDataStoreChangeEvent()
{
  return this;
}

JSObject*
DataStoreChangeEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return DataStoreChangeEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<DataStoreChangeEvent>
DataStoreChangeEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const DataStoreChangeEventInit& aEventInitDict)
{
  nsRefPtr<DataStoreChangeEvent> e = new DataStoreChangeEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mRevisionId = aEventInitDict.mRevisionId;
  e->mId = aEventInitDict.mId;
  e->mOperation = aEventInitDict.mOperation;
  e->mOwner = aEventInitDict.mOwner;
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<DataStoreChangeEvent>
DataStoreChangeEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const DataStoreChangeEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
DataStoreChangeEvent::GetRevisionId(nsString& aRetVal) const
{
  aRetVal = mRevisionId;
}

void
DataStoreChangeEvent::GetId(Nullable<OwningStringOrUnsignedLong>& aRetVal) const
{
  aRetVal = mId;
}

void
DataStoreChangeEvent::GetOperation(nsString& aRetVal) const
{
  aRetVal = mOperation;
}

void
DataStoreChangeEvent::GetOwner(nsString& aRetVal) const
{
  aRetVal = mOwner;
}


} // namespace dom
} // namespace mozilla
