/* THIS FILE IS AUTOGENERATED FROM MediaQueryList.webidl BY Codegen.py - DO NOT EDIT */

#include "MediaQueryListBinding.h"
#include "WrapperFactory.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/MediaQueryList.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {

void
MediaQueryListListener::Call(JSContext* cx, JS::Handle<JS::Value> aThisVal, MediaQueryList& list, ErrorResult& aRv)
{
  JS::Rooted<JS::Value> rval(cx, JS::UndefinedValue());
  JS::AutoValueVector argv(cx);
  if (!argv.resize(1)) {
    aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
    return;
  }
  unsigned argc = 1;

  do {
    if (!GetOrCreateDOMReflector(cx, list, argv[0])) {
      MOZ_ASSERT(true || JS_IsExceptionPending(cx));
      aRv.Throw(NS_ERROR_UNEXPECTED);
      return;
    }
    break;
  } while (0);

  JS::Rooted<JS::Value> callable(cx, JS::ObjectValue(*mCallback));
  if (!JS::Call(cx, aThisVal, callable,
                JS::HandleValueArray::subarray(argv, 0, argc), &rval)) {
    aRv.Throw(NS_ERROR_UNEXPECTED);
    return;
  }
}



namespace MediaQueryListBinding {

static bool
get_media(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MediaQueryList* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetMedia(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo media_getterinfo = {
  { (JSJitGetterOp)get_media },
  prototypes::id::MediaQueryList,
  PrototypeTraits<prototypes::id::MediaQueryList>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_matches(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MediaQueryList* self, JSJitGetterCallArgs args)
{
  bool result(self->Matches());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo matches_getterinfo = {
  { (JSJitGetterOp)get_matches },
  prototypes::id::MediaQueryList,
  PrototypeTraits<prototypes::id::MediaQueryList>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
addListener(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MediaQueryList* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MediaQueryList.addListener");
  }
  OwningNonNull<MediaQueryListListener> arg0;
  if (args[0].isObject()) {
    if (JS::IsCallable(&args[0].toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new MediaQueryListListener(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Argument 1 of MediaQueryList.addListener");
      return false;
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of MediaQueryList.addListener");
    return false;
  }
  self->AddListener(NonNullHelper(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo addListener_methodinfo = {
  { (JSJitGetterOp)addListener },
  prototypes::id::MediaQueryList,
  PrototypeTraits<prototypes::id::MediaQueryList>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
removeListener(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MediaQueryList* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MediaQueryList.removeListener");
  }
  OwningNonNull<MediaQueryListListener> arg0;
  if (args[0].isObject()) {
    if (JS::IsCallable(&args[0].toObject())) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new MediaQueryListListener(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_CALLABLE, "Argument 1 of MediaQueryList.removeListener");
      return false;
    }
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 1 of MediaQueryList.removeListener");
    return false;
  }
  self->RemoveListener(NonNullHelper(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo removeListener_methodinfo = {
  { (JSJitGetterOp)removeListener },
  prototypes::id::MediaQueryList,
  PrototypeTraits<prototypes::id::MediaQueryList>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::MediaQueryList* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MediaQueryList>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::MediaQueryList* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MediaQueryList>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::MediaQueryList>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::MediaQueryList>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::MediaQueryList* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MediaQueryList>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("addListener", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&addListener_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("removeListener", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&removeListener_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[3];

static const JSPropertySpec sAttributes_specs[] = {
  { "media", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &media_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "matches", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &matches_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, nullptr }
};

static jsid sAttributes_ids[3];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::MediaQueryList,
  constructors::id::MediaQueryList,
  nullptr
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function MediaQueryList() {\n    [native code]\n}",
  prototypes::id::MediaQueryList,
  PrototypeTraits<prototypes::id::MediaQueryList>::Depth,
  JS_GetFunctionPrototype
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "MediaQueryListPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object MediaQueryListPrototype]",
  prototypes::id::MediaQueryList,
  PrototypeTraits<prototypes::id::MediaQueryList>::Depth,
  JS_GetObjectPrototype
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

static const DOMJSClass Class = {
  { "MediaQueryList",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::MediaQueryList, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::MediaQueryList >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::MediaQueryList>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::MediaQueryList>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::MediaQueryList* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::MediaQueryList*>(aObject) ==
             reinterpret_cast<mozilla::dom::MediaQueryList*>(aObject),
             "Multiple inheritance for mozilla::dom::MediaQueryList is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::MediaQueryList> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Rooted<JSObject*> parentProto(aCx, JS_GetObjectPrototype(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Rooted<JSObject*> constructorProto(aCx, JS_GetFunctionPrototype(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::MediaQueryList);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::MediaQueryList);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "MediaQueryList", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::MediaQueryList)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::MediaQueryList).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::MediaQueryList)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::MediaQueryList).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace MediaQueryListBinding



} // namespace dom
} // namespace mozilla
