/* THIS FILE IS AUTOGENERATED FROM MediaTrackConstraintSet.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "MediaTrackConstraintSetBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "mozilla/dom/UnionConversions.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {

namespace SupportedVideoConstraintsValues {
  extern const EnumEntry strings[10] = {
    {"other", 5},
    {"facingMode", 10},
    {"width", 5},
    {"height", 6},
    {"frameRate", 9},
    {"mediaSource", 11},
    {"browserWindow", 13},
    {"scrollWithPage", 14},
    {"deviceId", 8},
    { nullptr, 0 }
  };
} // namespace SupportedVideoConstraintsValues


namespace SupportedAudioConstraintsValues {
  extern const EnumEntry strings[2] = {
    {"other", 5},
    { nullptr, 0 }
  };
} // namespace SupportedAudioConstraintsValues


bool
DoubleOrConstrainDoubleRange::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eDouble: {
      rval.set(JS_NumberValue(double(mValue.mDouble.Value())));
      return true;
      break;
    }
    case eConstrainDoubleRange: {
      if (!mValue.mConstrainDoubleRange.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


double&
OwningDoubleOrConstrainDoubleRange::RawSetAsDouble()
{
  if (mType == eDouble) {
    return mValue.mDouble.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eDouble;
  return mValue.mDouble.SetValue();
}

double&
OwningDoubleOrConstrainDoubleRange::SetAsDouble()
{
  if (mType == eDouble) {
    return mValue.mDouble.Value();
  }
  Uninit();
  mType = eDouble;
  return mValue.mDouble.SetValue();
}

bool
OwningDoubleOrConstrainDoubleRange::TrySetToDouble(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    double& memberSlot = RawSetAsDouble();
    if (!ValueToPrimitive<double, eDefault>(cx, value, &memberSlot)) {
      return false;
    } else if (!mozilla::IsFinite(memberSlot)) {
      // Note: mozilla::IsFinite will do the right thing
      //       when passed a non-finite float too.
      ThrowErrorMessage(cx, MSG_NOT_FINITE, "Member of DoubleOrConstrainDoubleRange");
      return false;
    }
  }
  return true;
}

void
OwningDoubleOrConstrainDoubleRange::DestroyDouble()
{
  MOZ_ASSERT(IsDouble(), "Wrong type!");
  mValue.mDouble.Destroy();
  mType = eUninitialized;
}




ConstrainDoubleRange&
OwningDoubleOrConstrainDoubleRange::RawSetAsConstrainDoubleRange()
{
  if (mType == eConstrainDoubleRange) {
    return mValue.mConstrainDoubleRange.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eConstrainDoubleRange;
  return mValue.mConstrainDoubleRange.SetValue();
}

ConstrainDoubleRange&
OwningDoubleOrConstrainDoubleRange::SetAsConstrainDoubleRange()
{
  if (mType == eConstrainDoubleRange) {
    return mValue.mConstrainDoubleRange.Value();
  }
  Uninit();
  mType = eConstrainDoubleRange;
  return mValue.mConstrainDoubleRange.SetValue();
}

bool
OwningDoubleOrConstrainDoubleRange::TrySetToConstrainDoubleRange(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    ConstrainDoubleRange& memberSlot = RawSetAsConstrainDoubleRange();
    if (!IsConvertibleToDictionary(cx, value)) {
      DestroyConstrainDoubleRange();
      tryNext = true;
      return true;
    }

    if (!memberSlot.Init(cx, value, "Member of DoubleOrConstrainDoubleRange", passedToJSImpl)) {
      return false;
    }
  }
  return true;
}

void
OwningDoubleOrConstrainDoubleRange::DestroyConstrainDoubleRange()
{
  MOZ_ASSERT(IsConstrainDoubleRange(), "Wrong type!");
  mValue.mConstrainDoubleRange.Destroy();
  mType = eUninitialized;
}




void
OwningDoubleOrConstrainDoubleRange::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eDouble: {
      DestroyDouble();
      break;
    }
    case eConstrainDoubleRange: {
      DestroyConstrainDoubleRange();
      break;
    }
  }
}

bool
OwningDoubleOrConstrainDoubleRange::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eDouble: {
      rval.set(JS_NumberValue(double(mValue.mDouble.Value())));
      return true;
      break;
    }
    case eConstrainDoubleRange: {
      if (!mValue.mConstrainDoubleRange.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningDoubleOrConstrainDoubleRange::TraceUnion(JSTracer* trc)
{
}

void
OwningDoubleOrConstrainDoubleRange::operator=(const OwningDoubleOrConstrainDoubleRange& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eDouble: {
      SetAsDouble() = aOther.GetAsDouble();
      break;
    }
    case eConstrainDoubleRange: {
      SetAsConstrainDoubleRange() = aOther.GetAsConstrainDoubleRange();
      break;
    }
  }
}


bool
LongOrConstrainLongRange::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eLong: {
      rval.setInt32(int32_t(mValue.mLong.Value()));
      return true;
      break;
    }
    case eConstrainLongRange: {
      if (!mValue.mConstrainLongRange.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


int32_t&
OwningLongOrConstrainLongRange::RawSetAsLong()
{
  if (mType == eLong) {
    return mValue.mLong.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eLong;
  return mValue.mLong.SetValue();
}

int32_t&
OwningLongOrConstrainLongRange::SetAsLong()
{
  if (mType == eLong) {
    return mValue.mLong.Value();
  }
  Uninit();
  mType = eLong;
  return mValue.mLong.SetValue();
}

bool
OwningLongOrConstrainLongRange::TrySetToLong(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    int32_t& memberSlot = RawSetAsLong();
    if (!ValueToPrimitive<int32_t, eDefault>(cx, value, &memberSlot)) {
      return false;
    }
  }
  return true;
}

void
OwningLongOrConstrainLongRange::DestroyLong()
{
  MOZ_ASSERT(IsLong(), "Wrong type!");
  mValue.mLong.Destroy();
  mType = eUninitialized;
}




ConstrainLongRange&
OwningLongOrConstrainLongRange::RawSetAsConstrainLongRange()
{
  if (mType == eConstrainLongRange) {
    return mValue.mConstrainLongRange.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eConstrainLongRange;
  return mValue.mConstrainLongRange.SetValue();
}

ConstrainLongRange&
OwningLongOrConstrainLongRange::SetAsConstrainLongRange()
{
  if (mType == eConstrainLongRange) {
    return mValue.mConstrainLongRange.Value();
  }
  Uninit();
  mType = eConstrainLongRange;
  return mValue.mConstrainLongRange.SetValue();
}

bool
OwningLongOrConstrainLongRange::TrySetToConstrainLongRange(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    ConstrainLongRange& memberSlot = RawSetAsConstrainLongRange();
    if (!IsConvertibleToDictionary(cx, value)) {
      DestroyConstrainLongRange();
      tryNext = true;
      return true;
    }

    if (!memberSlot.Init(cx, value, "Member of LongOrConstrainLongRange", passedToJSImpl)) {
      return false;
    }
  }
  return true;
}

void
OwningLongOrConstrainLongRange::DestroyConstrainLongRange()
{
  MOZ_ASSERT(IsConstrainLongRange(), "Wrong type!");
  mValue.mConstrainLongRange.Destroy();
  mType = eUninitialized;
}




void
OwningLongOrConstrainLongRange::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eLong: {
      DestroyLong();
      break;
    }
    case eConstrainLongRange: {
      DestroyConstrainLongRange();
      break;
    }
  }
}

bool
OwningLongOrConstrainLongRange::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eLong: {
      rval.setInt32(int32_t(mValue.mLong.Value()));
      return true;
      break;
    }
    case eConstrainLongRange: {
      if (!mValue.mConstrainLongRange.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningLongOrConstrainLongRange::TraceUnion(JSTracer* trc)
{
}

void
OwningLongOrConstrainLongRange::operator=(const OwningLongOrConstrainLongRange& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eLong: {
      SetAsLong() = aOther.GetAsLong();
      break;
    }
    case eConstrainLongRange: {
      SetAsConstrainLongRange() = aOther.GetAsConstrainLongRange();
      break;
    }
  }
}


bool
StringOrStringSequenceOrConstrainDOMStringParameters::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eString: {
      if (!xpc::NonVoidStringToJsval(cx, mValue.mString.Value(), rval)) {
        return false;
      }
      return true;
      break;
    }
    case eStringSequence: {

      uint32_t length = mValue.mStringSequence.Value().Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!xpc::NonVoidStringToJsval(cx, mValue.mStringSequence.Value()[sequenceIdx0], &tmp)) {
              return false;
            }
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      rval.setObject(*returnArray);
      return true;
      break;
    }
    case eConstrainDOMStringParameters: {
      if (!mValue.mConstrainDOMStringParameters.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}


nsString&
OwningStringOrStringSequenceOrConstrainDOMStringParameters::RawSetAsString()
{
  if (mType == eString) {
    return mValue.mString.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eString;
  return mValue.mString.SetValue();
}

nsString&
OwningStringOrStringSequenceOrConstrainDOMStringParameters::SetAsString()
{
  if (mType == eString) {
    return mValue.mString.Value();
  }
  Uninit();
  mType = eString;
  return mValue.mString.SetValue();
}

bool
OwningStringOrStringSequenceOrConstrainDOMStringParameters::TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    nsString& memberSlot = RawSetAsString();
    if (!ConvertJSValueToString(cx, value, eStringify, eStringify, memberSlot)) {
      return false;
    }
  }
  return true;
}


void
OwningStringOrStringSequenceOrConstrainDOMStringParameters::DestroyString()
{
  MOZ_ASSERT(IsString(), "Wrong type!");
  mValue.mString.Destroy();
  mType = eUninitialized;
}




Sequence<nsString>&
OwningStringOrStringSequenceOrConstrainDOMStringParameters::RawSetAsStringSequence()
{
  if (mType == eStringSequence) {
    return mValue.mStringSequence.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eStringSequence;
  return mValue.mStringSequence.SetValue();
}

Sequence<nsString>&
OwningStringOrStringSequenceOrConstrainDOMStringParameters::SetAsStringSequence()
{
  if (mType == eStringSequence) {
    return mValue.mStringSequence.Value();
  }
  Uninit();
  mType = eStringSequence;
  return mValue.mStringSequence.SetValue();
}

bool
OwningStringOrStringSequenceOrConstrainDOMStringParameters::TrySetToStringSequence(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    Sequence<nsString>& memberSlot = RawSetAsStringSequence();
    JS::ForOfIterator iter(cx);
    if (!iter.init(value, JS::ForOfIterator::AllowNonIterable)) {
      return false;
    }
    if (!iter.valueIsIterable()) {
      DestroyStringSequence();
      tryNext = true;
      return true;
    }
    Sequence<nsString> &arr = memberSlot;
    JS::Rooted<JS::Value> temp(cx);
    while (true) {
      bool done;
      if (!iter.next(&temp, &done)) {
        return false;
      }
      if (done) {
        break;
      }
      nsString* slotPtr = arr.AppendElement(mozilla::fallible);
      if (!slotPtr) {
        JS_ReportOutOfMemory(cx);
        return false;
      }
      nsString& slot = *slotPtr;
      if (!ConvertJSValueToString(cx, temp, eStringify, eStringify, slot)) {
        return false;
      }
    }
  }
  return true;
}

void
OwningStringOrStringSequenceOrConstrainDOMStringParameters::DestroyStringSequence()
{
  MOZ_ASSERT(IsStringSequence(), "Wrong type!");
  mValue.mStringSequence.Destroy();
  mType = eUninitialized;
}




ConstrainDOMStringParameters&
OwningStringOrStringSequenceOrConstrainDOMStringParameters::RawSetAsConstrainDOMStringParameters()
{
  if (mType == eConstrainDOMStringParameters) {
    return mValue.mConstrainDOMStringParameters.Value();
  }
  MOZ_ASSERT(mType == eUninitialized);
  mType = eConstrainDOMStringParameters;
  return mValue.mConstrainDOMStringParameters.SetValue();
}

ConstrainDOMStringParameters&
OwningStringOrStringSequenceOrConstrainDOMStringParameters::SetAsConstrainDOMStringParameters()
{
  if (mType == eConstrainDOMStringParameters) {
    return mValue.mConstrainDOMStringParameters.Value();
  }
  Uninit();
  mType = eConstrainDOMStringParameters;
  return mValue.mConstrainDOMStringParameters.SetValue();
}

bool
OwningStringOrStringSequenceOrConstrainDOMStringParameters::TrySetToConstrainDOMStringParameters(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl)
{
  tryNext = false;
  { // scope for memberSlot
    ConstrainDOMStringParameters& memberSlot = RawSetAsConstrainDOMStringParameters();
    if (!IsConvertibleToDictionary(cx, value)) {
      DestroyConstrainDOMStringParameters();
      tryNext = true;
      return true;
    }

    if (!memberSlot.Init(cx, value, "Member of StringOrStringSequenceOrConstrainDOMStringParameters", passedToJSImpl)) {
      return false;
    }
  }
  return true;
}

void
OwningStringOrStringSequenceOrConstrainDOMStringParameters::DestroyConstrainDOMStringParameters()
{
  MOZ_ASSERT(IsConstrainDOMStringParameters(), "Wrong type!");
  mValue.mConstrainDOMStringParameters.Destroy();
  mType = eUninitialized;
}




void
OwningStringOrStringSequenceOrConstrainDOMStringParameters::Uninit()
{
  switch (mType) {
    case eUninitialized: {
      break;
    }
    case eString: {
      DestroyString();
      break;
    }
    case eStringSequence: {
      DestroyStringSequence();
      break;
    }
    case eConstrainDOMStringParameters: {
      DestroyConstrainDOMStringParameters();
      break;
    }
  }
}

bool
OwningStringOrStringSequenceOrConstrainDOMStringParameters::ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const
{
  switch (mType) {
    case eUninitialized: {
      return false;
      break;
    }
    case eString: {
      if (!xpc::NonVoidStringToJsval(cx, mValue.mString.Value(), rval)) {
        return false;
      }
      return true;
      break;
    }
    case eStringSequence: {

      uint32_t length = mValue.mStringSequence.Value().Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!xpc::NonVoidStringToJsval(cx, mValue.mStringSequence.Value()[sequenceIdx0], &tmp)) {
              return false;
            }
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      rval.setObject(*returnArray);
      return true;
      break;
    }
    case eConstrainDOMStringParameters: {
      if (!mValue.mConstrainDOMStringParameters.Value().ToObjectInternal(cx, rval)) {
        return false;
      }
      return true;
      break;
    }
    default: {
      return false;
      break;
    }
  }

  return false;
}

void
OwningStringOrStringSequenceOrConstrainDOMStringParameters::TraceUnion(JSTracer* trc)
{
}

void
OwningStringOrStringSequenceOrConstrainDOMStringParameters::operator=(const OwningStringOrStringSequenceOrConstrainDOMStringParameters& aOther)
{
  switch (aOther.mType) {
    case eUninitialized: {
      MOZ_ASSERT(mType == eUninitialized,
                 "We need to destroy ourselves?");
      break;
    }
    case eString: {
      SetAsString() = aOther.GetAsString();
      break;
    }
    case eStringSequence: {
      SetAsStringSequence() = aOther.GetAsStringSequence();
      break;
    }
    case eConstrainDOMStringParameters: {
      SetAsConstrainDOMStringParameters() = aOther.GetAsConstrainDOMStringParameters();
      break;
    }
  }
}



MediaTrackConstraintSet::MediaTrackConstraintSet()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MediaTrackConstraintSet::InitIds(JSContext* cx, MediaTrackConstraintSetAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->width_id.init(cx, "width") ||
      !atomsCache->scrollWithPage_id.init(cx, "scrollWithPage") ||
      !atomsCache->mediaSource_id.init(cx, "mediaSource") ||
      !atomsCache->height_id.init(cx, "height") ||
      !atomsCache->frameRate_id.init(cx, "frameRate") ||
      !atomsCache->facingMode_id.init(cx, "facingMode") ||
      !atomsCache->deviceId_id.init(cx, "deviceId") ||
      !atomsCache->browserWindow_id.init(cx, "browserWindow")) {
    return false;
  }
  return true;
}

bool
MediaTrackConstraintSet::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MediaTrackConstraintSetAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MediaTrackConstraintSetAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->browserWindow_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mBrowserWindow.Construct();
    if (!ValueToPrimitive<int64_t, eDefault>(cx, temp.ref(), &(mBrowserWindow.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->deviceId_id, temp.ptr())) {
    return false;
  }
  mDeviceId.Uninit();
  if (!(!isNull && !temp->isUndefined())) {
    if (!mDeviceId.RawSetAsConstrainDOMStringParameters().Init(cx, JS::NullHandleValue, "Member of StringOrStringSequenceOrConstrainDOMStringParameters")) {
      return false;
    }
  } else {
    {
      bool done = false, failed = false, tryNext;
      if (temp.ref().isObject()) {
        done = (failed = !mDeviceId.TrySetToStringSequence(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        done = (failed = !mDeviceId.TrySetToConstrainDOMStringParameters(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        do {
          done = (failed = !mDeviceId.TrySetToString(cx, temp.ref(), tryNext)) || !tryNext;
          break;
        } while (0);
      }
      if (failed) {
        return false;
      }
      if (!done) {
        ThrowErrorMessage(cx, MSG_NOT_IN_UNION, "'deviceId' member of MediaTrackConstraintSet", "StringSequence, ConstrainDOMStringParameters");
        return false;
      }
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->facingMode_id, temp.ptr())) {
    return false;
  }
  mFacingMode.Uninit();
  if (!(!isNull && !temp->isUndefined())) {
    if (!mFacingMode.RawSetAsConstrainDOMStringParameters().Init(cx, JS::NullHandleValue, "Member of StringOrStringSequenceOrConstrainDOMStringParameters")) {
      return false;
    }
  } else {
    {
      bool done = false, failed = false, tryNext;
      if (temp.ref().isObject()) {
        done = (failed = !mFacingMode.TrySetToStringSequence(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        done = (failed = !mFacingMode.TrySetToConstrainDOMStringParameters(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        do {
          done = (failed = !mFacingMode.TrySetToString(cx, temp.ref(), tryNext)) || !tryNext;
          break;
        } while (0);
      }
      if (failed) {
        return false;
      }
      if (!done) {
        ThrowErrorMessage(cx, MSG_NOT_IN_UNION, "'facingMode' member of MediaTrackConstraintSet", "StringSequence, ConstrainDOMStringParameters");
        return false;
      }
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->frameRate_id, temp.ptr())) {
    return false;
  }
  mFrameRate.Uninit();
  if (!(!isNull && !temp->isUndefined())) {
    if (!mFrameRate.RawSetAsConstrainDoubleRange().Init(cx, JS::NullHandleValue, "Member of DoubleOrConstrainDoubleRange")) {
      return false;
    }
  } else {
    {
      bool done = false, failed = false, tryNext;
      if (!done) {
        done = (failed = !mFrameRate.TrySetToConstrainDoubleRange(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        do {
          done = (failed = !mFrameRate.TrySetToDouble(cx, temp.ref(), tryNext)) || !tryNext;
          break;
        } while (0);
      }
      if (failed) {
        return false;
      }
      if (!done) {
        ThrowErrorMessage(cx, MSG_NOT_IN_UNION, "'frameRate' member of MediaTrackConstraintSet", "ConstrainDoubleRange");
        return false;
      }
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->height_id, temp.ptr())) {
    return false;
  }
  mHeight.Uninit();
  if (!(!isNull && !temp->isUndefined())) {
    if (!mHeight.RawSetAsConstrainLongRange().Init(cx, JS::NullHandleValue, "Member of LongOrConstrainLongRange")) {
      return false;
    }
  } else {
    {
      bool done = false, failed = false, tryNext;
      if (!done) {
        done = (failed = !mHeight.TrySetToConstrainLongRange(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        do {
          done = (failed = !mHeight.TrySetToLong(cx, temp.ref(), tryNext)) || !tryNext;
          break;
        } while (0);
      }
      if (failed) {
        return false;
      }
      if (!done) {
        ThrowErrorMessage(cx, MSG_NOT_IN_UNION, "'height' member of MediaTrackConstraintSet", "ConstrainLongRange");
        return false;
      }
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->mediaSource_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, mMediaSource)) {
      return false;
    }
  } else {
    static const char16_t data[] = { 'c', 'a', 'm', 'e', 'r', 'a', 0 };
    mMediaSource.Rebind(data, ArrayLength(data) - 1);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->scrollWithPage_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mScrollWithPage.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mScrollWithPage.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->width_id, temp.ptr())) {
    return false;
  }
  mWidth.Uninit();
  if (!(!isNull && !temp->isUndefined())) {
    if (!mWidth.RawSetAsConstrainLongRange().Init(cx, JS::NullHandleValue, "Member of LongOrConstrainLongRange")) {
      return false;
    }
  } else {
    {
      bool done = false, failed = false, tryNext;
      if (!done) {
        done = (failed = !mWidth.TrySetToConstrainLongRange(cx, temp.ref(), tryNext, passedToJSImpl)) || !tryNext;
      }
      if (!done) {
        do {
          done = (failed = !mWidth.TrySetToLong(cx, temp.ref(), tryNext)) || !tryNext;
          break;
        } while (0);
      }
      if (failed) {
        return false;
      }
      if (!done) {
        ThrowErrorMessage(cx, MSG_NOT_IN_UNION, "'width' member of MediaTrackConstraintSet", "ConstrainLongRange");
        return false;
      }
    }
  }
  return true;
}

bool
MediaTrackConstraintSet::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MediaTrackConstraintSet::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MediaTrackConstraintSetAtoms* atomsCache = GetAtomCache<MediaTrackConstraintSetAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mBrowserWindow.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      int64_t const & currentValue = mBrowserWindow.InternalValue();
      temp.set(JS_NumberValue(double(currentValue)));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->browserWindow_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    OwningStringOrStringSequenceOrConstrainDOMStringParameters const & currentValue = mDeviceId;
    if (!currentValue.ToJSVal(cx, obj, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->deviceId_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    OwningStringOrStringSequenceOrConstrainDOMStringParameters const & currentValue = mFacingMode;
    if (!currentValue.ToJSVal(cx, obj, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->facingMode_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    OwningDoubleOrConstrainDoubleRange const & currentValue = mFrameRate;
    if (!currentValue.ToJSVal(cx, obj, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->frameRate_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    OwningLongOrConstrainLongRange const & currentValue = mHeight;
    if (!currentValue.ToJSVal(cx, obj, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->height_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mMediaSource;
    if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->mediaSource_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mScrollWithPage.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mScrollWithPage.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->scrollWithPage_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    OwningLongOrConstrainLongRange const & currentValue = mWidth;
    if (!currentValue.ToJSVal(cx, obj, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->width_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MediaTrackConstraintSet::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MediaTrackConstraintSet::TraceDictionary(JSTracer* trc)
{
}

void
MediaTrackConstraintSet::operator=(const MediaTrackConstraintSet& aOther)
{
  if (aOther.mBrowserWindow.WasPassed()) {
    mBrowserWindow.Construct();
    mBrowserWindow.Value() = aOther.mBrowserWindow.Value();
  } else {
    mBrowserWindow.Reset();
  }
  mDeviceId = aOther.mDeviceId;
  mFacingMode = aOther.mFacingMode;
  mFrameRate = aOther.mFrameRate;
  mHeight = aOther.mHeight;
  mMediaSource = aOther.mMediaSource;
  if (aOther.mScrollWithPage.WasPassed()) {
    mScrollWithPage.Construct();
    mScrollWithPage.Value() = aOther.mScrollWithPage.Value();
  } else {
    mScrollWithPage.Reset();
  }
  mWidth = aOther.mWidth;
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
