/* THIS FILE IS AUTOGENERATED FROM MouseEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "MouseEventBinding.h"
#include "UIEventBinding.h"
#include "WrapperFactory.h"
#include "mozilla/FloatingPoint.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/EventTarget.h"
#include "mozilla/dom/MouseEvent.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "nsContentUtils.h"
#include "nsGlobalWindow.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


MouseEventInit::MouseEventInit()
  : EventModifierInit(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MouseEventInit::InitIds(JSContext* cx, MouseEventInitAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->screenY_id.init(cx, "screenY") ||
      !atomsCache->screenX_id.init(cx, "screenX") ||
      !atomsCache->relatedTarget_id.init(cx, "relatedTarget") ||
      !atomsCache->movementY_id.init(cx, "movementY") ||
      !atomsCache->movementX_id.init(cx, "movementX") ||
      !atomsCache->clientY_id.init(cx, "clientY") ||
      !atomsCache->clientX_id.init(cx, "clientX") ||
      !atomsCache->buttons_id.init(cx, "buttons") ||
      !atomsCache->button_id.init(cx, "button")) {
    return false;
  }
  return true;
}

bool
MouseEventInit::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MouseEventInitAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MouseEventInitAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!EventModifierInit::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->button_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int16_t, eDefault>(cx, temp.ref(), &mButton)) {
      return false;
    }
  } else {
    mButton = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->buttons_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &mButtons)) {
      return false;
    }
  } else {
    mButtons = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->clientX_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mClientX)) {
      return false;
    }
  } else {
    mClientX = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->clientY_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mClientY)) {
      return false;
    }
  } else {
    mClientY = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->movementX_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mMovementX)) {
      return false;
    }
  } else {
    mMovementX = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->movementY_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mMovementY)) {
      return false;
    }
  } else {
    mMovementY = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->relatedTarget_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (temp.ref().isObject()) {
      static_assert(IsRefcounted<mozilla::dom::EventTarget>::value, "We can only store refcounted classes.");{
        nsresult rv = UnwrapObject<prototypes::id::EventTarget, mozilla::dom::EventTarget>(&temp.ref().toObject(), mRelatedTarget);
        if (NS_FAILED(rv)) {
          nsRefPtr<mozilla::dom::EventTarget> objPtr;
          JS::Rooted<JSObject*> source(cx, &temp.ref().toObject());
          nsresult rv = UnwrapArg<mozilla::dom::EventTarget>(source, getter_AddRefs(objPtr));
          if (NS_FAILED(rv)) {
            ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "'relatedTarget' member of MouseEventInit", "EventTarget");
            return false;
          }
          // We should have an object
          MOZ_ASSERT(objPtr);
          mRelatedTarget = objPtr;
        }
      }
    } else if (temp.ref().isNullOrUndefined()) {
      mRelatedTarget = nullptr;
    } else {
      ThrowErrorMessage(cx, MSG_NOT_OBJECT, "'relatedTarget' member of MouseEventInit");
      return false;
    }
  } else {
    mRelatedTarget = nullptr;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->screenX_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mScreenX)) {
      return false;
    }
  } else {
    mScreenX = 0;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->screenY_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<int32_t, eDefault>(cx, temp.ref(), &mScreenY)) {
      return false;
    }
  } else {
    mScreenY = 0;
  }
  return true;
}

bool
MouseEventInit::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MouseEventInit::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MouseEventInitAtoms* atomsCache = GetAtomCache<MouseEventInitAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!EventModifierInit::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int16_t const & currentValue = mButton;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->button_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint16_t const & currentValue = mButtons;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->buttons_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mClientX;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->clientX_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mClientY;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->clientY_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mMovementX;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->movementX_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mMovementY;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->movementY_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsRefPtr<mozilla::dom::EventTarget> const & currentValue = mRelatedTarget;
    if (!currentValue) {
      temp.setNull();
      if (!JS_DefinePropertyById(cx, obj, atomsCache->relatedTarget_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!GetOrCreateDOMReflector(cx, currentValue, &temp)) {
      if (!HandleNewBindingWrappingFailure(cx, obj, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->relatedTarget_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->relatedTarget_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mScreenX;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->screenX_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    int32_t const & currentValue = mScreenY;
    temp.setInt32(int32_t(currentValue));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->screenY_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MouseEventInit::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MouseEventInit::TraceDictionary(JSTracer* trc)
{
  EventModifierInit::TraceDictionary(trc);
}

void
MouseEventInit::operator=(const MouseEventInit& aOther)
{
  EventModifierInit::operator=(aOther);
  mButton = aOther.mButton;
  mButtons = aOther.mButtons;
  mClientX = aOther.mClientX;
  mClientY = aOther.mClientY;
  mMovementX = aOther.mMovementX;
  mMovementY = aOther.mMovementY;
  mRelatedTarget = aOther.mRelatedTarget;
  mScreenX = aOther.mScreenX;
  mScreenY = aOther.mScreenY;
}

namespace binding_detail {
} // namespace binding_detail


namespace MouseEventBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<UIEventBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
get_screenX(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->ScreenX());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo screenX_getterinfo = {
  { (JSJitGetterOp)get_screenX },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_screenY(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->ScreenY());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo screenY_getterinfo = {
  { (JSJitGetterOp)get_screenY },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_clientX(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->ClientX());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo clientX_getterinfo = {
  { (JSJitGetterOp)get_clientX },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_clientY(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->ClientY());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo clientY_getterinfo = {
  { (JSJitGetterOp)get_clientY },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_offsetX(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->OffsetX());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo offsetX_getterinfo = {
  { (JSJitGetterOp)get_offsetX },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_offsetY(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->OffsetY());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo offsetY_getterinfo = {
  { (JSJitGetterOp)get_offsetY },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_ctrlKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->CtrlKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo ctrlKey_getterinfo = {
  { (JSJitGetterOp)get_ctrlKey },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_shiftKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->ShiftKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo shiftKey_getterinfo = {
  { (JSJitGetterOp)get_shiftKey },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_altKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->AltKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo altKey_getterinfo = {
  { (JSJitGetterOp)get_altKey },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_metaKey(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->MetaKey());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo metaKey_getterinfo = {
  { (JSJitGetterOp)get_metaKey },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_button(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int16_t result(self->Button());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo button_getterinfo = {
  { (JSJitGetterOp)get_button },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_buttons(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  uint16_t result(self->Buttons());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo buttons_getterinfo = {
  { (JSJitGetterOp)get_buttons },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_relatedTarget(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::EventTarget>(self->GetRelatedTarget()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    if (!HandleNewBindingWrappingFailure(cx, obj, result, args.rval())) {
      return false;
    }
    return true;
  }
  return true;
}

static const JSJitInfo relatedTarget_getterinfo = {
  { (JSJitGetterOp)get_relatedTarget },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_region(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetRegion(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::StringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo region_getterinfo = {
  { (JSJitGetterOp)get_region },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_movementX(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->MovementX());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo movementX_getterinfo = {
  { (JSJitGetterOp)get_movementX },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_movementY(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->MovementY());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo movementY_getterinfo = {
  { (JSJitGetterOp)get_movementY },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
initMouseEvent(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 15)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MouseEvent.initMouseEvent");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool arg1;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  bool arg2;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  nsGlobalWindow* arg3;
  if (args[3].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::Window, nsGlobalWindow>(&args[3].toObject(), arg3);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 4 of MouseEvent.initMouseEvent", "Window");
        return false;
      }
    }
  } else if (args[3].isNullOrUndefined()) {
    arg3 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 4 of MouseEvent.initMouseEvent");
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  int32_t arg7;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  int32_t arg8;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  bool arg9;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[9], &arg9)) {
    return false;
  }
  bool arg10;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[10], &arg10)) {
    return false;
  }
  bool arg11;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[11], &arg11)) {
    return false;
  }
  bool arg12;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[12], &arg12)) {
    return false;
  }
  int16_t arg13;
  if (!ValueToPrimitive<int16_t, eDefault>(cx, args[13], &arg13)) {
    return false;
  }
  mozilla::dom::EventTarget* arg14;
  if (args[14].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::EventTarget, mozilla::dom::EventTarget>(&args[14].toObject(), arg14);
      if (NS_FAILED(rv)) {
        nsRefPtr<mozilla::dom::EventTarget> objPtr;
        JS::Rooted<JSObject*> source(cx, &args[14].toObject());
        nsresult rv = UnwrapArg<mozilla::dom::EventTarget>(source, getter_AddRefs(objPtr));
        if (NS_FAILED(rv)) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 15 of MouseEvent.initMouseEvent", "EventTarget");
          return false;
        }
        // We should have an object
        MOZ_ASSERT(objPtr);
        arg14 = objPtr;
      }
    }
  } else if (args[14].isNullOrUndefined()) {
    arg14 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 15 of MouseEvent.initMouseEvent");
    return false;
  }
  ErrorResult rv;
  self->InitMouseEvent(NonNullHelper(Constify(arg0)), arg1, arg2, Constify(arg3), arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, Constify(arg14), rv);
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailed(cx, rv);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo initMouseEvent_methodinfo = {
  { (JSJitGetterOp)initMouseEvent },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getModifierState(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MouseEvent.getModifierState");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool result(self->GetModifierState(NonNullHelper(Constify(arg0))));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo getModifierState_methodinfo = {
  { (JSJitGetterOp)getModifierState },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_mozMovementX(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->MovementX());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo mozMovementX_getterinfo = {
  { (JSJitGetterOp)get_mozMovementX },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_mozMovementY(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  int32_t result(self->MovementY());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo mozMovementY_getterinfo = {
  { (JSJitGetterOp)get_mozMovementY },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_mozPressure(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  float result(self->MozPressure());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().set(JS_NumberValue(double(result)));
  return true;
}

static const JSJitInfo mozPressure_getterinfo = {
  { (JSJitGetterOp)get_mozPressure },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_mozInputSource(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  uint16_t result(self->MozInputSource());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static const JSJitInfo mozInputSource_getterinfo = {
  { (JSJitGetterOp)get_mozInputSource },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
initNSMouseEvent(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 17)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MouseEvent.initNSMouseEvent");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  bool arg1;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[1], &arg1)) {
    return false;
  }
  bool arg2;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[2], &arg2)) {
    return false;
  }
  nsGlobalWindow* arg3;
  if (args[3].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::Window, nsGlobalWindow>(&args[3].toObject(), arg3);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 4 of MouseEvent.initNSMouseEvent", "Window");
        return false;
      }
    }
  } else if (args[3].isNullOrUndefined()) {
    arg3 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 4 of MouseEvent.initNSMouseEvent");
    return false;
  }
  int32_t arg4;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[4], &arg4)) {
    return false;
  }
  int32_t arg5;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[5], &arg5)) {
    return false;
  }
  int32_t arg6;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[6], &arg6)) {
    return false;
  }
  int32_t arg7;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[7], &arg7)) {
    return false;
  }
  int32_t arg8;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[8], &arg8)) {
    return false;
  }
  bool arg9;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[9], &arg9)) {
    return false;
  }
  bool arg10;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[10], &arg10)) {
    return false;
  }
  bool arg11;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[11], &arg11)) {
    return false;
  }
  bool arg12;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[12], &arg12)) {
    return false;
  }
  int16_t arg13;
  if (!ValueToPrimitive<int16_t, eDefault>(cx, args[13], &arg13)) {
    return false;
  }
  mozilla::dom::EventTarget* arg14;
  if (args[14].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::EventTarget, mozilla::dom::EventTarget>(&args[14].toObject(), arg14);
      if (NS_FAILED(rv)) {
        nsRefPtr<mozilla::dom::EventTarget> objPtr;
        JS::Rooted<JSObject*> source(cx, &args[14].toObject());
        nsresult rv = UnwrapArg<mozilla::dom::EventTarget>(source, getter_AddRefs(objPtr));
        if (NS_FAILED(rv)) {
          ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Argument 15 of MouseEvent.initNSMouseEvent", "EventTarget");
          return false;
        }
        // We should have an object
        MOZ_ASSERT(objPtr);
        arg14 = objPtr;
      }
    }
  } else if (args[14].isNullOrUndefined()) {
    arg14 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Argument 15 of MouseEvent.initNSMouseEvent");
    return false;
  }
  float arg15;
  if (!ValueToPrimitive<float, eDefault>(cx, args[15], &arg15)) {
    return false;
  } else if (!mozilla::IsFinite(arg15)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 16 of MouseEvent.initNSMouseEvent");
    return false;
  }
  uint16_t arg16;
  if (!ValueToPrimitive<uint16_t, eDefault>(cx, args[16], &arg16)) {
    return false;
  }
  ErrorResult rv;
  self->InitNSMouseEvent(NonNullHelper(Constify(arg0)), arg1, arg2, Constify(arg3), arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, Constify(arg14), arg15, arg16, rv);
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailed(cx, rv);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}

static const JSJitInfo initNSMouseEvent_methodinfo = {
  { (JSJitGetterOp)initNSMouseEvent },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_hitCluster(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->HitCluster());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo hitCluster_getterinfo = {
  { (JSJitGetterOp)get_hitCluster },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_isTrusted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MouseEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->IsTrusted());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isTrusted_getterinfo = {
  { (JSJitGetterOp)get_isTrusted },
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasDOMSets, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::MouseEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MouseEvent>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::MouseEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MouseEvent>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::MouseEvent>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::MouseEvent>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::MouseEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MouseEvent>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("initMouseEvent", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&initMouseEvent_methodinfo), 15, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getModifierState", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getModifierState_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("initNSMouseEvent", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&initNSMouseEvent_methodinfo), 17, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[4];

static const JSPropertySpec sAttributes_specs[] = {
  { "screenX", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &screenX_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "screenY", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &screenY_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "clientX", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &clientX_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "clientY", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &clientY_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END,
  { "offsetX", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &offsetX_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "offsetY", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &offsetY_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END,
  { "ctrlKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &ctrlKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "shiftKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &shiftKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "altKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &altKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "metaKey", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &metaKey_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "button", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &button_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "buttons", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &buttons_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "relatedTarget", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &relatedTarget_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "region", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &region_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "movementX", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &movementX_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "movementY", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &movementY_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "mozMovementX", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &mozMovementX_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "mozMovementY", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &mozMovementY_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "mozPressure", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &mozPressure_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "mozInputSource", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &mozInputSource_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[5] },
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[8] },
  { false, nullptr }
};

static jsid sAttributes_ids[23];

static const JSPropertySpec sChromeAttributes_specs[] = {
  { "hitCluster", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &hitCluster_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sChromeAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sChromeAttributes_specs[0] },
  { false, nullptr }
};

static jsid sChromeAttributes_ids[2];

static const JSPropertySpec sUnforgeableAttributes_specs[] = {
  { "isTrusted", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_PERMANENT, { { GenericBindingGetter, &isTrusted_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sUnforgeableAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sUnforgeableAttributes_specs[0] },
  { false, nullptr }
};

static jsid sUnforgeableAttributes_ids[2];

static const ConstantSpec sConstants_specs[] = {
  { "MOZ_SOURCE_UNKNOWN", JS::Int32Value(0) },
  { "MOZ_SOURCE_MOUSE", JS::Int32Value(1) },
  { "MOZ_SOURCE_PEN", JS::Int32Value(2) },
  { "MOZ_SOURCE_ERASER", JS::Int32Value(3) },
  { "MOZ_SOURCE_CURSOR", JS::Int32Value(4) },
  { "MOZ_SOURCE_TOUCH", JS::Int32Value(5) },
  { "MOZ_SOURCE_KEYBOARD", JS::Int32Value(6) },
  { 0, JS::UndefinedValue() }
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const ConstantSpec> sConstants[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sConstants_specs[0] },
  { false, nullptr }
};

static jsid sConstants_ids[8];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  sUnforgeableAttributes, sUnforgeableAttributes_ids, sUnforgeableAttributes_specs,
  sConstants, sConstants_ids, sConstants_specs,
  -1
};

static const NativeProperties sChromeOnlyNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sChromeAttributes, sChromeAttributes_ids, sChromeAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, &sChromeOnlyNativeProperties },
  prototypes::id::MouseEvent,
  constructors::id::MouseEvent,
  UIEventBinding::sNativePropertyHooks
} };

static bool
_constructor(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  JS::Rooted<JSObject*> obj(cx, &args.callee());
  bool mayInvoke = args.isConstructing();
#ifdef RELEASE_BUILD
  mayInvoke = mayInvoke || nsContentUtils::ThreadsafeIsCallerChrome();
#endif // RELEASE_BUILD
  if (!mayInvoke) {
    // XXXbz wish I could get the name from the callee instead of
    // Adding more relocations
    return ThrowConstructorWithoutNew(cx, "MouseEvent");
  }
  JS::Rooted<JSObject*> desiredProto(cx);
  if (!GetDesiredProto(cx, args, &desiredProto)) {
    return false;
  }

  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MouseEvent");
  }
  GlobalObject global(cx, obj);
  if (global.Failed()) {
    return false;
  }

  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  binding_detail::FastMouseEventInit arg1;
  if (!arg1.Init(cx, (args.hasDefined(1)) ? args[1] : JS::NullHandleValue, "Argument 2 of MouseEvent.constructor", false)) {
    return false;
  }
  Maybe<JSAutoCompartment> ac;
  if (objIsXray) {
    obj = js::CheckedUnwrap(obj);
    if (!obj) {
      return false;
    }
    ac.emplace(cx, obj);
    if (!JS_WrapObject(cx, &desiredProto)) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::MouseEvent>(mozilla::dom::MouseEvent::Constructor(global, NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailed(cx, rv);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval(), desiredProto)) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    _constructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    _constructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function MouseEvent() {\n    [native code]\n}",
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  UIEventBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "MouseEventPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE + 1 /* slot for the JSObject holding the unforgeable properties */),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object MouseEventPrototype]",
  prototypes::id::MouseEvent,
  PrototypeTraits<prototypes::id::MouseEvent>::Depth,
  UIEventBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

static const DOMJSClass Class = {
  { "MouseEvent",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::Event, prototypes::id::UIEvent, prototypes::id::MouseEvent, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::MouseEvent >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::MouseEvent>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::MouseEvent>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::MouseEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::MouseEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::MouseEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::MouseEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::UIEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::UIEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::UIEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::Event*>(aObject) ==
             reinterpret_cast<mozilla::dom::Event*>(aObject),
             "Multiple inheritance for mozilla::dom::Event is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::MouseEvent> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);

  // Important: do unforgeable property setup after we have handed
  // over ownership of the C++ object to obj as needed, so that if
  // we fail and it ends up GCed it won't have problems in the
  // finalizer trying to drop its ownership of the C++ object.
  JS::Rooted<JSObject*> unforgeableHolder(aCx,
    &js::GetReservedSlot(canonicalProto, DOM_INTERFACE_PROTO_SLOTS_BASE).toObject());
  if (!JS_InitializePropertiesFromCompatibleNativeObject(aCx, aReflector, unforgeableHolder)) {
    aCache->ReleaseWrapper(aObject);
    aCache->ClearWrapper();
    return false;
  }
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(UIEventBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(UIEventBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sChromeAttributes, sChromeAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sUnforgeableAttributes, sUnforgeableAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sConstants, sConstants_ids)) {
      return;
    }
    sIdsInited = true;
  }

  static bool sPrefCachesInited = false;
  if (!sPrefCachesInited) {
    sPrefCachesInited = true;
    Preferences::AddBoolVarCache(&sAttributes[1].enabled, "dom.mouseEvent.offsetXY.enabled");
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::MouseEvent);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::MouseEvent);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 1, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nsContentUtils::ThreadsafeIsCallerChrome() ? &sChromeOnlyNativeProperties : nullptr,
                              "MouseEvent", aDefineOnGlobal);

  JS::Rooted<JSObject*> unforgeableHolder(aCx);
  {
    JS::Rooted<JSObject*> holderProto(aCx, *protoCache);
    unforgeableHolder = JS_NewObjectWithoutMetadata(aCx, Class.ToJSClass(), holderProto);
    if (!unforgeableHolder) {
      *protoCache = nullptr;
      if (interfaceCache) {
        *interfaceCache = nullptr;
      }
      return;
    }
  }

  if (!DefineUnforgeableAttributes(aCx, unforgeableHolder, sUnforgeableAttributes)) {
    *protoCache = nullptr;
    if (interfaceCache) {
      *interfaceCache = nullptr;
    }
    return;
  }

  if (*protoCache) {
    js::SetReservedSlot(*protoCache, DOM_INTERFACE_PROTO_SLOTS_BASE,
                        JS::ObjectValue(*unforgeableHolder));
  }
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::MouseEvent)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::MouseEvent).address());
}

JSObject*
GetProtoObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetProtoObjectHandle(aCx, aGlobal);
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::MouseEvent)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::MouseEvent).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace MouseEventBinding



} // namespace dom
} // namespace mozilla
