/* THIS FILE IS AUTOGENERATED FROM MozIccManager.webidl BY Codegen.py - DO NOT EDIT */

#include "EventHandlerBinding.h"
#include "EventTargetBinding.h"
#include "MozIccManagerBinding.h"
#include "WrapperFactory.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/Icc.h"
#include "mozilla/dom/IccManager.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/Nullable.h"

namespace mozilla {
namespace dom {

namespace MozIccManagerBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<EventTargetBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
get_iccIds(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IccManager* self, JSJitGetterCallArgs args)
{
  // Have to either root across the getter call or reget after.
  JS::Rooted<JSObject*> reflector(cx);
  // Safe to do an unchecked unwrap, since we've gotten this far.
  // Also make sure to unwrap outer windows, since we want the
  // real DOM object.
  reflector = IsDOMObject(obj) ? obj : js::UncheckedUnwrap(obj, /* stopAtOuter = */ false);
  {
    // Scope for cachedVal
    JS::Value cachedVal = js::GetReservedSlot(reflector, (DOM_INSTANCE_RESERVED_SLOTS + 0));
    if (!cachedVal.isUndefined()) {
      args.rval().set(cachedVal);
      // The cached value is in the compartment of reflector,
      // so wrap into the caller compartment as needed.
      return MaybeWrapNonDOMObjectValue(cx, args.rval());
    }
  }

  nsTArray<nsString> result;
  self->GetIccIds(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  { // Make sure we wrap and store in the slot in reflector's compartment
    JSAutoCompartment ac(cx, reflector);
    do { // block we break out of when done wrapping

      uint32_t length = result.Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!xpc::NonVoidStringToJsval(cx, result[sequenceIdx0], &tmp)) {
              return false;
            }
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      args.rval().setObject(*returnArray);
      break;
    } while (0);
    js::SetReservedSlot(reflector, (DOM_INSTANCE_RESERVED_SLOTS + 0), args.rval());
    PreserveWrapper(self);
  }
  // And now make sure args.rval() is in the caller compartment
  return MaybeWrapNonDOMObjectValue(cx, args.rval());
}

static const JSJitInfo iccIds_getterinfo = {
  { (JSJitGetterOp)get_iccIds },
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasDOMSets, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  true, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  (DOM_INSTANCE_RESERVED_SLOTS + 0)   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert((DOM_INSTANCE_RESERVED_SLOTS + 0) <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getIccById(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IccManager* self, const JSJitMethodCallArgs& args)
{
  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MozIccManager.getIccById");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  auto result(StrongOrRawPtr<mozilla::dom::Icc>(self->GetIccById(NonNullHelper(Constify(arg0)))));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo getIccById_methodinfo = {
  { (JSJitGetterOp)getIccById },
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_oniccdetected(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IccManager* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOniccdetected());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_oniccdetected(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IccManager* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOniccdetected(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo oniccdetected_getterinfo = {
  { (JSJitGetterOp)get_oniccdetected },
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo oniccdetected_setterinfo = {
  { (JSJitGetterOp)set_oniccdetected },
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_oniccundetected(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IccManager* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOniccundetected());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_oniccundetected(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::IccManager* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(cx, tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOniccundetected(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}

static const JSJitInfo oniccundetected_getterinfo = {
  { (JSJitGetterOp)get_oniccundetected },
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");
static const JSJitInfo oniccundetected_setterinfo = {
  { (JSJitGetterOp)set_oniccundetected },
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::IccManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::IccManager>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::IccManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::IccManager>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::IccManager>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::IccManager>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::IccManager* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::IccManager>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const char* const anypermissions_0[] = {
  "mobileconnection",
  nullptr
};

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getIccById", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getIccById_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[2];

static const JSPropertySpec sAttributes_specs[] = {
  { "iccIds", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &iccIds_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "oniccdetected", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &oniccdetected_getterinfo } }, { { GenericBindingSetter, &oniccdetected_setterinfo } }},
  { "oniccundetected", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &oniccundetected_getterinfo } }, { { GenericBindingSetter, &oniccundetected_setterinfo } }},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, nullptr }
};

static jsid sAttributes_ids[4];

static const ConstantSpec sConstants_specs[] = {
  { "STK_MENU_TYPE_NOT_SPECIFIED", JS::Int32Value(0) },
  { "STK_MENU_TYPE_DATA_VALUES", JS::Int32Value(1) },
  { "STK_MENU_TYPE_NAVIGATION_OPTIONS", JS::Int32Value(3) },
  { "STK_BROWSER_MODE_LAUNCH_IF_NOT_ALREADY_LAUNCHED", JS::Int32Value(0) },
  { "STK_BROWSER_MODE_USING_EXISTING_BROWSER", JS::Int32Value(2) },
  { "STK_BROWSER_MODE_USING_NEW_BROWSER", JS::Int32Value(3) },
  { "STK_CMD_REFRESH", JS::Int32Value(1) },
  { "STK_CMD_POLL_INTERVAL", JS::Int32Value(3) },
  { "STK_CMD_POLL_OFF", JS::Int32Value(4) },
  { "STK_CMD_SET_UP_EVENT_LIST", JS::Int32Value(5) },
  { "STK_CMD_SET_UP_CALL", JS::Int32Value(16) },
  { "STK_CMD_SEND_SS", JS::Int32Value(17) },
  { "STK_CMD_SEND_USSD", JS::Int32Value(18) },
  { "STK_CMD_SEND_SMS", JS::Int32Value(19) },
  { "STK_CMD_SEND_DTMF", JS::Int32Value(20) },
  { "STK_CMD_LAUNCH_BROWSER", JS::Int32Value(21) },
  { "STK_CMD_PLAY_TONE", JS::Int32Value(32) },
  { "STK_CMD_DISPLAY_TEXT", JS::Int32Value(33) },
  { "STK_CMD_GET_INKEY", JS::Int32Value(34) },
  { "STK_CMD_GET_INPUT", JS::Int32Value(35) },
  { "STK_CMD_SELECT_ITEM", JS::Int32Value(36) },
  { "STK_CMD_SET_UP_MENU", JS::Int32Value(37) },
  { "STK_CMD_PROVIDE_LOCAL_INFO", JS::Int32Value(38) },
  { "STK_CMD_TIMER_MANAGEMENT", JS::Int32Value(39) },
  { "STK_CMD_SET_UP_IDLE_MODE_TEXT", JS::Int32Value(40) },
  { "STK_CMD_OPEN_CHANNEL", JS::Int32Value(64) },
  { "STK_CMD_CLOSE_CHANNEL", JS::Int32Value(65) },
  { "STK_CMD_RECEIVE_DATA", JS::Int32Value(66) },
  { "STK_CMD_SEND_DATA", JS::Int32Value(67) },
  { "STK_RESULT_OK", JS::Int32Value(0) },
  { "STK_RESULT_PRFRMD_WITH_PARTIAL_COMPREHENSION", JS::Int32Value(1) },
  { "STK_RESULT_PRFRMD_WITH_MISSING_INFO", JS::Int32Value(2) },
  { "STK_RESULT_PRFRMD_WITH_ADDITIONAL_EFS_READ", JS::Int32Value(3) },
  { "STK_RESULT_PRFRMD_ICON_NOT_DISPLAYED", JS::Int32Value(4) },
  { "STK_RESULT_PRFRMD_LIMITED_SERVICE", JS::Int32Value(6) },
  { "STK_RESULT_UICC_SESSION_TERM_BY_USER", JS::Int32Value(16) },
  { "STK_RESULT_BACKWARD_MOVE_BY_USER", JS::Int32Value(17) },
  { "STK_RESULT_NO_RESPONSE_FROM_USER", JS::Int32Value(18) },
  { "STK_RESULT_HELP_INFO_REQUIRED", JS::Int32Value(19) },
  { "STK_RESULT_USSD_SS_SESSION_TERM_BY_USER", JS::Int32Value(20) },
  { "STK_RESULT_TERMINAL_CRNTLY_UNABLE_TO_PROCESS", JS::Int32Value(32) },
  { "STK_RESULT_NETWORK_CRNTLY_UNABLE_TO_PROCESS", JS::Int32Value(33) },
  { "STK_RESULT_USER_NOT_ACCEPT", JS::Int32Value(34) },
  { "STK_RESULT_USER_CLEAR_DOWN_CALL", JS::Int32Value(35) },
  { "STK_RESULT_ACTION_CONTRADICTION_TIMER_STATE", JS::Int32Value(36) },
  { "STK_RESULT_LAUNCH_BROWSER_ERROR", JS::Int32Value(38) },
  { "STK_RESULT_BEYOND_TERMINAL_CAPABILITY", JS::Int32Value(48) },
  { "STK_RESULT_CMD_TYPE_NOT_UNDERSTOOD", JS::Int32Value(49) },
  { "STK_RESULT_CMD_DATA_NOT_UNDERSTOOD", JS::Int32Value(50) },
  { "STK_RESULT_CMD_NUM_NOT_KNOWN", JS::Int32Value(51) },
  { "STK_RESULT_SS_RETURN_ERROR", JS::Int32Value(52) },
  { "STK_RESULT_SMS_RP_ERROR", JS::Int32Value(53) },
  { "STK_RESULT_REQUIRED_VALUES_MISSING", JS::Int32Value(54) },
  { "STK_RESULT_USSD_RETURN_ERROR", JS::Int32Value(55) },
  { "STK_RESULT_MULTI_CARDS_CMD_ERROR", JS::Int32Value(56) },
  { "STK_RESULT_USIM_CALL_CONTROL_PERMANENT", JS::Int32Value(57) },
  { "STK_RESULT_BIP_ERROR", JS::Int32Value(58) },
  { "STK_ADDITIONAL_INFO_ME_PROBLEM_SCREEN_IS_BUSY", JS::Int32Value(1) },
  { "STK_EVENT_TYPE_MT_CALL", JS::Int32Value(0) },
  { "STK_EVENT_TYPE_CALL_CONNECTED", JS::Int32Value(1) },
  { "STK_EVENT_TYPE_CALL_DISCONNECTED", JS::Int32Value(2) },
  { "STK_EVENT_TYPE_LOCATION_STATUS", JS::Int32Value(3) },
  { "STK_EVENT_TYPE_USER_ACTIVITY", JS::Int32Value(4) },
  { "STK_EVENT_TYPE_IDLE_SCREEN_AVAILABLE", JS::Int32Value(5) },
  { "STK_EVENT_TYPE_CARD_READER_STATUS", JS::Int32Value(6) },
  { "STK_EVENT_TYPE_LANGUAGE_SELECTION", JS::Int32Value(7) },
  { "STK_EVENT_TYPE_BROWSER_TERMINATION", JS::Int32Value(8) },
  { "STK_EVENT_TYPE_DATA_AVAILABLE", JS::Int32Value(9) },
  { "STK_EVENT_TYPE_CHANNEL_STATUS", JS::Int32Value(10) },
  { "STK_EVENT_TYPE_SINGLE_ACCESS_TECHNOLOGY_CHANGED", JS::Int32Value(11) },
  { "STK_EVENT_TYPE_DISPLAY_PARAMETER_CHANGED", JS::Int32Value(12) },
  { "STK_EVENT_TYPE_LOCAL_CONNECTION", JS::Int32Value(13) },
  { "STK_EVENT_TYPE_NETWORK_SEARCH_MODE_CHANGED", JS::Int32Value(14) },
  { "STK_EVENT_TYPE_BROWSING_STATUS", JS::Int32Value(15) },
  { "STK_EVENT_TYPE_FRAMES_INFORMATION_CHANGED", JS::Int32Value(16) },
  { "STK_SERVICE_STATE_NORMAL", JS::Int32Value(0) },
  { "STK_SERVICE_STATE_LIMITED", JS::Int32Value(1) },
  { "STK_SERVICE_STATE_UNAVAILABLE", JS::Int32Value(2) },
  { "STK_TONE_TYPE_DIAL_TONE", JS::Int32Value(1) },
  { "STK_TONE_TYPE_CALLED_SUBSCRIBER_BUSY", JS::Int32Value(2) },
  { "STK_TONE_TYPE_CONGESTION", JS::Int32Value(3) },
  { "STK_TONE_TYPE_RADIO_PATH_ACK", JS::Int32Value(4) },
  { "STK_TONE_TYPE_RADIO_PATH_NOT_AVAILABLE", JS::Int32Value(5) },
  { "STK_TONE_TYPE_ERROR", JS::Int32Value(6) },
  { "STK_TONE_TYPE_CALL_WAITING_TONE", JS::Int32Value(7) },
  { "STK_TONE_TYPE_RINGING_TONE", JS::Int32Value(8) },
  { "STK_TONE_TYPE_GENERAL_BEEP", JS::Int32Value(16) },
  { "STK_TONE_TYPE_POSITIVE_ACK_TONE", JS::Int32Value(17) },
  { "STK_TONE_TYPE_NEGATIVE_ACK_TONE", JS::Int32Value(18) },
  { "STK_TIME_UNIT_MINUTE", JS::Int32Value(0) },
  { "STK_TIME_UNIT_SECOND", JS::Int32Value(1) },
  { "STK_TIME_UNIT_TENTH_SECOND", JS::Int32Value(2) },
  { "STK_LOCAL_INFO_LOCATION_INFO", JS::Int32Value(0) },
  { "STK_LOCAL_INFO_IMEI", JS::Int32Value(1) },
  { "STK_LOCAL_INFO_DATE_TIME_ZONE", JS::Int32Value(3) },
  { "STK_LOCAL_INFO_LANGUAGE", JS::Int32Value(4) },
  { "STK_TIMER_START", JS::Int32Value(0) },
  { "STK_TIMER_DEACTIVATE", JS::Int32Value(1) },
  { "STK_TIMER_GET_CURRENT_VALUE", JS::Int32Value(2) },
  { "STK_BROWSER_TERMINATION_CAUSE_USER", JS::Int32Value(0) },
  { "STK_BROWSER_TERMINATION_CAUSE_ERROR", JS::Int32Value(1) },
  { "STK_NEXT_ACTION_NULL", JS::Int32Value(0) },
  { "STK_NEXT_ACTION_END_PROACTIVE_SESSION", JS::Int32Value(129) },
  { 0, JS::UndefinedValue() }
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const ConstantSpec> sConstants[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sConstants_specs[0] },
  { false, nullptr }
};

static jsid sConstants_ids[104];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sConstants, sConstants_ids, sConstants_specs,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::MozIccManager,
  constructors::id::MozIccManager,
  EventTargetBinding::sNativePropertyHooks
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function MozIccManager() {\n    [native code]\n}",
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  EventTargetBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "MozIccManagerPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object MozIccManagerPrototype]",
  prototypes::id::MozIccManager,
  PrototypeTraits<prototypes::id::MozIccManager>::Depth,
  EventTargetBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.icc.enabled") &&
         IsInCertifiedApp(aCx, aObj) &&
         CheckAnyPermissions(aCx, aObj, anypermissions_0);
}

static const DOMJSClass Class = {
  { "MozIccManager",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(2),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::MozIccManager, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::IccManager >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::IccManager>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::IccManager>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(2 >= 2,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::IccManager* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::IccManager*>(aObject) ==
             reinterpret_cast<mozilla::dom::IccManager*>(aObject),
             "Multiple inheritance for mozilla::dom::IccManager is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject),
             "Multiple inheritance for mozilla::dom::EventTarget is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::IccManager> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
ClearCachedIccIdsValue(mozilla::dom::IccManager* aObject)
{
  JSObject* obj;
  obj = aObject->GetWrapper();
  if (!obj) {
    return;
  }
  js::SetReservedSlot(obj, (DOM_INSTANCE_RESERVED_SLOTS + 0), JS::UndefinedValue());
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventTargetBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventTargetBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sConstants, sConstants_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::MozIccManager);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::MozIccManager);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "MozIccManager", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::MozIccManager)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::MozIccManager).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::MozIccManager)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::MozIccManager).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace MozIccManagerBinding



} // namespace dom
} // namespace mozilla
