/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM MozMessageDeletedEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "MozMessageDeletedEvent.h"
#include "MozMessageDeletedEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/MozMessageDeletedEvent.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(MozMessageDeletedEvent)

NS_IMPL_ADDREF_INHERITED(MozMessageDeletedEvent, Event)
NS_IMPL_RELEASE_INHERITED(MozMessageDeletedEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(MozMessageDeletedEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(MozMessageDeletedEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(MozMessageDeletedEvent, Event)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(MozMessageDeletedEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

MozMessageDeletedEvent::MozMessageDeletedEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

MozMessageDeletedEvent::~MozMessageDeletedEvent()
{
}

MozMessageDeletedEvent*
MozMessageDeletedEvent::AsMozMessageDeletedEvent()
{
  return this;
}

JSObject*
MozMessageDeletedEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return MozMessageDeletedEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<MozMessageDeletedEvent>
MozMessageDeletedEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const MozMessageDeletedEventInit& aEventInitDict)
{
  nsRefPtr<MozMessageDeletedEvent> e = new MozMessageDeletedEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  if (!aEventInitDict.mDeletedMessageIds.IsNull()) {
    e->mDeletedMessageIds.SetValue().AppendElements(aEventInitDict.mDeletedMessageIds.Value());
  }
  if (!aEventInitDict.mDeletedThreadIds.IsNull()) {
    e->mDeletedThreadIds.SetValue().AppendElements(aEventInitDict.mDeletedThreadIds.Value());
  }
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<MozMessageDeletedEvent>
MozMessageDeletedEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const MozMessageDeletedEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
MozMessageDeletedEvent::GetDeletedMessageIds(Nullable<nsTArray<int32_t>>& aRetVal) const
{
  aRetVal = mDeletedMessageIds;
}

void
MozMessageDeletedEvent::GetDeletedThreadIds(Nullable<nsTArray<uint64_t>>& aRetVal) const
{
  aRetVal = mDeletedThreadIds;
}


} // namespace dom
} // namespace mozilla
