/* THIS FILE IS AUTOGENERATED FROM MozMmsMessage.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "MozMmsMessageBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


MmsDeliveryInfo::MmsDeliveryInfo()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MmsDeliveryInfo::InitIds(JSContext* cx, MmsDeliveryInfoAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->receiver_id.init(cx, "receiver") ||
      !atomsCache->readTimestamp_id.init(cx, "readTimestamp") ||
      !atomsCache->readStatus_id.init(cx, "readStatus") ||
      !atomsCache->deliveryTimestamp_id.init(cx, "deliveryTimestamp") ||
      !atomsCache->deliveryStatus_id.init(cx, "deliveryStatus")) {
    return false;
  }
  return true;
}

bool
MmsDeliveryInfo::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MmsDeliveryInfoAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MmsDeliveryInfoAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->deliveryStatus_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, mDeliveryStatus)) {
      return false;
    }
  } else {
    mDeliveryStatus.SetIsVoid(true);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->deliveryTimestamp_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &mDeliveryTimestamp)) {
      return false;
    }
  } else {
    mDeliveryTimestamp = 0ULL;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->readStatus_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, mReadStatus)) {
      return false;
    }
  } else {
    mReadStatus.SetIsVoid(true);
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->readTimestamp_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &mReadTimestamp)) {
      return false;
    }
  } else {
    mReadTimestamp = 0ULL;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->receiver_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, mReceiver)) {
      return false;
    }
  } else {
    mReceiver.SetIsVoid(true);
  }
  return true;
}

bool
MmsDeliveryInfo::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MmsDeliveryInfo::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MmsDeliveryInfoAtoms* atomsCache = GetAtomCache<MmsDeliveryInfoAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mDeliveryStatus;
    if (!xpc::StringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->deliveryStatus_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint64_t const & currentValue = mDeliveryTimestamp;
    temp.set(JS_NumberValue(double(currentValue)));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->deliveryTimestamp_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mReadStatus;
    if (!xpc::StringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->readStatus_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    uint64_t const & currentValue = mReadTimestamp;
    temp.set(JS_NumberValue(double(currentValue)));
    if (!JS_DefinePropertyById(cx, obj, atomsCache->readTimestamp_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    nsString const & currentValue = mReceiver;
    if (!xpc::StringToJsval(cx, currentValue, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->receiver_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MmsDeliveryInfo::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MmsDeliveryInfo::TraceDictionary(JSTracer* trc)
{
}

void
MmsDeliveryInfo::operator=(const MmsDeliveryInfo& aOther)
{
  mDeliveryStatus = aOther.mDeliveryStatus;
  mDeliveryTimestamp = aOther.mDeliveryTimestamp;
  mReadStatus = aOther.mReadStatus;
  mReadTimestamp = aOther.mReadTimestamp;
  mReceiver = aOther.mReceiver;
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
