/* THIS FILE IS AUTOGENERATED FROM MozStkCommandEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "EventBinding.h"
#include "MozStkCommandEventBinding.h"
#include "WrapperFactory.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/MozStkCommandEvent.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {

namespace IccImageCodingSchemeValues {
  extern const EnumEntry strings[4] = {
    {"basic", 5},
    {"color", 5},
    {"color-transparency", 18},
    { nullptr, 0 }
  };
} // namespace IccImageCodingSchemeValues



MozStkBrowserTerminationEvent::MozStkBrowserTerminationEvent()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkBrowserTerminationEvent::InitIds(JSContext* cx, MozStkBrowserTerminationEventAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->terminationCause_id.init(cx, "terminationCause") ||
      !atomsCache->eventType_id.init(cx, "eventType")) {
    return false;
  }
  return true;
}

bool
MozStkBrowserTerminationEvent::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkBrowserTerminationEventAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkBrowserTerminationEventAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->eventType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEventType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mEventType.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->terminationCause_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTerminationCause.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mTerminationCause.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkBrowserTerminationEvent::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkBrowserTerminationEvent::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkBrowserTerminationEventAtoms* atomsCache = GetAtomCache<MozStkBrowserTerminationEventAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mEventType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mEventType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->eventType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTerminationCause.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mTerminationCause.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->terminationCause_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkBrowserTerminationEvent::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkBrowserTerminationEvent::TraceDictionary(JSTracer* trc)
{
}

void
MozStkBrowserTerminationEvent::operator=(const MozStkBrowserTerminationEvent& aOther)
{
  if (aOther.mEventType.WasPassed()) {
    mEventType.Construct();
    mEventType.Value() = aOther.mEventType.Value();
  } else {
    mEventType.Reset();
  }
  if (aOther.mTerminationCause.WasPassed()) {
    mTerminationCause.Construct();
    mTerminationCause.Value() = aOther.mTerminationCause.Value();
  } else {
    mTerminationCause.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkCallEvent::MozStkCallEvent()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkCallEvent::InitIds(JSContext* cx, MozStkCallEventAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->number_id.init(cx, "number") ||
      !atomsCache->isIssuedByRemote_id.init(cx, "isIssuedByRemote") ||
      !atomsCache->eventType_id.init(cx, "eventType") ||
      !atomsCache->error_id.init(cx, "error")) {
    return false;
  }
  return true;
}

bool
MozStkCallEvent::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkCallEventAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkCallEventAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->error_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mError.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mError.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->eventType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEventType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mEventType.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isIssuedByRemote_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsIssuedByRemote.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsIssuedByRemote.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->number_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mNumber.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mNumber.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkCallEvent::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkCallEvent::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkCallEventAtoms* atomsCache = GetAtomCache<MozStkCallEventAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mError.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mError.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->error_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mEventType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mEventType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->eventType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsIssuedByRemote.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsIssuedByRemote.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isIssuedByRemote_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mNumber.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mNumber.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->number_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkCallEvent::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkCallEvent::TraceDictionary(JSTracer* trc)
{
}

void
MozStkCallEvent::operator=(const MozStkCallEvent& aOther)
{
  if (aOther.mError.WasPassed()) {
    mError.Construct();
    mError.Value() = aOther.mError.Value();
  } else {
    mError.Reset();
  }
  if (aOther.mEventType.WasPassed()) {
    mEventType.Construct();
    mEventType.Value() = aOther.mEventType.Value();
  } else {
    mEventType.Reset();
  }
  if (aOther.mIsIssuedByRemote.WasPassed()) {
    mIsIssuedByRemote.Construct();
    mIsIssuedByRemote.Value() = aOther.mIsIssuedByRemote.Value();
  } else {
    mIsIssuedByRemote.Reset();
  }
  if (aOther.mNumber.WasPassed()) {
    mNumber.Construct();
    mNumber.Value() = aOther.mNumber.Value();
  } else {
    mNumber.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkCommand::MozStkCommand()
  : mOptions(JS::UndefinedValue())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
MozStkCommand::InitIds(JSContext* cx, MozStkCommandAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->typeOfCommand_id.init(cx, "typeOfCommand") ||
      !atomsCache->options_id.init(cx, "options") ||
      !atomsCache->commandQualifier_id.init(cx, "commandQualifier") ||
      !atomsCache->commandNumber_id.init(cx, "commandNumber")) {
    return false;
  }
  return true;
}

bool
MozStkCommand::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkCommandAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkCommandAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->commandNumber_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mCommandNumber.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mCommandNumber.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->commandQualifier_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mCommandQualifier.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mCommandQualifier.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->options_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (passedToJSImpl && !CallerSubsumes(temp.ref())) {
      ThrowErrorMessage(cx, MSG_PERMISSION_DENIED_TO_PASS_ARG, "'options' member of MozStkCommand");
      return false;
    }
    mOptions = temp.ref();
  } else {
    mOptions = JS::UndefinedValue();
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->typeOfCommand_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTypeOfCommand.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mTypeOfCommand.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkCommand::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkCommand::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkCommandAtoms* atomsCache = GetAtomCache<MozStkCommandAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mCommandNumber.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mCommandNumber.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->commandNumber_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mCommandQualifier.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mCommandQualifier.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->commandQualifier_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    JS::Value const & currentValue = mOptions;
    JS::ExposeValueToActiveJS(currentValue);
    temp.set(currentValue);
    if (!MaybeWrapValue(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->options_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mTypeOfCommand.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mTypeOfCommand.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->typeOfCommand_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkCommand::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkCommand::TraceDictionary(JSTracer* trc)
{
  JS_CallUnbarrieredValueTracer(trc, &mOptions, "MozStkCommand.mOptions");
}

namespace binding_detail {
} // namespace binding_detail



MozStkCommandEventInit::MozStkCommandEventInit()
  : EventInit(FastDictionaryInitializer()),
    mCommand(JS::UndefinedValue())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
MozStkCommandEventInit::InitIds(JSContext* cx, MozStkCommandEventInitAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->command_id.init(cx, "command")) {
    return false;
  }
  return true;
}

bool
MozStkCommandEventInit::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkCommandEventInitAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkCommandEventInitAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!EventInit::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->command_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    if (passedToJSImpl && !CallerSubsumes(temp.ref())) {
      ThrowErrorMessage(cx, MSG_PERMISSION_DENIED_TO_PASS_ARG, "'command' member of MozStkCommandEventInit");
      return false;
    }
    mCommand = temp.ref();
  } else {
    mCommand = JS::NullValue();
  }
  return true;
}

bool
MozStkCommandEventInit::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkCommandEventInit::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkCommandEventInitAtoms* atomsCache = GetAtomCache<MozStkCommandEventInitAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!EventInit::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    JS::Value const & currentValue = mCommand;
    JS::ExposeValueToActiveJS(currentValue);
    temp.set(currentValue);
    if (!MaybeWrapValue(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->command_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MozStkCommandEventInit::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkCommandEventInit::TraceDictionary(JSTracer* trc)
{
  EventInit::TraceDictionary(trc);
  JS_CallUnbarrieredValueTracer(trc, &mCommand, "MozStkCommandEventInit.mCommand");
}

namespace binding_detail {
} // namespace binding_detail



MozStkDuration::MozStkDuration()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkDuration::InitIds(JSContext* cx, MozStkDurationAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->timeUnit_id.init(cx, "timeUnit") ||
      !atomsCache->timeInterval_id.init(cx, "timeInterval")) {
    return false;
  }
  return true;
}

bool
MozStkDuration::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkDurationAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkDurationAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->timeInterval_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTimeInterval.Construct();
    if (!ValueToPrimitive<uint8_t, eDefault>(cx, temp.ref(), &(mTimeInterval.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->timeUnit_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTimeUnit.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mTimeUnit.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkDuration::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkDuration::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkDurationAtoms* atomsCache = GetAtomCache<MozStkDurationAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mTimeInterval.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint8_t const & currentValue = mTimeInterval.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->timeInterval_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTimeUnit.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mTimeUnit.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->timeUnit_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkDuration::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkDuration::TraceDictionary(JSTracer* trc)
{
}

void
MozStkDuration::operator=(const MozStkDuration& aOther)
{
  if (aOther.mTimeInterval.WasPassed()) {
    mTimeInterval.Construct();
    mTimeInterval.Value() = aOther.mTimeInterval.Value();
  } else {
    mTimeInterval.Reset();
  }
  if (aOther.mTimeUnit.WasPassed()) {
    mTimeUnit.Construct();
    mTimeUnit.Value() = aOther.mTimeUnit.Value();
  } else {
    mTimeUnit.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkGeneralEvent::MozStkGeneralEvent()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkGeneralEvent::InitIds(JSContext* cx, MozStkGeneralEventAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->eventType_id.init(cx, "eventType")) {
    return false;
  }
  return true;
}

bool
MozStkGeneralEvent::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkGeneralEventAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkGeneralEventAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->eventType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEventType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mEventType.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkGeneralEvent::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkGeneralEvent::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkGeneralEventAtoms* atomsCache = GetAtomCache<MozStkGeneralEventAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mEventType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mEventType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->eventType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkGeneralEvent::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkGeneralEvent::TraceDictionary(JSTracer* trc)
{
}

void
MozStkGeneralEvent::operator=(const MozStkGeneralEvent& aOther)
{
  if (aOther.mEventType.WasPassed()) {
    mEventType.Construct();
    mEventType.Value() = aOther.mEventType.Value();
  } else {
    mEventType.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkIcon::MozStkIcon()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkIcon::InitIds(JSContext* cx, MozStkIconAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->width_id.init(cx, "width") ||
      !atomsCache->pixels_id.init(cx, "pixels") ||
      !atomsCache->height_id.init(cx, "height") ||
      !atomsCache->codingScheme_id.init(cx, "codingScheme")) {
    return false;
  }
  return true;
}

bool
MozStkIcon::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkIconAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkIconAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->codingScheme_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mCodingScheme.Construct();
    {
      bool ok;
      int index = FindEnumStringIndex<true>(cx, temp.ref(), IccImageCodingSchemeValues::strings, "IccImageCodingScheme", "'codingScheme' member of MozStkIcon", &ok);
      if (!ok) {
        return false;
      }
      MOZ_ASSERT(index >= 0);
      (mCodingScheme.Value()) = static_cast<IccImageCodingScheme>(index);
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->height_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mHeight.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &(mHeight.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->pixels_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mPixels.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'pixels' member of MozStkIcon");
        return false;
      }
      Sequence<uint32_t> &arr = (mPixels.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        uint32_t* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        uint32_t& slot = *slotPtr;
        if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp, &slot)) {
          return false;
        }
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'pixels' member of MozStkIcon");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->width_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mWidth.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &(mWidth.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkIcon::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkIcon::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkIconAtoms* atomsCache = GetAtomCache<MozStkIconAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mCodingScheme.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      IccImageCodingScheme const & currentValue = mCodingScheme.InternalValue();
      {
        // Scope for resultStr
        MOZ_ASSERT(uint32_t(currentValue) < ArrayLength(IccImageCodingSchemeValues::strings));
        JSString* resultStr = JS_NewStringCopyN(cx, IccImageCodingSchemeValues::strings[uint32_t(currentValue)].value, IccImageCodingSchemeValues::strings[uint32_t(currentValue)].length);
        if (!resultStr) {
          return false;
        }
        temp.setString(resultStr);
        if (!JS_DefinePropertyById(cx, obj, atomsCache->codingScheme_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(0);
  }

  if (mHeight.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint32_t const & currentValue = mHeight.InternalValue();
      temp.setNumber(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->height_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mPixels.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Sequence<uint32_t> const & currentValue = mPixels.InternalValue();

      uint32_t length = currentValue.Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            tmp.setNumber(currentValue[sequenceIdx0]);
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      temp.setObject(*returnArray);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->pixels_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mWidth.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint32_t const & currentValue = mWidth.InternalValue();
      temp.setNumber(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->width_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkIcon::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkIcon::TraceDictionary(JSTracer* trc)
{
}

void
MozStkIcon::operator=(const MozStkIcon& aOther)
{
  if (aOther.mCodingScheme.WasPassed()) {
    mCodingScheme.Construct();
    mCodingScheme.Value() = aOther.mCodingScheme.Value();
  } else {
    mCodingScheme.Reset();
  }
  if (aOther.mHeight.WasPassed()) {
    mHeight.Construct();
    mHeight.Value() = aOther.mHeight.Value();
  } else {
    mHeight.Reset();
  }
  if (aOther.mPixels.WasPassed()) {
    mPixels.Construct();
    mPixels.Value() = aOther.mPixels.Value();
  } else {
    mPixels.Reset();
  }
  if (aOther.mWidth.WasPassed()) {
    mWidth.Construct();
    mWidth.Value() = aOther.mWidth.Value();
  } else {
    mWidth.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkLanguageSelectionEvent::MozStkLanguageSelectionEvent()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkLanguageSelectionEvent::InitIds(JSContext* cx, MozStkLanguageSelectionEventAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->language_id.init(cx, "language") ||
      !atomsCache->eventType_id.init(cx, "eventType")) {
    return false;
  }
  return true;
}

bool
MozStkLanguageSelectionEvent::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkLanguageSelectionEventAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkLanguageSelectionEventAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->eventType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEventType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mEventType.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->language_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mLanguage.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mLanguage.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkLanguageSelectionEvent::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkLanguageSelectionEvent::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkLanguageSelectionEventAtoms* atomsCache = GetAtomCache<MozStkLanguageSelectionEventAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mEventType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mEventType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->eventType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mLanguage.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mLanguage.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->language_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkLanguageSelectionEvent::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkLanguageSelectionEvent::TraceDictionary(JSTracer* trc)
{
}

void
MozStkLanguageSelectionEvent::operator=(const MozStkLanguageSelectionEvent& aOther)
{
  if (aOther.mEventType.WasPassed()) {
    mEventType.Construct();
    mEventType.Value() = aOther.mEventType.Value();
  } else {
    mEventType.Reset();
  }
  if (aOther.mLanguage.WasPassed()) {
    mLanguage.Construct();
    mLanguage.Value() = aOther.mLanguage.Value();
  } else {
    mLanguage.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkLocationInfo::MozStkLocationInfo()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkLocationInfo::InitIds(JSContext* cx, MozStkLocationInfoAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->mnc_id.init(cx, "mnc") ||
      !atomsCache->mcc_id.init(cx, "mcc") ||
      !atomsCache->gsmLocationAreaCode_id.init(cx, "gsmLocationAreaCode") ||
      !atomsCache->gsmCellId_id.init(cx, "gsmCellId")) {
    return false;
  }
  return true;
}

bool
MozStkLocationInfo::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkLocationInfoAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkLocationInfoAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->gsmCellId_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mGsmCellId.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &(mGsmCellId.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->gsmLocationAreaCode_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mGsmLocationAreaCode.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mGsmLocationAreaCode.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->mcc_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mMcc.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mMcc.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->mnc_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mMnc.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mMnc.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkLocationInfo::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkLocationInfo::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkLocationInfoAtoms* atomsCache = GetAtomCache<MozStkLocationInfoAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mGsmCellId.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint32_t const & currentValue = mGsmCellId.InternalValue();
      temp.setNumber(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->gsmCellId_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mGsmLocationAreaCode.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mGsmLocationAreaCode.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->gsmLocationAreaCode_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mMcc.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mMcc.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->mcc_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mMnc.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mMnc.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->mnc_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkLocationInfo::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkLocationInfo::TraceDictionary(JSTracer* trc)
{
}

void
MozStkLocationInfo::operator=(const MozStkLocationInfo& aOther)
{
  if (aOther.mGsmCellId.WasPassed()) {
    mGsmCellId.Construct();
    mGsmCellId.Value() = aOther.mGsmCellId.Value();
  } else {
    mGsmCellId.Reset();
  }
  if (aOther.mGsmLocationAreaCode.WasPassed()) {
    mGsmLocationAreaCode.Construct();
    mGsmLocationAreaCode.Value() = aOther.mGsmLocationAreaCode.Value();
  } else {
    mGsmLocationAreaCode.Reset();
  }
  if (aOther.mMcc.WasPassed()) {
    mMcc.Construct();
    mMcc.Value() = aOther.mMcc.Value();
  } else {
    mMcc.Reset();
  }
  if (aOther.mMnc.WasPassed()) {
    mMnc.Construct();
    mMnc.Value() = aOther.mMnc.Value();
  } else {
    mMnc.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkProvideLocalInfo::MozStkProvideLocalInfo()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkProvideLocalInfo::InitIds(JSContext* cx, MozStkProvideLocalInfoAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->localInfoType_id.init(cx, "localInfoType")) {
    return false;
  }
  return true;
}

bool
MozStkProvideLocalInfo::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkProvideLocalInfoAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkProvideLocalInfoAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->localInfoType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mLocalInfoType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mLocalInfoType.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkProvideLocalInfo::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkProvideLocalInfo::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkProvideLocalInfoAtoms* atomsCache = GetAtomCache<MozStkProvideLocalInfoAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mLocalInfoType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mLocalInfoType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->localInfoType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkProvideLocalInfo::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkProvideLocalInfo::TraceDictionary(JSTracer* trc)
{
}

void
MozStkProvideLocalInfo::operator=(const MozStkProvideLocalInfo& aOther)
{
  if (aOther.mLocalInfoType.WasPassed()) {
    mLocalInfoType.Construct();
    mLocalInfoType.Value() = aOther.mLocalInfoType.Value();
  } else {
    mLocalInfoType.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkSetUpEventList::MozStkSetUpEventList()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkSetUpEventList::InitIds(JSContext* cx, MozStkSetUpEventListAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->eventList_id.init(cx, "eventList")) {
    return false;
  }
  return true;
}

bool
MozStkSetUpEventList::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkSetUpEventListAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkSetUpEventListAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->eventList_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEventList.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'eventList' member of MozStkSetUpEventList");
        return false;
      }
      Sequence<uint16_t> &arr = (mEventList.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        uint16_t* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        uint16_t& slot = *slotPtr;
        if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp, &slot)) {
          return false;
        }
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'eventList' member of MozStkSetUpEventList");
      return false;
    }
  }
  return true;
}

bool
MozStkSetUpEventList::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkSetUpEventList::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkSetUpEventListAtoms* atomsCache = GetAtomCache<MozStkSetUpEventListAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mEventList.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Sequence<uint16_t> const & currentValue = mEventList.InternalValue();

      uint32_t length = currentValue.Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            tmp.setInt32(int32_t(currentValue[sequenceIdx0]));
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      temp.setObject(*returnArray);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->eventList_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkSetUpEventList::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkSetUpEventList::TraceDictionary(JSTracer* trc)
{
}

void
MozStkSetUpEventList::operator=(const MozStkSetUpEventList& aOther)
{
  if (aOther.mEventList.WasPassed()) {
    mEventList.Construct();
    mEventList.Value() = aOther.mEventList.Value();
  } else {
    mEventList.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkTimer::MozStkTimer()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkTimer::InitIds(JSContext* cx, MozStkTimerAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->timerValue_id.init(cx, "timerValue") ||
      !atomsCache->timerId_id.init(cx, "timerId") ||
      !atomsCache->timerAction_id.init(cx, "timerAction")) {
    return false;
  }
  return true;
}

bool
MozStkTimer::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkTimerAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkTimerAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->timerAction_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTimerAction.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mTimerAction.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->timerId_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTimerId.Construct();
    if (!ValueToPrimitive<uint8_t, eDefault>(cx, temp.ref(), &(mTimerId.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->timerValue_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTimerValue.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, temp.ref(), &(mTimerValue.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkTimer::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkTimer::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkTimerAtoms* atomsCache = GetAtomCache<MozStkTimerAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mTimerAction.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mTimerAction.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->timerAction_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTimerId.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint8_t const & currentValue = mTimerId.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->timerId_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTimerValue.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint32_t const & currentValue = mTimerValue.InternalValue();
      temp.setNumber(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->timerValue_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkTimer::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkTimer::TraceDictionary(JSTracer* trc)
{
}

void
MozStkTimer::operator=(const MozStkTimer& aOther)
{
  if (aOther.mTimerAction.WasPassed()) {
    mTimerAction.Construct();
    mTimerAction.Value() = aOther.mTimerAction.Value();
  } else {
    mTimerAction.Reset();
  }
  if (aOther.mTimerId.WasPassed()) {
    mTimerId.Construct();
    mTimerId.Value() = aOther.mTimerId.Value();
  } else {
    mTimerId.Reset();
  }
  if (aOther.mTimerValue.WasPassed()) {
    mTimerValue.Construct();
    mTimerValue.Value() = aOther.mTimerValue.Value();
  } else {
    mTimerValue.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkIconContainer::MozStkIconContainer()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkIconContainer::InitIds(JSContext* cx, MozStkIconContainerAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->icons_id.init(cx, "icons") ||
      !atomsCache->iconSelfExplanatory_id.init(cx, "iconSelfExplanatory")) {
    return false;
  }
  return true;
}

bool
MozStkIconContainer::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkIconContainerAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkIconContainerAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->iconSelfExplanatory_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIconSelfExplanatory.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIconSelfExplanatory.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->icons_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIcons.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'icons' member of MozStkIconContainer");
        return false;
      }
      Sequence<MozStkIcon> &arr = (mIcons.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        MozStkIcon* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        MozStkIcon& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'icons' member of MozStkIconContainer", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'icons' member of MozStkIconContainer");
      return false;
    }
  }
  return true;
}

bool
MozStkIconContainer::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkIconContainer::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkIconContainerAtoms* atomsCache = GetAtomCache<MozStkIconContainerAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mIconSelfExplanatory.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIconSelfExplanatory.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->iconSelfExplanatory_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIcons.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Sequence<MozStkIcon> const & currentValue = mIcons.InternalValue();

      uint32_t length = currentValue.Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!currentValue[sequenceIdx0].ToObjectInternal(cx, &tmp)) {
              return false;
            }
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      temp.setObject(*returnArray);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->icons_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkIconContainer::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkIconContainer::TraceDictionary(JSTracer* trc)
{
}

void
MozStkIconContainer::operator=(const MozStkIconContainer& aOther)
{
  if (aOther.mIconSelfExplanatory.WasPassed()) {
    mIconSelfExplanatory.Construct();
    mIconSelfExplanatory.Value() = aOther.mIconSelfExplanatory.Value();
  } else {
    mIconSelfExplanatory.Reset();
  }
  if (aOther.mIcons.WasPassed()) {
    mIcons.Construct();
    mIcons.Value() = aOther.mIcons.Value();
  } else {
    mIcons.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkLocalInfo::MozStkLocalInfo()
  : mLocationInfo(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
MozStkLocalInfo::InitIds(JSContext* cx, MozStkLocalInfoAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->locationInfo_id.init(cx, "locationInfo") ||
      !atomsCache->language_id.init(cx, "language") ||
      !atomsCache->imei_id.init(cx, "imei") ||
      !atomsCache->date_id.init(cx, "date")) {
    return false;
  }
  return true;
}

bool
MozStkLocalInfo::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkLocalInfoAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkLocalInfoAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->date_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mDate.Construct();
    if (temp.ref().isObject()) {
      JS::Rooted<JSObject*> possibleDateObject(cx, &temp.ref().toObject());
      if (!JS_ObjectIsDate(cx, possibleDateObject) ||
          !(mDate.Value()).SetTimeStamp(cx, possibleDateObject)) {
        ThrowErrorMessage(cx, MSG_NOT_DATE, "'date' member of MozStkLocalInfo");
        return false;
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_DATE, "'date' member of MozStkLocalInfo");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->imei_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mImei.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mImei.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->language_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mLanguage.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mLanguage.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->locationInfo_id, temp.ptr())) {
    return false;
  }
  if (!mLocationInfo.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'locationInfo' member of MozStkLocalInfo", passedToJSImpl)) {
    return false;
  }
  return true;
}

bool
MozStkLocalInfo::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkLocalInfo::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkLocalInfoAtoms* atomsCache = GetAtomCache<MozStkLocalInfoAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mDate.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Date const & currentValue = mDate.InternalValue();
      if (!currentValue.ToDateObject(cx, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->date_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mImei.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mImei.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->imei_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mLanguage.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mLanguage.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->language_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkLocationInfo const & currentValue = mLocationInfo;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->locationInfo_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MozStkLocalInfo::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkLocalInfo::TraceDictionary(JSTracer* trc)
{
}

namespace binding_detail {
} // namespace binding_detail



MozStkLocationEvent::MozStkLocationEvent()
  : mLocationInfo(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkLocationEvent::InitIds(JSContext* cx, MozStkLocationEventAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->locationStatus_id.init(cx, "locationStatus") ||
      !atomsCache->locationInfo_id.init(cx, "locationInfo") ||
      !atomsCache->eventType_id.init(cx, "eventType")) {
    return false;
  }
  return true;
}

bool
MozStkLocationEvent::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkLocationEventAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkLocationEventAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->eventType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEventType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mEventType.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->locationInfo_id, temp.ptr())) {
    return false;
  }
  if (!mLocationInfo.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'locationInfo' member of MozStkLocationEvent", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->locationStatus_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mLocationStatus.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mLocationStatus.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkLocationEvent::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkLocationEvent::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkLocationEventAtoms* atomsCache = GetAtomCache<MozStkLocationEventAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mEventType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mEventType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->eventType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkLocationInfo const & currentValue = mLocationInfo;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->locationInfo_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mLocationStatus.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mLocationStatus.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->locationStatus_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkLocationEvent::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkLocationEvent::TraceDictionary(JSTracer* trc)
{
}

void
MozStkLocationEvent::operator=(const MozStkLocationEvent& aOther)
{
  if (aOther.mEventType.WasPassed()) {
    mEventType.Construct();
    mEventType.Value() = aOther.mEventType.Value();
  } else {
    mEventType.Reset();
  }
  mLocationInfo = aOther.mLocationInfo;
  if (aOther.mLocationStatus.WasPassed()) {
    mLocationStatus.Construct();
    mLocationStatus.Value() = aOther.mLocationStatus.Value();
  } else {
    mLocationStatus.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkBipMessage::MozStkBipMessage()
  : MozStkIconContainer(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkBipMessage::InitIds(JSContext* cx, MozStkBipMessageAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->text_id.init(cx, "text")) {
    return false;
  }
  return true;
}

bool
MozStkBipMessage::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkBipMessageAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkBipMessageAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!MozStkIconContainer::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->text_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mText.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mText.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkBipMessage::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkBipMessage::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkBipMessageAtoms* atomsCache = GetAtomCache<MozStkBipMessageAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!MozStkIconContainer::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  if (mText.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mText.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->text_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkBipMessage::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkBipMessage::TraceDictionary(JSTracer* trc)
{
  MozStkIconContainer::TraceDictionary(trc);
}

void
MozStkBipMessage::operator=(const MozStkBipMessage& aOther)
{
  MozStkIconContainer::operator=(aOther);
  if (aOther.mText.WasPassed()) {
    mText.Construct();
    mText.Value() = aOther.mText.Value();
  } else {
    mText.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkInput::MozStkInput()
  : MozStkIconContainer(FastDictionaryInitializer()),
    mDuration(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkInput::InitIds(JSContext* cx, MozStkInputAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->text_id.init(cx, "text") ||
      !atomsCache->minLength_id.init(cx, "minLength") ||
      !atomsCache->maxLength_id.init(cx, "maxLength") ||
      !atomsCache->isYesNoRequested_id.init(cx, "isYesNoRequested") ||
      !atomsCache->isUCS2_id.init(cx, "isUCS2") ||
      !atomsCache->isPacked_id.init(cx, "isPacked") ||
      !atomsCache->isHelpAvailable_id.init(cx, "isHelpAvailable") ||
      !atomsCache->isAlphabet_id.init(cx, "isAlphabet") ||
      !atomsCache->hideInput_id.init(cx, "hideInput") ||
      !atomsCache->duration_id.init(cx, "duration") ||
      !atomsCache->defaultText_id.init(cx, "defaultText")) {
    return false;
  }
  return true;
}

bool
MozStkInput::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkInputAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkInputAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!MozStkIconContainer::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->defaultText_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mDefaultText.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mDefaultText.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->duration_id, temp.ptr())) {
    return false;
  }
  if (!mDuration.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'duration' member of MozStkInput", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->hideInput_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mHideInput.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mHideInput.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isAlphabet_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsAlphabet.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsAlphabet.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isHelpAvailable_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsHelpAvailable.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsHelpAvailable.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isPacked_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsPacked.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsPacked.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isUCS2_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsUCS2.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsUCS2.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isYesNoRequested_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsYesNoRequested.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsYesNoRequested.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->maxLength_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mMaxLength.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mMaxLength.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->minLength_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mMinLength.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mMinLength.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->text_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mText.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mText.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkInput::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkInput::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkInputAtoms* atomsCache = GetAtomCache<MozStkInputAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!MozStkIconContainer::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  if (mDefaultText.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mDefaultText.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->defaultText_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkDuration const & currentValue = mDuration;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->duration_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mHideInput.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mHideInput.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->hideInput_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsAlphabet.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsAlphabet.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isAlphabet_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsHelpAvailable.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsHelpAvailable.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isHelpAvailable_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsPacked.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsPacked.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isPacked_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsUCS2.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsUCS2.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isUCS2_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsYesNoRequested.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsYesNoRequested.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isYesNoRequested_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mMaxLength.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mMaxLength.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->maxLength_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mMinLength.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mMinLength.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->minLength_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mText.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mText.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->text_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkInput::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkInput::TraceDictionary(JSTracer* trc)
{
  MozStkIconContainer::TraceDictionary(trc);
}

void
MozStkInput::operator=(const MozStkInput& aOther)
{
  MozStkIconContainer::operator=(aOther);
  if (aOther.mDefaultText.WasPassed()) {
    mDefaultText.Construct();
    mDefaultText.Value() = aOther.mDefaultText.Value();
  } else {
    mDefaultText.Reset();
  }
  mDuration = aOther.mDuration;
  if (aOther.mHideInput.WasPassed()) {
    mHideInput.Construct();
    mHideInput.Value() = aOther.mHideInput.Value();
  } else {
    mHideInput.Reset();
  }
  if (aOther.mIsAlphabet.WasPassed()) {
    mIsAlphabet.Construct();
    mIsAlphabet.Value() = aOther.mIsAlphabet.Value();
  } else {
    mIsAlphabet.Reset();
  }
  if (aOther.mIsHelpAvailable.WasPassed()) {
    mIsHelpAvailable.Construct();
    mIsHelpAvailable.Value() = aOther.mIsHelpAvailable.Value();
  } else {
    mIsHelpAvailable.Reset();
  }
  if (aOther.mIsPacked.WasPassed()) {
    mIsPacked.Construct();
    mIsPacked.Value() = aOther.mIsPacked.Value();
  } else {
    mIsPacked.Reset();
  }
  if (aOther.mIsUCS2.WasPassed()) {
    mIsUCS2.Construct();
    mIsUCS2.Value() = aOther.mIsUCS2.Value();
  } else {
    mIsUCS2.Reset();
  }
  if (aOther.mIsYesNoRequested.WasPassed()) {
    mIsYesNoRequested.Construct();
    mIsYesNoRequested.Value() = aOther.mIsYesNoRequested.Value();
  } else {
    mIsYesNoRequested.Reset();
  }
  if (aOther.mMaxLength.WasPassed()) {
    mMaxLength.Construct();
    mMaxLength.Value() = aOther.mMaxLength.Value();
  } else {
    mMaxLength.Reset();
  }
  if (aOther.mMinLength.WasPassed()) {
    mMinLength.Construct();
    mMinLength.Value() = aOther.mMinLength.Value();
  } else {
    mMinLength.Reset();
  }
  if (aOther.mText.WasPassed()) {
    mText.Construct();
    mText.Value() = aOther.mText.Value();
  } else {
    mText.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkItem::MozStkItem()
  : MozStkIconContainer(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkItem::InitIds(JSContext* cx, MozStkItemAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->text_id.init(cx, "text") ||
      !atomsCache->identifier_id.init(cx, "identifier")) {
    return false;
  }
  return true;
}

bool
MozStkItem::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkItemAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkItemAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!MozStkIconContainer::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->identifier_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIdentifier.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mIdentifier.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->text_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mText.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mText.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkItem::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkItem::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkItemAtoms* atomsCache = GetAtomCache<MozStkItemAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!MozStkIconContainer::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  if (mIdentifier.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mIdentifier.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->identifier_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mText.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mText.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->text_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkItem::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkItem::TraceDictionary(JSTracer* trc)
{
  MozStkIconContainer::TraceDictionary(trc);
}

void
MozStkItem::operator=(const MozStkItem& aOther)
{
  MozStkIconContainer::operator=(aOther);
  if (aOther.mIdentifier.WasPassed()) {
    mIdentifier.Construct();
    mIdentifier.Value() = aOther.mIdentifier.Value();
  } else {
    mIdentifier.Reset();
  }
  if (aOther.mText.WasPassed()) {
    mText.Construct();
    mText.Value() = aOther.mText.Value();
  } else {
    mText.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkPlayTone::MozStkPlayTone()
  : MozStkIconContainer(FastDictionaryInitializer()),
    mDuration(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkPlayTone::InitIds(JSContext* cx, MozStkPlayToneAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->tone_id.init(cx, "tone") ||
      !atomsCache->text_id.init(cx, "text") ||
      !atomsCache->isVibrate_id.init(cx, "isVibrate") ||
      !atomsCache->duration_id.init(cx, "duration")) {
    return false;
  }
  return true;
}

bool
MozStkPlayTone::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkPlayToneAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkPlayToneAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!MozStkIconContainer::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->duration_id, temp.ptr())) {
    return false;
  }
  if (!mDuration.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'duration' member of MozStkPlayTone", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isVibrate_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsVibrate.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsVibrate.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->text_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mText.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mText.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->tone_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTone.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mTone.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkPlayTone::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkPlayTone::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkPlayToneAtoms* atomsCache = GetAtomCache<MozStkPlayToneAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!MozStkIconContainer::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkDuration const & currentValue = mDuration;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->duration_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mIsVibrate.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsVibrate.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isVibrate_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mText.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mText.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->text_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTone.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mTone.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->tone_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkPlayTone::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkPlayTone::TraceDictionary(JSTracer* trc)
{
  MozStkIconContainer::TraceDictionary(trc);
}

void
MozStkPlayTone::operator=(const MozStkPlayTone& aOther)
{
  MozStkIconContainer::operator=(aOther);
  mDuration = aOther.mDuration;
  if (aOther.mIsVibrate.WasPassed()) {
    mIsVibrate.Construct();
    mIsVibrate.Value() = aOther.mIsVibrate.Value();
  } else {
    mIsVibrate.Reset();
  }
  if (aOther.mText.WasPassed()) {
    mText.Construct();
    mText.Value() = aOther.mText.Value();
  } else {
    mText.Reset();
  }
  if (aOther.mTone.WasPassed()) {
    mTone.Construct();
    mTone.Value() = aOther.mTone.Value();
  } else {
    mTone.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkResponse::MozStkResponse()
  : mLocalInfo(FastDictionaryInitializer()),
    mTimer(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}


bool
MozStkResponse::InitIds(JSContext* cx, MozStkResponseAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->timer_id.init(cx, "timer") ||
      !atomsCache->resultCode_id.init(cx, "resultCode") ||
      !atomsCache->localInfo_id.init(cx, "localInfo") ||
      !atomsCache->itemIdentifier_id.init(cx, "itemIdentifier") ||
      !atomsCache->isYesNo_id.init(cx, "isYesNo") ||
      !atomsCache->input_id.init(cx, "input") ||
      !atomsCache->hasConfirmed_id.init(cx, "hasConfirmed") ||
      !atomsCache->additionalInformation_id.init(cx, "additionalInformation")) {
    return false;
  }
  return true;
}

bool
MozStkResponse::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkResponseAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkResponseAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->additionalInformation_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mAdditionalInformation.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mAdditionalInformation.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->hasConfirmed_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mHasConfirmed.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mHasConfirmed.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->input_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mInput.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mInput.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isYesNo_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsYesNo.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsYesNo.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->itemIdentifier_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mItemIdentifier.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mItemIdentifier.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->localInfo_id, temp.ptr())) {
    return false;
  }
  if (!mLocalInfo.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'localInfo' member of MozStkResponse", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->resultCode_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mResultCode.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mResultCode.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->timer_id, temp.ptr())) {
    return false;
  }
  if (!mTimer.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'timer' member of MozStkResponse", passedToJSImpl)) {
    return false;
  }
  return true;
}

bool
MozStkResponse::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkResponse::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkResponseAtoms* atomsCache = GetAtomCache<MozStkResponseAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mAdditionalInformation.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mAdditionalInformation.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->additionalInformation_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mHasConfirmed.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mHasConfirmed.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->hasConfirmed_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mInput.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mInput.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->input_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsYesNo.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsYesNo.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isYesNo_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mItemIdentifier.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mItemIdentifier.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->itemIdentifier_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkLocalInfo const & currentValue = mLocalInfo;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->localInfo_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mResultCode.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mResultCode.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->resultCode_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkTimer const & currentValue = mTimer;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->timer_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MozStkResponse::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkResponse::TraceDictionary(JSTracer* trc)
{
}

namespace binding_detail {
} // namespace binding_detail



MozStkTextMessage::MozStkTextMessage()
  : MozStkIconContainer(FastDictionaryInitializer()),
    mDuration(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkTextMessage::InitIds(JSContext* cx, MozStkTextMessageAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->userClear_id.init(cx, "userClear") ||
      !atomsCache->text_id.init(cx, "text") ||
      !atomsCache->responseNeeded_id.init(cx, "responseNeeded") ||
      !atomsCache->isHighPriority_id.init(cx, "isHighPriority") ||
      !atomsCache->duration_id.init(cx, "duration")) {
    return false;
  }
  return true;
}

bool
MozStkTextMessage::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkTextMessageAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkTextMessageAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!MozStkIconContainer::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->duration_id, temp.ptr())) {
    return false;
  }
  if (!mDuration.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'duration' member of MozStkTextMessage", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isHighPriority_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsHighPriority.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsHighPriority.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->responseNeeded_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mResponseNeeded.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mResponseNeeded.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->text_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mText.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mText.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->userClear_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mUserClear.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mUserClear.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkTextMessage::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkTextMessage::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkTextMessageAtoms* atomsCache = GetAtomCache<MozStkTextMessageAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!MozStkIconContainer::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkDuration const & currentValue = mDuration;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->duration_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mIsHighPriority.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsHighPriority.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isHighPriority_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mResponseNeeded.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mResponseNeeded.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->responseNeeded_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mText.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mText.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->text_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mUserClear.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mUserClear.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->userClear_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkTextMessage::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkTextMessage::TraceDictionary(JSTracer* trc)
{
  MozStkIconContainer::TraceDictionary(trc);
}

void
MozStkTextMessage::operator=(const MozStkTextMessage& aOther)
{
  MozStkIconContainer::operator=(aOther);
  mDuration = aOther.mDuration;
  if (aOther.mIsHighPriority.WasPassed()) {
    mIsHighPriority.Construct();
    mIsHighPriority.Value() = aOther.mIsHighPriority.Value();
  } else {
    mIsHighPriority.Reset();
  }
  if (aOther.mResponseNeeded.WasPassed()) {
    mResponseNeeded.Construct();
    mResponseNeeded.Value() = aOther.mResponseNeeded.Value();
  } else {
    mResponseNeeded.Reset();
  }
  if (aOther.mText.WasPassed()) {
    mText.Construct();
    mText.Value() = aOther.mText.Value();
  } else {
    mText.Reset();
  }
  if (aOther.mUserClear.WasPassed()) {
    mUserClear.Construct();
    mUserClear.Value() = aOther.mUserClear.Value();
  } else {
    mUserClear.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkBrowserSetting::MozStkBrowserSetting()
  : mConfirmMessage(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkBrowserSetting::InitIds(JSContext* cx, MozStkBrowserSettingAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->url_id.init(cx, "url") ||
      !atomsCache->mode_id.init(cx, "mode") ||
      !atomsCache->confirmMessage_id.init(cx, "confirmMessage")) {
    return false;
  }
  return true;
}

bool
MozStkBrowserSetting::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkBrowserSettingAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkBrowserSettingAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->confirmMessage_id, temp.ptr())) {
    return false;
  }
  if (!mConfirmMessage.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'confirmMessage' member of MozStkBrowserSetting", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->mode_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mMode.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mMode.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->url_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mUrl.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mUrl.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkBrowserSetting::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkBrowserSetting::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkBrowserSettingAtoms* atomsCache = GetAtomCache<MozStkBrowserSettingAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkTextMessage const & currentValue = mConfirmMessage;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->confirmMessage_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  if (mMode.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mMode.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->mode_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mUrl.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mUrl.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->url_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkBrowserSetting::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkBrowserSetting::TraceDictionary(JSTracer* trc)
{
}

void
MozStkBrowserSetting::operator=(const MozStkBrowserSetting& aOther)
{
  mConfirmMessage = aOther.mConfirmMessage;
  if (aOther.mMode.WasPassed()) {
    mMode.Construct();
    mMode.Value() = aOther.mMode.Value();
  } else {
    mMode.Reset();
  }
  if (aOther.mUrl.WasPassed()) {
    mUrl.Construct();
    mUrl.Value() = aOther.mUrl.Value();
  } else {
    mUrl.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkMenu::MozStkMenu()
  : MozStkIconContainer(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkMenu::InitIds(JSContext* cx, MozStkMenuAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->title_id.init(cx, "title") ||
      !atomsCache->presentationType_id.init(cx, "presentationType") ||
      !atomsCache->nextActionList_id.init(cx, "nextActionList") ||
      !atomsCache->items_id.init(cx, "items") ||
      !atomsCache->isHelpAvailable_id.init(cx, "isHelpAvailable") ||
      !atomsCache->defaultItem_id.init(cx, "defaultItem")) {
    return false;
  }
  return true;
}

bool
MozStkMenu::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkMenuAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkMenuAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  // Per spec, we init the parent's members first
  if (!MozStkIconContainer::Init(cx, val)) {
    return false;
  }
  MOZ_ASSERT(IsConvertibleToDictionary(cx, val));

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->defaultItem_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mDefaultItem.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mDefaultItem.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->isHelpAvailable_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mIsHelpAvailable.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mIsHelpAvailable.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->items_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mItems.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'items' member of MozStkMenu");
        return false;
      }
      Sequence<MozStkItem> &arr = (mItems.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        MozStkItem* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        MozStkItem& slot = *slotPtr;
        if (!slot.Init(cx, temp, "Element of 'items' member of MozStkMenu", passedToJSImpl)) {
          return false;
        }
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'items' member of MozStkMenu");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->nextActionList_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mNextActionList.Construct();
    if (temp.ref().isObject()) {
      JS::ForOfIterator iter(cx);
      if (!iter.init(temp.ref(), JS::ForOfIterator::AllowNonIterable)) {
        return false;
      }
      if (!iter.valueIsIterable()) {
        ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'nextActionList' member of MozStkMenu");
        return false;
      }
      Sequence<uint16_t> &arr = (mNextActionList.Value());
      JS::Rooted<JS::Value> temp(cx);
      while (true) {
        bool done;
        if (!iter.next(&temp, &done)) {
          return false;
        }
        if (done) {
          break;
        }
        uint16_t* slotPtr = arr.AppendElement(mozilla::fallible);
        if (!slotPtr) {
          JS_ReportOutOfMemory(cx);
          return false;
        }
        uint16_t& slot = *slotPtr;
        if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp, &slot)) {
          return false;
        }
      }
    } else {
      ThrowErrorMessage(cx, MSG_NOT_SEQUENCE, "'nextActionList' member of MozStkMenu");
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->presentationType_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mPresentationType.Construct();
    if (!ValueToPrimitive<uint16_t, eDefault>(cx, temp.ref(), &(mPresentationType.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->title_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mTitle.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mTitle.Value()))) {
      return false;
    }
  }
  return true;
}

bool
MozStkMenu::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkMenu::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkMenuAtoms* atomsCache = GetAtomCache<MozStkMenuAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  // Per spec, we define the parent's members first
  if (!MozStkIconContainer::ToObjectInternal(cx, rval)) {
    return false;
  }
  JS::Rooted<JSObject*> obj(cx, &rval.toObject());

  if (mDefaultItem.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mDefaultItem.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->defaultItem_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mIsHelpAvailable.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mIsHelpAvailable.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->isHelpAvailable_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mItems.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Sequence<MozStkItem> const & currentValue = mItems.InternalValue();

      uint32_t length = currentValue.Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            if (!currentValue[sequenceIdx0].ToObjectInternal(cx, &tmp)) {
              return false;
            }
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      temp.setObject(*returnArray);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->items_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mNextActionList.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Sequence<uint16_t> const & currentValue = mNextActionList.InternalValue();

      uint32_t length = currentValue.Length();
      JS::Rooted<JSObject*> returnArray(cx, JS_NewArrayObject(cx, length));
      if (!returnArray) {
        return false;
      }
      // Scope for 'tmp'
      {
        JS::Rooted<JS::Value> tmp(cx);
        for (uint32_t sequenceIdx0 = 0; sequenceIdx0 < length; ++sequenceIdx0) {
          // Control block to let us common up the JS_DefineElement calls when there
          // are different ways to succeed at wrapping the object.
          do {
            tmp.setInt32(int32_t(currentValue[sequenceIdx0]));
            break;
          } while (0);
          if (!JS_DefineElement(cx, returnArray, sequenceIdx0, tmp,
                                JSPROP_ENUMERATE)) {
            return false;
          }
        }
      }
      temp.setObject(*returnArray);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->nextActionList_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mPresentationType.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint16_t const & currentValue = mPresentationType.InternalValue();
      temp.setInt32(int32_t(currentValue));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->presentationType_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mTitle.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mTitle.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->title_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
MozStkMenu::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkMenu::TraceDictionary(JSTracer* trc)
{
  MozStkIconContainer::TraceDictionary(trc);
}

void
MozStkMenu::operator=(const MozStkMenu& aOther)
{
  MozStkIconContainer::operator=(aOther);
  if (aOther.mDefaultItem.WasPassed()) {
    mDefaultItem.Construct();
    mDefaultItem.Value() = aOther.mDefaultItem.Value();
  } else {
    mDefaultItem.Reset();
  }
  if (aOther.mIsHelpAvailable.WasPassed()) {
    mIsHelpAvailable.Construct();
    mIsHelpAvailable.Value() = aOther.mIsHelpAvailable.Value();
  } else {
    mIsHelpAvailable.Reset();
  }
  if (aOther.mItems.WasPassed()) {
    mItems.Construct();
    mItems.Value() = aOther.mItems.Value();
  } else {
    mItems.Reset();
  }
  if (aOther.mNextActionList.WasPassed()) {
    mNextActionList.Construct();
    mNextActionList.Value() = aOther.mNextActionList.Value();
  } else {
    mNextActionList.Reset();
  }
  if (aOther.mPresentationType.WasPassed()) {
    mPresentationType.Construct();
    mPresentationType.Value() = aOther.mPresentationType.Value();
  } else {
    mPresentationType.Reset();
  }
  if (aOther.mTitle.WasPassed()) {
    mTitle.Construct();
    mTitle.Value() = aOther.mTitle.Value();
  } else {
    mTitle.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail



MozStkSetUpCall::MozStkSetUpCall()
  : mCallMessage(FastDictionaryInitializer()),
    mConfirmMessage(FastDictionaryInitializer()),
    mDuration(FastDictionaryInitializer())
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MozStkSetUpCall::InitIds(JSContext* cx, MozStkSetUpCallAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->duration_id.init(cx, "duration") ||
      !atomsCache->confirmMessage_id.init(cx, "confirmMessage") ||
      !atomsCache->callMessage_id.init(cx, "callMessage") ||
      !atomsCache->address_id.init(cx, "address")) {
    return false;
  }
  return true;
}

bool
MozStkSetUpCall::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MozStkSetUpCallAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MozStkSetUpCallAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->address_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mAddress.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eStringify, eStringify, (mAddress.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->callMessage_id, temp.ptr())) {
    return false;
  }
  if (!mCallMessage.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'callMessage' member of MozStkSetUpCall", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->confirmMessage_id, temp.ptr())) {
    return false;
  }
  if (!mConfirmMessage.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'confirmMessage' member of MozStkSetUpCall", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->duration_id, temp.ptr())) {
    return false;
  }
  if (!mDuration.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'duration' member of MozStkSetUpCall", passedToJSImpl)) {
    return false;
  }
  return true;
}

bool
MozStkSetUpCall::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MozStkSetUpCall::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MozStkSetUpCallAtoms* atomsCache = GetAtomCache<MozStkSetUpCallAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mAddress.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mAddress.InternalValue();
      if (!xpc::NonVoidStringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->address_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkTextMessage const & currentValue = mCallMessage;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->callMessage_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkTextMessage const & currentValue = mConfirmMessage;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->confirmMessage_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MozStkDuration const & currentValue = mDuration;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->duration_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MozStkSetUpCall::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MozStkSetUpCall::TraceDictionary(JSTracer* trc)
{
}

void
MozStkSetUpCall::operator=(const MozStkSetUpCall& aOther)
{
  if (aOther.mAddress.WasPassed()) {
    mAddress.Construct();
    mAddress.Value() = aOther.mAddress.Value();
  } else {
    mAddress.Reset();
  }
  mCallMessage = aOther.mCallMessage;
  mConfirmMessage = aOther.mConfirmMessage;
  mDuration = aOther.mDuration;
}

namespace binding_detail {
} // namespace binding_detail


namespace MozStkCommandEventBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<EventBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
get_command(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MozStkCommandEvent* self, JSJitGetterCallArgs args)
{
  JS::Rooted<JS::Value> result(cx);
  self->GetCommand(cx, &result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  JS::ExposeValueToActiveJS(result);
  args.rval().set(result);
  if (!MaybeWrapValue(cx, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo command_getterinfo = {
  { (JSJitGetterOp)get_command },
  prototypes::id::MozStkCommandEvent,
  PrototypeTraits<prototypes::id::MozStkCommandEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_isTrusted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::MozStkCommandEvent* self, JSJitGetterCallArgs args)
{
  bool result(self->IsTrusted());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isTrusted_getterinfo = {
  { (JSJitGetterOp)get_isTrusted },
  prototypes::id::MozStkCommandEvent,
  PrototypeTraits<prototypes::id::MozStkCommandEvent>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasDOMSets, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  true,  /* isMovable.  Not relevant for setters. */
  true, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::MozStkCommandEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MozStkCommandEvent>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::MozStkCommandEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MozStkCommandEvent>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::MozStkCommandEvent>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::MozStkCommandEvent>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::MozStkCommandEvent* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::MozStkCommandEvent>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const char* const anypermissions_0[] = {
  "mobileconnection",
  nullptr
};

static const JSPropertySpec sAttributes_specs[] = {
  { "command", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &command_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, nullptr }
};

static jsid sAttributes_ids[2];

static const JSPropertySpec sUnforgeableAttributes_specs[] = {
  { "isTrusted", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_PERMANENT, { { GenericBindingGetter, &isTrusted_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sUnforgeableAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sUnforgeableAttributes_specs[0] },
  { false, nullptr }
};

static jsid sUnforgeableAttributes_ids[2];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  sUnforgeableAttributes, sUnforgeableAttributes_ids, sUnforgeableAttributes_specs,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::MozStkCommandEvent,
  constructors::id::MozStkCommandEvent,
  EventBinding::sNativePropertyHooks
} };

static bool
_constructor(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  JS::Rooted<JSObject*> obj(cx, &args.callee());
  bool mayInvoke = args.isConstructing();
#ifdef RELEASE_BUILD
  mayInvoke = mayInvoke || nsContentUtils::ThreadsafeIsCallerChrome();
#endif // RELEASE_BUILD
  if (!mayInvoke) {
    // XXXbz wish I could get the name from the callee instead of
    // Adding more relocations
    return ThrowConstructorWithoutNew(cx, "MozStkCommandEvent");
  }
  JS::Rooted<JSObject*> desiredProto(cx);
  if (!GetDesiredProto(cx, args, &desiredProto)) {
    return false;
  }

  if (MOZ_UNLIKELY(args.length() < 1)) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "MozStkCommandEvent");
  }
  GlobalObject global(cx, obj);
  if (global.Failed()) {
    return false;
  }

  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  RootedDictionary<binding_detail::FastMozStkCommandEventInit> arg1(cx);
  if (!arg1.Init(cx, (args.hasDefined(1)) ? args[1] : JS::NullHandleValue, "Argument 2 of MozStkCommandEvent.constructor", false)) {
    return false;
  }
  Maybe<JSAutoCompartment> ac;
  if (objIsXray) {
    obj = js::CheckedUnwrap(obj);
    if (!obj) {
      return false;
    }
    ac.emplace(cx, obj);
    if (!JS_WrapObject(cx, &desiredProto)) {
      return false;
    }
    if (!JS_WrapValue(cx, JS::MutableHandle<JS::Value>::fromMarkedLocation(&arg1.mCommand))) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::MozStkCommandEvent>(mozilla::dom::MozStkCommandEvent::Constructor(global, NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailed(cx, rv);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!GetOrCreateDOMReflector(cx, result, args.rval(), desiredProto)) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    _constructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    _constructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function MozStkCommandEvent() {\n    [native code]\n}",
  prototypes::id::MozStkCommandEvent,
  PrototypeTraits<prototypes::id::MozStkCommandEvent>::Depth,
  EventBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "MozStkCommandEventPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE + 1 /* slot for the JSObject holding the unforgeable properties */),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object MozStkCommandEventPrototype]",
  prototypes::id::MozStkCommandEvent,
  PrototypeTraits<prototypes::id::MozStkCommandEvent>::Depth,
  EventBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.icc.enabled") &&
         IsInCertifiedApp(aCx, aObj) &&
         CheckAnyPermissions(aCx, aObj, anypermissions_0);
}

static const DOMJSClass Class = {
  { "MozStkCommandEvent",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::Event, prototypes::id::MozStkCommandEvent, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::MozStkCommandEvent >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::MozStkCommandEvent>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::MozStkCommandEvent>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::MozStkCommandEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::MozStkCommandEvent*>(aObject) ==
             reinterpret_cast<mozilla::dom::MozStkCommandEvent*>(aObject),
             "Multiple inheritance for mozilla::dom::MozStkCommandEvent is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::Event*>(aObject) ==
             reinterpret_cast<mozilla::dom::Event*>(aObject),
             "Multiple inheritance for mozilla::dom::Event is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::MozStkCommandEvent> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);

  // Important: do unforgeable property setup after we have handed
  // over ownership of the C++ object to obj as needed, so that if
  // we fail and it ends up GCed it won't have problems in the
  // finalizer trying to drop its ownership of the C++ object.
  JS::Rooted<JSObject*> unforgeableHolder(aCx,
    &js::GetReservedSlot(canonicalProto, DOM_INTERFACE_PROTO_SLOTS_BASE).toObject());
  if (!JS_InitializePropertiesFromCompatibleNativeObject(aCx, aReflector, unforgeableHolder)) {
    aCache->ReleaseWrapper(aObject);
    aCache->ClearWrapper();
    return false;
  }
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sUnforgeableAttributes, sUnforgeableAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::MozStkCommandEvent);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::MozStkCommandEvent);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 1, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "MozStkCommandEvent", aDefineOnGlobal);

  JS::Rooted<JSObject*> unforgeableHolder(aCx);
  {
    JS::Rooted<JSObject*> holderProto(aCx, *protoCache);
    unforgeableHolder = JS_NewObjectWithoutMetadata(aCx, Class.ToJSClass(), holderProto);
    if (!unforgeableHolder) {
      *protoCache = nullptr;
      if (interfaceCache) {
        *interfaceCache = nullptr;
      }
      return;
    }
  }

  if (!DefineUnforgeableAttributes(aCx, unforgeableHolder, sUnforgeableAttributes)) {
    *protoCache = nullptr;
    if (interfaceCache) {
      *interfaceCache = nullptr;
    }
    return;
  }

  if (*protoCache) {
    js::SetReservedSlot(*protoCache, DOM_INTERFACE_PROTO_SLOTS_BASE,
                        JS::ObjectValue(*unforgeableHolder));
  }
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::MozStkCommandEvent)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::MozStkCommandEvent).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::MozStkCommandEvent)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::MozStkCommandEvent).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace MozStkCommandEventBinding



} // namespace dom
} // namespace mozilla
