/* THIS FILE IS AUTOGENERATED FROM NativeOSFileInternals.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "NativeOSFileInternalsBinding.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {


NativeOSFileReadOptions::NativeOSFileReadOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
NativeOSFileReadOptions::InitIds(JSContext* cx, NativeOSFileReadOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->encoding_id.init(cx, "encoding") ||
      !atomsCache->bytes_id.init(cx, "bytes")) {
    return false;
  }
  return true;
}

bool
NativeOSFileReadOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  NativeOSFileReadOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<NativeOSFileReadOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->bytes_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mBytes.Construct();
    if (temp.ref().isNullOrUndefined()) {
      (mBytes.Value()).SetNull();
    } else if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &(mBytes.Value()).SetValue())) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->encoding_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mEncoding.Construct();
    if (!ConvertJSValueToString(cx, temp.ref(), eNull, eNull, (mEncoding.Value()))) {
      return false;
    }
  }
  return true;
}

bool
NativeOSFileReadOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
NativeOSFileReadOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  NativeOSFileReadOptionsAtoms* atomsCache = GetAtomCache<NativeOSFileReadOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mBytes.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      Nullable<uint64_t> const & currentValue = mBytes.InternalValue();
      if (currentValue.IsNull()) {
        temp.setNull();
        if (!JS_DefinePropertyById(cx, obj, atomsCache->bytes_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
      temp.set(JS_NumberValue(double(currentValue.Value())));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->bytes_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mEncoding.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      nsString const & currentValue = mEncoding.InternalValue();
      if (!xpc::StringToJsval(cx, currentValue, &temp)) {
        return false;
      }
      if (!JS_DefinePropertyById(cx, obj, atomsCache->encoding_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
NativeOSFileReadOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
NativeOSFileReadOptions::TraceDictionary(JSTracer* trc)
{
}

void
NativeOSFileReadOptions::operator=(const NativeOSFileReadOptions& aOther)
{
  if (aOther.mBytes.WasPassed()) {
    mBytes.Construct();
    mBytes.Value() = aOther.mBytes.Value();
  } else {
    mBytes.Reset();
  }
  if (aOther.mEncoding.WasPassed()) {
    mEncoding.Construct();
    mEncoding.Value() = aOther.mEncoding.Value();
  } else {
    mEncoding.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
