/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM SelectionStateChangedEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "SelectionStateChangedEvent.h"
#include "SelectionStateChangedEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/DOMRect.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/SelectionStateChangedEvent.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(SelectionStateChangedEvent)

NS_IMPL_ADDREF_INHERITED(SelectionStateChangedEvent, Event)
NS_IMPL_RELEASE_INHERITED(SelectionStateChangedEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(SelectionStateChangedEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mBoundingClientRect)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(SelectionStateChangedEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(SelectionStateChangedEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mBoundingClientRect)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(SelectionStateChangedEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

SelectionStateChangedEvent::SelectionStateChangedEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

SelectionStateChangedEvent::~SelectionStateChangedEvent()
{
}

SelectionStateChangedEvent*
SelectionStateChangedEvent::AsSelectionStateChangedEvent()
{
  return this;
}

JSObject*
SelectionStateChangedEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return SelectionStateChangedEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<SelectionStateChangedEvent>
SelectionStateChangedEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const SelectionStateChangedEventInit& aEventInit)
{
  nsRefPtr<SelectionStateChangedEvent> e = new SelectionStateChangedEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInit.mBubbles, aEventInit.mCancelable);
  e->mVisible = aEventInit.mVisible;
  e->mSelectedText = aEventInit.mSelectedText;
  e->mBoundingClientRect = aEventInit.mBoundingClientRect;
  e->mStates.AppendElements(aEventInit.mStates);
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<SelectionStateChangedEvent>
SelectionStateChangedEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const SelectionStateChangedEventInit& aEventInit, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInit);
}

bool
SelectionStateChangedEvent::Visible() const
{
  return mVisible;
}

void
SelectionStateChangedEvent::GetSelectedText(nsString& aRetVal) const
{
  aRetVal = mSelectedText;
}

DOMRectReadOnly*
SelectionStateChangedEvent::GetBoundingClientRect() const
{
  return mBoundingClientRect;
}

void
SelectionStateChangedEvent::GetStates(nsTArray<SelectionState>& aRetVal) const
{
  aRetVal = mStates;
}


} // namespace dom
} // namespace mozilla
