/* THIS FILE IS AUTOGENERATED FROM TVChannel.webidl BY Codegen.py - DO NOT EDIT */

#include "AtomList.h"
#include "EventTargetBinding.h"
#include "Navigator.h"
#include "TVChannelBinding.h"
#include "WrapperFactory.h"
#include "mozilla/OwningNonNull.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/NonRefcountedDOMObject.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/Promise.h"
#include "mozilla/dom/ScriptSettings.h"
#include "mozilla/dom/TVChannel.h"
#include "mozilla/dom/TVSource.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {

namespace TVChannelTypeValues {
  extern const EnumEntry strings[4] = {
    {"tv", 2},
    {"radio", 5},
    {"data", 4},
    { nullptr, 0 }
  };
} // namespace TVChannelTypeValues



TVGetProgramsOptions::TVGetProgramsOptions()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
TVGetProgramsOptions::InitIds(JSContext* cx, TVGetProgramsOptionsAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->startTime_id.init(cx, "startTime") ||
      !atomsCache->duration_id.init(cx, "duration")) {
    return false;
  }
  return true;
}

bool
TVGetProgramsOptions::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  TVGetProgramsOptionsAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<TVGetProgramsOptionsAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->duration_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mDuration.Construct();
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &(mDuration.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->startTime_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mStartTime.Construct();
    if (!ValueToPrimitive<uint64_t, eDefault>(cx, temp.ref(), &(mStartTime.Value()))) {
      return false;
    }
  }
  return true;
}

bool
TVGetProgramsOptions::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
TVGetProgramsOptions::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  TVGetProgramsOptionsAtoms* atomsCache = GetAtomCache<TVGetProgramsOptionsAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewPlainObject(cx));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mDuration.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint64_t const & currentValue = mDuration.InternalValue();
      temp.set(JS_NumberValue(double(currentValue)));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->duration_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mStartTime.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      uint64_t const & currentValue = mStartTime.InternalValue();
      temp.set(JS_NumberValue(double(currentValue)));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->startTime_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  return true;
}

bool
TVGetProgramsOptions::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
TVGetProgramsOptions::TraceDictionary(JSTracer* trc)
{
}

void
TVGetProgramsOptions::operator=(const TVGetProgramsOptions& aOther)
{
  if (aOther.mDuration.WasPassed()) {
    mDuration.Construct();
    mDuration.Value() = aOther.mDuration.Value();
  } else {
    mDuration.Reset();
  }
  if (aOther.mStartTime.WasPassed()) {
    mStartTime.Construct();
    mStartTime.Value() = aOther.mStartTime.Value();
  } else {
    mStartTime.Reset();
  }
}

namespace binding_detail {
} // namespace binding_detail


namespace TVChannelBinding {

static_assert(IsRefcounted<NativeType>::value == IsRefcounted<EventTargetBinding::NativeType>::value,
              "Can't inherit from an interface with a different ownership model.");

static bool
getPrograms(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, const JSJitMethodCallArgs& args)
{
  binding_detail::FastTVGetProgramsOptions arg0;
  if (!arg0.Init(cx, (args.hasDefined(0)) ? args[0] : JS::NullHandleValue, "Argument 1 of TVChannel.getPrograms", false)) {
    return false;
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->GetPrograms(Constify(arg0), rv)));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailed(cx, rv);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
getPrograms_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = getPrograms(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo getPrograms_methodinfo = {
  { (JSJitGetterOp)getPrograms_promiseWrapper },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
getCurrentProgram(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, const JSJitMethodCallArgs& args)
{
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->GetCurrentProgram(rv)));
  rv.WouldReportJSException();
  if (MOZ_UNLIKELY(rv.Failed())) {
    return ThrowMethodFailed(cx, rv);
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
getCurrentProgram_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = getCurrentProgram(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}

static const JSJitInfo getCurrentProgram_methodinfo = {
  { (JSJitGetterOp)getCurrentProgram_promiseWrapper },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_networkId(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetNetworkId(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo networkId_getterinfo = {
  { (JSJitGetterOp)get_networkId },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_transportStreamId(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetTransportStreamId(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo transportStreamId_getterinfo = {
  { (JSJitGetterOp)get_transportStreamId },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_serviceId(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetServiceId(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo serviceId_getterinfo = {
  { (JSJitGetterOp)get_serviceId },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_source(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::TVSource>(self->Source()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!GetOrCreateDOMReflector(cx, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const JSJitInfo source_getterinfo = {
  { (JSJitGetterOp)get_source },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_type(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  TVChannelType result(self->Type());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  {
    // Scope for resultStr
    MOZ_ASSERT(uint32_t(result) < ArrayLength(TVChannelTypeValues::strings));
    JSString* resultStr = JS_NewStringCopyN(cx, TVChannelTypeValues::strings[uint32_t(result)].value, TVChannelTypeValues::strings[uint32_t(result)].length);
    if (!resultStr) {
      return false;
    }
    args.rval().setString(resultStr);
    return true;
  }
}

static const JSJitInfo type_getterinfo = {
  { (JSJitGetterOp)get_type },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_name(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetName(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo name_getterinfo = {
  { (JSJitGetterOp)get_name },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_number(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetNumber(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static const JSJitInfo number_getterinfo = {
  { (JSJitGetterOp)get_number },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_isEmergency(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  bool result(self->IsEmergency());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isEmergency_getterinfo = {
  { (JSJitGetterOp)get_isEmergency },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
get_isFree(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TVChannel* self, JSJitGetterCallArgs args)
{
  bool result(self->IsFree());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static const JSJitInfo isFree_getterinfo = {
  { (JSJitGetterOp)get_isFree },
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isEliminatable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};
static_assert(0 <= JSJitInfo::maxSlotIndex, "We won't fit");

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::Handle<JS::Value> val)
{
  mozilla::dom::TVChannel* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::TVChannel>(obj);
  // We don't want to preserve if we don't have a wrapper, and we
  // obviously can't preserve if we're not initialized.
  if (self && self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::TVChannel* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::TVChannel>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::TVChannel>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::TVChannel>(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::TVChannel* self = UnwrapPossiblyNotInitializedDOMObject<mozilla::dom::TVChannel>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const char* const anypermissions_0[] = {
  "tv",
  nullptr
};

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getPrograms", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&getPrograms_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("getCurrentProgram", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&getCurrentProgram_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[3];

static const JSPropertySpec sAttributes_specs[] = {
  { "networkId", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &networkId_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "transportStreamId", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &transportStreamId_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "serviceId", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &serviceId_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "source", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &source_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "type", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &type_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "name", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &name_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "number", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &number_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "isEmergency", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &isEmergency_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  { "isFree", JSPROP_SHARED | JSPROP_ENUMERATE, { { GenericBindingGetter, &isFree_getterinfo } }, JSNATIVE_WRAPPER(nullptr)},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, nullptr }
};

static jsid sAttributes_ids[10];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  -1
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::TVChannel,
  constructors::id::TVChannel,
  EventTargetBinding::sNativePropertyHooks
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function TVChannel() {\n    [native code]\n}",
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  EventTargetBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "TVChannelPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    nullptr,               /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr,               /* enumerate */
    nullptr,               /* resolve */
    nullptr,               /* mayResolve */
    nullptr,               /* convert */
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object TVChannelPrototype]",
  prototypes::id::TVChannel,
  PrototypeTraits<prototypes::id::TVChannel>::Depth,
  EventTargetBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.tv.enabled") &&
         Navigator::HasTVSupport(aCx, aObj) &&
         CheckAnyPermissions(aCx, aObj, anypermissions_0);
}

static const DOMJSClass Class = {
  { "TVChannel",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    nullptr,               /* delProperty */
    nullptr,               /* getProperty */
    nullptr,               /* setProperty */
    nullptr, /* enumerate */
    nullptr, /* resolve */
    nullptr, /* mayResolve */
    nullptr,               /* convert */
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::TVChannel, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::TVChannel >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::TVChannel>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::TVChannel>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

bool
Wrap(JSContext* aCx, mozilla::dom::TVChannel* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector)
{
  MOZ_ASSERT(static_cast<mozilla::dom::TVChannel*>(aObject) ==
             reinterpret_cast<mozilla::dom::TVChannel*>(aObject),
             "Multiple inheritance for mozilla::dom::TVChannel is broken.");
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject),
             "Multiple inheritance for mozilla::dom::EventTarget is broken.");
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));
  MOZ_ASSERT(!aCache->GetWrapper(),
             "You should probably not be using Wrap() directly; use "
             "GetOrCreateDOMReflector instead");

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx, WrapNativeParent(aCx, aObject->GetParentObject()));
  if (!parent) {
    return false;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.
  aReflector.set(aCache->GetWrapper());
  if (aReflector) {
#ifdef DEBUG
    binding_detail::AssertReflectorHasGivenProto(aCx, aReflector, aGivenProto);
#endif // DEBUG
    return true;
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, js::GetGlobalForObjectCrossCompartment(parent));
  JS::Handle<JSObject*> canonicalProto = GetProtoObjectHandle(aCx, global);
  if (!canonicalProto) {
    return false;
  }
  JS::Rooted<JSObject*> proto(aCx);
  if (aGivenProto) {
    proto = aGivenProto;
    // Unfortunately, while aGivenProto was in the compartment of aCx
    // coming in, we changed compartments to that of "parent" so may need
    // to wrap the proto here.
    if (js::GetContextCompartment(aCx) != js::GetObjectCompartment(proto)) {
      if (!JS_WrapObject(aCx, &proto)) {
        return false;
      }
    }
  } else {
    proto = canonicalProto;
  }

  BindingJSObjectCreator<mozilla::dom::TVChannel> creator(aCx);
  creator.CreateObject(aCx, Class.ToJSClass(), proto, aObject, aReflector);
  if (!aReflector) {
    return false;
  }

  aCache->SetWrapper(aReflector);
  creator.InitializationSucceeded();

  MOZ_ASSERT(aCache->GetWrapperPreserveColor() &&
             aCache->GetWrapperPreserveColor() == aReflector);
  // If proto != canonicalProto, we have to preserve our wrapper;
  // otherwise we won't be able to properly recreate it later, since
  // we won't know what proto to use.  Note that we don't check
  // aGivenProto here, since it's entirely possible (and even
  // somewhat common) to have a non-null aGivenProto which is the
  // same as canonicalProto.
  if (proto != canonicalProto) {
    PreserveWrapper(aObject);
  }

  return true;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventTargetBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventTargetBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  JS::Heap<JSObject*>* protoCache = &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::TVChannel);
  JS::Heap<JSObject*>* interfaceCache = &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::TVChannel);
  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, protoCache,
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              interfaceCache,
                              &sNativeProperties,
                              nullptr,
                              "TVChannel", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::TVChannel)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::TVChannel).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return nullptr;
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::TVChannel)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::TVChannel).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace TVChannelBinding



} // namespace dom
} // namespace mozilla
