//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/plugins/PBrowserStreamParent.h"

#include "mozilla/plugins/PPluginInstanceParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace plugins {



MOZ_IMPLICIT PBrowserStreamParent::PBrowserStreamParent() :
    mId(0),
    mState(PBrowserStream::__Dead)
{
    MOZ_COUNT_CTOR(PBrowserStreamParent);
}

PBrowserStreamParent::~PBrowserStreamParent()
{
    MOZ_COUNT_DTOR(PBrowserStreamParent);
}

auto PBrowserStreamParent::Manager() const -> PPluginInstanceParent*
{
    return static_cast<PPluginInstanceParent*>(mManager);
}

auto PBrowserStreamParent::state() -> PBrowserStream::State
{
    return mState;
}

auto PBrowserStreamParent::SendWrite(
        const int32_t& offset,
        const Buffer& data,
        const uint32_t& newlength) -> bool
{
    PBrowserStream::Msg_Write* msg__ = new PBrowserStream::Msg_Write(mId);

    Write(offset, msg__);
    Write(data, msg__);
    Write(newlength, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
        (msg__)->Log("[PBrowserStreamParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PBrowserStream", "AsyncSendWrite", js::ProfileEntry::Category::OTHER);
    if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Send, PBrowserStream::Msg_Write__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PBrowserStreamParent::SendNPP_StreamAsFile(const nsCString& fname) -> bool
{
    PBrowserStream::Msg_NPP_StreamAsFile* msg__ = new PBrowserStream::Msg_NPP_StreamAsFile(mId);

    Write(fname, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
        (msg__)->Log("[PBrowserStreamParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PBrowserStream", "AsyncSendNPP_StreamAsFile", js::ProfileEntry::Category::OTHER);
    if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Send, PBrowserStream::Msg_NPP_StreamAsFile__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PBrowserStreamParent::SendNPP_DestroyStream(const NPReason& reason) -> bool
{
    PBrowserStream::Msg_NPP_DestroyStream* msg__ = new PBrowserStream::Msg_NPP_DestroyStream(mId);

    Write(reason, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
        (msg__)->Log("[PBrowserStreamParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PBrowserStream", "AsyncSendNPP_DestroyStream", js::ProfileEntry::Category::OTHER);
    if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Send, PBrowserStream::Msg_NPP_DestroyStream__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PBrowserStreamParent::Send__delete__(PBrowserStreamParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PBrowserStream::Msg___delete__* msg__ = new PBrowserStream::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
        (msg__)->Log("[PBrowserStreamParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PBrowserStream", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PBrowserStream::Transition((actor)->mState, Trigger(Trigger::Send, PBrowserStream::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PBrowserStreamMsgStart, actor);
    return sendok__;
}

auto PBrowserStreamParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PBrowserStreamParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PBrowserStreamParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PBrowserStreamParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PBrowserStreamParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PBrowserStreamParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PBrowserStreamParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PBrowserStreamParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PBrowserStreamParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PBrowserStreamParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PBrowserStreamParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PBrowserStreamParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PBrowserStreamParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PBrowserStreamParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PBrowserStream has not yet been implemented");
    return nullptr;
}

auto PBrowserStreamParent::OnMessageReceived(const Message& msg__) -> PBrowserStreamParent::Result
{
    switch ((msg__).type()) {
    case PBrowserStream::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PBrowserStream::Msg_AsyncNPP_NewStreamResult__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PBrowserStream::Msg_AsyncNPP_NewStreamResult");
            if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
                (static_cast<const PBrowserStream::Msg_AsyncNPP_NewStreamResult*>((&(msg__))))->Log("[PBrowserStreamParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PBrowserStream", "RecvAsyncNPP_NewStreamResult", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            NPError rv;
            uint16_t stype;

            if ((!(Read((&(rv)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'NPError'");
                return MsgValueError;
            }
            if ((!(Read((&(stype)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Recv, PBrowserStream::Msg_AsyncNPP_NewStreamResult__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvAsyncNPP_NewStreamResult(mozilla::Move(rv), mozilla::Move(stype))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for AsyncNPP_NewStreamResult returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBrowserStream::Msg_NPN_DestroyStream__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PBrowserStream::Msg_NPN_DestroyStream");
            if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
                (static_cast<const PBrowserStream::Msg_NPN_DestroyStream*>((&(msg__))))->Log("[PBrowserStreamParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PBrowserStream", "RecvNPN_DestroyStream", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            NPReason reason;

            if ((!(Read((&(reason)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'NPReason'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Recv, PBrowserStream::Msg_NPN_DestroyStream__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvNPN_DestroyStream(mozilla::Move(reason))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for NPN_DestroyStream returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBrowserStream::Msg_StreamDestroyed__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PBrowserStream::Msg_StreamDestroyed");
            if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
                (static_cast<const PBrowserStream::Msg_StreamDestroyed*>((&(msg__))))->Log("[PBrowserStreamParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PBrowserStream", "RecvStreamDestroyed", js::ProfileEntry::Category::OTHER);

            if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Recv, PBrowserStream::Msg_StreamDestroyed__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvStreamDestroyed()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for StreamDestroyed returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PBrowserStreamParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PBrowserStreamParent::Result
{
    return MsgNotKnown;
}

auto PBrowserStreamParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PBrowserStreamParent::Result
{
    switch ((msg__).type()) {
    case PBrowserStream::Msg_NPN_RequestRead__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PBrowserStream::Msg_NPN_RequestRead");
            if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
                (static_cast<const PBrowserStream::Msg_NPN_RequestRead*>((&(msg__))))->Log("[PBrowserStreamParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PBrowserStream", "RecvNPN_RequestRead", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            IPCByteRanges ranges;

            if ((!(Read((&(ranges)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'IPCByteRanges'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PBrowserStream::Transition(mState, Trigger(Trigger::Recv, PBrowserStream::Msg_NPN_RequestRead__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            NPError result;
            int32_t id__ = mId;
            if ((!(AnswerNPN_RequestRead(mozilla::Move(ranges), (&(result)))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for NPN_RequestRead returned error code");
                return MsgProcessingError;
            }

            reply__ = new PBrowserStream::Reply_NPN_RequestRead(id__);

            Write(result, reply__);
            (reply__)->set_interrupt();
            (reply__)->set_reply();

            if (mozilla::ipc::LoggingEnabledFor("PPluginModule")) {
                (static_cast<const PBrowserStream::Reply_NPN_RequestRead*>(reply__))->Log("[PBrowserStreamParent] Sending reply ", OtherPid(), false);
            }
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PBrowserStreamParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PBrowserStreamParent::GetProtocolTypeId() -> int32_t
{
    return PBrowserStreamMsgStart;
}

auto PBrowserStreamParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PBrowserStreamParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PBrowserStreamParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PBrowserStreamParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PBrowserStreamParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PBrowserStreamParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PBrowserStreamParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PBrowserStreamParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PBrowserStreamParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PBrowserStreamParent", aMsg, OtherPid(), true);
}

auto PBrowserStreamParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PBrowserStreamParent::DeallocSubtree() -> void
{
}

auto PBrowserStreamParent::Write(
        PBrowserStreamParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PBrowserStreamParent::Read(
        PBrowserStreamParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PBrowserStreamParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PBrowserStream");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PBrowserStream");
        return false;
    }

    if ((PBrowserStreamMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PBrowserStream has different type");
        return false;
    }

    (*(v__)) = static_cast<PBrowserStreamParent*>(listener);
    return true;
}



} // namespace plugins
} // namespace mozilla
