//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "nsID.h"

#include "mozilla/ipc/PBackgroundParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {



MOZ_IMPLICIT PCacheStreamControlParent::PCacheStreamControlParent() :
    mId(0),
    mState(PCacheStreamControl::__Dead)
{
    MOZ_COUNT_CTOR(PCacheStreamControlParent);
}

PCacheStreamControlParent::~PCacheStreamControlParent()
{
    MOZ_COUNT_DTOR(PCacheStreamControlParent);
}

auto PCacheStreamControlParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(mManager);
}

auto PCacheStreamControlParent::state() -> PCacheStreamControl::State
{
    return mState;
}

auto PCacheStreamControlParent::SendClose(const nsID& aStreamId) -> bool
{
    PCacheStreamControl::Msg_Close* msg__ = new PCacheStreamControl::Msg_Close(mId);

    Write(aStreamId, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCacheStreamControlParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCacheStreamControl", "AsyncSendClose", js::ProfileEntry::Category::OTHER);
    if ((!(PCacheStreamControl::Transition(mState, Trigger(Trigger::Send, PCacheStreamControl::Msg_Close__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCacheStreamControlParent::SendCloseAll() -> bool
{
    PCacheStreamControl::Msg_CloseAll* msg__ = new PCacheStreamControl::Msg_CloseAll(mId);





    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCacheStreamControlParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCacheStreamControl", "AsyncSendCloseAll", js::ProfileEntry::Category::OTHER);
    if ((!(PCacheStreamControl::Transition(mState, Trigger(Trigger::Send, PCacheStreamControl::Msg_CloseAll__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PCacheStreamControlParent::Send__delete__(PCacheStreamControlParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PCacheStreamControl::Msg___delete__* msg__ = new PCacheStreamControl::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PCacheStreamControlParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PCacheStreamControl", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PCacheStreamControl::Transition((actor)->mState, Trigger(Trigger::Send, PCacheStreamControl::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PCacheStreamControlMsgStart, actor);
    return sendok__;
}

auto PCacheStreamControlParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PCacheStreamControlParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PCacheStreamControlParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PCacheStreamControlParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PCacheStreamControlParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PCacheStreamControlParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PCacheStreamControlParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PCacheStreamControlParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PCacheStreamControlParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PCacheStreamControlParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PCacheStreamControlParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PCacheStreamControlParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PCacheStreamControlParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PCacheStreamControlParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PCacheStreamControl has not yet been implemented");
    return nullptr;
}

auto PCacheStreamControlParent::OnMessageReceived(const Message& msg__) -> PCacheStreamControlParent::Result
{
    switch ((msg__).type()) {
    case PCacheStreamControl::Msg_NoteClosed__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PCacheStreamControl::Msg_NoteClosed");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PCacheStreamControl::Msg_NoteClosed*>((&(msg__))))->Log("[PCacheStreamControlParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PCacheStreamControl", "RecvNoteClosed", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsID aStreamId;

            if ((!(Read((&(aStreamId)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsID'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PCacheStreamControl::Transition(mState, Trigger(Trigger::Recv, PCacheStreamControl::Msg_NoteClosed__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvNoteClosed(mozilla::Move(aStreamId))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for NoteClosed returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStreamControl::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PCacheStreamControlParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStreamControlParent::Result
{
    return MsgNotKnown;
}

auto PCacheStreamControlParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStreamControlParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStreamControlParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PCacheStreamControlParent::GetProtocolTypeId() -> int32_t
{
    return PCacheStreamControlMsgStart;
}

auto PCacheStreamControlParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PCacheStreamControlParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PCacheStreamControlParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PCacheStreamControlParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PCacheStreamControlParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCacheStreamControlParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCacheStreamControlParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PCacheStreamControlParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PCacheStreamControlParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PCacheStreamControlParent", aMsg, OtherPid(), true);
}

auto PCacheStreamControlParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PCacheStreamControlParent::DeallocSubtree() -> void
{
}

auto PCacheStreamControlParent::Write(
        PCacheStreamControlParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PCacheStreamControlParent::Read(
        PCacheStreamControlParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PCacheStreamControlParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PCacheStreamControl");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PCacheStreamControl");
        return false;
    }

    if ((PCacheStreamControlMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PCacheStreamControl has different type");
        return false;
    }

    (*(v__)) = static_cast<PCacheStreamControlParent*>(listener);
    return true;
}



} // namespace cache
} // namespace dom
} // namespace mozilla
