//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPStorageChild.h"

#include "mozilla/gmp/PGMPChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPStorageChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PGMPStorageChild::PGMPStorageChild() :
    mId(0),
    mState(PGMPStorage::__Dead)
{
    MOZ_COUNT_CTOR(PGMPStorageChild);
}

PGMPStorageChild::~PGMPStorageChild()
{
    MOZ_COUNT_DTOR(PGMPStorageChild);
}

auto PGMPStorageChild::Manager() const -> PGMPChild*
{
    return static_cast<PGMPChild*>(mManager);
}

auto PGMPStorageChild::state() -> PGMPStorage::State
{
    return mState;
}

auto PGMPStorageChild::SendOpen(const nsCString& aRecordName) -> bool
{
    PGMPStorage::Msg_Open* msg__ = new PGMPStorage::Msg_Open(mId);

    Write(aRecordName, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendOpen", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Open__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageChild::SendRead(const nsCString& aRecordName) -> bool
{
    PGMPStorage::Msg_Read* msg__ = new PGMPStorage::Msg_Read(mId);

    Write(aRecordName, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendRead", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Read__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageChild::SendWrite(
        const nsCString& aRecordName,
        const nsTArray<uint8_t>& aBytes) -> bool
{
    PGMPStorage::Msg_Write* msg__ = new PGMPStorage::Msg_Write(mId);

    Write(aRecordName, msg__);
    Write(aBytes, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendWrite", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Write__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageChild::SendClose(const nsCString& aRecordName) -> bool
{
    PGMPStorage::Msg_Close* msg__ = new PGMPStorage::Msg_Close(mId);

    Write(aRecordName, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendClose", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Close__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageChild::SendGetRecordNames() -> bool
{
    PGMPStorage::Msg_GetRecordNames* msg__ = new PGMPStorage::Msg_GetRecordNames(mId);





    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendGetRecordNames", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_GetRecordNames__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageChild::Send__delete__(PGMPStorageChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PGMPStorage::Msg___delete__* msg__ = new PGMPStorage::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageChild] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition((actor)->mState, Trigger(Trigger::Recv, PGMPStorage::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PGMPStorageMsgStart, actor);
    return sendok__;
}

auto PGMPStorageChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PGMPStorageChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PGMPStorageChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PGMPStorageChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PGMPStorageChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPStorageChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PGMPStorageChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PGMPStorageChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PGMPStorageChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PGMPStorageChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PGMPStorageChild::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PGMPStorageChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PGMPStorageChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPStorageChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPStorage has not yet been implemented");
    return nullptr;
}

auto PGMPStorageChild::OnMessageReceived(const Message& msg__) -> PGMPStorageChild::Result
{
    switch ((msg__).type()) {
    case PGMPStorage::Msg_OpenComplete__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_OpenComplete");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_OpenComplete*>((&(msg__))))->Log("[PGMPStorageChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvOpenComplete", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;
            GMPErr aStatus;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_OpenComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOpenComplete(mozilla::Move(aRecordName), mozilla::Move(aStatus))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OpenComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_ReadComplete__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_ReadComplete");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_ReadComplete*>((&(msg__))))->Log("[PGMPStorageChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvReadComplete", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;
            GMPErr aStatus;
            nsTArray<uint8_t> aBytes;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            if ((!(Read((&(aBytes)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_ReadComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvReadComplete(mozilla::Move(aRecordName), mozilla::Move(aStatus), mozilla::Move(aBytes))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for ReadComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_WriteComplete__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_WriteComplete");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_WriteComplete*>((&(msg__))))->Log("[PGMPStorageChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvWriteComplete", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;
            GMPErr aStatus;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_WriteComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvWriteComplete(mozilla::Move(aRecordName), mozilla::Move(aStatus))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for WriteComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_RecordNames__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_RecordNames");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_RecordNames*>((&(msg__))))->Log("[PGMPStorageChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvRecordNames", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsTArray<nsCString> aRecordNames;
            GMPErr aStatus;

            if ((!(Read((&(aRecordNames)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_RecordNames__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRecordNames(mozilla::Move(aRecordNames), mozilla::Move(aStatus))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for RecordNames returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Shutdown__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_Shutdown");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Shutdown*>((&(msg__))))->Log("[PGMPStorageChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvShutdown", js::ProfileEntry::Category::OTHER);

            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_Shutdown__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvShutdown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Shutdown returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PGMPStorageChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPStorageChild::Result
{
    return MsgNotKnown;
}

auto PGMPStorageChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPStorageChild::Result
{
    return MsgNotKnown;
}

auto PGMPStorageChild::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PGMPStorageChild::GetProtocolTypeId() -> int32_t
{
    return PGMPStorageMsgStart;
}

auto PGMPStorageChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PGMPStorageChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PGMPStorageChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PGMPStorageChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PGMPStorageChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPStorageChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPStorageChild", aMsg, 0, false);
}

auto PGMPStorageChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPStorageChild::DeallocSubtree() -> void
{
}

auto PGMPStorageChild::Write(
        PGMPStorageChild* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PGMPStorageChild::Read(
        PGMPStorageChild** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PGMPStorageChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PGMPStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PGMPStorage");
        return false;
    }

    if ((PGMPStorageMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PGMPStorage has different type");
        return false;
    }

    (*(v__)) = static_cast<PGMPStorageChild*>(listener);
    return true;
}



} // namespace gmp
} // namespace mozilla
