//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPStorageParent.h"

#include "mozilla/gmp/PGMPParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPStorageParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PGMPStorageParent::PGMPStorageParent() :
    mId(0),
    mState(PGMPStorage::__Dead)
{
    MOZ_COUNT_CTOR(PGMPStorageParent);
}

PGMPStorageParent::~PGMPStorageParent()
{
    MOZ_COUNT_DTOR(PGMPStorageParent);
}

auto PGMPStorageParent::Manager() const -> PGMPParent*
{
    return static_cast<PGMPParent*>(mManager);
}

auto PGMPStorageParent::state() -> PGMPStorage::State
{
    return mState;
}

auto PGMPStorageParent::SendOpenComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus) -> bool
{
    PGMPStorage::Msg_OpenComplete* msg__ = new PGMPStorage::Msg_OpenComplete(mId);

    Write(aRecordName, msg__);
    Write(aStatus, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendOpenComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_OpenComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageParent::SendReadComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus,
        const nsTArray<uint8_t>& aBytes) -> bool
{
    PGMPStorage::Msg_ReadComplete* msg__ = new PGMPStorage::Msg_ReadComplete(mId);

    Write(aRecordName, msg__);
    Write(aStatus, msg__);
    Write(aBytes, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendReadComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_ReadComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageParent::SendWriteComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus) -> bool
{
    PGMPStorage::Msg_WriteComplete* msg__ = new PGMPStorage::Msg_WriteComplete(mId);

    Write(aRecordName, msg__);
    Write(aStatus, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendWriteComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_WriteComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageParent::SendRecordNames(
        const nsTArray<nsCString>& aRecordNames,
        const GMPErr& aStatus) -> bool
{
    PGMPStorage::Msg_RecordNames* msg__ = new PGMPStorage::Msg_RecordNames(mId);

    Write(aRecordNames, msg__);
    Write(aStatus, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendRecordNames", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_RecordNames__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageParent::SendShutdown() -> bool
{
    PGMPStorage::Msg_Shutdown* msg__ = new PGMPStorage::Msg_Shutdown(mId);





    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPStorageParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendShutdown", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_Shutdown__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPStorageParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PGMPStorageParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PGMPStorageParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PGMPStorageParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PGMPStorageParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPStorageParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PGMPStorageParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PGMPStorageParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PGMPStorageParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PGMPStorageParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PGMPStorageParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PGMPStorageParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PGMPStorageParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPStorageParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPStorage has not yet been implemented");
    return nullptr;
}

auto PGMPStorageParent::OnMessageReceived(const Message& msg__) -> PGMPStorageParent::Result
{
    switch ((msg__).type()) {
    case PGMPStorage::Msg_Open__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_Open");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Open*>((&(msg__))))->Log("[PGMPStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvOpen", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Open__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOpen(mozilla::Move(aRecordName))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Open returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Read__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_Read");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Read*>((&(msg__))))->Log("[PGMPStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvRead", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Read__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRead(mozilla::Move(aRecordName))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Read returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Write__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_Write");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Write*>((&(msg__))))->Log("[PGMPStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvWrite", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;
            nsTArray<uint8_t> aBytes;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aBytes)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Write__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvWrite(mozilla::Move(aRecordName), mozilla::Move(aBytes))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Write returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Close__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Close*>((&(msg__))))->Log("[PGMPStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvClose", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aRecordName;

            if ((!(Read((&(aRecordName)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose(mozilla::Move(aRecordName))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_GetRecordNames__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg_GetRecordNames");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_GetRecordNames*>((&(msg__))))->Log("[PGMPStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvGetRecordNames", js::ProfileEntry::Category::OTHER);

            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_GetRecordNames__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvGetRecordNames()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for GetRecordNames returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg___delete____ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPStorage::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg___delete__*>((&(msg__))))->Log("[PGMPStorageParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            PGMPStorageParent* actor;

            if ((!(Read((&(actor)), (&(msg__)), (&(iter__)), false)))) {
                FatalError("Error deserializing 'PGMPStorageParent'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }

            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PGMPStorageMsgStart, actor);


            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PGMPStorageParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPStorageParent::Result
{
    return MsgNotKnown;
}

auto PGMPStorageParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPStorageParent::Result
{
    return MsgNotKnown;
}

auto PGMPStorageParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PGMPStorageParent::GetProtocolTypeId() -> int32_t
{
    return PGMPStorageMsgStart;
}

auto PGMPStorageParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PGMPStorageParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PGMPStorageParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PGMPStorageParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PGMPStorageParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPStorageParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPStorageParent", aMsg, OtherPid(), true);
}

auto PGMPStorageParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPStorageParent::DeallocSubtree() -> void
{
}

auto PGMPStorageParent::Write(
        PGMPStorageParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PGMPStorageParent::Read(
        PGMPStorageParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PGMPStorageParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PGMPStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PGMPStorage");
        return false;
    }

    if ((PGMPStorageMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PGMPStorage has different type");
        return false;
    }

    (*(v__)) = static_cast<PGMPStorageParent*>(listener);
    return true;
}



} // namespace gmp
} // namespace mozilla
