//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPTimerChild.h"

#include "mozilla/gmp/PGMPChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPTimerChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PGMPTimerChild::PGMPTimerChild() :
    mId(0),
    mState(PGMPTimer::__Dead)
{
    MOZ_COUNT_CTOR(PGMPTimerChild);
}

PGMPTimerChild::~PGMPTimerChild()
{
    MOZ_COUNT_DTOR(PGMPTimerChild);
}

auto PGMPTimerChild::Manager() const -> PGMPChild*
{
    return static_cast<PGMPChild*>(mManager);
}

auto PGMPTimerChild::state() -> PGMPTimer::State
{
    return mState;
}

auto PGMPTimerChild::SendSetTimer(
        const uint32_t& aTimerId,
        const uint32_t& aTimeoutMs) -> bool
{
    PGMPTimer::Msg_SetTimer* msg__ = new PGMPTimer::Msg_SetTimer(mId);

    Write(aTimerId, msg__);
    Write(aTimeoutMs, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPTimerChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPTimer", "AsyncSendSetTimer", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPTimer::Transition(mState, Trigger(Trigger::Recv, PGMPTimer::Msg_SetTimer__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PGMPTimerChild::Send__delete__(PGMPTimerChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PGMPTimer::Msg___delete__* msg__ = new PGMPTimer::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (msg__)->Log("[PGMPTimerChild] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PGMPTimer", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPTimer::Transition((actor)->mState, Trigger(Trigger::Recv, PGMPTimer::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PGMPTimerMsgStart, actor);
    return sendok__;
}

auto PGMPTimerChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PGMPTimerChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PGMPTimerChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PGMPTimerChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PGMPTimerChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPTimerChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PGMPTimerChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PGMPTimerChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PGMPTimerChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PGMPTimerChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PGMPTimerChild::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PGMPTimerChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PGMPTimerChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPTimerChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPTimer has not yet been implemented");
    return nullptr;
}

auto PGMPTimerChild::OnMessageReceived(const Message& msg__) -> PGMPTimerChild::Result
{
    switch ((msg__).type()) {
    case PGMPTimer::Msg_TimerExpired__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PGMPTimer::Msg_TimerExpired");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPTimer::Msg_TimerExpired*>((&(msg__))))->Log("[PGMPTimerChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PGMPTimer", "RecvTimerExpired", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint32_t aTimerId;

            if ((!(Read((&(aTimerId)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PGMPTimer::Transition(mState, Trigger(Trigger::Send, PGMPTimer::Msg_TimerExpired__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvTimerExpired(mozilla::Move(aTimerId))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for TimerExpired returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPTimer::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PGMPTimerChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPTimerChild::Result
{
    return MsgNotKnown;
}

auto PGMPTimerChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PGMPTimerChild::Result
{
    return MsgNotKnown;
}

auto PGMPTimerChild::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PGMPTimerChild::GetProtocolTypeId() -> int32_t
{
    return PGMPTimerMsgStart;
}

auto PGMPTimerChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PGMPTimerChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PGMPTimerChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PGMPTimerChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PGMPTimerChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPTimerChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPTimerChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPTimerChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPTimerChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPTimerChild", aMsg, 0, false);
}

auto PGMPTimerChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPTimerChild::DeallocSubtree() -> void
{
}

auto PGMPTimerChild::Write(
        PGMPTimerChild* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PGMPTimerChild::Read(
        PGMPTimerChild** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PGMPTimerChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PGMPTimer");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PGMPTimer");
        return false;
    }

    if ((PGMPTimerMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PGMPTimer has different type");
        return false;
    }

    (*(v__)) = static_cast<PGMPTimerChild*>(listener);
    return true;
}



} // namespace gmp
} // namespace mozilla
