//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/PProcessHangMonitor.h"
#include "mozilla/dom/PContentParent.h"

namespace mozilla {
namespace PProcessHangMonitor {

bool
Open(mozilla::dom::PContentParent* opener)
{
    return mozilla::ipc::Open(mozilla::ipc::PrivateIPDLInterface(), (opener)->GetIPCChannel(), (opener)->OtherPid(), mozilla::ipc::Transport::MODE_SERVER, PProcessHangMonitorMsgStart, PProcessHangMonitorMsgStartChild);
}
bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next)
{
    switch (from) {
    case __Null:
    case __Error:
        return (__Null) == (from);
    case __Dead:
        NS_RUNTIMEABORT("__delete__()d actor");
        return false;
    case __Dying:
        NS_RUNTIMEABORT("__delete__()d (and unexpectedly dying) actor");
        return false;
    default:
        NS_RUNTIMEABORT("corrupted actor state");
        return false;
    }
}

} // namespace PProcessHangMonitor
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct SlowScriptData|
//
namespace mozilla {
MOZ_IMPLICIT SlowScriptData::SlowScriptData() :
    tabId_(),
    filename_(),
    lineno_()
{
    Init();
}

SlowScriptData::~SlowScriptData()
{
}

auto SlowScriptData::operator==(const SlowScriptData& _o) const -> bool
{
    if ((!((tabId()) == ((_o).tabId())))) {
        return false;
    }
    if ((!((filename()) == ((_o).filename())))) {
        return false;
    }
    if ((!((lineno()) == ((_o).lineno())))) {
        return false;
    }
    return true;
}

auto SlowScriptData::Init() -> void
{
}

auto SlowScriptData::Assign(
        const TabId& _tabId,
        const nsCString& _filename,
        const uint32_t& _lineno) -> void
{
    tabId_ = _tabId;
    filename_ = _filename;
    lineno_ = _lineno;
}

} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct PluginHangData|
//
namespace mozilla {
MOZ_IMPLICIT PluginHangData::PluginHangData() :
    pluginId_()
{
    Init();
}

PluginHangData::~PluginHangData()
{
}

auto PluginHangData::operator==(const PluginHangData& _o) const -> bool
{
    if ((!((pluginId()) == ((_o).pluginId())))) {
        return false;
    }
    return true;
}

auto PluginHangData::Init() -> void
{
}

auto PluginHangData::Assign(const uint32_t& _pluginId) -> void
{
    pluginId_ = _pluginId;
}

} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union HangData|
//
namespace mozilla {
auto HangData::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TSlowScriptData:
        {
            (ptr_SlowScriptData())->~SlowScriptData__tdef();
            break;
        }
    case TPluginHangData:
        {
            (ptr_PluginHangData())->~PluginHangData__tdef();
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT HangData::HangData(const SlowScriptData& aOther)
{
    new (ptr_SlowScriptData()) SlowScriptData(aOther);
    mType = TSlowScriptData;
}

MOZ_IMPLICIT HangData::HangData(const PluginHangData& aOther)
{
    new (ptr_PluginHangData()) PluginHangData(aOther);
    mType = TPluginHangData;
}

MOZ_IMPLICIT HangData::HangData(const HangData& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TSlowScriptData:
        {
            new (ptr_SlowScriptData()) SlowScriptData((aOther).get_SlowScriptData());
            break;
        }
    case TPluginHangData:
        {
            new (ptr_PluginHangData()) PluginHangData((aOther).get_PluginHangData());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

HangData::~HangData()
{
    MaybeDestroy(T__None);
}

auto HangData::operator=(const SlowScriptData& aRhs) -> HangData&
{
    if (MaybeDestroy(TSlowScriptData)) {
        new (ptr_SlowScriptData()) SlowScriptData;
    }
    (*(ptr_SlowScriptData())) = aRhs;
    mType = TSlowScriptData;
    return (*(this));
}

auto HangData::operator=(const PluginHangData& aRhs) -> HangData&
{
    if (MaybeDestroy(TPluginHangData)) {
        new (ptr_PluginHangData()) PluginHangData;
    }
    (*(ptr_PluginHangData())) = aRhs;
    mType = TPluginHangData;
    return (*(this));
}

auto HangData::operator=(const HangData& aRhs) -> HangData&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TSlowScriptData:
        {
            if (MaybeDestroy(t)) {
                new (ptr_SlowScriptData()) SlowScriptData;
            }
            (*(ptr_SlowScriptData())) = (aRhs).get_SlowScriptData();
            break;
        }
    case TPluginHangData:
        {
            if (MaybeDestroy(t)) {
                new (ptr_PluginHangData()) PluginHangData;
            }
            (*(ptr_PluginHangData())) = (aRhs).get_PluginHangData();
            break;
        }
    case T__None:
        {
            MaybeDestroy(t);
            break;
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto HangData::operator==(const SlowScriptData& aRhs) const -> bool
{
    return (get_SlowScriptData()) == (aRhs);
}

auto HangData::operator==(const PluginHangData& aRhs) const -> bool
{
    return (get_PluginHangData()) == (aRhs);
}

auto HangData::operator==(const HangData& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TSlowScriptData:
        {
            return (get_SlowScriptData()) == ((aRhs).get_SlowScriptData());
        }
    case TPluginHangData:
        {
            return (get_PluginHangData()) == ((aRhs).get_PluginHangData());
        }
    default:
        {
            NS_RUNTIMEABORT("unreached");
            return false;
        }
    }
}

} // namespace mozilla
