//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/layout/PVsyncChild.h"
#include "mozilla/TimeStamp.h"

#include "mozilla/ipc/PBackgroundChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace layout {


auto PVsyncChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PVsyncChild::PVsyncChild() :
    mId(0),
    mState(PVsync::__Dead)
{
    MOZ_COUNT_CTOR(PVsyncChild);
}

PVsyncChild::~PVsyncChild()
{
    MOZ_COUNT_DTOR(PVsyncChild);
}

auto PVsyncChild::Manager() const -> PBackgroundChild*
{
    return static_cast<PBackgroundChild*>(mManager);
}

auto PVsyncChild::state() -> PVsync::State
{
    return mState;
}

auto PVsyncChild::SendObserve() -> bool
{
    PVsync::Msg_Observe* msg__ = new PVsync::Msg_Observe(mId);





    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PVsyncChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PVsync", "AsyncSendObserve", js::ProfileEntry::Category::OTHER);
    if ((!(PVsync::Transition(mState, Trigger(Trigger::Recv, PVsync::Msg_Observe__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PVsyncChild::SendUnobserve() -> bool
{
    PVsync::Msg_Unobserve* msg__ = new PVsync::Msg_Unobserve(mId);





    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PVsyncChild] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PVsync", "AsyncSendUnobserve", js::ProfileEntry::Category::OTHER);
    if ((!(PVsync::Transition(mState, Trigger(Trigger::Recv, PVsync::Msg_Unobserve__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PVsyncChild::Send__delete__(PVsyncChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PVsync::Msg___delete__* msg__ = new PVsync::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
        (msg__)->Log("[PVsyncChild] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PVsync", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PVsync::Transition((actor)->mState, Trigger(Trigger::Recv, PVsync::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PVsyncMsgStart, actor);
    return sendok__;
}

auto PVsyncChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PVsyncChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PVsyncChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PVsyncChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PVsyncChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PVsyncChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PVsyncChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PVsyncChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PVsyncChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PVsyncChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PVsyncChild::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PVsyncChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PVsyncChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PVsyncChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PVsync has not yet been implemented");
    return nullptr;
}

auto PVsyncChild::OnMessageReceived(const Message& msg__) -> PVsyncChild::Result
{
    switch ((msg__).type()) {
    case PVsync::Msg_Notify__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PVsync::Msg_Notify");
            if (mozilla::ipc::LoggingEnabledFor("PBackground")) {
                (static_cast<const PVsync::Msg_Notify*>((&(msg__))))->Log("[PVsyncChild] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PVsync", "RecvNotify", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            TimeStamp aVsyncTimestamp;

            if ((!(Read((&(aVsyncTimestamp)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'TimeStamp'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PVsync::Transition(mState, Trigger(Trigger::Send, PVsync::Msg_Notify__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvNotify(mozilla::Move(aVsyncTimestamp))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Notify returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PVsync::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PVsyncChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PVsyncChild::Result
{
    return MsgNotKnown;
}

auto PVsyncChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PVsyncChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PVsyncChild::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PVsyncChild::GetProtocolTypeId() -> int32_t
{
    return PVsyncMsgStart;
}

auto PVsyncChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PVsyncChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PVsyncChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PVsyncChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PVsyncChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PVsyncChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PVsyncChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PVsyncChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PVsyncChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PVsyncChild", aMsg, 0, false);
}

auto PVsyncChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PVsyncChild::DeallocSubtree() -> void
{
}

auto PVsyncChild::Write(
        PVsyncChild* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PVsyncChild::Read(
        PVsyncChild** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PVsyncChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PVsync");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PVsync");
        return false;
    }

    if ((PVsyncMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PVsync has different type");
        return false;
    }

    (*(v__)) = static_cast<PVsyncChild*>(listener);
    return true;
}



} // namespace layout
} // namespace mozilla
