//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PWebSocketParent.h"
#include "SerializedLoadContext.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/dom/PBrowserParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {



MOZ_IMPLICIT PWebSocketParent::PWebSocketParent() :
    mId(0),
    mState(PWebSocket::__Dead)
{
    MOZ_COUNT_CTOR(PWebSocketParent);
}

PWebSocketParent::~PWebSocketParent()
{
    MOZ_COUNT_DTOR(PWebSocketParent);
}

auto PWebSocketParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(mManager);
}

auto PWebSocketParent::state() -> PWebSocket::State
{
    return mState;
}

auto PWebSocketParent::SendOnStart(
        const nsCString& aProtocol,
        const nsCString& aExtensions,
        const nsString& aEffectiveURL,
        const bool& aEncrypted) -> bool
{
    PWebSocket::Msg_OnStart* msg__ = new PWebSocket::Msg_OnStart(mId);

    Write(aProtocol, msg__);
    Write(aExtensions, msg__);
    Write(aEffectiveURL, msg__);
    Write(aEncrypted, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnStart", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnStart__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PWebSocketParent::SendOnStop(const nsresult& aStatusCode) -> bool
{
    PWebSocket::Msg_OnStop* msg__ = new PWebSocket::Msg_OnStop(mId);

    Write(aStatusCode, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnStop", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnStop__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PWebSocketParent::SendOnMessageAvailable(const nsCString& aMsg) -> bool
{
    PWebSocket::Msg_OnMessageAvailable* msg__ = new PWebSocket::Msg_OnMessageAvailable(mId);

    Write(aMsg, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnMessageAvailable", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnMessageAvailable__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PWebSocketParent::SendOnBinaryMessageAvailable(const nsCString& aMsg) -> bool
{
    PWebSocket::Msg_OnBinaryMessageAvailable* msg__ = new PWebSocket::Msg_OnBinaryMessageAvailable(mId);

    Write(aMsg, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnBinaryMessageAvailable", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnBinaryMessageAvailable__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PWebSocketParent::SendOnAcknowledge(const uint32_t& aSize) -> bool
{
    PWebSocket::Msg_OnAcknowledge* msg__ = new PWebSocket::Msg_OnAcknowledge(mId);

    Write(aSize, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnAcknowledge", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnAcknowledge__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PWebSocketParent::SendOnServerClose(
        const uint16_t& code,
        const nsCString& aReason) -> bool
{
    PWebSocket::Msg_OnServerClose* msg__ = new PWebSocket::Msg_OnServerClose(mId);

    Write(code, msg__);
    Write(aReason, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnServerClose", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnServerClose__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PWebSocketParent::Send__delete__(PWebSocketParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    PWebSocket::Msg___delete__* msg__ = new PWebSocket::Msg___delete__((actor)->mId);

    (actor)->Write(actor, msg__, false);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (msg__)->Log("[PWebSocketParent] Sending ", (actor)->OtherPid(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition((actor)->mState, Trigger(Trigger::Send, PWebSocket::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = ((actor)->mChannel)->Send(msg__);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PWebSocketMsgStart, actor);
    return sendok__;
}

auto PWebSocketParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PWebSocketParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PWebSocketParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PWebSocketParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PWebSocketParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PWebSocketParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PWebSocketParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PWebSocketParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PWebSocketParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PWebSocketParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PWebSocketParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PWebSocketParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PWebSocketParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PWebSocketParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PWebSocket has not yet been implemented");
    return nullptr;
}

auto PWebSocketParent::OnMessageReceived(const Message& msg__) -> PWebSocketParent::Result
{
    switch ((msg__).type()) {
    case PWebSocket::Msg_AsyncOpen__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PWebSocket::Msg_AsyncOpen");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_AsyncOpen*>((&(msg__))))->Log("[PWebSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvAsyncOpen", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            URIParams aURI;
            nsCString aOrigin;
            nsCString aProtocol;
            bool aSecure;
            uint32_t aPingInterval;
            bool aClientSetPingInterval;
            uint32_t aPingTimeout;
            bool aClientSetPingTimeout;
            OptionalLoadInfoArgs aLoadInfoArgs;

            if ((!(Read((&(aURI)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'URIParams'");
                return MsgValueError;
            }
            if ((!(Read((&(aOrigin)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aProtocol)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aSecure)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(aPingInterval)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aClientSetPingInterval)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(aPingTimeout)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aClientSetPingTimeout)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(aLoadInfoArgs)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'OptionalLoadInfoArgs'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_AsyncOpen__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvAsyncOpen(mozilla::Move(aURI), mozilla::Move(aOrigin), mozilla::Move(aProtocol), mozilla::Move(aSecure), mozilla::Move(aPingInterval), mozilla::Move(aClientSetPingInterval), mozilla::Move(aPingTimeout), mozilla::Move(aClientSetPingTimeout), mozilla::Move(aLoadInfoArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for AsyncOpen returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_Close__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PWebSocket::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_Close*>((&(msg__))))->Log("[PWebSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvClose", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            uint16_t code;
            nsCString reason;

            if ((!(Read((&(code)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            if ((!(Read((&(reason)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose(mozilla::Move(code), mozilla::Move(reason))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_SendMsg__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PWebSocket::Msg_SendMsg");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_SendMsg*>((&(msg__))))->Log("[PWebSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvSendMsg", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aMsg;

            if ((!(Read((&(aMsg)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_SendMsg__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSendMsg(mozilla::Move(aMsg))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SendMsg returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_SendBinaryMsg__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PWebSocket::Msg_SendBinaryMsg");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_SendBinaryMsg*>((&(msg__))))->Log("[PWebSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvSendBinaryMsg", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            nsCString aMsg;

            if ((!(Read((&(aMsg)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_SendBinaryMsg__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSendBinaryMsg(mozilla::Move(aMsg))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SendBinaryMsg returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_SendBinaryStream__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PWebSocket::Msg_SendBinaryStream");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_SendBinaryStream*>((&(msg__))))->Log("[PWebSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvSendBinaryStream", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            InputStreamParams aStream;
            uint32_t aLength;

            if ((!(Read((&(aStream)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'InputStreamParams'");
                return MsgValueError;
            }
            if ((!(Read((&(aLength)), (&(msg__)), (&(iter__)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_SendBinaryStream__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSendBinaryStream(mozilla::Move(aStream), mozilla::Move(aLength))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SendBinaryStream returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_DeleteSelf__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PWebSocket::Msg_DeleteSelf");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_DeleteSelf*>((&(msg__))))->Log("[PWebSocketParent] Received ", OtherPid(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvDeleteSelf", js::ProfileEntry::Category::OTHER);

            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_DeleteSelf__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDeleteSelf()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DeleteSelf returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PWebSocketParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PWebSocketParent::Result
{
    return MsgNotKnown;
}

auto PWebSocketParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PWebSocketParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PWebSocketParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PWebSocketParent::GetProtocolTypeId() -> int32_t
{
    return PWebSocketMsgStart;
}

auto PWebSocketParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PWebSocketParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PWebSocketParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PWebSocketParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PWebSocketParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PWebSocketParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PWebSocketParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PWebSocketParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PWebSocketParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PWebSocketParent", aMsg, OtherPid(), true);
}

auto PWebSocketParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PWebSocketParent::DeallocSubtree() -> void
{
}

auto PWebSocketParent::Write(
        const SystemPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PWebSocketParent::Read(
        SystemPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PWebSocketParent::Write(
        const nsTArray<PrincipalInfo>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PWebSocketParent::Read(
        nsTArray<PrincipalInfo>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<PrincipalInfo> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'PrincipalInfo[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'PrincipalInfo[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PWebSocketParent::Write(
        const BufferedInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    Write((v__).bufferSize(), msg__);
}

auto PWebSocketParent::Read(
        BufferedInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->bufferSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const nsTArray<InputStreamParams>& v__,
        Message* msg__) -> void
{
    uint32_t length = (v__).Length();
    Write(length, msg__);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(v__[i], msg__);
    }
}

auto PWebSocketParent::Read(
        nsTArray<InputStreamParams>* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    FallibleTArray<InputStreamParams> fa;
    uint32_t length;
    if ((!(Read((&(length)), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'InputStreamParams[]'");
        return false;
    }

    if ((!((fa).SetLength(length, mozilla::fallible)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), msg__, iter__)))) {
            FatalError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
    }
    (v__)->SwapElements(fa);
    return true;
}

auto PWebSocketParent::Write(
        const OptionalURIParams& v__,
        Message* msg__) -> void
{
    typedef OptionalURIParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TURIParams:
        {
            Write((v__).get_URIParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        OptionalURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalURIParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalURIParams'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TURIParams:
        {
            URIParams tmp = URIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_URIParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const StandardURLParams& v__,
        Message* msg__) -> void
{
    Write((v__).urlType(), msg__);
    Write((v__).port(), msg__);
    Write((v__).defaultPort(), msg__);
    Write((v__).spec(), msg__);
    Write((v__).scheme(), msg__);
    Write((v__).authority(), msg__);
    Write((v__).username(), msg__);
    Write((v__).password(), msg__);
    Write((v__).host(), msg__);
    Write((v__).path(), msg__);
    Write((v__).filePath(), msg__);
    Write((v__).directory(), msg__);
    Write((v__).baseName(), msg__);
    Write((v__).extension(), msg__);
    Write((v__).query(), msg__);
    Write((v__).ref(), msg__);
    Write((v__).originCharset(), msg__);
    Write((v__).isMutable(), msg__);
    Write((v__).supportsFileURL(), msg__);
    Write((v__).hostEncoding(), msg__);
}

auto PWebSocketParent::Read(
        StandardURLParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->urlType())), msg__, iter__)))) {
        FatalError("Error deserializing 'urlType' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->port())), msg__, iter__)))) {
        FatalError("Error deserializing 'port' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->defaultPort())), msg__, iter__)))) {
        FatalError("Error deserializing 'defaultPort' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->scheme())), msg__, iter__)))) {
        FatalError("Error deserializing 'scheme' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->authority())), msg__, iter__)))) {
        FatalError("Error deserializing 'authority' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->username())), msg__, iter__)))) {
        FatalError("Error deserializing 'username' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->password())), msg__, iter__)))) {
        FatalError("Error deserializing 'password' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->host())), msg__, iter__)))) {
        FatalError("Error deserializing 'host' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->path())), msg__, iter__)))) {
        FatalError("Error deserializing 'path' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->filePath())), msg__, iter__)))) {
        FatalError("Error deserializing 'filePath' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->directory())), msg__, iter__)))) {
        FatalError("Error deserializing 'directory' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->baseName())), msg__, iter__)))) {
        FatalError("Error deserializing 'baseName' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->extension())), msg__, iter__)))) {
        FatalError("Error deserializing 'extension' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->query())), msg__, iter__)))) {
        FatalError("Error deserializing 'query' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->ref())), msg__, iter__)))) {
        FatalError("Error deserializing 'ref' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->originCharset())), msg__, iter__)))) {
        FatalError("Error deserializing 'originCharset' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->isMutable())), msg__, iter__)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->supportsFileURL())), msg__, iter__)))) {
        FatalError("Error deserializing 'supportsFileURL' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((v__)->hostEncoding())), msg__, iter__)))) {
        FatalError("Error deserializing 'hostEncoding' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const OptionalInputStreamParams& v__,
        Message* msg__) -> void
{
    typedef OptionalInputStreamParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TInputStreamParams:
        {
            Write((v__).get_InputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        OptionalInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalInputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalInputStreamParams'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_InputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const URIParams& v__,
        Message* msg__) -> void
{
    typedef URIParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TSimpleURIParams:
        {
            Write((v__).get_SimpleURIParams(), msg__);
            return;
        }
    case type__::TStandardURLParams:
        {
            Write((v__).get_StandardURLParams(), msg__);
            return;
        }
    case type__::TJARURIParams:
        {
            Write((v__).get_JARURIParams(), msg__);
            return;
        }
    case type__::TIconURIParams:
        {
            Write((v__).get_IconURIParams(), msg__);
            return;
        }
    case type__::TNullPrincipalURIParams:
        {
            Write((v__).get_NullPrincipalURIParams(), msg__);
            return;
        }
    case type__::TJSURIParams:
        {
            Write((v__).get_JSURIParams(), msg__);
            return;
        }
    case type__::TSimpleNestedURIParams:
        {
            Write((v__).get_SimpleNestedURIParams(), msg__);
            return;
        }
    case type__::THostObjectURIParams:
        {
            Write((v__).get_HostObjectURIParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        URIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef URIParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'URIParams'");
        return false;
    }

    switch (type) {
    case type__::TSimpleURIParams:
        {
            SimpleURIParams tmp = SimpleURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SimpleURIParams())), msg__, iter__);
        }
    case type__::TStandardURLParams:
        {
            StandardURLParams tmp = StandardURLParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StandardURLParams())), msg__, iter__);
        }
    case type__::TJARURIParams:
        {
            JARURIParams tmp = JARURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_JARURIParams())), msg__, iter__);
        }
    case type__::TIconURIParams:
        {
            IconURIParams tmp = IconURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_IconURIParams())), msg__, iter__);
        }
    case type__::TNullPrincipalURIParams:
        {
            NullPrincipalURIParams tmp = NullPrincipalURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_NullPrincipalURIParams())), msg__, iter__);
        }
    case type__::TJSURIParams:
        {
            JSURIParams tmp = JSURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_JSURIParams())), msg__, iter__);
        }
    case type__::TSimpleNestedURIParams:
        {
            SimpleNestedURIParams tmp = SimpleNestedURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SimpleNestedURIParams())), msg__, iter__);
        }
    case type__::THostObjectURIParams:
        {
            HostObjectURIParams tmp = HostObjectURIParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_HostObjectURIParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const FileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileDescriptorIndex(), msg__);
    Write((v__).behaviorFlags(), msg__);
    Write((v__).ioFlags(), msg__);
}

auto PWebSocketParent::Read(
        FileInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->fileDescriptorIndex())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->behaviorFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->ioFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const SimpleNestedURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).simpleParams(), msg__);
    Write((v__).innerURI(), msg__);
}

auto PWebSocketParent::Read(
        SimpleNestedURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->simpleParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'simpleParams' (SimpleURIParams) member of 'SimpleNestedURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->innerURI())), msg__, iter__)))) {
        FatalError("Error deserializing 'innerURI' (URIParams) member of 'SimpleNestedURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const OptionalPrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef OptionalPrincipalInfo type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TPrincipalInfo:
        {
            Write((v__).get_PrincipalInfo(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        OptionalPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalPrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalPrincipalInfo'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TPrincipalInfo:
        {
            PrincipalInfo tmp = PrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_PrincipalInfo())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const ExpandedPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).whitelist(), msg__);
}

auto PWebSocketParent::Read(
        ExpandedPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->whitelist())), msg__, iter__)))) {
        FatalError("Error deserializing 'whitelist' (PrincipalInfo[]) member of 'ExpandedPrincipalInfo'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const JSURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).simpleParams(), msg__);
    Write((v__).baseURI(), msg__);
}

auto PWebSocketParent::Read(
        JSURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->simpleParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'simpleParams' (SimpleURIParams) member of 'JSURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->baseURI())), msg__, iter__)))) {
        FatalError("Error deserializing 'baseURI' (OptionalURIParams) member of 'JSURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const HostObjectURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).simpleParams(), msg__);
    Write((v__).principal(), msg__);
}

auto PWebSocketParent::Read(
        HostObjectURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->simpleParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'simpleParams' (SimpleURIParams) member of 'HostObjectURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->principal())), msg__, iter__)))) {
        FatalError("Error deserializing 'principal' (OptionalPrincipalInfo) member of 'HostObjectURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        PWebSocketParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PWebSocketParent::Read(
        PWebSocketParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PWebSocketParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PWebSocket");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PWebSocket");
        return false;
    }

    if ((PWebSocketMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PWebSocket has different type");
        return false;
    }

    (*(v__)) = static_cast<PWebSocketParent*>(listener);
    return true;
}

auto PWebSocketParent::Write(
        const PrincipalInfo& v__,
        Message* msg__) -> void
{
    typedef PrincipalInfo type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TContentPrincipalInfo:
        {
            Write((v__).get_ContentPrincipalInfo(), msg__);
            return;
        }
    case type__::TSystemPrincipalInfo:
        {
            Write((v__).get_SystemPrincipalInfo(), msg__);
            return;
        }
    case type__::TNullPrincipalInfo:
        {
            Write((v__).get_NullPrincipalInfo(), msg__);
            return;
        }
    case type__::TExpandedPrincipalInfo:
        {
            Write((v__).get_ExpandedPrincipalInfo(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        PrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef PrincipalInfo type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'PrincipalInfo'");
        return false;
    }

    switch (type) {
    case type__::TContentPrincipalInfo:
        {
            ContentPrincipalInfo tmp = ContentPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_ContentPrincipalInfo())), msg__, iter__);
        }
    case type__::TSystemPrincipalInfo:
        {
            SystemPrincipalInfo tmp = SystemPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SystemPrincipalInfo())), msg__, iter__);
        }
    case type__::TNullPrincipalInfo:
        {
            NullPrincipalInfo tmp = NullPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_NullPrincipalInfo())), msg__, iter__);
        }
    case type__::TExpandedPrincipalInfo:
        {
            ExpandedPrincipalInfo tmp = ExpandedPrincipalInfo();
            (*(v__)) = tmp;
            return Read((&((v__)->get_ExpandedPrincipalInfo())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const MIMEInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).optionalStream(), msg__);
    Write((v__).headers(), msg__);
    Write((v__).contentLength(), msg__);
    Write((v__).startedReading(), msg__);
    Write((v__).addContentLength(), msg__);
}

auto PWebSocketParent::Read(
        MIMEInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->optionalStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->headers())), msg__, iter__)))) {
        FatalError("Error deserializing 'headers' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->contentLength())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentLength' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReading())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->addContentLength())), msg__, iter__)))) {
        FatalError("Error deserializing 'addContentLength' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const JARURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).jarFile(), msg__);
    Write((v__).jarEntry(), msg__);
    Write((v__).charset(), msg__);
}

auto PWebSocketParent::Read(
        JARURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->jarFile())), msg__, iter__)))) {
        FatalError("Error deserializing 'jarFile' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->jarEntry())), msg__, iter__)))) {
        FatalError("Error deserializing 'jarEntry' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->charset())), msg__, iter__)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'JARURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const InputStreamParams& v__,
        Message* msg__) -> void
{
    typedef InputStreamParams type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::TStringInputStreamParams:
        {
            Write((v__).get_StringInputStreamParams(), msg__);
            return;
        }
    case type__::TFileInputStreamParams:
        {
            Write((v__).get_FileInputStreamParams(), msg__);
            return;
        }
    case type__::TPartialFileInputStreamParams:
        {
            Write((v__).get_PartialFileInputStreamParams(), msg__);
            return;
        }
    case type__::TBufferedInputStreamParams:
        {
            Write((v__).get_BufferedInputStreamParams(), msg__);
            return;
        }
    case type__::TMIMEInputStreamParams:
        {
            Write((v__).get_MIMEInputStreamParams(), msg__);
            return;
        }
    case type__::TMultiplexInputStreamParams:
        {
            Write((v__).get_MultiplexInputStreamParams(), msg__);
            return;
        }
    case type__::TRemoteInputStreamParams:
        {
            Write((v__).get_RemoteInputStreamParams(), msg__);
            return;
        }
    case type__::TSameProcessInputStreamParams:
        {
            Write((v__).get_SameProcessInputStreamParams(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        InputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef InputStreamParams type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'InputStreamParams'");
        return false;
    }

    switch (type) {
    case type__::TStringInputStreamParams:
        {
            StringInputStreamParams tmp = StringInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_StringInputStreamParams())), msg__, iter__);
        }
    case type__::TFileInputStreamParams:
        {
            FileInputStreamParams tmp = FileInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_FileInputStreamParams())), msg__, iter__);
        }
    case type__::TPartialFileInputStreamParams:
        {
            PartialFileInputStreamParams tmp = PartialFileInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_PartialFileInputStreamParams())), msg__, iter__);
        }
    case type__::TBufferedInputStreamParams:
        {
            BufferedInputStreamParams tmp = BufferedInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_BufferedInputStreamParams())), msg__, iter__);
        }
    case type__::TMIMEInputStreamParams:
        {
            MIMEInputStreamParams tmp = MIMEInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_MIMEInputStreamParams())), msg__, iter__);
        }
    case type__::TMultiplexInputStreamParams:
        {
            MultiplexInputStreamParams tmp = MultiplexInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_MultiplexInputStreamParams())), msg__, iter__);
        }
    case type__::TRemoteInputStreamParams:
        {
            RemoteInputStreamParams tmp = RemoteInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_RemoteInputStreamParams())), msg__, iter__);
        }
    case type__::TSameProcessInputStreamParams:
        {
            SameProcessInputStreamParams tmp = SameProcessInputStreamParams();
            (*(v__)) = tmp;
            return Read((&((v__)->get_SameProcessInputStreamParams())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const SameProcessInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).addRefedInputStream(), msg__);
}

auto PWebSocketParent::Read(
        SameProcessInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->addRefedInputStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'addRefedInputStream' (intptr_t) member of 'SameProcessInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const MultiplexInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).streams(), msg__);
    Write((v__).currentStream(), msg__);
    Write((v__).status(), msg__);
    Write((v__).startedReadingCurrent(), msg__);
}

auto PWebSocketParent::Read(
        MultiplexInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->streams())), msg__, iter__)))) {
        FatalError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->currentStream())), msg__, iter__)))) {
        FatalError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->status())), msg__, iter__)))) {
        FatalError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->startedReadingCurrent())), msg__, iter__)))) {
        FatalError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const OptionalLoadInfoArgs& v__,
        Message* msg__) -> void
{
    typedef OptionalLoadInfoArgs type__;
    Write(int((v__).type()), msg__);

    switch ((v__).type()) {
    case type__::Tvoid_t:
        {
            Write((v__).get_void_t(), msg__);
            return;
        }
    case type__::TLoadInfoArgs:
        {
            Write((v__).get_LoadInfoArgs(), msg__);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        OptionalLoadInfoArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    typedef OptionalLoadInfoArgs type__;
    int type;
    if ((!(Read((&(type)), msg__, iter__)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalLoadInfoArgs'");
        return false;
    }

    switch (type) {
    case type__::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(v__)) = tmp;
            return Read((&((v__)->get_void_t())), msg__, iter__);
        }
    case type__::TLoadInfoArgs:
        {
            LoadInfoArgs tmp = LoadInfoArgs();
            (*(v__)) = tmp;
            return Read((&((v__)->get_LoadInfoArgs())), msg__, iter__);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const SimpleURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).scheme(), msg__);
    Write((v__).path(), msg__);
    Write((v__).ref(), msg__);
    Write((v__).isMutable(), msg__);
}

auto PWebSocketParent::Read(
        SimpleURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->scheme())), msg__, iter__)))) {
        FatalError("Error deserializing 'scheme' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->path())), msg__, iter__)))) {
        FatalError("Error deserializing 'path' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->ref())), msg__, iter__)))) {
        FatalError("Error deserializing 'ref' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->isMutable())), msg__, iter__)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'SimpleURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const StringInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).data(), msg__);
}

auto PWebSocketParent::Read(
        StringInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->data())), msg__, iter__)))) {
        FatalError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const NullPrincipalURIParams& v__,
        Message* msg__) -> void
{
}

auto PWebSocketParent::Read(
        NullPrincipalURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PWebSocketParent::Write(
        const IconURIParams& v__,
        Message* msg__) -> void
{
    Write((v__).uri(), msg__);
    Write((v__).size(), msg__);
    Write((v__).contentType(), msg__);
    Write((v__).fileName(), msg__);
    Write((v__).stockIcon(), msg__);
    Write((v__).iconSize(), msg__);
    Write((v__).iconState(), msg__);
}

auto PWebSocketParent::Read(
        IconURIParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->uri())), msg__, iter__)))) {
        FatalError("Error deserializing 'uri' (OptionalURIParams) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->size())), msg__, iter__)))) {
        FatalError("Error deserializing 'size' (uint32_t) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->contentType())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentType' (nsCString) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->fileName())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileName' (nsCString) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->stockIcon())), msg__, iter__)))) {
        FatalError("Error deserializing 'stockIcon' (nsCString) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->iconSize())), msg__, iter__)))) {
        FatalError("Error deserializing 'iconSize' (int32_t) member of 'IconURIParams'");
        return false;
    }
    if ((!(Read((&((v__)->iconState())), msg__, iter__)))) {
        FatalError("Error deserializing 'iconState' (int32_t) member of 'IconURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const ContentPrincipalInfo& v__,
        Message* msg__) -> void
{
    Write((v__).appId(), msg__);
    Write((v__).isInBrowserElement(), msg__);
    Write((v__).spec(), msg__);
}

auto PWebSocketParent::Read(
        ContentPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->appId())), msg__, iter__)))) {
        FatalError("Error deserializing 'appId' (uint32_t) member of 'ContentPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->isInBrowserElement())), msg__, iter__)))) {
        FatalError("Error deserializing 'isInBrowserElement' (bool) member of 'ContentPrincipalInfo'");
        return false;
    }
    if ((!(Read((&((v__)->spec())), msg__, iter__)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'ContentPrincipalInfo'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const LoadInfoArgs& v__,
        Message* msg__) -> void
{
    Write((v__).requestingPrincipalInfo(), msg__);
    Write((v__).triggeringPrincipalInfo(), msg__);
    Write((v__).securityFlags(), msg__);
    Write((v__).contentPolicyType(), msg__);
    Write((v__).upgradeInsecureRequests(), msg__);
    Write((v__).innerWindowID(), msg__);
    Write((v__).outerWindowID(), msg__);
    Write((v__).parentOuterWindowID(), msg__);
    Write((v__).enforceSecurity(), msg__);
    Write((v__).initialSecurityCheckDone(), msg__);
    Write((v__).redirectChain(), msg__);
}

auto PWebSocketParent::Read(
        LoadInfoArgs* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->requestingPrincipalInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'requestingPrincipalInfo' (PrincipalInfo) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->triggeringPrincipalInfo())), msg__, iter__)))) {
        FatalError("Error deserializing 'triggeringPrincipalInfo' (PrincipalInfo) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->securityFlags())), msg__, iter__)))) {
        FatalError("Error deserializing 'securityFlags' (uint32_t) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->contentPolicyType())), msg__, iter__)))) {
        FatalError("Error deserializing 'contentPolicyType' (uint32_t) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->upgradeInsecureRequests())), msg__, iter__)))) {
        FatalError("Error deserializing 'upgradeInsecureRequests' (bool) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->innerWindowID())), msg__, iter__)))) {
        FatalError("Error deserializing 'innerWindowID' (uint64_t) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->outerWindowID())), msg__, iter__)))) {
        FatalError("Error deserializing 'outerWindowID' (uint64_t) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->parentOuterWindowID())), msg__, iter__)))) {
        FatalError("Error deserializing 'parentOuterWindowID' (uint64_t) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->enforceSecurity())), msg__, iter__)))) {
        FatalError("Error deserializing 'enforceSecurity' (bool) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->initialSecurityCheckDone())), msg__, iter__)))) {
        FatalError("Error deserializing 'initialSecurityCheckDone' (bool) member of 'LoadInfoArgs'");
        return false;
    }
    if ((!(Read((&((v__)->redirectChain())), msg__, iter__)))) {
        FatalError("Error deserializing 'redirectChain' (PrincipalInfo[]) member of 'LoadInfoArgs'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const NullPrincipalInfo& v__,
        Message* msg__) -> void
{
}

auto PWebSocketParent::Read(
        NullPrincipalInfo* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    return true;
}

auto PWebSocketParent::Write(
        const StandardURLSegment& v__,
        Message* msg__) -> void
{
    Write((v__).position(), msg__);
    Write((v__).length(), msg__);
}

auto PWebSocketParent::Read(
        StandardURLSegment* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->position())), msg__, iter__)))) {
        FatalError("Error deserializing 'position' (uint32_t) member of 'StandardURLSegment'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (int32_t) member of 'StandardURLSegment'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const PartialFileInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).fileStreamParams(), msg__);
    Write((v__).begin(), msg__);
    Write((v__).length(), msg__);
}

auto PWebSocketParent::Read(
        PartialFileInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->fileStreamParams())), msg__, iter__)))) {
        FatalError("Error deserializing 'fileStreamParams' (FileInputStreamParams) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->begin())), msg__, iter__)))) {
        FatalError("Error deserializing 'begin' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((v__)->length())), msg__, iter__)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const RemoteInputStreamParams& v__,
        Message* msg__) -> void
{
    Write((v__).id(), msg__);
}

auto PWebSocketParent::Read(
        RemoteInputStreamParams* v__,
        const Message* msg__,
        void** iter__) -> bool
{
    if ((!(Read((&((v__)->id())), msg__, iter__)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'RemoteInputStreamParams'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
