//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PProcessHangMonitor_h
#define PProcessHangMonitor_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "mozilla/dom/ipc/IdType.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SlowScriptData|
//
namespace mozilla {
class SlowScriptData final
{
private:
    typedef mozilla::dom::TabId TabId;

public:
    MOZ_IMPLICIT SlowScriptData();

    MOZ_IMPLICIT SlowScriptData(
            const TabId& _tabId,
            const nsCString& _filename,
            const uint32_t& _lineno)
    {
        Init();
        Assign(_tabId, _filename, _lineno);
    }

    MOZ_IMPLICIT SlowScriptData(const SlowScriptData& _o)
    {
        Init();
        Assign((_o).tabId(), (_o).filename(), (_o).lineno());
    }

    ~SlowScriptData();

    void
    operator=(const SlowScriptData& _o)
    {
        Assign((_o).tabId(), (_o).filename(), (_o).lineno());
    }

    bool
    operator==(const SlowScriptData& _o) const;

    TabId&
    tabId()
    {
        return tabId_;
    }
    const TabId&
    tabId() const
    {
        return tabId_;
    }

    nsCString&
    filename()
    {
        return filename_;
    }
    const nsCString&
    filename() const
    {
        return filename_;
    }

    uint32_t&
    lineno()
    {
        return lineno_;
    }
    const uint32_t&
    lineno() const
    {
        return lineno_;
    }

private:
    void
    Init();

    void
    Assign(
            const TabId& _tabId,
            const nsCString& _filename,
            const uint32_t& _lineno);

    TabId tabId_;
    nsCString filename_;
    uint32_t lineno_;
};
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PluginHangData|
//
namespace mozilla {
class PluginHangData final
{
private:

public:
    MOZ_IMPLICIT PluginHangData();

    MOZ_IMPLICIT PluginHangData(const uint32_t& _pluginId)
    {
        Init();
        Assign(_pluginId);
    }

    MOZ_IMPLICIT PluginHangData(const PluginHangData& _o)
    {
        Init();
        Assign((_o).pluginId());
    }

    ~PluginHangData();

    void
    operator=(const PluginHangData& _o)
    {
        Assign((_o).pluginId());
    }

    bool
    operator==(const PluginHangData& _o) const;

    uint32_t&
    pluginId()
    {
        return pluginId_;
    }
    const uint32_t&
    pluginId() const
    {
        return pluginId_;
    }

private:
    void
    Init();

    void
    Assign(const uint32_t& _pluginId);

    uint32_t pluginId_;
};
} // namespace mozilla

namespace mozilla {
class SlowScriptData;
} // namespace mozilla
namespace mozilla {
class PluginHangData;
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HangData|
//
namespace mozilla {
class HangData final
{
public:
    enum Type {
        T__None,
        TSlowScriptData = 1,
        TPluginHangData,
        T__Last = TPluginHangData
    };

private:
    typedef mozilla::SlowScriptData SlowScriptData;
    typedef mozilla::PluginHangData PluginHangData;
    typedef SlowScriptData SlowScriptData__tdef;
    typedef PluginHangData PluginHangData__tdef;

    union Value {
        char VSlowScriptData[sizeof(SlowScriptData)];
        char VPluginHangData[sizeof(PluginHangData)];
    };

    SlowScriptData*
    ptr_SlowScriptData()
    {
        return reinterpret_cast<SlowScriptData*>((&((mValue).VSlowScriptData)));
    }
    const SlowScriptData* const
    constptr_SlowScriptData() const
    {
        return reinterpret_cast<const SlowScriptData* const>((&((mValue).VSlowScriptData)));
    }
    PluginHangData*
    ptr_PluginHangData()
    {
        return reinterpret_cast<PluginHangData*>((&((mValue).VPluginHangData)));
    }
    const PluginHangData* const
    constptr_PluginHangData() const
    {
        return reinterpret_cast<const PluginHangData* const>((&((mValue).VPluginHangData)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HangData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HangData(const SlowScriptData& aOther);

    MOZ_IMPLICIT HangData(const PluginHangData& aOther);

    MOZ_IMPLICIT HangData(const HangData& aOther);

    ~HangData();

    Type
    type() const
    {
        return mType;
    }

    HangData&
    operator=(const SlowScriptData& aRhs);

    HangData&
    operator=(const PluginHangData& aRhs);

    HangData&
    operator=(const HangData& aRhs);

    bool
    operator==(const SlowScriptData& aRhs) const;

    bool
    operator==(const PluginHangData& aRhs) const;

    bool
    operator==(const HangData& aRhs) const;

    SlowScriptData&
    get_SlowScriptData()
    {
        AssertSanity(TSlowScriptData);
        return (*(ptr_SlowScriptData()));
    }
    const SlowScriptData&
    get_SlowScriptData() const
    {
        AssertSanity(TSlowScriptData);
        return (*(constptr_SlowScriptData()));
    }
    operator SlowScriptData&()
    {
        return get_SlowScriptData();
    }
    operator const SlowScriptData&() const
    {
        return get_SlowScriptData();
    }

    PluginHangData&
    get_PluginHangData()
    {
        AssertSanity(TPluginHangData);
        return (*(ptr_PluginHangData()));
    }
    const PluginHangData&
    get_PluginHangData() const
    {
        AssertSanity(TPluginHangData);
        return (*(constptr_PluginHangData()));
    }
    operator PluginHangData&()
    {
        return get_PluginHangData();
    }
    operator const PluginHangData&() const
    {
        return get_PluginHangData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PProcessHangMonitorChild and PProcessHangMonitorParent
//
namespace mozilla {
namespace PProcessHangMonitor {

bool
Open(mozilla::dom::PContentParent* opener);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PProcessHangMonitorStart = PProcessHangMonitorMsgStart << 16,
    Msg_HangEvidence__ID,
    Msg_TerminateScript__ID,
    Msg_BeginStartingDebugger__ID,
    Msg_EndStartingDebugger__ID,
    PProcessHangMonitorEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_HangEvidence :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HangEvidence__ID
    };
    MOZ_IMPLICIT Msg_HangEvidence(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PProcessHangMonitor::Msg_HangEvidence")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_HangEvidence(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_TerminateScript :
    public IPC::Message
{
public:
    enum {
        ID = Msg_TerminateScript__ID
    };
    MOZ_IMPLICIT Msg_TerminateScript(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PProcessHangMonitor::Msg_TerminateScript")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_TerminateScript(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_BeginStartingDebugger :
    public IPC::Message
{
public:
    enum {
        ID = Msg_BeginStartingDebugger__ID
    };
    MOZ_IMPLICIT Msg_BeginStartingDebugger(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PProcessHangMonitor::Msg_BeginStartingDebugger")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_BeginStartingDebugger(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EndStartingDebugger :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EndStartingDebugger__ID
    };
    MOZ_IMPLICIT Msg_EndStartingDebugger(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PProcessHangMonitor::Msg_EndStartingDebugger")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EndStartingDebugger(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PProcessHangMonitor
} // namespace mozilla

#endif // ifndef PProcessHangMonitor_h
