//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFMRadioParent_h
#define PFMRadioParent_h

#include "mozilla/dom/PFMRadio.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/HalTypes.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PFMRadioRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PFMRadioRequestChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PFMRadioRequestParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PFMRadioParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

    friend class mozilla::dom::PFMRadioRequestParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::CancelSeekRequestArgs CancelSeekRequestArgs;
    typedef mozilla::dom::DisableRDSArgs DisableRDSArgs;
    typedef mozilla::dom::DisableRequestArgs DisableRequestArgs;
    typedef mozilla::dom::EnableRDSArgs EnableRDSArgs;
    typedef mozilla::dom::EnableRequestArgs EnableRequestArgs;
    typedef mozilla::dom::FMRadioRequestArgs FMRadioRequestArgs;
    typedef mozilla::hal::FMRadioSeekDirection FMRadioSeekDirection;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::SeekRequestArgs SeekRequestArgs;
    typedef mozilla::dom::SetFrequencyRequestArgs SetFrequencyRequestArgs;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::StatusInfo StatusInfo;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PFMRadioRequestParent PFMRadioRequestParent;
    typedef mozilla::dom::PFMRadioRequestChild PFMRadioRequestChild;

    typedef PFMRadio::State State;

    virtual bool
    RecvGetStatusInfo(StatusInfo* info) = 0;
    virtual bool
    RecvPFMRadioRequestConstructor(
            PFMRadioRequestParent* actor,
            const FMRadioRequestArgs& requestType);
    virtual bool
    RecvEnableAudio(const bool& audioEnabled) = 0;
    virtual bool
    RecvSetRDSGroupMask(const uint32_t& groupMask) = 0;
    virtual PFMRadioRequestParent*
    AllocPFMRadioRequestParent(const FMRadioRequestArgs& requestType) = 0;
    virtual bool
    DeallocPFMRadioRequestParent(PFMRadioRequestParent* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PFMRadioParent();

    virtual ~PFMRadioParent();

    PContentParent*
    Manager() const;

    void
    ManagedPFMRadioRequestParent(nsTArray<PFMRadioRequestParent*>& aArr) const;
    const nsTArray<PFMRadioRequestParent*>&
    ManagedPFMRadioRequestParent() const;

    PFMRadio::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyFrequencyChanged(const double& frequency);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyEnabledChanged(
            const bool& enabled,
            const double& frequency);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyRDSEnabledChanged(const bool& enabled);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyPIChanged(
            const bool& valid,
            const uint16_t& code);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyPTYChanged(
            const bool& valid,
            const uint8_t& pty);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyPSChanged(const nsString& psname);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyRadiotextChanged(const nsString& radiotext);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyNewRDSGroup(const uint64_t& data);

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(PFMRadioParent* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PFMRadioRequestParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PFMRadioRequestParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const EnableRequestArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            EnableRequestArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const FMRadioRequestArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            FMRadioRequestArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const DisableRDSArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DisableRDSArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const EnableRDSArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            EnableRDSArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SetFrequencyRequestArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SetFrequencyRequestArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const CancelSeekRequestArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            CancelSeekRequestArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PFMRadioParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PFMRadioParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const DisableRequestArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DisableRequestArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SeekRequestArgs& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SeekRequestArgs* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const StatusInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            StatusInfo* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
    // Sorted by pointer value
    nsTArray<PFMRadioRequestParent*> mManagedPFMRadioRequestParent;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class FMRadioParent :
    public PFMRadioParent
{
    virtual bool
    RecvGetStatusInfo(StatusInfo* info);

    virtual bool
    RecvEnableAudio(const bool& audioEnabled);

    virtual bool
    RecvSetRDSGroupMask(const uint32_t& groupMask);

    virtual PFMRadioRequestParent*
    AllocPFMRadioRequestParent(const FMRadioRequestArgs& requestType);

    virtual bool
    DeallocPFMRadioRequestParent(PFMRadioRequestParent* aActor);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT FMRadioParent();
    virtual ~FMRadioParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
FMRadioParent::RecvGetStatusInfo(StatusInfo* info)
{
    return false;
}

bool
FMRadioParent::RecvEnableAudio(const bool& audioEnabled)
{
    return false;
}

bool
FMRadioParent::RecvSetRDSGroupMask(const uint32_t& groupMask)
{
    return false;
}

PFMRadioRequestParent*
FMRadioParent::AllocPFMRadioRequestParent(const FMRadioRequestArgs& requestType)
{
    return 0;
}

bool
FMRadioParent::DeallocPFMRadioRequestParent(PFMRadioRequestParent* aActor)
{
    return false;
}

void
FMRadioParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT FMRadioParent::FMRadioParent()
{
    MOZ_COUNT_CTOR(FMRadioParent);
}

MOZ_IMPLICIT FMRadioParent::~FMRadioParent()
{
    MOZ_COUNT_DTOR(FMRadioParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PFMRadioParent_h
