//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFMRadioRequest_h
#define PFMRadioRequest_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ErrorResponse|
//
namespace mozilla {
namespace dom {
class ErrorResponse final
{
private:

public:
    MOZ_IMPLICIT ErrorResponse();

    MOZ_IMPLICIT ErrorResponse(const nsString& _error)
    {
        Init();
        Assign(_error);
    }

    MOZ_IMPLICIT ErrorResponse(const ErrorResponse& _o)
    {
        Init();
        Assign((_o).error());
    }

    ~ErrorResponse();

    void
    operator=(const ErrorResponse& _o)
    {
        Assign((_o).error());
    }

    bool
    operator==(const ErrorResponse& _o) const;

    nsString&
    error()
    {
        return error_;
    }
    const nsString&
    error() const
    {
        return error_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _error);

    nsString error_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SuccessResponse|
//
namespace mozilla {
namespace dom {
class SuccessResponse final
{
private:

public:
    MOZ_IMPLICIT SuccessResponse()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT SuccessResponse(const SuccessResponse& _o)
    {
        Init();
        Assign();
    }

    ~SuccessResponse();

    void
    operator=(const SuccessResponse& _o)
    {
        Assign();
    }

    bool
    operator==(const SuccessResponse& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ErrorResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SuccessResponse;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FMRadioResponseType|
//
namespace mozilla {
namespace dom {
class FMRadioResponseType final
{
public:
    enum Type {
        T__None,
        TErrorResponse = 1,
        TSuccessResponse,
        T__Last = TSuccessResponse
    };

private:
    typedef mozilla::dom::ErrorResponse ErrorResponse;
    typedef mozilla::dom::SuccessResponse SuccessResponse;
    typedef ErrorResponse ErrorResponse__tdef;
    typedef SuccessResponse SuccessResponse__tdef;

    union Value {
        char VErrorResponse[sizeof(ErrorResponse)];
        char VSuccessResponse[sizeof(SuccessResponse)];
    };

    ErrorResponse*
    ptr_ErrorResponse()
    {
        return reinterpret_cast<ErrorResponse*>((&((mValue).VErrorResponse)));
    }
    const ErrorResponse* const
    constptr_ErrorResponse() const
    {
        return reinterpret_cast<const ErrorResponse* const>((&((mValue).VErrorResponse)));
    }
    SuccessResponse*
    ptr_SuccessResponse()
    {
        return reinterpret_cast<SuccessResponse*>((&((mValue).VSuccessResponse)));
    }
    const SuccessResponse* const
    constptr_SuccessResponse() const
    {
        return reinterpret_cast<const SuccessResponse* const>((&((mValue).VSuccessResponse)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FMRadioResponseType() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FMRadioResponseType(const ErrorResponse& aOther);

    MOZ_IMPLICIT FMRadioResponseType(const SuccessResponse& aOther);

    MOZ_IMPLICIT FMRadioResponseType(const FMRadioResponseType& aOther);

    ~FMRadioResponseType();

    Type
    type() const
    {
        return mType;
    }

    FMRadioResponseType&
    operator=(const ErrorResponse& aRhs);

    FMRadioResponseType&
    operator=(const SuccessResponse& aRhs);

    FMRadioResponseType&
    operator=(const FMRadioResponseType& aRhs);

    bool
    operator==(const ErrorResponse& aRhs) const;

    bool
    operator==(const SuccessResponse& aRhs) const;

    bool
    operator==(const FMRadioResponseType& aRhs) const;

    ErrorResponse&
    get_ErrorResponse()
    {
        AssertSanity(TErrorResponse);
        return (*(ptr_ErrorResponse()));
    }
    const ErrorResponse&
    get_ErrorResponse() const
    {
        AssertSanity(TErrorResponse);
        return (*(constptr_ErrorResponse()));
    }
    operator ErrorResponse&()
    {
        return get_ErrorResponse();
    }
    operator const ErrorResponse&() const
    {
        return get_ErrorResponse();
    }

    SuccessResponse&
    get_SuccessResponse()
    {
        AssertSanity(TSuccessResponse);
        return (*(ptr_SuccessResponse()));
    }
    const SuccessResponse&
    get_SuccessResponse() const
    {
        AssertSanity(TSuccessResponse);
        return (*(constptr_SuccessResponse()));
    }
    operator SuccessResponse&()
    {
        return get_SuccessResponse();
    }
    operator const SuccessResponse&() const
    {
        return get_SuccessResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PFMRadioRequestChild and PFMRadioRequestParent
//
namespace mozilla {
namespace dom {
namespace PFMRadioRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PFMRadioRequestStart = PFMRadioRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    PFMRadioRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFMRadioRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFMRadioRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PFMRadioRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PFMRadioRequest_h
