//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFilePicker_h
#define PFilePicker_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct InputFiles|
//
namespace mozilla {
namespace dom {
class InputFiles final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT InputFiles();

    MOZ_IMPLICIT InputFiles(
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild)
    {
        Init();
        Assign(_blobsParent, _blobsChild);
    }

    MOZ_IMPLICIT InputFiles(const InputFiles& _o)
    {
        Init();
        Assign((_o).blobsParent(), (_o).blobsChild());
    }

    ~InputFiles();

    void
    operator=(const InputFiles& _o)
    {
        Assign((_o).blobsParent(), (_o).blobsChild());
    }

    bool
    operator==(const InputFiles& _o) const;

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild);

    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class InputFiles;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeInputFiles|
//
namespace mozilla {
namespace dom {
class MaybeInputFiles final
{
public:
    enum Type {
        T__None,
        TInputFiles = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::InputFiles InputFiles;
    typedef mozilla::void_t void_t;
    typedef InputFiles InputFiles__tdef;
    typedef void_t void_t__tdef;

    union Value {
        char VInputFiles[sizeof(InputFiles)];
        char Vvoid_t[sizeof(void_t)];
    };

    InputFiles*
    ptr_InputFiles()
    {
        return reinterpret_cast<InputFiles*>((&((mValue).VInputFiles)));
    }
    const InputFiles* const
    constptr_InputFiles() const
    {
        return reinterpret_cast<const InputFiles* const>((&((mValue).VInputFiles)));
    }
    void_t*
    ptr_void_t()
    {
        return reinterpret_cast<void_t*>((&((mValue).Vvoid_t)));
    }
    const void_t* const
    constptr_void_t() const
    {
        return reinterpret_cast<const void_t* const>((&((mValue).Vvoid_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeInputFiles() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeInputFiles(const InputFiles& aOther);

    MOZ_IMPLICIT MaybeInputFiles(const void_t& aOther);

    MOZ_IMPLICIT MaybeInputFiles(const MaybeInputFiles& aOther);

    ~MaybeInputFiles();

    Type
    type() const
    {
        return mType;
    }

    MaybeInputFiles&
    operator=(const InputFiles& aRhs);

    MaybeInputFiles&
    operator=(const void_t& aRhs);

    MaybeInputFiles&
    operator=(const MaybeInputFiles& aRhs);

    bool
    operator==(const InputFiles& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const MaybeInputFiles& aRhs) const;

    InputFiles&
    get_InputFiles()
    {
        AssertSanity(TInputFiles);
        return (*(ptr_InputFiles()));
    }
    const InputFiles&
    get_InputFiles() const
    {
        AssertSanity(TInputFiles);
        return (*(constptr_InputFiles()));
    }
    operator InputFiles&()
    {
        return get_InputFiles();
    }
    operator const InputFiles&() const
    {
        return get_InputFiles();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PFilePickerChild and PFilePickerParent
//
namespace mozilla {
namespace dom {
namespace PFilePicker {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PFilePickerStart = PFilePickerMsgStart << 16,
    Msg_Open__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PFilePickerEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_Open :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Open__ID
    };
    MOZ_IMPLICIT Msg_Open(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFilePicker::Msg_Open")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Open(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFilePicker::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PFilePicker::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PFilePicker
} // namespace dom
} // namespace mozilla

#endif // ifndef PFilePicker_h
