//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFilePickerParent_h
#define PFilePickerParent_h

#include "mozilla/dom/PFilePicker.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace dom {


class PFilePickerParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PBrowserParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::InputFiles InputFiles;
    typedef mozilla::dom::MaybeInputFiles MaybeInputFiles;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;

    typedef PFilePicker::State State;

    virtual bool
    RecvOpen(
            const int16_t& selectedType,
            const bool& addToRecentDocs,
            const nsString& defaultFile,
            const nsString& defaultExtension,
            nsTArray<nsString>&& filters,
            nsTArray<nsString>&& filterNames,
            const nsString& displayDirectory) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PFilePickerParent();

    virtual ~PFilePickerParent();

    PBrowserParent*
    Manager() const;

    PFilePicker::State
    state();

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(
            PFilePickerParent* actor,
            const MaybeInputFiles& files,
            const int16_t& result);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const MaybeInputFiles& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            MaybeInputFiles* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const InputFiles& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            InputFiles* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<PBlobParent*>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<PBlobParent*>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PFilePickerParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PFilePickerParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            PBlobParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PBlobParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class FilePickerParent :
    public PFilePickerParent
{
    virtual bool
    RecvOpen(
            const int16_t& selectedType,
            const bool& addToRecentDocs,
            const nsString& defaultFile,
            const nsString& defaultExtension,
            nsTArray<nsString>&& filters,
            nsTArray<nsString>&& filterNames,
            const nsString& displayDirectory);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT FilePickerParent();
    virtual ~FilePickerParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
FilePickerParent::RecvOpen(
        const int16_t& selectedType,
        const bool& addToRecentDocs,
        const nsString& defaultFile,
        const nsString& defaultExtension,
        nsTArray<nsString>&& filters,
        nsTArray<nsString>&& filterNames,
        const nsString& displayDirectory)
{
    return false;
}

void
FilePickerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT FilePickerParent::FilePickerParent()
{
    MOZ_COUNT_CTOR(FilePickerParent);
}

MOZ_IMPLICIT FilePickerParent::~FilePickerParent()
{
    MOZ_COUNT_DTOR(FilePickerParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PFilePickerParent_h
