//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMessagePort_h
#define PMessagePort_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "nsID.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MessagePortIdentifier|
//
namespace mozilla {
namespace dom {
class MessagePortIdentifier final
{
private:

public:
    MOZ_IMPLICIT MessagePortIdentifier();

    MOZ_IMPLICIT MessagePortIdentifier(
            const nsID& _uuid,
            const nsID& _destinationUuid,
            const uint32_t& _sequenceId,
            const bool& _neutered)
    {
        Init();
        Assign(_uuid, _destinationUuid, _sequenceId, _neutered);
    }

    MOZ_IMPLICIT MessagePortIdentifier(const MessagePortIdentifier& _o)
    {
        Init();
        Assign((_o).uuid(), (_o).destinationUuid(), (_o).sequenceId(), (_o).neutered());
    }

    ~MessagePortIdentifier();

    void
    operator=(const MessagePortIdentifier& _o)
    {
        Assign((_o).uuid(), (_o).destinationUuid(), (_o).sequenceId(), (_o).neutered());
    }

    bool
    operator==(const MessagePortIdentifier& _o) const;

    nsID&
    uuid()
    {
        return uuid_;
    }
    const nsID&
    uuid() const
    {
        return uuid_;
    }

    nsID&
    destinationUuid()
    {
        return destinationUuid_;
    }
    const nsID&
    destinationUuid() const
    {
        return destinationUuid_;
    }

    uint32_t&
    sequenceId()
    {
        return sequenceId_;
    }
    const uint32_t&
    sequenceId() const
    {
        return sequenceId_;
    }

    bool&
    neutered()
    {
        return neutered_;
    }
    const bool&
    neutered() const
    {
        return neutered_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _uuid,
            const nsID& _destinationUuid,
            const uint32_t& _sequenceId,
            const bool& _neutered);

    nsID uuid_;
    nsID destinationUuid_;
    uint32_t sequenceId_;
    bool neutered_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class MessagePortIdentifier;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MessagePortMessage|
//
namespace mozilla {
namespace dom {
class MessagePortMessage final
{
private:
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT MessagePortMessage();

    MOZ_IMPLICIT MessagePortMessage(
            const nsTArray<MessagePortIdentifier>& _transferredPorts,
            const nsTArray<uint8_t>& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild)
    {
        Init();
        Assign(_transferredPorts, _data, _blobsParent, _blobsChild);
    }

    MOZ_IMPLICIT MessagePortMessage(const MessagePortMessage& _o)
    {
        Init();
        Assign((_o).transferredPorts(), (_o).data(), (_o).blobsParent(), (_o).blobsChild());
    }

    ~MessagePortMessage();

    void
    operator=(const MessagePortMessage& _o)
    {
        Assign((_o).transferredPorts(), (_o).data(), (_o).blobsParent(), (_o).blobsChild());
    }

    bool
    operator==(const MessagePortMessage& _o) const;

    nsTArray<MessagePortIdentifier>&
    transferredPorts()
    {
        return transferredPorts_;
    }
    const nsTArray<MessagePortIdentifier>&
    transferredPorts() const
    {
        return transferredPorts_;
    }

    nsTArray<uint8_t>&
    data()
    {
        return data_;
    }
    const nsTArray<uint8_t>&
    data() const
    {
        return data_;
    }

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<MessagePortIdentifier>& _transferredPorts,
            const nsTArray<uint8_t>& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild);

    nsTArray<MessagePortIdentifier> transferredPorts_;
    nsTArray<uint8_t> data_;
    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PMessagePortChild and PMessagePortParent
//
namespace mozilla {
namespace dom {
namespace PMessagePort {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PMessagePortStart = PMessagePortMsgStart << 16,
    Msg_PostMessages__ID,
    Msg_Disentangle__ID,
    Msg_StopSendingData__ID,
    Msg_Close__ID,
    Msg_Entangled__ID,
    Msg_ReceiveData__ID,
    Msg_StopSendingDataConfirmed__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PMessagePortEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_PostMessages :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PostMessages__ID
    };
    MOZ_IMPLICIT Msg_PostMessages(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_PostMessages")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PostMessages(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Disentangle :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Disentangle__ID
    };
    MOZ_IMPLICIT Msg_Disentangle(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_Disentangle")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Disentangle(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StopSendingData :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StopSendingData__ID
    };
    MOZ_IMPLICIT Msg_StopSendingData(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_StopSendingData")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StopSendingData(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Close :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Close__ID
    };
    MOZ_IMPLICIT Msg_Close(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_Close")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Close(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Entangled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Entangled__ID
    };
    MOZ_IMPLICIT Msg_Entangled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_Entangled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Entangled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ReceiveData :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ReceiveData__ID
    };
    MOZ_IMPLICIT Msg_ReceiveData(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_ReceiveData")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ReceiveData(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_StopSendingDataConfirmed :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StopSendingDataConfirmed__ID
    };
    MOZ_IMPLICIT Msg_StopSendingDataConfirmed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg_StopSendingDataConfirmed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_StopSendingDataConfirmed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PMessagePort::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PMessagePort
} // namespace dom
} // namespace mozilla

#endif // ifndef PMessagePort_h
