//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMessagePortChild_h
#define PMessagePortChild_h

#include "mozilla/dom/PMessagePort.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

struct nsID;

namespace mozilla {
namespace dom {


class PMessagePortChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::ipc::PBackgroundChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;
    typedef mozilla::dom::MessagePortMessage MessagePortMessage;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef mozilla::dom::PBlobParent PBlobParent;

    typedef PMessagePort::State State;

    virtual bool
    RecvEntangled(nsTArray<MessagePortMessage>&& messages) = 0;
    virtual bool
    RecvReceiveData(nsTArray<MessagePortMessage>&& messages) = 0;
    virtual bool
    RecvStopSendingDataConfirmed() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PMessagePortChild();

    virtual ~PMessagePortChild();

    PBackgroundChild*
    Manager() const;

    PMessagePort::State
    state();

    bool
    SendPostMessages(const nsTArray<MessagePortMessage>& messages);

    bool
    SendDisentangle(const nsTArray<MessagePortMessage>& messages);

    bool
    SendStopSendingData();

    bool
    SendClose();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<MessagePortMessage>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<MessagePortMessage>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const MessagePortMessage& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            MessagePortMessage* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<MessagePortIdentifier>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<MessagePortIdentifier>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<PBlobChild*>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<PBlobChild*>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PMessagePortChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PMessagePortChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const MessagePortIdentifier& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            MessagePortIdentifier* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PBlobChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PBlobChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class MessagePortChild :
    public PMessagePortChild
{
    virtual bool
    RecvEntangled(nsTArray<MessagePortMessage>&& messages);

    virtual bool
    RecvReceiveData(nsTArray<MessagePortMessage>&& messages);

    virtual bool
    RecvStopSendingDataConfirmed();

    MOZ_IMPLICIT MessagePortChild();
    virtual ~MessagePortChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
MessagePortChild::RecvEntangled(nsTArray<MessagePortMessage>&& messages)
{
    return false;
}

bool
MessagePortChild::RecvReceiveData(nsTArray<MessagePortMessage>&& messages)
{
    return false;
}

bool
MessagePortChild::RecvStopSendingDataConfirmed()
{
    return false;
}

MOZ_IMPLICIT MessagePortChild::MessagePortChild()
{
    MOZ_COUNT_CTOR(MessagePortChild);
}

MOZ_IMPLICIT MessagePortChild::~MessagePortChild()
{
    MOZ_COUNT_DTOR(MessagePortChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PMessagePortChild_h
