//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPresentation_h
#define PPresentation_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/InputStreamParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StartSessionRequest|
//
namespace mozilla {
namespace dom {
class StartSessionRequest final
{
private:

public:
    MOZ_IMPLICIT StartSessionRequest();

    MOZ_IMPLICIT StartSessionRequest(
            const nsString& _url,
            const nsString& _sessionId,
            const nsString& _origin)
    {
        Init();
        Assign(_url, _sessionId, _origin);
    }

    MOZ_IMPLICIT StartSessionRequest(const StartSessionRequest& _o)
    {
        Init();
        Assign((_o).url(), (_o).sessionId(), (_o).origin());
    }

    ~StartSessionRequest();

    void
    operator=(const StartSessionRequest& _o)
    {
        Assign((_o).url(), (_o).sessionId(), (_o).origin());
    }

    bool
    operator==(const StartSessionRequest& _o) const;

    nsString&
    url()
    {
        return url_;
    }
    const nsString&
    url() const
    {
        return url_;
    }

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

    nsString&
    origin()
    {
        return origin_;
    }
    const nsString&
    origin() const
    {
        return origin_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _url,
            const nsString& _sessionId,
            const nsString& _origin);

    nsString url_;
    nsString sessionId_;
    nsString origin_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SendSessionMessageRequest|
//
namespace mozilla {
namespace dom {
class SendSessionMessageRequest final
{
private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;

public:
    MOZ_IMPLICIT SendSessionMessageRequest();

    MOZ_IMPLICIT SendSessionMessageRequest(
            const nsString& _sessionId,
            const InputStreamParams& _data)
    {
        Init();
        Assign(_sessionId, _data);
    }

    MOZ_IMPLICIT SendSessionMessageRequest(const SendSessionMessageRequest& _o)
    {
        Init();
        Assign((_o).sessionId(), (_o).data());
    }

    ~SendSessionMessageRequest();

    void
    operator=(const SendSessionMessageRequest& _o)
    {
        Assign((_o).sessionId(), (_o).data());
    }

    bool
    operator==(const SendSessionMessageRequest& _o) const;

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

    InputStreamParams&
    data()
    {
        return data_;
    }
    const InputStreamParams&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _sessionId,
            const InputStreamParams& _data);

    nsString sessionId_;
    InputStreamParams data_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TerminateRequest|
//
namespace mozilla {
namespace dom {
class TerminateRequest final
{
private:

public:
    MOZ_IMPLICIT TerminateRequest();

    MOZ_IMPLICIT TerminateRequest(const nsString& _sessionId)
    {
        Init();
        Assign(_sessionId);
    }

    MOZ_IMPLICIT TerminateRequest(const TerminateRequest& _o)
    {
        Init();
        Assign((_o).sessionId());
    }

    ~TerminateRequest();

    void
    operator=(const TerminateRequest& _o)
    {
        Assign((_o).sessionId());
    }

    bool
    operator==(const TerminateRequest& _o) const;

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _sessionId);

    nsString sessionId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class StartSessionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SendSessionMessageRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class TerminateRequest;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union PresentationRequest|
//
namespace mozilla {
namespace dom {
class PresentationRequest final
{
public:
    enum Type {
        T__None,
        TStartSessionRequest = 1,
        TSendSessionMessageRequest,
        TTerminateRequest,
        T__Last = TTerminateRequest
    };

private:
    typedef mozilla::dom::StartSessionRequest StartSessionRequest;
    typedef mozilla::dom::SendSessionMessageRequest SendSessionMessageRequest;
    typedef mozilla::dom::TerminateRequest TerminateRequest;
    typedef StartSessionRequest StartSessionRequest__tdef;
    typedef SendSessionMessageRequest SendSessionMessageRequest__tdef;
    typedef TerminateRequest TerminateRequest__tdef;

    union Value {
        char VStartSessionRequest[sizeof(StartSessionRequest)];
        char VSendSessionMessageRequest[sizeof(SendSessionMessageRequest)];
        char VTerminateRequest[sizeof(TerminateRequest)];
    };

    StartSessionRequest*
    ptr_StartSessionRequest()
    {
        return reinterpret_cast<StartSessionRequest*>((&((mValue).VStartSessionRequest)));
    }
    const StartSessionRequest* const
    constptr_StartSessionRequest() const
    {
        return reinterpret_cast<const StartSessionRequest* const>((&((mValue).VStartSessionRequest)));
    }
    SendSessionMessageRequest*
    ptr_SendSessionMessageRequest()
    {
        return reinterpret_cast<SendSessionMessageRequest*>((&((mValue).VSendSessionMessageRequest)));
    }
    const SendSessionMessageRequest* const
    constptr_SendSessionMessageRequest() const
    {
        return reinterpret_cast<const SendSessionMessageRequest* const>((&((mValue).VSendSessionMessageRequest)));
    }
    TerminateRequest*
    ptr_TerminateRequest()
    {
        return reinterpret_cast<TerminateRequest*>((&((mValue).VTerminateRequest)));
    }
    const TerminateRequest* const
    constptr_TerminateRequest() const
    {
        return reinterpret_cast<const TerminateRequest* const>((&((mValue).VTerminateRequest)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT PresentationRequest() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT PresentationRequest(const StartSessionRequest& aOther);

    MOZ_IMPLICIT PresentationRequest(const SendSessionMessageRequest& aOther);

    MOZ_IMPLICIT PresentationRequest(const TerminateRequest& aOther);

    MOZ_IMPLICIT PresentationRequest(const PresentationRequest& aOther);

    ~PresentationRequest();

    Type
    type() const
    {
        return mType;
    }

    PresentationRequest&
    operator=(const StartSessionRequest& aRhs);

    PresentationRequest&
    operator=(const SendSessionMessageRequest& aRhs);

    PresentationRequest&
    operator=(const TerminateRequest& aRhs);

    PresentationRequest&
    operator=(const PresentationRequest& aRhs);

    bool
    operator==(const StartSessionRequest& aRhs) const;

    bool
    operator==(const SendSessionMessageRequest& aRhs) const;

    bool
    operator==(const TerminateRequest& aRhs) const;

    bool
    operator==(const PresentationRequest& aRhs) const;

    StartSessionRequest&
    get_StartSessionRequest()
    {
        AssertSanity(TStartSessionRequest);
        return (*(ptr_StartSessionRequest()));
    }
    const StartSessionRequest&
    get_StartSessionRequest() const
    {
        AssertSanity(TStartSessionRequest);
        return (*(constptr_StartSessionRequest()));
    }
    operator StartSessionRequest&()
    {
        return get_StartSessionRequest();
    }
    operator const StartSessionRequest&() const
    {
        return get_StartSessionRequest();
    }

    SendSessionMessageRequest&
    get_SendSessionMessageRequest()
    {
        AssertSanity(TSendSessionMessageRequest);
        return (*(ptr_SendSessionMessageRequest()));
    }
    const SendSessionMessageRequest&
    get_SendSessionMessageRequest() const
    {
        AssertSanity(TSendSessionMessageRequest);
        return (*(constptr_SendSessionMessageRequest()));
    }
    operator SendSessionMessageRequest&()
    {
        return get_SendSessionMessageRequest();
    }
    operator const SendSessionMessageRequest&() const
    {
        return get_SendSessionMessageRequest();
    }

    TerminateRequest&
    get_TerminateRequest()
    {
        AssertSanity(TTerminateRequest);
        return (*(ptr_TerminateRequest()));
    }
    const TerminateRequest&
    get_TerminateRequest() const
    {
        AssertSanity(TTerminateRequest);
        return (*(constptr_TerminateRequest()));
    }
    operator TerminateRequest&()
    {
        return get_TerminateRequest();
    }
    operator const TerminateRequest&() const
    {
        return get_TerminateRequest();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PPresentationChild and PPresentationParent
//
namespace mozilla {
namespace dom {
namespace PPresentation {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PPresentationStart = PPresentationMsgStart << 16,
    Msg_NotifyAvailableChange__ID,
    Msg_NotifySessionStateChange__ID,
    Msg_NotifyMessage__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_RegisterHandler__ID,
    Msg_UnregisterHandler__ID,
    Msg_RegisterSessionHandler__ID,
    Msg_UnregisterSessionHandler__ID,
    Msg_PPresentationRequestConstructor__ID,
    Reply_PPresentationRequestConstructor__ID,
    Msg_GetExistentSessionIdAtLaunch__ID,
    Reply_GetExistentSessionIdAtLaunch__ID,
    Msg_NotifyReceiverReady__ID,
    PPresentationEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_NotifyAvailableChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyAvailableChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyAvailableChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_NotifyAvailableChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyAvailableChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifySessionStateChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifySessionStateChange__ID
    };
    MOZ_IMPLICIT Msg_NotifySessionStateChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_NotifySessionStateChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifySessionStateChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyMessage :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyMessage__ID
    };
    MOZ_IMPLICIT Msg_NotifyMessage(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_NotifyMessage")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyMessage(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RegisterHandler :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RegisterHandler__ID
    };
    MOZ_IMPLICIT Msg_RegisterHandler(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_RegisterHandler")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RegisterHandler(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UnregisterHandler :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UnregisterHandler__ID
    };
    MOZ_IMPLICIT Msg_UnregisterHandler(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_UnregisterHandler")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UnregisterHandler(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_RegisterSessionHandler :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RegisterSessionHandler__ID
    };
    MOZ_IMPLICIT Msg_RegisterSessionHandler(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_RegisterSessionHandler")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_RegisterSessionHandler(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UnregisterSessionHandler :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UnregisterSessionHandler__ID
    };
    MOZ_IMPLICIT Msg_UnregisterSessionHandler(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_UnregisterSessionHandler")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UnregisterSessionHandler(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PPresentationRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PPresentationRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PPresentationRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_PPresentationRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PPresentationRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_PPresentationRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PPresentationRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PPresentationRequestConstructor(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Reply_PPresentationRequestConstructor")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_PPresentationRequestConstructor(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetExistentSessionIdAtLaunch :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetExistentSessionIdAtLaunch__ID
    };
    MOZ_IMPLICIT Msg_GetExistentSessionIdAtLaunch(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_GetExistentSessionIdAtLaunch")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetExistentSessionIdAtLaunch(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetExistentSessionIdAtLaunch :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetExistentSessionIdAtLaunch__ID
    };
    MOZ_IMPLICIT Reply_GetExistentSessionIdAtLaunch(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Reply_GetExistentSessionIdAtLaunch")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetExistentSessionIdAtLaunch(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyReceiverReady :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyReceiverReady__ID
    };
    MOZ_IMPLICIT Msg_NotifyReceiverReady(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PPresentation::Msg_NotifyReceiverReady")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyReceiverReady(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PPresentation
} // namespace dom
} // namespace mozilla

#endif // ifndef PPresentation_h
