//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PStorageParent_h
#define PStorageParent_h

#include "mozilla/dom/PStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PStorageParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PStorage::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvPreload(
            const nsCString& scope,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv) = 0;
    virtual bool
    RecvAsyncPreload(
            const nsCString& scope,
            const bool& priority) = 0;
    virtual bool
    RecvAsyncGetUsage(const nsCString& scope) = 0;
    virtual bool
    RecvAsyncAddItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value) = 0;
    virtual bool
    RecvAsyncUpdateItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value) = 0;
    virtual bool
    RecvAsyncRemoveItem(
            const nsCString& scope,
            const nsString& key) = 0;
    virtual bool
    RecvAsyncClear(const nsCString& scope) = 0;
    virtual bool
    RecvAsyncFlush() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PStorageParent();

    virtual ~PStorageParent();

    PContentParent*
    Manager() const;

    PStorage::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendObserve(
            const nsCString& topic,
            const nsCString& scopePrefix);

    MOZ_WARN_UNUSED_RESULT bool
    SendScopesHavingData(const nsTArray<nsCString>& scopes);

    MOZ_WARN_UNUSED_RESULT bool
    SendLoadItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value);

    MOZ_WARN_UNUSED_RESULT bool
    SendLoadDone(
            const nsCString& scope,
            const nsresult& rv);

    MOZ_WARN_UNUSED_RESULT bool
    SendLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    MOZ_WARN_UNUSED_RESULT bool
    SendError(const nsresult& rv);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PStorageParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PStorageParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class StorageParent :
    public PStorageParent
{
    virtual bool
    RecvPreload(
            const nsCString& scope,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv);

    virtual bool
    RecvAsyncPreload(
            const nsCString& scope,
            const bool& priority);

    virtual bool
    RecvAsyncGetUsage(const nsCString& scope);

    virtual bool
    RecvAsyncAddItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value);

    virtual bool
    RecvAsyncUpdateItem(
            const nsCString& scope,
            const nsString& key,
            const nsString& value);

    virtual bool
    RecvAsyncRemoveItem(
            const nsCString& scope,
            const nsString& key);

    virtual bool
    RecvAsyncClear(const nsCString& scope);

    virtual bool
    RecvAsyncFlush();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT StorageParent();
    virtual ~StorageParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
StorageParent::RecvPreload(
        const nsCString& scope,
        const uint32_t& alreadyLoadedCount,
        nsTArray<nsString>* keys,
        nsTArray<nsString>* values,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvAsyncPreload(
        const nsCString& scope,
        const bool& priority)
{
    return false;
}

bool
StorageParent::RecvAsyncGetUsage(const nsCString& scope)
{
    return false;
}

bool
StorageParent::RecvAsyncAddItem(
        const nsCString& scope,
        const nsString& key,
        const nsString& value)
{
    return false;
}

bool
StorageParent::RecvAsyncUpdateItem(
        const nsCString& scope,
        const nsString& key,
        const nsString& value)
{
    return false;
}

bool
StorageParent::RecvAsyncRemoveItem(
        const nsCString& scope,
        const nsString& key)
{
    return false;
}

bool
StorageParent::RecvAsyncClear(const nsCString& scope)
{
    return false;
}

bool
StorageParent::RecvAsyncFlush()
{
    return false;
}

void
StorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT StorageParent::StorageParent()
{
    MOZ_COUNT_CTOR(StorageParent);
}

MOZ_IMPLICIT StorageParent::~StorageParent()
{
    MOZ_COUNT_DTOR(StorageParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PStorageParent_h
