//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTabContext_h
#define PTabContext_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/dom/PBrowserOrId.h"

namespace mozilla {
namespace dom {
class PBrowserOrId;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PopupIPCTabContext|
//
namespace mozilla {
namespace dom {
class PopupIPCTabContext final
{
private:
    typedef mozilla::dom::PBrowserOrId PBrowserOrId;

public:
    MOZ_IMPLICIT PopupIPCTabContext();

    MOZ_IMPLICIT PopupIPCTabContext(
            const PBrowserOrId& _opener,
            const bool& _isBrowserElement)
    {
        Init();
        Assign(_opener, _isBrowserElement);
    }

    MOZ_IMPLICIT PopupIPCTabContext(const PopupIPCTabContext& _o)
    {
        Init();
        Assign((_o).opener(), (_o).isBrowserElement());
    }

    ~PopupIPCTabContext();

    void
    operator=(const PopupIPCTabContext& _o)
    {
        Assign((_o).opener(), (_o).isBrowserElement());
    }

    bool
    operator==(const PopupIPCTabContext& _o) const;

    PBrowserOrId&
    opener()
    {
        return opener_;
    }
    const PBrowserOrId&
    opener() const
    {
        return opener_;
    }

    bool&
    isBrowserElement()
    {
        return isBrowserElement_;
    }
    const bool&
    isBrowserElement() const
    {
        return isBrowserElement_;
    }

private:
    void
    Init();

    void
    Assign(
            const PBrowserOrId& _opener,
            const bool& _isBrowserElement);

    PBrowserOrId opener_;
    bool isBrowserElement_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AppFrameIPCTabContext|
//
namespace mozilla {
namespace dom {
class AppFrameIPCTabContext final
{
private:

public:
    MOZ_IMPLICIT AppFrameIPCTabContext();

    MOZ_IMPLICIT AppFrameIPCTabContext(
            const uint32_t& _ownAppId,
            const uint32_t& _appFrameOwnerAppId)
    {
        Init();
        Assign(_ownAppId, _appFrameOwnerAppId);
    }

    MOZ_IMPLICIT AppFrameIPCTabContext(const AppFrameIPCTabContext& _o)
    {
        Init();
        Assign((_o).ownAppId(), (_o).appFrameOwnerAppId());
    }

    ~AppFrameIPCTabContext();

    void
    operator=(const AppFrameIPCTabContext& _o)
    {
        Assign((_o).ownAppId(), (_o).appFrameOwnerAppId());
    }

    bool
    operator==(const AppFrameIPCTabContext& _o) const;

    uint32_t&
    ownAppId()
    {
        return ownAppId_;
    }
    const uint32_t&
    ownAppId() const
    {
        return ownAppId_;
    }

    uint32_t&
    appFrameOwnerAppId()
    {
        return appFrameOwnerAppId_;
    }
    const uint32_t&
    appFrameOwnerAppId() const
    {
        return appFrameOwnerAppId_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _ownAppId,
            const uint32_t& _appFrameOwnerAppId);

    uint32_t ownAppId_;
    uint32_t appFrameOwnerAppId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BrowserFrameIPCTabContext|
//
namespace mozilla {
namespace dom {
class BrowserFrameIPCTabContext final
{
private:

public:
    MOZ_IMPLICIT BrowserFrameIPCTabContext();

    MOZ_IMPLICIT BrowserFrameIPCTabContext(const uint32_t& _browserFrameOwnerAppId)
    {
        Init();
        Assign(_browserFrameOwnerAppId);
    }

    MOZ_IMPLICIT BrowserFrameIPCTabContext(const BrowserFrameIPCTabContext& _o)
    {
        Init();
        Assign((_o).browserFrameOwnerAppId());
    }

    ~BrowserFrameIPCTabContext();

    void
    operator=(const BrowserFrameIPCTabContext& _o)
    {
        Assign((_o).browserFrameOwnerAppId());
    }

    bool
    operator==(const BrowserFrameIPCTabContext& _o) const;

    uint32_t&
    browserFrameOwnerAppId()
    {
        return browserFrameOwnerAppId_;
    }
    const uint32_t&
    browserFrameOwnerAppId() const
    {
        return browserFrameOwnerAppId_;
    }

private:
    void
    Init();

    void
    Assign(const uint32_t& _browserFrameOwnerAppId);

    uint32_t browserFrameOwnerAppId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct VanillaFrameIPCTabContext|
//
namespace mozilla {
namespace dom {
class VanillaFrameIPCTabContext final
{
private:

public:
    MOZ_IMPLICIT VanillaFrameIPCTabContext()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT VanillaFrameIPCTabContext(const VanillaFrameIPCTabContext& _o)
    {
        Init();
        Assign();
    }

    ~VanillaFrameIPCTabContext();

    void
    operator=(const VanillaFrameIPCTabContext& _o)
    {
        Assign();
    }

    bool
    operator==(const VanillaFrameIPCTabContext& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PopupIPCTabContext;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class AppFrameIPCTabContext;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class BrowserFrameIPCTabContext;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class VanillaFrameIPCTabContext;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCTabAppBrowserContext|
//
namespace mozilla {
namespace dom {
class IPCTabAppBrowserContext final
{
public:
    enum Type {
        T__None,
        TPopupIPCTabContext = 1,
        TAppFrameIPCTabContext,
        TBrowserFrameIPCTabContext,
        TVanillaFrameIPCTabContext,
        T__Last = TVanillaFrameIPCTabContext
    };

private:
    typedef mozilla::dom::PopupIPCTabContext PopupIPCTabContext;
    typedef mozilla::dom::AppFrameIPCTabContext AppFrameIPCTabContext;
    typedef mozilla::dom::BrowserFrameIPCTabContext BrowserFrameIPCTabContext;
    typedef mozilla::dom::VanillaFrameIPCTabContext VanillaFrameIPCTabContext;
    typedef PopupIPCTabContext PopupIPCTabContext__tdef;
    typedef AppFrameIPCTabContext AppFrameIPCTabContext__tdef;
    typedef BrowserFrameIPCTabContext BrowserFrameIPCTabContext__tdef;
    typedef VanillaFrameIPCTabContext VanillaFrameIPCTabContext__tdef;

    union Value {
        char VPopupIPCTabContext[sizeof(PopupIPCTabContext)];
        char VAppFrameIPCTabContext[sizeof(AppFrameIPCTabContext)];
        char VBrowserFrameIPCTabContext[sizeof(BrowserFrameIPCTabContext)];
        char VVanillaFrameIPCTabContext[sizeof(VanillaFrameIPCTabContext)];
    };

    PopupIPCTabContext*
    ptr_PopupIPCTabContext()
    {
        return reinterpret_cast<PopupIPCTabContext*>((&((mValue).VPopupIPCTabContext)));
    }
    const PopupIPCTabContext* const
    constptr_PopupIPCTabContext() const
    {
        return reinterpret_cast<const PopupIPCTabContext* const>((&((mValue).VPopupIPCTabContext)));
    }
    AppFrameIPCTabContext*
    ptr_AppFrameIPCTabContext()
    {
        return reinterpret_cast<AppFrameIPCTabContext*>((&((mValue).VAppFrameIPCTabContext)));
    }
    const AppFrameIPCTabContext* const
    constptr_AppFrameIPCTabContext() const
    {
        return reinterpret_cast<const AppFrameIPCTabContext* const>((&((mValue).VAppFrameIPCTabContext)));
    }
    BrowserFrameIPCTabContext*
    ptr_BrowserFrameIPCTabContext()
    {
        return reinterpret_cast<BrowserFrameIPCTabContext*>((&((mValue).VBrowserFrameIPCTabContext)));
    }
    const BrowserFrameIPCTabContext* const
    constptr_BrowserFrameIPCTabContext() const
    {
        return reinterpret_cast<const BrowserFrameIPCTabContext* const>((&((mValue).VBrowserFrameIPCTabContext)));
    }
    VanillaFrameIPCTabContext*
    ptr_VanillaFrameIPCTabContext()
    {
        return reinterpret_cast<VanillaFrameIPCTabContext*>((&((mValue).VVanillaFrameIPCTabContext)));
    }
    const VanillaFrameIPCTabContext* const
    constptr_VanillaFrameIPCTabContext() const
    {
        return reinterpret_cast<const VanillaFrameIPCTabContext* const>((&((mValue).VVanillaFrameIPCTabContext)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCTabAppBrowserContext() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCTabAppBrowserContext(const PopupIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabAppBrowserContext(const AppFrameIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabAppBrowserContext(const BrowserFrameIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabAppBrowserContext(const VanillaFrameIPCTabContext& aOther);

    MOZ_IMPLICIT IPCTabAppBrowserContext(const IPCTabAppBrowserContext& aOther);

    ~IPCTabAppBrowserContext();

    Type
    type() const
    {
        return mType;
    }

    IPCTabAppBrowserContext&
    operator=(const PopupIPCTabContext& aRhs);

    IPCTabAppBrowserContext&
    operator=(const AppFrameIPCTabContext& aRhs);

    IPCTabAppBrowserContext&
    operator=(const BrowserFrameIPCTabContext& aRhs);

    IPCTabAppBrowserContext&
    operator=(const VanillaFrameIPCTabContext& aRhs);

    IPCTabAppBrowserContext&
    operator=(const IPCTabAppBrowserContext& aRhs);

    bool
    operator==(const PopupIPCTabContext& aRhs) const;

    bool
    operator==(const AppFrameIPCTabContext& aRhs) const;

    bool
    operator==(const BrowserFrameIPCTabContext& aRhs) const;

    bool
    operator==(const VanillaFrameIPCTabContext& aRhs) const;

    bool
    operator==(const IPCTabAppBrowserContext& aRhs) const;

    PopupIPCTabContext&
    get_PopupIPCTabContext()
    {
        AssertSanity(TPopupIPCTabContext);
        return (*(ptr_PopupIPCTabContext()));
    }
    const PopupIPCTabContext&
    get_PopupIPCTabContext() const
    {
        AssertSanity(TPopupIPCTabContext);
        return (*(constptr_PopupIPCTabContext()));
    }
    operator PopupIPCTabContext&()
    {
        return get_PopupIPCTabContext();
    }
    operator const PopupIPCTabContext&() const
    {
        return get_PopupIPCTabContext();
    }

    AppFrameIPCTabContext&
    get_AppFrameIPCTabContext()
    {
        AssertSanity(TAppFrameIPCTabContext);
        return (*(ptr_AppFrameIPCTabContext()));
    }
    const AppFrameIPCTabContext&
    get_AppFrameIPCTabContext() const
    {
        AssertSanity(TAppFrameIPCTabContext);
        return (*(constptr_AppFrameIPCTabContext()));
    }
    operator AppFrameIPCTabContext&()
    {
        return get_AppFrameIPCTabContext();
    }
    operator const AppFrameIPCTabContext&() const
    {
        return get_AppFrameIPCTabContext();
    }

    BrowserFrameIPCTabContext&
    get_BrowserFrameIPCTabContext()
    {
        AssertSanity(TBrowserFrameIPCTabContext);
        return (*(ptr_BrowserFrameIPCTabContext()));
    }
    const BrowserFrameIPCTabContext&
    get_BrowserFrameIPCTabContext() const
    {
        AssertSanity(TBrowserFrameIPCTabContext);
        return (*(constptr_BrowserFrameIPCTabContext()));
    }
    operator BrowserFrameIPCTabContext&()
    {
        return get_BrowserFrameIPCTabContext();
    }
    operator const BrowserFrameIPCTabContext&() const
    {
        return get_BrowserFrameIPCTabContext();
    }

    VanillaFrameIPCTabContext&
    get_VanillaFrameIPCTabContext()
    {
        AssertSanity(TVanillaFrameIPCTabContext);
        return (*(ptr_VanillaFrameIPCTabContext()));
    }
    const VanillaFrameIPCTabContext&
    get_VanillaFrameIPCTabContext() const
    {
        AssertSanity(TVanillaFrameIPCTabContext);
        return (*(constptr_VanillaFrameIPCTabContext()));
    }
    operator VanillaFrameIPCTabContext&()
    {
        return get_VanillaFrameIPCTabContext();
    }
    operator const VanillaFrameIPCTabContext&() const
    {
        return get_VanillaFrameIPCTabContext();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class IPCTabAppBrowserContext;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCTabContext|
//
namespace mozilla {
namespace dom {
class IPCTabContext final
{
private:
    typedef mozilla::dom::IPCTabAppBrowserContext IPCTabAppBrowserContext;

public:
    MOZ_IMPLICIT IPCTabContext();

    MOZ_IMPLICIT IPCTabContext(const IPCTabAppBrowserContext& _appBrowserContext)
    {
        Init();
        Assign(_appBrowserContext);
    }

    MOZ_IMPLICIT IPCTabContext(const IPCTabContext& _o)
    {
        Init();
        Assign((_o).appBrowserContext());
    }

    ~IPCTabContext();

    void
    operator=(const IPCTabContext& _o)
    {
        Assign((_o).appBrowserContext());
    }

    bool
    operator==(const IPCTabContext& _o) const;

    IPCTabAppBrowserContext&
    appBrowserContext()
    {
        return appBrowserContext_;
    }
    const IPCTabAppBrowserContext&
    appBrowserContext() const
    {
        return appBrowserContext_;
    }

private:
    void
    Init();

    void
    Assign(const IPCTabAppBrowserContext& _appBrowserContext);

    IPCTabAppBrowserContext appBrowserContext_;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef PTabContext_h
