//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebrtcGlobalChild_h
#define PWebrtcGlobalChild_h

#include "mozilla/dom/PWebrtcGlobal.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/media/webrtc/WebrtcGlobal.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
struct RTCStatsReportInternal;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebrtcGlobalChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::RTCStatsReportInternal RTCStatsReportInternal;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;

    typedef PWebrtcGlobal::State State;

    virtual bool
    RecvGetStatsRequest(
            const int& aRequestId,
            const nsString& aPcIdFilter) = 0;
    virtual bool
    RecvGetLogRequest(
            const int& aRequestId,
            const nsCString& aPattern) = 0;
    virtual bool
    RecvSetAecLogging(const bool& aEnable) = 0;
    virtual bool
    RecvSetDebugMode(const int& aLevel) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PWebrtcGlobalChild();

    virtual ~PWebrtcGlobalChild();

    PContentChild*
    Manager() const;

    PWebrtcGlobal::State
    state();

    bool
    SendGetStatsResult(
            const int& aRequestId,
            const nsTArray<RTCStatsReportInternal>& aStats);

    bool
    SendGetLogResult(
            const int& aRequestId,
            const WebrtcGlobalLog& aLog);

    static bool
    Send__delete__(PWebrtcGlobalChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PWebrtcGlobalChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PWebrtcGlobalChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class WebrtcGlobalChild :
    public PWebrtcGlobalChild
{
    virtual bool
    RecvGetStatsRequest(
            const int& aRequestId,
            const nsString& aPcIdFilter);

    virtual bool
    RecvGetLogRequest(
            const int& aRequestId,
            const nsCString& aPattern);

    virtual bool
    RecvSetAecLogging(const bool& aEnable);

    virtual bool
    RecvSetDebugMode(const int& aLevel);

    MOZ_IMPLICIT WebrtcGlobalChild();
    virtual ~WebrtcGlobalChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
WebrtcGlobalChild::RecvGetStatsRequest(
        const int& aRequestId,
        const nsString& aPcIdFilter)
{
    return false;
}

bool
WebrtcGlobalChild::RecvGetLogRequest(
        const int& aRequestId,
        const nsCString& aPattern)
{
    return false;
}

bool
WebrtcGlobalChild::RecvSetAecLogging(const bool& aEnable)
{
    return false;
}

bool
WebrtcGlobalChild::RecvSetDebugMode(const int& aLevel)
{
    return false;
}

MOZ_IMPLICIT WebrtcGlobalChild::WebrtcGlobalChild()
{
    MOZ_COUNT_CTOR(WebrtcGlobalChild);
}

MOZ_IMPLICIT WebrtcGlobalChild::~WebrtcGlobalChild()
{
    MOZ_COUNT_DTOR(WebrtcGlobalChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebrtcGlobalChild_h
