//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PDeviceStorageRequest_h
#define PDeviceStorageRequest_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ErrorResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class ErrorResponse final
{
private:

public:
    MOZ_IMPLICIT ErrorResponse();

    MOZ_IMPLICIT ErrorResponse(const nsString& _error)
    {
        Init();
        Assign(_error);
    }

    MOZ_IMPLICIT ErrorResponse(const ErrorResponse& _o)
    {
        Init();
        Assign((_o).error());
    }

    ~ErrorResponse();

    void
    operator=(const ErrorResponse& _o)
    {
        Assign((_o).error());
    }

    bool
    operator==(const ErrorResponse& _o) const;

    nsString&
    error()
    {
        return error_;
    }
    const nsString&
    error() const
    {
        return error_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _error);

    nsString error_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SuccessResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class SuccessResponse final
{
private:

public:
    MOZ_IMPLICIT SuccessResponse()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT SuccessResponse(const SuccessResponse& _o)
    {
        Init();
        Assign();
    }

    ~SuccessResponse();

    void
    operator=(const SuccessResponse& _o)
    {
        Assign();
    }

    bool
    operator==(const SuccessResponse& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileDescriptorResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class FileDescriptorResponse final
{
private:
    typedef mozilla::ipc::FileDescriptor FileDescriptor;

public:
    MOZ_IMPLICIT FileDescriptorResponse();

    MOZ_IMPLICIT FileDescriptorResponse(const FileDescriptor& _fileDescriptor)
    {
        Init();
        Assign(_fileDescriptor);
    }

    MOZ_IMPLICIT FileDescriptorResponse(const FileDescriptorResponse& _o)
    {
        Init();
        Assign((_o).fileDescriptor());
    }

    ~FileDescriptorResponse();

    void
    operator=(const FileDescriptorResponse& _o)
    {
        Assign((_o).fileDescriptor());
    }

    bool
    operator==(const FileDescriptorResponse& _o) const;

    FileDescriptor&
    fileDescriptor()
    {
        return fileDescriptor_;
    }
    const FileDescriptor&
    fileDescriptor() const
    {
        return const_cast<FileDescriptor&>(fileDescriptor_);
    }

private:
    void
    Init();

    void
    Assign(const FileDescriptor& _fileDescriptor);

    FileDescriptor fileDescriptor_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BlobResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class BlobResponse final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT BlobResponse();

    MOZ_IMPLICIT BlobResponse(
            PBlobParent* _blobParent,
            PBlobChild* _blobChild)
    {
        Init();
        Assign(_blobParent, _blobChild);
    }

    MOZ_IMPLICIT BlobResponse(const BlobResponse& _o)
    {
        Init();
        Assign(const_cast<PBlobParent*>((_o).blobParent()), const_cast<PBlobChild*>((_o).blobChild()));
    }

    ~BlobResponse();

    void
    operator=(const BlobResponse& _o)
    {
        Assign(const_cast<PBlobParent*>((_o).blobParent()), const_cast<PBlobChild*>((_o).blobChild()));
    }

    bool
    operator==(const BlobResponse& _o) const;

    PBlobParent*&
    blobParent()
    {
        return blobParent_;
    }
    PBlobParent*
    blobParent() const
    {
        return blobParent_;
    }

    PBlobChild*&
    blobChild()
    {
        return blobChild_;
    }
    PBlobChild*
    blobChild() const
    {
        return blobChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PBlobParent* _blobParent,
            PBlobChild* _blobChild);

    PBlobParent* blobParent_;
    PBlobChild* blobChild_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DeviceStorageFileValue|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class DeviceStorageFileValue final
{
private:

public:
    MOZ_IMPLICIT DeviceStorageFileValue();

    MOZ_IMPLICIT DeviceStorageFileValue(
            const nsString& _storageName,
            const nsString& _name)
    {
        Init();
        Assign(_storageName, _name);
    }

    MOZ_IMPLICIT DeviceStorageFileValue(const DeviceStorageFileValue& _o)
    {
        Init();
        Assign((_o).storageName(), (_o).name());
    }

    ~DeviceStorageFileValue();

    void
    operator=(const DeviceStorageFileValue& _o)
    {
        Assign((_o).storageName(), (_o).name());
    }

    bool
    operator==(const DeviceStorageFileValue& _o) const;

    nsString&
    storageName()
    {
        return storageName_;
    }
    const nsString&
    storageName() const
    {
        return storageName_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _storageName,
            const nsString& _name);

    nsString storageName_;
    nsString name_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace devicestorage {
class DeviceStorageFileValue;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct EnumerationResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class EnumerationResponse final
{
private:
    typedef mozilla::dom::devicestorage::DeviceStorageFileValue DeviceStorageFileValue;

public:
    MOZ_IMPLICIT EnumerationResponse();

    MOZ_IMPLICIT EnumerationResponse(
            const nsString& _type,
            const nsString& _rootdir,
            const nsTArray<DeviceStorageFileValue>& _paths)
    {
        Init();
        Assign(_type, _rootdir, _paths);
    }

    MOZ_IMPLICIT EnumerationResponse(const EnumerationResponse& _o)
    {
        Init();
        Assign((_o).type(), (_o).rootdir(), (_o).paths());
    }

    ~EnumerationResponse();

    void
    operator=(const EnumerationResponse& _o)
    {
        Assign((_o).type(), (_o).rootdir(), (_o).paths());
    }

    bool
    operator==(const EnumerationResponse& _o) const;

    nsString&
    type()
    {
        return type_;
    }
    const nsString&
    type() const
    {
        return type_;
    }

    nsString&
    rootdir()
    {
        return rootdir_;
    }
    const nsString&
    rootdir() const
    {
        return rootdir_;
    }

    nsTArray<DeviceStorageFileValue>&
    paths()
    {
        return paths_;
    }
    const nsTArray<DeviceStorageFileValue>&
    paths() const
    {
        return paths_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _type,
            const nsString& _rootdir,
            const nsTArray<DeviceStorageFileValue>& _paths);

    nsString type_;
    nsString rootdir_;
    nsTArray<DeviceStorageFileValue> paths_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FreeSpaceStorageResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class FreeSpaceStorageResponse final
{
private:

public:
    MOZ_IMPLICIT FreeSpaceStorageResponse();

    MOZ_IMPLICIT FreeSpaceStorageResponse(const uint64_t& _freeBytes)
    {
        Init();
        Assign(_freeBytes);
    }

    MOZ_IMPLICIT FreeSpaceStorageResponse(const FreeSpaceStorageResponse& _o)
    {
        Init();
        Assign((_o).freeBytes());
    }

    ~FreeSpaceStorageResponse();

    void
    operator=(const FreeSpaceStorageResponse& _o)
    {
        Assign((_o).freeBytes());
    }

    bool
    operator==(const FreeSpaceStorageResponse& _o) const;

    uint64_t&
    freeBytes()
    {
        return freeBytes_;
    }
    const uint64_t&
    freeBytes() const
    {
        return freeBytes_;
    }

private:
    void
    Init();

    void
    Assign(const uint64_t& _freeBytes);

    uint64_t freeBytes_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UsedSpaceStorageResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class UsedSpaceStorageResponse final
{
private:

public:
    MOZ_IMPLICIT UsedSpaceStorageResponse();

    MOZ_IMPLICIT UsedSpaceStorageResponse(const uint64_t& _usedBytes)
    {
        Init();
        Assign(_usedBytes);
    }

    MOZ_IMPLICIT UsedSpaceStorageResponse(const UsedSpaceStorageResponse& _o)
    {
        Init();
        Assign((_o).usedBytes());
    }

    ~UsedSpaceStorageResponse();

    void
    operator=(const UsedSpaceStorageResponse& _o)
    {
        Assign((_o).usedBytes());
    }

    bool
    operator==(const UsedSpaceStorageResponse& _o) const;

    uint64_t&
    usedBytes()
    {
        return usedBytes_;
    }
    const uint64_t&
    usedBytes() const
    {
        return usedBytes_;
    }

private:
    void
    Init();

    void
    Assign(const uint64_t& _usedBytes);

    uint64_t usedBytes_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AvailableStorageResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class AvailableStorageResponse final
{
private:

public:
    MOZ_IMPLICIT AvailableStorageResponse();

    MOZ_IMPLICIT AvailableStorageResponse(const nsString& _mountState)
    {
        Init();
        Assign(_mountState);
    }

    MOZ_IMPLICIT AvailableStorageResponse(const AvailableStorageResponse& _o)
    {
        Init();
        Assign((_o).mountState());
    }

    ~AvailableStorageResponse();

    void
    operator=(const AvailableStorageResponse& _o)
    {
        Assign((_o).mountState());
    }

    bool
    operator==(const AvailableStorageResponse& _o) const;

    nsString&
    mountState()
    {
        return mountState_;
    }
    const nsString&
    mountState() const
    {
        return mountState_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _mountState);

    nsString mountState_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StorageStatusResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class StorageStatusResponse final
{
private:

public:
    MOZ_IMPLICIT StorageStatusResponse();

    MOZ_IMPLICIT StorageStatusResponse(const nsString& _storageStatus)
    {
        Init();
        Assign(_storageStatus);
    }

    MOZ_IMPLICIT StorageStatusResponse(const StorageStatusResponse& _o)
    {
        Init();
        Assign((_o).storageStatus());
    }

    ~StorageStatusResponse();

    void
    operator=(const StorageStatusResponse& _o)
    {
        Assign((_o).storageStatus());
    }

    bool
    operator==(const StorageStatusResponse& _o) const;

    nsString&
    storageStatus()
    {
        return storageStatus_;
    }
    const nsString&
    storageStatus() const
    {
        return storageStatus_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _storageStatus);

    nsString storageStatus_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FormatStorageResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class FormatStorageResponse final
{
private:

public:
    MOZ_IMPLICIT FormatStorageResponse();

    MOZ_IMPLICIT FormatStorageResponse(const nsString& _mountState)
    {
        Init();
        Assign(_mountState);
    }

    MOZ_IMPLICIT FormatStorageResponse(const FormatStorageResponse& _o)
    {
        Init();
        Assign((_o).mountState());
    }

    ~FormatStorageResponse();

    void
    operator=(const FormatStorageResponse& _o)
    {
        Assign((_o).mountState());
    }

    bool
    operator==(const FormatStorageResponse& _o) const;

    nsString&
    mountState()
    {
        return mountState_;
    }
    const nsString&
    mountState() const
    {
        return mountState_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _mountState);

    nsString mountState_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MountStorageResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class MountStorageResponse final
{
private:

public:
    MOZ_IMPLICIT MountStorageResponse();

    MOZ_IMPLICIT MountStorageResponse(const nsString& _storageStatus)
    {
        Init();
        Assign(_storageStatus);
    }

    MOZ_IMPLICIT MountStorageResponse(const MountStorageResponse& _o)
    {
        Init();
        Assign((_o).storageStatus());
    }

    ~MountStorageResponse();

    void
    operator=(const MountStorageResponse& _o)
    {
        Assign((_o).storageStatus());
    }

    bool
    operator==(const MountStorageResponse& _o) const;

    nsString&
    storageStatus()
    {
        return storageStatus_;
    }
    const nsString&
    storageStatus() const
    {
        return storageStatus_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _storageStatus);

    nsString storageStatus_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct UnmountStorageResponse|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class UnmountStorageResponse final
{
private:

public:
    MOZ_IMPLICIT UnmountStorageResponse();

    MOZ_IMPLICIT UnmountStorageResponse(const nsString& _storageStatus)
    {
        Init();
        Assign(_storageStatus);
    }

    MOZ_IMPLICIT UnmountStorageResponse(const UnmountStorageResponse& _o)
    {
        Init();
        Assign((_o).storageStatus());
    }

    ~UnmountStorageResponse();

    void
    operator=(const UnmountStorageResponse& _o)
    {
        Assign((_o).storageStatus());
    }

    bool
    operator==(const UnmountStorageResponse& _o) const;

    nsString&
    storageStatus()
    {
        return storageStatus_;
    }
    const nsString&
    storageStatus() const
    {
        return storageStatus_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _storageStatus);

    nsString storageStatus_;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace devicestorage {
class ErrorResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class SuccessResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class FileDescriptorResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class BlobResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class EnumerationResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class FreeSpaceStorageResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class UsedSpaceStorageResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class AvailableStorageResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class StorageStatusResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class FormatStorageResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class MountStorageResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace devicestorage {
class UnmountStorageResponse;
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union DeviceStorageResponseValue|
//
namespace mozilla {
namespace dom {
namespace devicestorage {
class DeviceStorageResponseValue final
{
public:
    enum Type {
        T__None,
        TErrorResponse = 1,
        TSuccessResponse,
        TFileDescriptorResponse,
        TBlobResponse,
        TEnumerationResponse,
        TFreeSpaceStorageResponse,
        TUsedSpaceStorageResponse,
        TAvailableStorageResponse,
        TStorageStatusResponse,
        TFormatStorageResponse,
        TMountStorageResponse,
        TUnmountStorageResponse,
        T__Last = TUnmountStorageResponse
    };

private:
    typedef mozilla::dom::devicestorage::ErrorResponse ErrorResponse;
    typedef mozilla::dom::devicestorage::SuccessResponse SuccessResponse;
    typedef mozilla::dom::devicestorage::FileDescriptorResponse FileDescriptorResponse;
    typedef mozilla::dom::devicestorage::BlobResponse BlobResponse;
    typedef mozilla::dom::devicestorage::EnumerationResponse EnumerationResponse;
    typedef mozilla::dom::devicestorage::FreeSpaceStorageResponse FreeSpaceStorageResponse;
    typedef mozilla::dom::devicestorage::UsedSpaceStorageResponse UsedSpaceStorageResponse;
    typedef mozilla::dom::devicestorage::AvailableStorageResponse AvailableStorageResponse;
    typedef mozilla::dom::devicestorage::StorageStatusResponse StorageStatusResponse;
    typedef mozilla::dom::devicestorage::FormatStorageResponse FormatStorageResponse;
    typedef mozilla::dom::devicestorage::MountStorageResponse MountStorageResponse;
    typedef mozilla::dom::devicestorage::UnmountStorageResponse UnmountStorageResponse;
    typedef ErrorResponse ErrorResponse__tdef;
    typedef SuccessResponse SuccessResponse__tdef;
    typedef FileDescriptorResponse FileDescriptorResponse__tdef;
    typedef BlobResponse BlobResponse__tdef;
    typedef EnumerationResponse EnumerationResponse__tdef;
    typedef FreeSpaceStorageResponse FreeSpaceStorageResponse__tdef;
    typedef UsedSpaceStorageResponse UsedSpaceStorageResponse__tdef;
    typedef AvailableStorageResponse AvailableStorageResponse__tdef;
    typedef StorageStatusResponse StorageStatusResponse__tdef;
    typedef FormatStorageResponse FormatStorageResponse__tdef;
    typedef MountStorageResponse MountStorageResponse__tdef;
    typedef UnmountStorageResponse UnmountStorageResponse__tdef;

    union Value {
        char VErrorResponse[sizeof(ErrorResponse)];
        char VSuccessResponse[sizeof(SuccessResponse)];
        char VFileDescriptorResponse[sizeof(FileDescriptorResponse)];
        char VBlobResponse[sizeof(BlobResponse)];
        char VEnumerationResponse[sizeof(EnumerationResponse)];
        char VFreeSpaceStorageResponse[sizeof(FreeSpaceStorageResponse)];
        char VUsedSpaceStorageResponse[sizeof(UsedSpaceStorageResponse)];
        char VAvailableStorageResponse[sizeof(AvailableStorageResponse)];
        char VStorageStatusResponse[sizeof(StorageStatusResponse)];
        char VFormatStorageResponse[sizeof(FormatStorageResponse)];
        char VMountStorageResponse[sizeof(MountStorageResponse)];
        char VUnmountStorageResponse[sizeof(UnmountStorageResponse)];
    };

    ErrorResponse*
    ptr_ErrorResponse()
    {
        return reinterpret_cast<ErrorResponse*>((&((mValue).VErrorResponse)));
    }
    const ErrorResponse* const
    constptr_ErrorResponse() const
    {
        return reinterpret_cast<const ErrorResponse* const>((&((mValue).VErrorResponse)));
    }
    SuccessResponse*
    ptr_SuccessResponse()
    {
        return reinterpret_cast<SuccessResponse*>((&((mValue).VSuccessResponse)));
    }
    const SuccessResponse* const
    constptr_SuccessResponse() const
    {
        return reinterpret_cast<const SuccessResponse* const>((&((mValue).VSuccessResponse)));
    }
    FileDescriptorResponse*
    ptr_FileDescriptorResponse()
    {
        return reinterpret_cast<FileDescriptorResponse*>((&((mValue).VFileDescriptorResponse)));
    }
    const FileDescriptorResponse* const
    constptr_FileDescriptorResponse() const
    {
        return reinterpret_cast<const FileDescriptorResponse* const>((&((mValue).VFileDescriptorResponse)));
    }
    BlobResponse*
    ptr_BlobResponse()
    {
        return reinterpret_cast<BlobResponse*>((&((mValue).VBlobResponse)));
    }
    const BlobResponse* const
    constptr_BlobResponse() const
    {
        return reinterpret_cast<const BlobResponse* const>((&((mValue).VBlobResponse)));
    }
    EnumerationResponse*
    ptr_EnumerationResponse()
    {
        return reinterpret_cast<EnumerationResponse*>((&((mValue).VEnumerationResponse)));
    }
    const EnumerationResponse* const
    constptr_EnumerationResponse() const
    {
        return reinterpret_cast<const EnumerationResponse* const>((&((mValue).VEnumerationResponse)));
    }
    FreeSpaceStorageResponse*
    ptr_FreeSpaceStorageResponse()
    {
        return reinterpret_cast<FreeSpaceStorageResponse*>((&((mValue).VFreeSpaceStorageResponse)));
    }
    const FreeSpaceStorageResponse* const
    constptr_FreeSpaceStorageResponse() const
    {
        return reinterpret_cast<const FreeSpaceStorageResponse* const>((&((mValue).VFreeSpaceStorageResponse)));
    }
    UsedSpaceStorageResponse*
    ptr_UsedSpaceStorageResponse()
    {
        return reinterpret_cast<UsedSpaceStorageResponse*>((&((mValue).VUsedSpaceStorageResponse)));
    }
    const UsedSpaceStorageResponse* const
    constptr_UsedSpaceStorageResponse() const
    {
        return reinterpret_cast<const UsedSpaceStorageResponse* const>((&((mValue).VUsedSpaceStorageResponse)));
    }
    AvailableStorageResponse*
    ptr_AvailableStorageResponse()
    {
        return reinterpret_cast<AvailableStorageResponse*>((&((mValue).VAvailableStorageResponse)));
    }
    const AvailableStorageResponse* const
    constptr_AvailableStorageResponse() const
    {
        return reinterpret_cast<const AvailableStorageResponse* const>((&((mValue).VAvailableStorageResponse)));
    }
    StorageStatusResponse*
    ptr_StorageStatusResponse()
    {
        return reinterpret_cast<StorageStatusResponse*>((&((mValue).VStorageStatusResponse)));
    }
    const StorageStatusResponse* const
    constptr_StorageStatusResponse() const
    {
        return reinterpret_cast<const StorageStatusResponse* const>((&((mValue).VStorageStatusResponse)));
    }
    FormatStorageResponse*
    ptr_FormatStorageResponse()
    {
        return reinterpret_cast<FormatStorageResponse*>((&((mValue).VFormatStorageResponse)));
    }
    const FormatStorageResponse* const
    constptr_FormatStorageResponse() const
    {
        return reinterpret_cast<const FormatStorageResponse* const>((&((mValue).VFormatStorageResponse)));
    }
    MountStorageResponse*
    ptr_MountStorageResponse()
    {
        return reinterpret_cast<MountStorageResponse*>((&((mValue).VMountStorageResponse)));
    }
    const MountStorageResponse* const
    constptr_MountStorageResponse() const
    {
        return reinterpret_cast<const MountStorageResponse* const>((&((mValue).VMountStorageResponse)));
    }
    UnmountStorageResponse*
    ptr_UnmountStorageResponse()
    {
        return reinterpret_cast<UnmountStorageResponse*>((&((mValue).VUnmountStorageResponse)));
    }
    const UnmountStorageResponse* const
    constptr_UnmountStorageResponse() const
    {
        return reinterpret_cast<const UnmountStorageResponse* const>((&((mValue).VUnmountStorageResponse)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT DeviceStorageResponseValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT DeviceStorageResponseValue(const ErrorResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const SuccessResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const FileDescriptorResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const BlobResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const EnumerationResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const FreeSpaceStorageResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const UsedSpaceStorageResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const AvailableStorageResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const StorageStatusResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const FormatStorageResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const MountStorageResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const UnmountStorageResponse& aOther);

    MOZ_IMPLICIT DeviceStorageResponseValue(const DeviceStorageResponseValue& aOther);

    ~DeviceStorageResponseValue();

    Type
    type() const
    {
        return mType;
    }

    DeviceStorageResponseValue&
    operator=(const ErrorResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const SuccessResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const FileDescriptorResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const BlobResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const EnumerationResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const FreeSpaceStorageResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const UsedSpaceStorageResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const AvailableStorageResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const StorageStatusResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const FormatStorageResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const MountStorageResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const UnmountStorageResponse& aRhs);

    DeviceStorageResponseValue&
    operator=(const DeviceStorageResponseValue& aRhs);

    bool
    operator==(const ErrorResponse& aRhs) const;

    bool
    operator==(const SuccessResponse& aRhs) const;

    bool
    operator==(const FileDescriptorResponse& aRhs) const;

    bool
    operator==(const BlobResponse& aRhs) const;

    bool
    operator==(const EnumerationResponse& aRhs) const;

    bool
    operator==(const FreeSpaceStorageResponse& aRhs) const;

    bool
    operator==(const UsedSpaceStorageResponse& aRhs) const;

    bool
    operator==(const AvailableStorageResponse& aRhs) const;

    bool
    operator==(const StorageStatusResponse& aRhs) const;

    bool
    operator==(const FormatStorageResponse& aRhs) const;

    bool
    operator==(const MountStorageResponse& aRhs) const;

    bool
    operator==(const UnmountStorageResponse& aRhs) const;

    bool
    operator==(const DeviceStorageResponseValue& aRhs) const;

    ErrorResponse&
    get_ErrorResponse()
    {
        AssertSanity(TErrorResponse);
        return (*(ptr_ErrorResponse()));
    }
    const ErrorResponse&
    get_ErrorResponse() const
    {
        AssertSanity(TErrorResponse);
        return (*(constptr_ErrorResponse()));
    }
    operator ErrorResponse&()
    {
        return get_ErrorResponse();
    }
    operator const ErrorResponse&() const
    {
        return get_ErrorResponse();
    }

    SuccessResponse&
    get_SuccessResponse()
    {
        AssertSanity(TSuccessResponse);
        return (*(ptr_SuccessResponse()));
    }
    const SuccessResponse&
    get_SuccessResponse() const
    {
        AssertSanity(TSuccessResponse);
        return (*(constptr_SuccessResponse()));
    }
    operator SuccessResponse&()
    {
        return get_SuccessResponse();
    }
    operator const SuccessResponse&() const
    {
        return get_SuccessResponse();
    }

    FileDescriptorResponse&
    get_FileDescriptorResponse()
    {
        AssertSanity(TFileDescriptorResponse);
        return (*(ptr_FileDescriptorResponse()));
    }
    const FileDescriptorResponse&
    get_FileDescriptorResponse() const
    {
        AssertSanity(TFileDescriptorResponse);
        return (*(constptr_FileDescriptorResponse()));
    }
    operator FileDescriptorResponse&()
    {
        return get_FileDescriptorResponse();
    }
    operator const FileDescriptorResponse&() const
    {
        return get_FileDescriptorResponse();
    }

    BlobResponse&
    get_BlobResponse()
    {
        AssertSanity(TBlobResponse);
        return (*(ptr_BlobResponse()));
    }
    const BlobResponse&
    get_BlobResponse() const
    {
        AssertSanity(TBlobResponse);
        return (*(constptr_BlobResponse()));
    }
    operator BlobResponse&()
    {
        return get_BlobResponse();
    }
    operator const BlobResponse&() const
    {
        return get_BlobResponse();
    }

    EnumerationResponse&
    get_EnumerationResponse()
    {
        AssertSanity(TEnumerationResponse);
        return (*(ptr_EnumerationResponse()));
    }
    const EnumerationResponse&
    get_EnumerationResponse() const
    {
        AssertSanity(TEnumerationResponse);
        return (*(constptr_EnumerationResponse()));
    }
    operator EnumerationResponse&()
    {
        return get_EnumerationResponse();
    }
    operator const EnumerationResponse&() const
    {
        return get_EnumerationResponse();
    }

    FreeSpaceStorageResponse&
    get_FreeSpaceStorageResponse()
    {
        AssertSanity(TFreeSpaceStorageResponse);
        return (*(ptr_FreeSpaceStorageResponse()));
    }
    const FreeSpaceStorageResponse&
    get_FreeSpaceStorageResponse() const
    {
        AssertSanity(TFreeSpaceStorageResponse);
        return (*(constptr_FreeSpaceStorageResponse()));
    }
    operator FreeSpaceStorageResponse&()
    {
        return get_FreeSpaceStorageResponse();
    }
    operator const FreeSpaceStorageResponse&() const
    {
        return get_FreeSpaceStorageResponse();
    }

    UsedSpaceStorageResponse&
    get_UsedSpaceStorageResponse()
    {
        AssertSanity(TUsedSpaceStorageResponse);
        return (*(ptr_UsedSpaceStorageResponse()));
    }
    const UsedSpaceStorageResponse&
    get_UsedSpaceStorageResponse() const
    {
        AssertSanity(TUsedSpaceStorageResponse);
        return (*(constptr_UsedSpaceStorageResponse()));
    }
    operator UsedSpaceStorageResponse&()
    {
        return get_UsedSpaceStorageResponse();
    }
    operator const UsedSpaceStorageResponse&() const
    {
        return get_UsedSpaceStorageResponse();
    }

    AvailableStorageResponse&
    get_AvailableStorageResponse()
    {
        AssertSanity(TAvailableStorageResponse);
        return (*(ptr_AvailableStorageResponse()));
    }
    const AvailableStorageResponse&
    get_AvailableStorageResponse() const
    {
        AssertSanity(TAvailableStorageResponse);
        return (*(constptr_AvailableStorageResponse()));
    }
    operator AvailableStorageResponse&()
    {
        return get_AvailableStorageResponse();
    }
    operator const AvailableStorageResponse&() const
    {
        return get_AvailableStorageResponse();
    }

    StorageStatusResponse&
    get_StorageStatusResponse()
    {
        AssertSanity(TStorageStatusResponse);
        return (*(ptr_StorageStatusResponse()));
    }
    const StorageStatusResponse&
    get_StorageStatusResponse() const
    {
        AssertSanity(TStorageStatusResponse);
        return (*(constptr_StorageStatusResponse()));
    }
    operator StorageStatusResponse&()
    {
        return get_StorageStatusResponse();
    }
    operator const StorageStatusResponse&() const
    {
        return get_StorageStatusResponse();
    }

    FormatStorageResponse&
    get_FormatStorageResponse()
    {
        AssertSanity(TFormatStorageResponse);
        return (*(ptr_FormatStorageResponse()));
    }
    const FormatStorageResponse&
    get_FormatStorageResponse() const
    {
        AssertSanity(TFormatStorageResponse);
        return (*(constptr_FormatStorageResponse()));
    }
    operator FormatStorageResponse&()
    {
        return get_FormatStorageResponse();
    }
    operator const FormatStorageResponse&() const
    {
        return get_FormatStorageResponse();
    }

    MountStorageResponse&
    get_MountStorageResponse()
    {
        AssertSanity(TMountStorageResponse);
        return (*(ptr_MountStorageResponse()));
    }
    const MountStorageResponse&
    get_MountStorageResponse() const
    {
        AssertSanity(TMountStorageResponse);
        return (*(constptr_MountStorageResponse()));
    }
    operator MountStorageResponse&()
    {
        return get_MountStorageResponse();
    }
    operator const MountStorageResponse&() const
    {
        return get_MountStorageResponse();
    }

    UnmountStorageResponse&
    get_UnmountStorageResponse()
    {
        AssertSanity(TUnmountStorageResponse);
        return (*(ptr_UnmountStorageResponse()));
    }
    const UnmountStorageResponse&
    get_UnmountStorageResponse() const
    {
        AssertSanity(TUnmountStorageResponse);
        return (*(constptr_UnmountStorageResponse()));
    }
    operator UnmountStorageResponse&()
    {
        return get_UnmountStorageResponse();
    }
    operator const UnmountStorageResponse&() const
    {
        return get_UnmountStorageResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PDeviceStorageRequestChild and PDeviceStorageRequestParent
//
namespace mozilla {
namespace dom {
namespace devicestorage {
namespace PDeviceStorageRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PDeviceStorageRequestStart = PDeviceStorageRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    PDeviceStorageRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PDeviceStorageRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PDeviceStorageRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PDeviceStorageRequest
} // namespace devicestorage
} // namespace dom
} // namespace mozilla

#endif // ifndef PDeviceStorageRequest_h
