//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundIDBFactoryRequest_h
#define PBackgroundIDBFactoryRequest_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"

namespace mozilla {
namespace dom {
namespace indexedDB {
class PBackgroundIDBDatabaseParent;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class PBackgroundIDBDatabaseChild;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpenDatabaseRequestResponse|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class OpenDatabaseRequestResponse final
{
private:
    typedef mozilla::dom::indexedDB::PBackgroundIDBDatabaseParent PBackgroundIDBDatabaseParent;
    typedef mozilla::dom::indexedDB::PBackgroundIDBDatabaseChild PBackgroundIDBDatabaseChild;

public:
    MOZ_IMPLICIT OpenDatabaseRequestResponse();

    MOZ_IMPLICIT OpenDatabaseRequestResponse(
            PBackgroundIDBDatabaseParent* _databaseParent,
            PBackgroundIDBDatabaseChild* _databaseChild)
    {
        Init();
        Assign(_databaseParent, _databaseChild);
    }

    MOZ_IMPLICIT OpenDatabaseRequestResponse(const OpenDatabaseRequestResponse& _o)
    {
        Init();
        Assign(const_cast<PBackgroundIDBDatabaseParent*>((_o).databaseParent()), const_cast<PBackgroundIDBDatabaseChild*>((_o).databaseChild()));
    }

    ~OpenDatabaseRequestResponse();

    void
    operator=(const OpenDatabaseRequestResponse& _o)
    {
        Assign(const_cast<PBackgroundIDBDatabaseParent*>((_o).databaseParent()), const_cast<PBackgroundIDBDatabaseChild*>((_o).databaseChild()));
    }

    bool
    operator==(const OpenDatabaseRequestResponse& _o) const;

    PBackgroundIDBDatabaseParent*&
    databaseParent()
    {
        return databaseParent_;
    }
    PBackgroundIDBDatabaseParent*
    databaseParent() const
    {
        return databaseParent_;
    }

    PBackgroundIDBDatabaseChild*&
    databaseChild()
    {
        return databaseChild_;
    }
    PBackgroundIDBDatabaseChild*
    databaseChild() const
    {
        return databaseChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PBackgroundIDBDatabaseParent* _databaseParent,
            PBackgroundIDBDatabaseChild* _databaseChild);

    PBackgroundIDBDatabaseParent* databaseParent_;
    PBackgroundIDBDatabaseChild* databaseChild_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DeleteDatabaseRequestResponse|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class DeleteDatabaseRequestResponse final
{
private:

public:
    MOZ_IMPLICIT DeleteDatabaseRequestResponse();

    MOZ_IMPLICIT DeleteDatabaseRequestResponse(const uint64_t& _previousVersion)
    {
        Init();
        Assign(_previousVersion);
    }

    MOZ_IMPLICIT DeleteDatabaseRequestResponse(const DeleteDatabaseRequestResponse& _o)
    {
        Init();
        Assign((_o).previousVersion());
    }

    ~DeleteDatabaseRequestResponse();

    void
    operator=(const DeleteDatabaseRequestResponse& _o)
    {
        Assign((_o).previousVersion());
    }

    bool
    operator==(const DeleteDatabaseRequestResponse& _o) const;

    uint64_t&
    previousVersion()
    {
        return previousVersion_;
    }
    const uint64_t&
    previousVersion() const
    {
        return previousVersion_;
    }

private:
    void
    Init();

    void
    Assign(const uint64_t& _previousVersion);

    uint64_t previousVersion_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OpenDatabaseRequestResponse;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class DeleteDatabaseRequestResponse;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FactoryRequestResponse|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class FactoryRequestResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TOpenDatabaseRequestResponse,
        TDeleteDatabaseRequestResponse,
        T__Last = TDeleteDatabaseRequestResponse
    };

private:
    typedef mozilla::dom::indexedDB::OpenDatabaseRequestResponse OpenDatabaseRequestResponse;
    typedef mozilla::dom::indexedDB::DeleteDatabaseRequestResponse DeleteDatabaseRequestResponse;
    typedef nsresult nsresult__tdef;
    typedef OpenDatabaseRequestResponse OpenDatabaseRequestResponse__tdef;
    typedef DeleteDatabaseRequestResponse DeleteDatabaseRequestResponse__tdef;

    union Value {
        char Vnsresult[sizeof(nsresult)];
        char VOpenDatabaseRequestResponse[sizeof(OpenDatabaseRequestResponse)];
        char VDeleteDatabaseRequestResponse[sizeof(DeleteDatabaseRequestResponse)];
    };

    nsresult*
    ptr_nsresult()
    {
        return reinterpret_cast<nsresult*>((&((mValue).Vnsresult)));
    }
    const nsresult* const
    constptr_nsresult() const
    {
        return reinterpret_cast<const nsresult* const>((&((mValue).Vnsresult)));
    }
    OpenDatabaseRequestResponse*
    ptr_OpenDatabaseRequestResponse()
    {
        return reinterpret_cast<OpenDatabaseRequestResponse*>((&((mValue).VOpenDatabaseRequestResponse)));
    }
    const OpenDatabaseRequestResponse* const
    constptr_OpenDatabaseRequestResponse() const
    {
        return reinterpret_cast<const OpenDatabaseRequestResponse* const>((&((mValue).VOpenDatabaseRequestResponse)));
    }
    DeleteDatabaseRequestResponse*
    ptr_DeleteDatabaseRequestResponse()
    {
        return reinterpret_cast<DeleteDatabaseRequestResponse*>((&((mValue).VDeleteDatabaseRequestResponse)));
    }
    const DeleteDatabaseRequestResponse* const
    constptr_DeleteDatabaseRequestResponse() const
    {
        return reinterpret_cast<const DeleteDatabaseRequestResponse* const>((&((mValue).VDeleteDatabaseRequestResponse)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FactoryRequestResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FactoryRequestResponse(const nsresult& aOther);

    MOZ_IMPLICIT FactoryRequestResponse(const OpenDatabaseRequestResponse& aOther);

    MOZ_IMPLICIT FactoryRequestResponse(const DeleteDatabaseRequestResponse& aOther);

    MOZ_IMPLICIT FactoryRequestResponse(const FactoryRequestResponse& aOther);

    ~FactoryRequestResponse();

    Type
    type() const
    {
        return mType;
    }

    FactoryRequestResponse&
    operator=(const nsresult& aRhs);

    FactoryRequestResponse&
    operator=(const OpenDatabaseRequestResponse& aRhs);

    FactoryRequestResponse&
    operator=(const DeleteDatabaseRequestResponse& aRhs);

    FactoryRequestResponse&
    operator=(const FactoryRequestResponse& aRhs);

    bool
    operator==(const nsresult& aRhs) const;

    bool
    operator==(const OpenDatabaseRequestResponse& aRhs) const;

    bool
    operator==(const DeleteDatabaseRequestResponse& aRhs) const;

    bool
    operator==(const FactoryRequestResponse& aRhs) const;

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    OpenDatabaseRequestResponse&
    get_OpenDatabaseRequestResponse()
    {
        AssertSanity(TOpenDatabaseRequestResponse);
        return (*(ptr_OpenDatabaseRequestResponse()));
    }
    const OpenDatabaseRequestResponse&
    get_OpenDatabaseRequestResponse() const
    {
        AssertSanity(TOpenDatabaseRequestResponse);
        return (*(constptr_OpenDatabaseRequestResponse()));
    }
    operator OpenDatabaseRequestResponse&()
    {
        return get_OpenDatabaseRequestResponse();
    }
    operator const OpenDatabaseRequestResponse&() const
    {
        return get_OpenDatabaseRequestResponse();
    }

    DeleteDatabaseRequestResponse&
    get_DeleteDatabaseRequestResponse()
    {
        AssertSanity(TDeleteDatabaseRequestResponse);
        return (*(ptr_DeleteDatabaseRequestResponse()));
    }
    const DeleteDatabaseRequestResponse&
    get_DeleteDatabaseRequestResponse() const
    {
        AssertSanity(TDeleteDatabaseRequestResponse);
        return (*(constptr_DeleteDatabaseRequestResponse()));
    }
    operator DeleteDatabaseRequestResponse&()
    {
        return get_DeleteDatabaseRequestResponse();
    }
    operator const DeleteDatabaseRequestResponse&() const
    {
        return get_DeleteDatabaseRequestResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBackgroundIDBFactoryRequestChild and PBackgroundIDBFactoryRequestParent
//
namespace mozilla {
namespace dom {
namespace indexedDB {
namespace PBackgroundIDBFactoryRequest {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PBackgroundIDBFactoryRequestStart = PBackgroundIDBFactoryRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PermissionChallenge__ID,
    Msg_Blocked__ID,
    Msg_PermissionRetry__ID,
    PBackgroundIDBFactoryRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactoryRequest::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactoryRequest::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PermissionChallenge :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PermissionChallenge__ID
    };
    MOZ_IMPLICIT Msg_PermissionChallenge(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactoryRequest::Msg_PermissionChallenge")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PermissionChallenge(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Blocked :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Blocked__ID
    };
    MOZ_IMPLICIT Msg_Blocked(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactoryRequest::Msg_Blocked")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Blocked(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_PermissionRetry :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PermissionRetry__ID
    };
    MOZ_IMPLICIT Msg_PermissionRetry(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PBackgroundIDBFactoryRequest::Msg_PermissionRetry")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_PermissionRetry(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PBackgroundIDBFactoryRequest
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundIDBFactoryRequest_h
