//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundIDBSharedTypes_h
#define PBackgroundIDBSharedTypes_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/dom/indexedDB/IDBCursor.h"
#include "mozilla/dom/indexedDB/Key.h"
#include "mozilla/dom/indexedDB/KeyPath.h"
#include "mozilla/dom/quota/PersistenceType.h"
#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SerializedKeyRange|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedKeyRange final
{
private:
    typedef mozilla::dom::indexedDB::Key Key;

public:
    MOZ_IMPLICIT SerializedKeyRange();

    MOZ_IMPLICIT SerializedKeyRange(
            const Key& _lower,
            const Key& _upper,
            const bool& _lowerOpen,
            const bool& _upperOpen,
            const bool& _isOnly)
    {
        Init();
        Assign(_lower, _upper, _lowerOpen, _upperOpen, _isOnly);
    }

    MOZ_IMPLICIT SerializedKeyRange(const SerializedKeyRange& _o)
    {
        Init();
        Assign((_o).lower(), (_o).upper(), (_o).lowerOpen(), (_o).upperOpen(), (_o).isOnly());
    }

    ~SerializedKeyRange();

    void
    operator=(const SerializedKeyRange& _o)
    {
        Assign((_o).lower(), (_o).upper(), (_o).lowerOpen(), (_o).upperOpen(), (_o).isOnly());
    }

    bool
    operator==(const SerializedKeyRange& _o) const;

    Key&
    lower()
    {
        return lower_;
    }
    const Key&
    lower() const
    {
        return lower_;
    }

    Key&
    upper()
    {
        return upper_;
    }
    const Key&
    upper() const
    {
        return upper_;
    }

    bool&
    lowerOpen()
    {
        return lowerOpen_;
    }
    const bool&
    lowerOpen() const
    {
        return lowerOpen_;
    }

    bool&
    upperOpen()
    {
        return upperOpen_;
    }
    const bool&
    upperOpen() const
    {
        return upperOpen_;
    }

    bool&
    isOnly()
    {
        return isOnly_;
    }
    const bool&
    isOnly() const
    {
        return isOnly_;
    }

private:
    void
    Init();

    void
    Assign(
            const Key& _lower,
            const Key& _upper,
            const bool& _lowerOpen,
            const bool& _upperOpen,
            const bool& _isOnly);

    Key lower_;
    Key upper_;
    bool lowerOpen_;
    bool upperOpen_;
    bool isOnly_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SerializedStructuredCloneReadInfo|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedStructuredCloneReadInfo final
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT SerializedStructuredCloneReadInfo();

    MOZ_IMPLICIT SerializedStructuredCloneReadInfo(
            const nsTArray<uint8_t>& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild,
            const nsTArray<intptr_t>& _fileInfos)
    {
        Init();
        Assign(_data, _blobsParent, _blobsChild, _fileInfos);
    }

    MOZ_IMPLICIT SerializedStructuredCloneReadInfo(const SerializedStructuredCloneReadInfo& _o)
    {
        Init();
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild(), (_o).fileInfos());
    }

    ~SerializedStructuredCloneReadInfo();

    void
    operator=(const SerializedStructuredCloneReadInfo& _o)
    {
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild(), (_o).fileInfos());
    }

    bool
    operator==(const SerializedStructuredCloneReadInfo& _o) const;

    nsTArray<uint8_t>&
    data()
    {
        return data_;
    }
    const nsTArray<uint8_t>&
    data() const
    {
        return data_;
    }

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

    nsTArray<intptr_t>&
    fileInfos()
    {
        return fileInfos_;
    }
    const nsTArray<intptr_t>&
    fileInfos() const
    {
        return fileInfos_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild,
            const nsTArray<intptr_t>& _fileInfos);

    nsTArray<uint8_t> data_;
    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
    nsTArray<intptr_t> fileInfos_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SerializedStructuredCloneWriteInfo|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedStructuredCloneWriteInfo final
{
private:

public:
    MOZ_IMPLICIT SerializedStructuredCloneWriteInfo();

    MOZ_IMPLICIT SerializedStructuredCloneWriteInfo(
            const nsTArray<uint8_t>& _data,
            const uint64_t& _offsetToKeyProp)
    {
        Init();
        Assign(_data, _offsetToKeyProp);
    }

    MOZ_IMPLICIT SerializedStructuredCloneWriteInfo(const SerializedStructuredCloneWriteInfo& _o)
    {
        Init();
        Assign((_o).data(), (_o).offsetToKeyProp());
    }

    ~SerializedStructuredCloneWriteInfo();

    void
    operator=(const SerializedStructuredCloneWriteInfo& _o)
    {
        Assign((_o).data(), (_o).offsetToKeyProp());
    }

    bool
    operator==(const SerializedStructuredCloneWriteInfo& _o) const;

    nsTArray<uint8_t>&
    data()
    {
        return data_;
    }
    const nsTArray<uint8_t>&
    data() const
    {
        return data_;
    }

    uint64_t&
    offsetToKeyProp()
    {
        return offsetToKeyProp_;
    }
    const uint64_t&
    offsetToKeyProp() const
    {
        return offsetToKeyProp_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<uint8_t>& _data,
            const uint64_t& _offsetToKeyProp);

    nsTArray<uint8_t> data_;
    uint64_t offsetToKeyProp_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexUpdateInfo|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexUpdateInfo final
{
private:
    typedef mozilla::dom::indexedDB::Key Key;

public:
    MOZ_IMPLICIT IndexUpdateInfo();

    MOZ_IMPLICIT IndexUpdateInfo(
            const int64_t& _indexId,
            const Key& _value)
    {
        Init();
        Assign(_indexId, _value);
    }

    MOZ_IMPLICIT IndexUpdateInfo(const IndexUpdateInfo& _o)
    {
        Init();
        Assign((_o).indexId(), (_o).value());
    }

    ~IndexUpdateInfo();

    void
    operator=(const IndexUpdateInfo& _o)
    {
        Assign((_o).indexId(), (_o).value());
    }

    bool
    operator==(const IndexUpdateInfo& _o) const;

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    Key&
    value()
    {
        return value_;
    }
    const Key&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _indexId,
            const Key& _value);

    int64_t indexId_;
    Key value_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalKeyRange|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange final
{
public:
    enum Type {
        T__None,
        TSerializedKeyRange = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::indexedDB::SerializedKeyRange SerializedKeyRange;
    typedef mozilla::void_t void_t;
    typedef SerializedKeyRange SerializedKeyRange__tdef;
    typedef void_t void_t__tdef;

    union Value {
        char VSerializedKeyRange[sizeof(SerializedKeyRange)];
        char Vvoid_t[sizeof(void_t)];
    };

    SerializedKeyRange*
    ptr_SerializedKeyRange()
    {
        return reinterpret_cast<SerializedKeyRange*>((&((mValue).VSerializedKeyRange)));
    }
    const SerializedKeyRange* const
    constptr_SerializedKeyRange() const
    {
        return reinterpret_cast<const SerializedKeyRange* const>((&((mValue).VSerializedKeyRange)));
    }
    void_t*
    ptr_void_t()
    {
        return reinterpret_cast<void_t*>((&((mValue).Vvoid_t)));
    }
    const void_t* const
    constptr_void_t() const
    {
        return reinterpret_cast<const void_t* const>((&((mValue).Vvoid_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalKeyRange() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalKeyRange(const SerializedKeyRange& aOther);

    MOZ_IMPLICIT OptionalKeyRange(const void_t& aOther);

    MOZ_IMPLICIT OptionalKeyRange(const OptionalKeyRange& aOther);

    ~OptionalKeyRange();

    Type
    type() const
    {
        return mType;
    }

    OptionalKeyRange&
    operator=(const SerializedKeyRange& aRhs);

    OptionalKeyRange&
    operator=(const void_t& aRhs);

    OptionalKeyRange&
    operator=(const OptionalKeyRange& aRhs);

    bool
    operator==(const SerializedKeyRange& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalKeyRange& aRhs) const;

    SerializedKeyRange&
    get_SerializedKeyRange()
    {
        AssertSanity(TSerializedKeyRange);
        return (*(ptr_SerializedKeyRange()));
    }
    const SerializedKeyRange&
    get_SerializedKeyRange() const
    {
        AssertSanity(TSerializedKeyRange);
        return (*(constptr_SerializedKeyRange()));
    }
    operator SerializedKeyRange&()
    {
        return get_SerializedKeyRange();
    }
    operator const SerializedKeyRange&() const
    {
        return get_SerializedKeyRange();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DatabaseMetadata|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class DatabaseMetadata final
{
private:
    typedef mozilla::dom::quota::PersistenceType PersistenceType;

public:
    MOZ_IMPLICIT DatabaseMetadata();

    MOZ_IMPLICIT DatabaseMetadata(
            const nsString& _name,
            const uint64_t& _version,
            const PersistenceType& _persistenceType)
    {
        Init();
        Assign(_name, _version, _persistenceType);
    }

    MOZ_IMPLICIT DatabaseMetadata(const DatabaseMetadata& _o)
    {
        Init();
        Assign((_o).name(), (_o).version(), (_o).persistenceType());
    }

    ~DatabaseMetadata();

    void
    operator=(const DatabaseMetadata& _o)
    {
        Assign((_o).name(), (_o).version(), (_o).persistenceType());
    }

    bool
    operator==(const DatabaseMetadata& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    uint64_t&
    version()
    {
        return version_;
    }
    const uint64_t&
    version() const
    {
        return version_;
    }

    PersistenceType&
    persistenceType()
    {
        return persistenceType_;
    }
    const PersistenceType&
    persistenceType() const
    {
        return persistenceType_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const uint64_t& _version,
            const PersistenceType& _persistenceType);

    nsString name_;
    uint64_t version_;
    PersistenceType persistenceType_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreMetadata|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreMetadata final
{
private:
    typedef mozilla::dom::indexedDB::KeyPath KeyPath;

public:
    MOZ_IMPLICIT ObjectStoreMetadata();

    MOZ_IMPLICIT ObjectStoreMetadata(
            const int64_t& _id,
            const nsString& _name,
            const KeyPath& _keyPath,
            const bool& _autoIncrement)
    {
        Init();
        Assign(_id, _name, _keyPath, _autoIncrement);
    }

    MOZ_IMPLICIT ObjectStoreMetadata(const ObjectStoreMetadata& _o)
    {
        Init();
        Assign((_o).id(), (_o).name(), (_o).keyPath(), (_o).autoIncrement());
    }

    ~ObjectStoreMetadata();

    void
    operator=(const ObjectStoreMetadata& _o)
    {
        Assign((_o).id(), (_o).name(), (_o).keyPath(), (_o).autoIncrement());
    }

    bool
    operator==(const ObjectStoreMetadata& _o) const;

    int64_t&
    id()
    {
        return id_;
    }
    const int64_t&
    id() const
    {
        return id_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    KeyPath&
    keyPath()
    {
        return keyPath_;
    }
    const KeyPath&
    keyPath() const
    {
        return keyPath_;
    }

    bool&
    autoIncrement()
    {
        return autoIncrement_;
    }
    const bool&
    autoIncrement() const
    {
        return autoIncrement_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _id,
            const nsString& _name,
            const KeyPath& _keyPath,
            const bool& _autoIncrement);

    int64_t id_;
    nsString name_;
    KeyPath keyPath_;
    bool autoIncrement_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexMetadata|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexMetadata final
{
private:
    typedef mozilla::dom::indexedDB::KeyPath KeyPath;

public:
    MOZ_IMPLICIT IndexMetadata();

    MOZ_IMPLICIT IndexMetadata(
            const int64_t& _id,
            const nsString& _name,
            const KeyPath& _keyPath,
            const bool& _unique,
            const bool& _multiEntry)
    {
        Init();
        Assign(_id, _name, _keyPath, _unique, _multiEntry);
    }

    MOZ_IMPLICIT IndexMetadata(const IndexMetadata& _o)
    {
        Init();
        Assign((_o).id(), (_o).name(), (_o).keyPath(), (_o).unique(), (_o).multiEntry());
    }

    ~IndexMetadata();

    void
    operator=(const IndexMetadata& _o)
    {
        Assign((_o).id(), (_o).name(), (_o).keyPath(), (_o).unique(), (_o).multiEntry());
    }

    bool
    operator==(const IndexMetadata& _o) const;

    int64_t&
    id()
    {
        return id_;
    }
    const int64_t&
    id() const
    {
        return id_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    KeyPath&
    keyPath()
    {
        return keyPath_;
    }
    const KeyPath&
    keyPath() const
    {
        return keyPath_;
    }

    bool&
    unique()
    {
        return unique_;
    }
    const bool&
    unique() const
    {
        return unique_;
    }

    bool&
    multiEntry()
    {
        return multiEntry_;
    }
    const bool&
    multiEntry() const
    {
        return multiEntry_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _id,
            const nsString& _name,
            const KeyPath& _keyPath,
            const bool& _unique,
            const bool& _multiEntry);

    int64_t id_;
    nsString name_;
    KeyPath keyPath_;
    bool unique_;
    bool multiEntry_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class DatabaseMetadata;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreSpec;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DatabaseSpec|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class DatabaseSpec final
{
private:
    typedef mozilla::dom::indexedDB::DatabaseMetadata DatabaseMetadata;
    typedef mozilla::dom::indexedDB::ObjectStoreSpec ObjectStoreSpec;

public:
    MOZ_IMPLICIT DatabaseSpec();

    MOZ_IMPLICIT DatabaseSpec(
            const DatabaseMetadata& _metadata,
            const nsTArray<ObjectStoreSpec>& _objectStores)
    {
        Init();
        Assign(_metadata, _objectStores);
    }

    MOZ_IMPLICIT DatabaseSpec(const DatabaseSpec& _o)
    {
        Init();
        Assign((_o).metadata(), (_o).objectStores());
    }

    ~DatabaseSpec();

    void
    operator=(const DatabaseSpec& _o)
    {
        Assign((_o).metadata(), (_o).objectStores());
    }

    bool
    operator==(const DatabaseSpec& _o) const;

    DatabaseMetadata&
    metadata()
    {
        return metadata_;
    }
    const DatabaseMetadata&
    metadata() const
    {
        return metadata_;
    }

    nsTArray<ObjectStoreSpec>&
    objectStores()
    {
        return objectStores_;
    }
    const nsTArray<ObjectStoreSpec>&
    objectStores() const
    {
        return objectStores_;
    }

private:
    void
    Init();

    void
    Assign(
            const DatabaseMetadata& _metadata,
            const nsTArray<ObjectStoreSpec>& _objectStores);

    DatabaseMetadata metadata_;
    nsTArray<ObjectStoreSpec> objectStores_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreMetadata;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexMetadata;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreSpec|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreSpec final
{
private:
    typedef mozilla::dom::indexedDB::ObjectStoreMetadata ObjectStoreMetadata;
    typedef mozilla::dom::indexedDB::IndexMetadata IndexMetadata;

public:
    MOZ_IMPLICIT ObjectStoreSpec();

    MOZ_IMPLICIT ObjectStoreSpec(
            const ObjectStoreMetadata& _metadata,
            const nsTArray<IndexMetadata>& _indexes)
    {
        Init();
        Assign(_metadata, _indexes);
    }

    MOZ_IMPLICIT ObjectStoreSpec(const ObjectStoreSpec& _o)
    {
        Init();
        Assign((_o).metadata(), (_o).indexes());
    }

    ~ObjectStoreSpec();

    void
    operator=(const ObjectStoreSpec& _o)
    {
        Assign((_o).metadata(), (_o).indexes());
    }

    bool
    operator==(const ObjectStoreSpec& _o) const;

    ObjectStoreMetadata&
    metadata()
    {
        return metadata_;
    }
    const ObjectStoreMetadata&
    metadata() const
    {
        return metadata_;
    }

    nsTArray<IndexMetadata>&
    indexes()
    {
        return indexes_;
    }
    const nsTArray<IndexMetadata>&
    indexes() const
    {
        return indexes_;
    }

private:
    void
    Init();

    void
    Assign(
            const ObjectStoreMetadata& _metadata,
            const nsTArray<IndexMetadata>& _indexes);

    ObjectStoreMetadata metadata_;
    nsTArray<IndexMetadata> indexes_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreOpenCursorParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreOpenCursorParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;
    typedef mozilla::dom::indexedDB::IDBCursor::Direction Direction;

public:
    MOZ_IMPLICIT ObjectStoreOpenCursorParams();

    MOZ_IMPLICIT ObjectStoreOpenCursorParams(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction)
    {
        Init();
        Assign(_objectStoreId, _optionalKeyRange, _direction);
    }

    MOZ_IMPLICIT ObjectStoreOpenCursorParams(const ObjectStoreOpenCursorParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).direction());
    }

    ~ObjectStoreOpenCursorParams();

    void
    operator=(const ObjectStoreOpenCursorParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).direction());
    }

    bool
    operator==(const ObjectStoreOpenCursorParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    Direction&
    direction()
    {
        return direction_;
    }
    const Direction&
    direction() const
    {
        return direction_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction);

    int64_t objectStoreId_;
    OptionalKeyRange optionalKeyRange_;
    Direction direction_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreOpenKeyCursorParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreOpenKeyCursorParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;
    typedef mozilla::dom::indexedDB::IDBCursor::Direction Direction;

public:
    MOZ_IMPLICIT ObjectStoreOpenKeyCursorParams();

    MOZ_IMPLICIT ObjectStoreOpenKeyCursorParams(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction)
    {
        Init();
        Assign(_objectStoreId, _optionalKeyRange, _direction);
    }

    MOZ_IMPLICIT ObjectStoreOpenKeyCursorParams(const ObjectStoreOpenKeyCursorParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).direction());
    }

    ~ObjectStoreOpenKeyCursorParams();

    void
    operator=(const ObjectStoreOpenKeyCursorParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).direction());
    }

    bool
    operator==(const ObjectStoreOpenKeyCursorParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    Direction&
    direction()
    {
        return direction_;
    }
    const Direction&
    direction() const
    {
        return direction_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction);

    int64_t objectStoreId_;
    OptionalKeyRange optionalKeyRange_;
    Direction direction_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexOpenCursorParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexOpenCursorParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;
    typedef mozilla::dom::indexedDB::IDBCursor::Direction Direction;

public:
    MOZ_IMPLICIT IndexOpenCursorParams();

    MOZ_IMPLICIT IndexOpenCursorParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction)
    {
        Init();
        Assign(_objectStoreId, _indexId, _optionalKeyRange, _direction);
    }

    MOZ_IMPLICIT IndexOpenCursorParams(const IndexOpenCursorParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).direction());
    }

    ~IndexOpenCursorParams();

    void
    operator=(const IndexOpenCursorParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).direction());
    }

    bool
    operator==(const IndexOpenCursorParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    Direction&
    direction()
    {
        return direction_;
    }
    const Direction&
    direction() const
    {
        return direction_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction);

    int64_t objectStoreId_;
    int64_t indexId_;
    OptionalKeyRange optionalKeyRange_;
    Direction direction_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexOpenKeyCursorParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexOpenKeyCursorParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;
    typedef mozilla::dom::indexedDB::IDBCursor::Direction Direction;

public:
    MOZ_IMPLICIT IndexOpenKeyCursorParams();

    MOZ_IMPLICIT IndexOpenKeyCursorParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction)
    {
        Init();
        Assign(_objectStoreId, _indexId, _optionalKeyRange, _direction);
    }

    MOZ_IMPLICIT IndexOpenKeyCursorParams(const IndexOpenKeyCursorParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).direction());
    }

    ~IndexOpenKeyCursorParams();

    void
    operator=(const IndexOpenKeyCursorParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).direction());
    }

    bool
    operator==(const IndexOpenKeyCursorParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    Direction&
    direction()
    {
        return direction_;
    }
    const Direction&
    direction() const
    {
        return direction_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const Direction& _direction);

    int64_t objectStoreId_;
    int64_t indexId_;
    OptionalKeyRange optionalKeyRange_;
    Direction direction_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreOpenCursorParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreOpenKeyCursorParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexOpenCursorParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexOpenKeyCursorParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OpenCursorParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class OpenCursorParams final
{
public:
    enum Type {
        T__None,
        TObjectStoreOpenCursorParams = 1,
        TObjectStoreOpenKeyCursorParams,
        TIndexOpenCursorParams,
        TIndexOpenKeyCursorParams,
        T__Last = TIndexOpenKeyCursorParams
    };

private:
    typedef mozilla::dom::indexedDB::ObjectStoreOpenCursorParams ObjectStoreOpenCursorParams;
    typedef mozilla::dom::indexedDB::ObjectStoreOpenKeyCursorParams ObjectStoreOpenKeyCursorParams;
    typedef mozilla::dom::indexedDB::IndexOpenCursorParams IndexOpenCursorParams;
    typedef mozilla::dom::indexedDB::IndexOpenKeyCursorParams IndexOpenKeyCursorParams;
    typedef ObjectStoreOpenCursorParams ObjectStoreOpenCursorParams__tdef;
    typedef ObjectStoreOpenKeyCursorParams ObjectStoreOpenKeyCursorParams__tdef;
    typedef IndexOpenCursorParams IndexOpenCursorParams__tdef;
    typedef IndexOpenKeyCursorParams IndexOpenKeyCursorParams__tdef;

    union Value {
        char VObjectStoreOpenCursorParams[sizeof(ObjectStoreOpenCursorParams)];
        char VObjectStoreOpenKeyCursorParams[sizeof(ObjectStoreOpenKeyCursorParams)];
        char VIndexOpenCursorParams[sizeof(IndexOpenCursorParams)];
        char VIndexOpenKeyCursorParams[sizeof(IndexOpenKeyCursorParams)];
    };

    ObjectStoreOpenCursorParams*
    ptr_ObjectStoreOpenCursorParams()
    {
        return reinterpret_cast<ObjectStoreOpenCursorParams*>((&((mValue).VObjectStoreOpenCursorParams)));
    }
    const ObjectStoreOpenCursorParams* const
    constptr_ObjectStoreOpenCursorParams() const
    {
        return reinterpret_cast<const ObjectStoreOpenCursorParams* const>((&((mValue).VObjectStoreOpenCursorParams)));
    }
    ObjectStoreOpenKeyCursorParams*
    ptr_ObjectStoreOpenKeyCursorParams()
    {
        return reinterpret_cast<ObjectStoreOpenKeyCursorParams*>((&((mValue).VObjectStoreOpenKeyCursorParams)));
    }
    const ObjectStoreOpenKeyCursorParams* const
    constptr_ObjectStoreOpenKeyCursorParams() const
    {
        return reinterpret_cast<const ObjectStoreOpenKeyCursorParams* const>((&((mValue).VObjectStoreOpenKeyCursorParams)));
    }
    IndexOpenCursorParams*
    ptr_IndexOpenCursorParams()
    {
        return reinterpret_cast<IndexOpenCursorParams*>((&((mValue).VIndexOpenCursorParams)));
    }
    const IndexOpenCursorParams* const
    constptr_IndexOpenCursorParams() const
    {
        return reinterpret_cast<const IndexOpenCursorParams* const>((&((mValue).VIndexOpenCursorParams)));
    }
    IndexOpenKeyCursorParams*
    ptr_IndexOpenKeyCursorParams()
    {
        return reinterpret_cast<IndexOpenKeyCursorParams*>((&((mValue).VIndexOpenKeyCursorParams)));
    }
    const IndexOpenKeyCursorParams* const
    constptr_IndexOpenKeyCursorParams() const
    {
        return reinterpret_cast<const IndexOpenKeyCursorParams* const>((&((mValue).VIndexOpenKeyCursorParams)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OpenCursorParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OpenCursorParams(const ObjectStoreOpenCursorParams& aOther);

    MOZ_IMPLICIT OpenCursorParams(const ObjectStoreOpenKeyCursorParams& aOther);

    MOZ_IMPLICIT OpenCursorParams(const IndexOpenCursorParams& aOther);

    MOZ_IMPLICIT OpenCursorParams(const IndexOpenKeyCursorParams& aOther);

    MOZ_IMPLICIT OpenCursorParams(const OpenCursorParams& aOther);

    ~OpenCursorParams();

    Type
    type() const
    {
        return mType;
    }

    OpenCursorParams&
    operator=(const ObjectStoreOpenCursorParams& aRhs);

    OpenCursorParams&
    operator=(const ObjectStoreOpenKeyCursorParams& aRhs);

    OpenCursorParams&
    operator=(const IndexOpenCursorParams& aRhs);

    OpenCursorParams&
    operator=(const IndexOpenKeyCursorParams& aRhs);

    OpenCursorParams&
    operator=(const OpenCursorParams& aRhs);

    bool
    operator==(const ObjectStoreOpenCursorParams& aRhs) const;

    bool
    operator==(const ObjectStoreOpenKeyCursorParams& aRhs) const;

    bool
    operator==(const IndexOpenCursorParams& aRhs) const;

    bool
    operator==(const IndexOpenKeyCursorParams& aRhs) const;

    bool
    operator==(const OpenCursorParams& aRhs) const;

    ObjectStoreOpenCursorParams&
    get_ObjectStoreOpenCursorParams()
    {
        AssertSanity(TObjectStoreOpenCursorParams);
        return (*(ptr_ObjectStoreOpenCursorParams()));
    }
    const ObjectStoreOpenCursorParams&
    get_ObjectStoreOpenCursorParams() const
    {
        AssertSanity(TObjectStoreOpenCursorParams);
        return (*(constptr_ObjectStoreOpenCursorParams()));
    }
    operator ObjectStoreOpenCursorParams&()
    {
        return get_ObjectStoreOpenCursorParams();
    }
    operator const ObjectStoreOpenCursorParams&() const
    {
        return get_ObjectStoreOpenCursorParams();
    }

    ObjectStoreOpenKeyCursorParams&
    get_ObjectStoreOpenKeyCursorParams()
    {
        AssertSanity(TObjectStoreOpenKeyCursorParams);
        return (*(ptr_ObjectStoreOpenKeyCursorParams()));
    }
    const ObjectStoreOpenKeyCursorParams&
    get_ObjectStoreOpenKeyCursorParams() const
    {
        AssertSanity(TObjectStoreOpenKeyCursorParams);
        return (*(constptr_ObjectStoreOpenKeyCursorParams()));
    }
    operator ObjectStoreOpenKeyCursorParams&()
    {
        return get_ObjectStoreOpenKeyCursorParams();
    }
    operator const ObjectStoreOpenKeyCursorParams&() const
    {
        return get_ObjectStoreOpenKeyCursorParams();
    }

    IndexOpenCursorParams&
    get_IndexOpenCursorParams()
    {
        AssertSanity(TIndexOpenCursorParams);
        return (*(ptr_IndexOpenCursorParams()));
    }
    const IndexOpenCursorParams&
    get_IndexOpenCursorParams() const
    {
        AssertSanity(TIndexOpenCursorParams);
        return (*(constptr_IndexOpenCursorParams()));
    }
    operator IndexOpenCursorParams&()
    {
        return get_IndexOpenCursorParams();
    }
    operator const IndexOpenCursorParams&() const
    {
        return get_IndexOpenCursorParams();
    }

    IndexOpenKeyCursorParams&
    get_IndexOpenKeyCursorParams()
    {
        AssertSanity(TIndexOpenKeyCursorParams);
        return (*(ptr_IndexOpenKeyCursorParams()));
    }
    const IndexOpenKeyCursorParams&
    get_IndexOpenKeyCursorParams() const
    {
        AssertSanity(TIndexOpenKeyCursorParams);
        return (*(constptr_IndexOpenKeyCursorParams()));
    }
    operator IndexOpenKeyCursorParams&()
    {
        return get_IndexOpenKeyCursorParams();
    }
    operator const IndexOpenKeyCursorParams&() const
    {
        return get_IndexOpenKeyCursorParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class PBackgroundIDBDatabaseFileParent;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class PBackgroundIDBDatabaseFileChild;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union DatabaseFileOrMutableFileId|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class DatabaseFileOrMutableFileId final
{
public:
    enum Type {
        T__None,
        TPBackgroundIDBDatabaseFileParent = 1,
        TPBackgroundIDBDatabaseFileChild,
        Tint64_t,
        T__Last = Tint64_t
    };

private:
    typedef mozilla::dom::indexedDB::PBackgroundIDBDatabaseFileParent PBackgroundIDBDatabaseFileParent;
    typedef mozilla::dom::indexedDB::PBackgroundIDBDatabaseFileChild PBackgroundIDBDatabaseFileChild;
    typedef PBackgroundIDBDatabaseFileParent* PBackgroundIDBDatabaseFileParent__tdef;
    typedef PBackgroundIDBDatabaseFileChild* PBackgroundIDBDatabaseFileChild__tdef;
    typedef int64_t int64_t__tdef;

    union Value {
        char VPBackgroundIDBDatabaseFileParent[sizeof(PBackgroundIDBDatabaseFileParent*)];
        char VPBackgroundIDBDatabaseFileChild[sizeof(PBackgroundIDBDatabaseFileChild*)];
        char Vint64_t[sizeof(int64_t)];
    };

    PBackgroundIDBDatabaseFileParent**
    ptr_PBackgroundIDBDatabaseFileParent()
    {
        return reinterpret_cast<PBackgroundIDBDatabaseFileParent**>((&((mValue).VPBackgroundIDBDatabaseFileParent)));
    }
    PBackgroundIDBDatabaseFileParent* const*
    constptr_PBackgroundIDBDatabaseFileParent() const
    {
        return reinterpret_cast<PBackgroundIDBDatabaseFileParent* const*>((&((mValue).VPBackgroundIDBDatabaseFileParent)));
    }
    PBackgroundIDBDatabaseFileChild**
    ptr_PBackgroundIDBDatabaseFileChild()
    {
        return reinterpret_cast<PBackgroundIDBDatabaseFileChild**>((&((mValue).VPBackgroundIDBDatabaseFileChild)));
    }
    PBackgroundIDBDatabaseFileChild* const*
    constptr_PBackgroundIDBDatabaseFileChild() const
    {
        return reinterpret_cast<PBackgroundIDBDatabaseFileChild* const*>((&((mValue).VPBackgroundIDBDatabaseFileChild)));
    }
    int64_t*
    ptr_int64_t()
    {
        return reinterpret_cast<int64_t*>((&((mValue).Vint64_t)));
    }
    const int64_t* const
    constptr_int64_t() const
    {
        return reinterpret_cast<const int64_t* const>((&((mValue).Vint64_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT DatabaseFileOrMutableFileId() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT DatabaseFileOrMutableFileId(PBackgroundIDBDatabaseFileParent* aOther);

    MOZ_IMPLICIT DatabaseFileOrMutableFileId(PBackgroundIDBDatabaseFileChild* aOther);

    MOZ_IMPLICIT DatabaseFileOrMutableFileId(const int64_t& aOther);

    MOZ_IMPLICIT DatabaseFileOrMutableFileId(const DatabaseFileOrMutableFileId& aOther);

    ~DatabaseFileOrMutableFileId();

    Type
    type() const
    {
        return mType;
    }

    DatabaseFileOrMutableFileId&
    operator=(PBackgroundIDBDatabaseFileParent* aRhs);

    DatabaseFileOrMutableFileId&
    operator=(PBackgroundIDBDatabaseFileChild* aRhs);

    DatabaseFileOrMutableFileId&
    operator=(const int64_t& aRhs);

    DatabaseFileOrMutableFileId&
    operator=(const DatabaseFileOrMutableFileId& aRhs);

    bool
    operator==(PBackgroundIDBDatabaseFileParent* aRhs) const;

    bool
    operator==(PBackgroundIDBDatabaseFileChild* aRhs) const;

    bool
    operator==(const int64_t& aRhs) const;

    bool
    operator==(const DatabaseFileOrMutableFileId& aRhs) const;

    PBackgroundIDBDatabaseFileParent*&
    get_PBackgroundIDBDatabaseFileParent()
    {
        AssertSanity(TPBackgroundIDBDatabaseFileParent);
        return (*(ptr_PBackgroundIDBDatabaseFileParent()));
    }
    PBackgroundIDBDatabaseFileParent*
    get_PBackgroundIDBDatabaseFileParent() const
    {
        AssertSanity(TPBackgroundIDBDatabaseFileParent);
        return (*(constptr_PBackgroundIDBDatabaseFileParent()));
    }
    operator PBackgroundIDBDatabaseFileParent*&()
    {
        return get_PBackgroundIDBDatabaseFileParent();
    }
    operator PBackgroundIDBDatabaseFileParent*() const
    {
        return get_PBackgroundIDBDatabaseFileParent();
    }

    PBackgroundIDBDatabaseFileChild*&
    get_PBackgroundIDBDatabaseFileChild()
    {
        AssertSanity(TPBackgroundIDBDatabaseFileChild);
        return (*(ptr_PBackgroundIDBDatabaseFileChild()));
    }
    PBackgroundIDBDatabaseFileChild*
    get_PBackgroundIDBDatabaseFileChild() const
    {
        AssertSanity(TPBackgroundIDBDatabaseFileChild);
        return (*(constptr_PBackgroundIDBDatabaseFileChild()));
    }
    operator PBackgroundIDBDatabaseFileChild*&()
    {
        return get_PBackgroundIDBDatabaseFileChild();
    }
    operator PBackgroundIDBDatabaseFileChild*() const
    {
        return get_PBackgroundIDBDatabaseFileChild();
    }

    int64_t&
    get_int64_t()
    {
        AssertSanity(Tint64_t);
        return (*(ptr_int64_t()));
    }
    const int64_t&
    get_int64_t() const
    {
        AssertSanity(Tint64_t);
        return (*(constptr_int64_t()));
    }
    operator int64_t&()
    {
        return get_int64_t();
    }
    operator const int64_t&() const
    {
        return get_int64_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedStructuredCloneWriteInfo;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexUpdateInfo;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class DatabaseFileOrMutableFileId;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreAddPutParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreAddPutParams final
{
private:
    typedef mozilla::dom::indexedDB::SerializedStructuredCloneWriteInfo SerializedStructuredCloneWriteInfo;
    typedef mozilla::dom::indexedDB::Key Key;
    typedef mozilla::dom::indexedDB::IndexUpdateInfo IndexUpdateInfo;
    typedef mozilla::dom::indexedDB::DatabaseFileOrMutableFileId DatabaseFileOrMutableFileId;

public:
    MOZ_IMPLICIT ObjectStoreAddPutParams();

    MOZ_IMPLICIT ObjectStoreAddPutParams(
            const int64_t& _objectStoreId,
            const SerializedStructuredCloneWriteInfo& _cloneInfo,
            const Key& _key,
            const nsTArray<IndexUpdateInfo>& _indexUpdateInfos,
            const nsTArray<DatabaseFileOrMutableFileId>& _files)
    {
        Init();
        Assign(_objectStoreId, _cloneInfo, _key, _indexUpdateInfos, _files);
    }

    MOZ_IMPLICIT ObjectStoreAddPutParams(const ObjectStoreAddPutParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).cloneInfo(), (_o).key(), (_o).indexUpdateInfos(), (_o).files());
    }

    ~ObjectStoreAddPutParams();

    void
    operator=(const ObjectStoreAddPutParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).cloneInfo(), (_o).key(), (_o).indexUpdateInfos(), (_o).files());
    }

    bool
    operator==(const ObjectStoreAddPutParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    SerializedStructuredCloneWriteInfo&
    cloneInfo()
    {
        return cloneInfo_;
    }
    const SerializedStructuredCloneWriteInfo&
    cloneInfo() const
    {
        return cloneInfo_;
    }

    Key&
    key()
    {
        return key_;
    }
    const Key&
    key() const
    {
        return key_;
    }

    nsTArray<IndexUpdateInfo>&
    indexUpdateInfos()
    {
        return indexUpdateInfos_;
    }
    const nsTArray<IndexUpdateInfo>&
    indexUpdateInfos() const
    {
        return indexUpdateInfos_;
    }

    nsTArray<DatabaseFileOrMutableFileId>&
    files()
    {
        return files_;
    }
    const nsTArray<DatabaseFileOrMutableFileId>&
    files() const
    {
        return files_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const SerializedStructuredCloneWriteInfo& _cloneInfo,
            const Key& _key,
            const nsTArray<IndexUpdateInfo>& _indexUpdateInfos,
            const nsTArray<DatabaseFileOrMutableFileId>& _files);

    int64_t objectStoreId_;
    SerializedStructuredCloneWriteInfo cloneInfo_;
    Key key_;
    nsTArray<IndexUpdateInfo> indexUpdateInfos_;
    nsTArray<DatabaseFileOrMutableFileId> files_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreAddPutParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreAddParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreAddParams final
{
private:
    typedef mozilla::dom::indexedDB::ObjectStoreAddPutParams ObjectStoreAddPutParams;

public:
    MOZ_IMPLICIT ObjectStoreAddParams();

    MOZ_IMPLICIT ObjectStoreAddParams(const ObjectStoreAddPutParams& _commonParams)
    {
        Init();
        Assign(_commonParams);
    }

    MOZ_IMPLICIT ObjectStoreAddParams(const ObjectStoreAddParams& _o)
    {
        Init();
        Assign((_o).commonParams());
    }

    ~ObjectStoreAddParams();

    void
    operator=(const ObjectStoreAddParams& _o)
    {
        Assign((_o).commonParams());
    }

    bool
    operator==(const ObjectStoreAddParams& _o) const;

    ObjectStoreAddPutParams&
    commonParams()
    {
        return commonParams_;
    }
    const ObjectStoreAddPutParams&
    commonParams() const
    {
        return commonParams_;
    }

private:
    void
    Init();

    void
    Assign(const ObjectStoreAddPutParams& _commonParams);

    ObjectStoreAddPutParams commonParams_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreAddPutParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStorePutParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStorePutParams final
{
private:
    typedef mozilla::dom::indexedDB::ObjectStoreAddPutParams ObjectStoreAddPutParams;

public:
    MOZ_IMPLICIT ObjectStorePutParams();

    MOZ_IMPLICIT ObjectStorePutParams(const ObjectStoreAddPutParams& _commonParams)
    {
        Init();
        Assign(_commonParams);
    }

    MOZ_IMPLICIT ObjectStorePutParams(const ObjectStorePutParams& _o)
    {
        Init();
        Assign((_o).commonParams());
    }

    ~ObjectStorePutParams();

    void
    operator=(const ObjectStorePutParams& _o)
    {
        Assign((_o).commonParams());
    }

    bool
    operator==(const ObjectStorePutParams& _o) const;

    ObjectStoreAddPutParams&
    commonParams()
    {
        return commonParams_;
    }
    const ObjectStoreAddPutParams&
    commonParams() const
    {
        return commonParams_;
    }

private:
    void
    Init();

    void
    Assign(const ObjectStoreAddPutParams& _commonParams);

    ObjectStoreAddPutParams commonParams_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreGetParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreGetParams final
{
private:
    typedef mozilla::dom::indexedDB::SerializedKeyRange SerializedKeyRange;

public:
    MOZ_IMPLICIT ObjectStoreGetParams();

    MOZ_IMPLICIT ObjectStoreGetParams(
            const int64_t& _objectStoreId,
            const SerializedKeyRange& _keyRange)
    {
        Init();
        Assign(_objectStoreId, _keyRange);
    }

    MOZ_IMPLICIT ObjectStoreGetParams(const ObjectStoreGetParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).keyRange());
    }

    ~ObjectStoreGetParams();

    void
    operator=(const ObjectStoreGetParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).keyRange());
    }

    bool
    operator==(const ObjectStoreGetParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    SerializedKeyRange&
    keyRange()
    {
        return keyRange_;
    }
    const SerializedKeyRange&
    keyRange() const
    {
        return keyRange_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const SerializedKeyRange& _keyRange);

    int64_t objectStoreId_;
    SerializedKeyRange keyRange_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreGetAllParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreGetAllParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;

public:
    MOZ_IMPLICIT ObjectStoreGetAllParams();

    MOZ_IMPLICIT ObjectStoreGetAllParams(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit)
    {
        Init();
        Assign(_objectStoreId, _optionalKeyRange, _limit);
    }

    MOZ_IMPLICIT ObjectStoreGetAllParams(const ObjectStoreGetAllParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).limit());
    }

    ~ObjectStoreGetAllParams();

    void
    operator=(const ObjectStoreGetAllParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).limit());
    }

    bool
    operator==(const ObjectStoreGetAllParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    uint32_t&
    limit()
    {
        return limit_;
    }
    const uint32_t&
    limit() const
    {
        return limit_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit);

    int64_t objectStoreId_;
    OptionalKeyRange optionalKeyRange_;
    uint32_t limit_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreGetAllKeysParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreGetAllKeysParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;

public:
    MOZ_IMPLICIT ObjectStoreGetAllKeysParams();

    MOZ_IMPLICIT ObjectStoreGetAllKeysParams(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit)
    {
        Init();
        Assign(_objectStoreId, _optionalKeyRange, _limit);
    }

    MOZ_IMPLICIT ObjectStoreGetAllKeysParams(const ObjectStoreGetAllKeysParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).limit());
    }

    ~ObjectStoreGetAllKeysParams();

    void
    operator=(const ObjectStoreGetAllKeysParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).optionalKeyRange(), (_o).limit());
    }

    bool
    operator==(const ObjectStoreGetAllKeysParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    uint32_t&
    limit()
    {
        return limit_;
    }
    const uint32_t&
    limit() const
    {
        return limit_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit);

    int64_t objectStoreId_;
    OptionalKeyRange optionalKeyRange_;
    uint32_t limit_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreDeleteParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreDeleteParams final
{
private:
    typedef mozilla::dom::indexedDB::SerializedKeyRange SerializedKeyRange;

public:
    MOZ_IMPLICIT ObjectStoreDeleteParams();

    MOZ_IMPLICIT ObjectStoreDeleteParams(
            const int64_t& _objectStoreId,
            const SerializedKeyRange& _keyRange)
    {
        Init();
        Assign(_objectStoreId, _keyRange);
    }

    MOZ_IMPLICIT ObjectStoreDeleteParams(const ObjectStoreDeleteParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).keyRange());
    }

    ~ObjectStoreDeleteParams();

    void
    operator=(const ObjectStoreDeleteParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).keyRange());
    }

    bool
    operator==(const ObjectStoreDeleteParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    SerializedKeyRange&
    keyRange()
    {
        return keyRange_;
    }
    const SerializedKeyRange&
    keyRange() const
    {
        return keyRange_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const SerializedKeyRange& _keyRange);

    int64_t objectStoreId_;
    SerializedKeyRange keyRange_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreClearParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreClearParams final
{
private:

public:
    MOZ_IMPLICIT ObjectStoreClearParams();

    MOZ_IMPLICIT ObjectStoreClearParams(const int64_t& _objectStoreId)
    {
        Init();
        Assign(_objectStoreId);
    }

    MOZ_IMPLICIT ObjectStoreClearParams(const ObjectStoreClearParams& _o)
    {
        Init();
        Assign((_o).objectStoreId());
    }

    ~ObjectStoreClearParams();

    void
    operator=(const ObjectStoreClearParams& _o)
    {
        Assign((_o).objectStoreId());
    }

    bool
    operator==(const ObjectStoreClearParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

private:
    void
    Init();

    void
    Assign(const int64_t& _objectStoreId);

    int64_t objectStoreId_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ObjectStoreCountParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreCountParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;

public:
    MOZ_IMPLICIT ObjectStoreCountParams();

    MOZ_IMPLICIT ObjectStoreCountParams(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange)
    {
        Init();
        Assign(_objectStoreId, _optionalKeyRange);
    }

    MOZ_IMPLICIT ObjectStoreCountParams(const ObjectStoreCountParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).optionalKeyRange());
    }

    ~ObjectStoreCountParams();

    void
    operator=(const ObjectStoreCountParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).optionalKeyRange());
    }

    bool
    operator==(const ObjectStoreCountParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const OptionalKeyRange& _optionalKeyRange);

    int64_t objectStoreId_;
    OptionalKeyRange optionalKeyRange_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexGetParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetParams final
{
private:
    typedef mozilla::dom::indexedDB::SerializedKeyRange SerializedKeyRange;

public:
    MOZ_IMPLICIT IndexGetParams();

    MOZ_IMPLICIT IndexGetParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const SerializedKeyRange& _keyRange)
    {
        Init();
        Assign(_objectStoreId, _indexId, _keyRange);
    }

    MOZ_IMPLICIT IndexGetParams(const IndexGetParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).keyRange());
    }

    ~IndexGetParams();

    void
    operator=(const IndexGetParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).keyRange());
    }

    bool
    operator==(const IndexGetParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    SerializedKeyRange&
    keyRange()
    {
        return keyRange_;
    }
    const SerializedKeyRange&
    keyRange() const
    {
        return keyRange_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const SerializedKeyRange& _keyRange);

    int64_t objectStoreId_;
    int64_t indexId_;
    SerializedKeyRange keyRange_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class SerializedKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexGetKeyParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetKeyParams final
{
private:
    typedef mozilla::dom::indexedDB::SerializedKeyRange SerializedKeyRange;

public:
    MOZ_IMPLICIT IndexGetKeyParams();

    MOZ_IMPLICIT IndexGetKeyParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const SerializedKeyRange& _keyRange)
    {
        Init();
        Assign(_objectStoreId, _indexId, _keyRange);
    }

    MOZ_IMPLICIT IndexGetKeyParams(const IndexGetKeyParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).keyRange());
    }

    ~IndexGetKeyParams();

    void
    operator=(const IndexGetKeyParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).keyRange());
    }

    bool
    operator==(const IndexGetKeyParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    SerializedKeyRange&
    keyRange()
    {
        return keyRange_;
    }
    const SerializedKeyRange&
    keyRange() const
    {
        return keyRange_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const SerializedKeyRange& _keyRange);

    int64_t objectStoreId_;
    int64_t indexId_;
    SerializedKeyRange keyRange_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexGetAllParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetAllParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;

public:
    MOZ_IMPLICIT IndexGetAllParams();

    MOZ_IMPLICIT IndexGetAllParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit)
    {
        Init();
        Assign(_objectStoreId, _indexId, _optionalKeyRange, _limit);
    }

    MOZ_IMPLICIT IndexGetAllParams(const IndexGetAllParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).limit());
    }

    ~IndexGetAllParams();

    void
    operator=(const IndexGetAllParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).limit());
    }

    bool
    operator==(const IndexGetAllParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    uint32_t&
    limit()
    {
        return limit_;
    }
    const uint32_t&
    limit() const
    {
        return limit_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit);

    int64_t objectStoreId_;
    int64_t indexId_;
    OptionalKeyRange optionalKeyRange_;
    uint32_t limit_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexGetAllKeysParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetAllKeysParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;

public:
    MOZ_IMPLICIT IndexGetAllKeysParams();

    MOZ_IMPLICIT IndexGetAllKeysParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit)
    {
        Init();
        Assign(_objectStoreId, _indexId, _optionalKeyRange, _limit);
    }

    MOZ_IMPLICIT IndexGetAllKeysParams(const IndexGetAllKeysParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).limit());
    }

    ~IndexGetAllKeysParams();

    void
    operator=(const IndexGetAllKeysParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange(), (_o).limit());
    }

    bool
    operator==(const IndexGetAllKeysParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

    uint32_t&
    limit()
    {
        return limit_;
    }
    const uint32_t&
    limit() const
    {
        return limit_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange,
            const uint32_t& _limit);

    int64_t objectStoreId_;
    int64_t indexId_;
    OptionalKeyRange optionalKeyRange_;
    uint32_t limit_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class OptionalKeyRange;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IndexCountParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexCountParams final
{
private:
    typedef mozilla::dom::indexedDB::OptionalKeyRange OptionalKeyRange;

public:
    MOZ_IMPLICIT IndexCountParams();

    MOZ_IMPLICIT IndexCountParams(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange)
    {
        Init();
        Assign(_objectStoreId, _indexId, _optionalKeyRange);
    }

    MOZ_IMPLICIT IndexCountParams(const IndexCountParams& _o)
    {
        Init();
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange());
    }

    ~IndexCountParams();

    void
    operator=(const IndexCountParams& _o)
    {
        Assign((_o).objectStoreId(), (_o).indexId(), (_o).optionalKeyRange());
    }

    bool
    operator==(const IndexCountParams& _o) const;

    int64_t&
    objectStoreId()
    {
        return objectStoreId_;
    }
    const int64_t&
    objectStoreId() const
    {
        return objectStoreId_;
    }

    int64_t&
    indexId()
    {
        return indexId_;
    }
    const int64_t&
    indexId() const
    {
        return indexId_;
    }

    OptionalKeyRange&
    optionalKeyRange()
    {
        return optionalKeyRange_;
    }
    const OptionalKeyRange&
    optionalKeyRange() const
    {
        return optionalKeyRange_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _objectStoreId,
            const int64_t& _indexId,
            const OptionalKeyRange& _optionalKeyRange);

    int64_t objectStoreId_;
    int64_t indexId_;
    OptionalKeyRange optionalKeyRange_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreAddParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStorePutParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreGetParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreGetAllParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreGetAllKeysParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreDeleteParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreClearParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class ObjectStoreCountParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetKeyParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetAllParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexGetAllKeysParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace indexedDB {
class IndexCountParams;
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union RequestParams|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class RequestParams final
{
public:
    enum Type {
        T__None,
        TObjectStoreAddParams = 1,
        TObjectStorePutParams,
        TObjectStoreGetParams,
        TObjectStoreGetAllParams,
        TObjectStoreGetAllKeysParams,
        TObjectStoreDeleteParams,
        TObjectStoreClearParams,
        TObjectStoreCountParams,
        TIndexGetParams,
        TIndexGetKeyParams,
        TIndexGetAllParams,
        TIndexGetAllKeysParams,
        TIndexCountParams,
        T__Last = TIndexCountParams
    };

private:
    typedef mozilla::dom::indexedDB::ObjectStoreAddParams ObjectStoreAddParams;
    typedef mozilla::dom::indexedDB::ObjectStorePutParams ObjectStorePutParams;
    typedef mozilla::dom::indexedDB::ObjectStoreGetParams ObjectStoreGetParams;
    typedef mozilla::dom::indexedDB::ObjectStoreGetAllParams ObjectStoreGetAllParams;
    typedef mozilla::dom::indexedDB::ObjectStoreGetAllKeysParams ObjectStoreGetAllKeysParams;
    typedef mozilla::dom::indexedDB::ObjectStoreDeleteParams ObjectStoreDeleteParams;
    typedef mozilla::dom::indexedDB::ObjectStoreClearParams ObjectStoreClearParams;
    typedef mozilla::dom::indexedDB::ObjectStoreCountParams ObjectStoreCountParams;
    typedef mozilla::dom::indexedDB::IndexGetParams IndexGetParams;
    typedef mozilla::dom::indexedDB::IndexGetKeyParams IndexGetKeyParams;
    typedef mozilla::dom::indexedDB::IndexGetAllParams IndexGetAllParams;
    typedef mozilla::dom::indexedDB::IndexGetAllKeysParams IndexGetAllKeysParams;
    typedef mozilla::dom::indexedDB::IndexCountParams IndexCountParams;
    typedef ObjectStoreAddParams ObjectStoreAddParams__tdef;
    typedef ObjectStorePutParams ObjectStorePutParams__tdef;
    typedef ObjectStoreGetParams ObjectStoreGetParams__tdef;
    typedef ObjectStoreGetAllParams ObjectStoreGetAllParams__tdef;
    typedef ObjectStoreGetAllKeysParams ObjectStoreGetAllKeysParams__tdef;
    typedef ObjectStoreDeleteParams ObjectStoreDeleteParams__tdef;
    typedef ObjectStoreClearParams ObjectStoreClearParams__tdef;
    typedef ObjectStoreCountParams ObjectStoreCountParams__tdef;
    typedef IndexGetParams IndexGetParams__tdef;
    typedef IndexGetKeyParams IndexGetKeyParams__tdef;
    typedef IndexGetAllParams IndexGetAllParams__tdef;
    typedef IndexGetAllKeysParams IndexGetAllKeysParams__tdef;
    typedef IndexCountParams IndexCountParams__tdef;

    union Value {
        char VObjectStoreAddParams[sizeof(ObjectStoreAddParams)];
        char VObjectStorePutParams[sizeof(ObjectStorePutParams)];
        char VObjectStoreGetParams[sizeof(ObjectStoreGetParams)];
        char VObjectStoreGetAllParams[sizeof(ObjectStoreGetAllParams)];
        char VObjectStoreGetAllKeysParams[sizeof(ObjectStoreGetAllKeysParams)];
        char VObjectStoreDeleteParams[sizeof(ObjectStoreDeleteParams)];
        char VObjectStoreClearParams[sizeof(ObjectStoreClearParams)];
        char VObjectStoreCountParams[sizeof(ObjectStoreCountParams)];
        char VIndexGetParams[sizeof(IndexGetParams)];
        char VIndexGetKeyParams[sizeof(IndexGetKeyParams)];
        char VIndexGetAllParams[sizeof(IndexGetAllParams)];
        char VIndexGetAllKeysParams[sizeof(IndexGetAllKeysParams)];
        char VIndexCountParams[sizeof(IndexCountParams)];
    };

    ObjectStoreAddParams*
    ptr_ObjectStoreAddParams()
    {
        return reinterpret_cast<ObjectStoreAddParams*>((&((mValue).VObjectStoreAddParams)));
    }
    const ObjectStoreAddParams* const
    constptr_ObjectStoreAddParams() const
    {
        return reinterpret_cast<const ObjectStoreAddParams* const>((&((mValue).VObjectStoreAddParams)));
    }
    ObjectStorePutParams*
    ptr_ObjectStorePutParams()
    {
        return reinterpret_cast<ObjectStorePutParams*>((&((mValue).VObjectStorePutParams)));
    }
    const ObjectStorePutParams* const
    constptr_ObjectStorePutParams() const
    {
        return reinterpret_cast<const ObjectStorePutParams* const>((&((mValue).VObjectStorePutParams)));
    }
    ObjectStoreGetParams*
    ptr_ObjectStoreGetParams()
    {
        return reinterpret_cast<ObjectStoreGetParams*>((&((mValue).VObjectStoreGetParams)));
    }
    const ObjectStoreGetParams* const
    constptr_ObjectStoreGetParams() const
    {
        return reinterpret_cast<const ObjectStoreGetParams* const>((&((mValue).VObjectStoreGetParams)));
    }
    ObjectStoreGetAllParams*
    ptr_ObjectStoreGetAllParams()
    {
        return reinterpret_cast<ObjectStoreGetAllParams*>((&((mValue).VObjectStoreGetAllParams)));
    }
    const ObjectStoreGetAllParams* const
    constptr_ObjectStoreGetAllParams() const
    {
        return reinterpret_cast<const ObjectStoreGetAllParams* const>((&((mValue).VObjectStoreGetAllParams)));
    }
    ObjectStoreGetAllKeysParams*
    ptr_ObjectStoreGetAllKeysParams()
    {
        return reinterpret_cast<ObjectStoreGetAllKeysParams*>((&((mValue).VObjectStoreGetAllKeysParams)));
    }
    const ObjectStoreGetAllKeysParams* const
    constptr_ObjectStoreGetAllKeysParams() const
    {
        return reinterpret_cast<const ObjectStoreGetAllKeysParams* const>((&((mValue).VObjectStoreGetAllKeysParams)));
    }
    ObjectStoreDeleteParams*
    ptr_ObjectStoreDeleteParams()
    {
        return reinterpret_cast<ObjectStoreDeleteParams*>((&((mValue).VObjectStoreDeleteParams)));
    }
    const ObjectStoreDeleteParams* const
    constptr_ObjectStoreDeleteParams() const
    {
        return reinterpret_cast<const ObjectStoreDeleteParams* const>((&((mValue).VObjectStoreDeleteParams)));
    }
    ObjectStoreClearParams*
    ptr_ObjectStoreClearParams()
    {
        return reinterpret_cast<ObjectStoreClearParams*>((&((mValue).VObjectStoreClearParams)));
    }
    const ObjectStoreClearParams* const
    constptr_ObjectStoreClearParams() const
    {
        return reinterpret_cast<const ObjectStoreClearParams* const>((&((mValue).VObjectStoreClearParams)));
    }
    ObjectStoreCountParams*
    ptr_ObjectStoreCountParams()
    {
        return reinterpret_cast<ObjectStoreCountParams*>((&((mValue).VObjectStoreCountParams)));
    }
    const ObjectStoreCountParams* const
    constptr_ObjectStoreCountParams() const
    {
        return reinterpret_cast<const ObjectStoreCountParams* const>((&((mValue).VObjectStoreCountParams)));
    }
    IndexGetParams*
    ptr_IndexGetParams()
    {
        return reinterpret_cast<IndexGetParams*>((&((mValue).VIndexGetParams)));
    }
    const IndexGetParams* const
    constptr_IndexGetParams() const
    {
        return reinterpret_cast<const IndexGetParams* const>((&((mValue).VIndexGetParams)));
    }
    IndexGetKeyParams*
    ptr_IndexGetKeyParams()
    {
        return reinterpret_cast<IndexGetKeyParams*>((&((mValue).VIndexGetKeyParams)));
    }
    const IndexGetKeyParams* const
    constptr_IndexGetKeyParams() const
    {
        return reinterpret_cast<const IndexGetKeyParams* const>((&((mValue).VIndexGetKeyParams)));
    }
    IndexGetAllParams*
    ptr_IndexGetAllParams()
    {
        return reinterpret_cast<IndexGetAllParams*>((&((mValue).VIndexGetAllParams)));
    }
    const IndexGetAllParams* const
    constptr_IndexGetAllParams() const
    {
        return reinterpret_cast<const IndexGetAllParams* const>((&((mValue).VIndexGetAllParams)));
    }
    IndexGetAllKeysParams*
    ptr_IndexGetAllKeysParams()
    {
        return reinterpret_cast<IndexGetAllKeysParams*>((&((mValue).VIndexGetAllKeysParams)));
    }
    const IndexGetAllKeysParams* const
    constptr_IndexGetAllKeysParams() const
    {
        return reinterpret_cast<const IndexGetAllKeysParams* const>((&((mValue).VIndexGetAllKeysParams)));
    }
    IndexCountParams*
    ptr_IndexCountParams()
    {
        return reinterpret_cast<IndexCountParams*>((&((mValue).VIndexCountParams)));
    }
    const IndexCountParams* const
    constptr_IndexCountParams() const
    {
        return reinterpret_cast<const IndexCountParams* const>((&((mValue).VIndexCountParams)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT RequestParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT RequestParams(const ObjectStoreAddParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStorePutParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStoreGetParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStoreGetAllParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStoreGetAllKeysParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStoreDeleteParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStoreClearParams& aOther);

    MOZ_IMPLICIT RequestParams(const ObjectStoreCountParams& aOther);

    MOZ_IMPLICIT RequestParams(const IndexGetParams& aOther);

    MOZ_IMPLICIT RequestParams(const IndexGetKeyParams& aOther);

    MOZ_IMPLICIT RequestParams(const IndexGetAllParams& aOther);

    MOZ_IMPLICIT RequestParams(const IndexGetAllKeysParams& aOther);

    MOZ_IMPLICIT RequestParams(const IndexCountParams& aOther);

    MOZ_IMPLICIT RequestParams(const RequestParams& aOther);

    ~RequestParams();

    Type
    type() const
    {
        return mType;
    }

    RequestParams&
    operator=(const ObjectStoreAddParams& aRhs);

    RequestParams&
    operator=(const ObjectStorePutParams& aRhs);

    RequestParams&
    operator=(const ObjectStoreGetParams& aRhs);

    RequestParams&
    operator=(const ObjectStoreGetAllParams& aRhs);

    RequestParams&
    operator=(const ObjectStoreGetAllKeysParams& aRhs);

    RequestParams&
    operator=(const ObjectStoreDeleteParams& aRhs);

    RequestParams&
    operator=(const ObjectStoreClearParams& aRhs);

    RequestParams&
    operator=(const ObjectStoreCountParams& aRhs);

    RequestParams&
    operator=(const IndexGetParams& aRhs);

    RequestParams&
    operator=(const IndexGetKeyParams& aRhs);

    RequestParams&
    operator=(const IndexGetAllParams& aRhs);

    RequestParams&
    operator=(const IndexGetAllKeysParams& aRhs);

    RequestParams&
    operator=(const IndexCountParams& aRhs);

    RequestParams&
    operator=(const RequestParams& aRhs);

    bool
    operator==(const ObjectStoreAddParams& aRhs) const;

    bool
    operator==(const ObjectStorePutParams& aRhs) const;

    bool
    operator==(const ObjectStoreGetParams& aRhs) const;

    bool
    operator==(const ObjectStoreGetAllParams& aRhs) const;

    bool
    operator==(const ObjectStoreGetAllKeysParams& aRhs) const;

    bool
    operator==(const ObjectStoreDeleteParams& aRhs) const;

    bool
    operator==(const ObjectStoreClearParams& aRhs) const;

    bool
    operator==(const ObjectStoreCountParams& aRhs) const;

    bool
    operator==(const IndexGetParams& aRhs) const;

    bool
    operator==(const IndexGetKeyParams& aRhs) const;

    bool
    operator==(const IndexGetAllParams& aRhs) const;

    bool
    operator==(const IndexGetAllKeysParams& aRhs) const;

    bool
    operator==(const IndexCountParams& aRhs) const;

    bool
    operator==(const RequestParams& aRhs) const;

    ObjectStoreAddParams&
    get_ObjectStoreAddParams()
    {
        AssertSanity(TObjectStoreAddParams);
        return (*(ptr_ObjectStoreAddParams()));
    }
    const ObjectStoreAddParams&
    get_ObjectStoreAddParams() const
    {
        AssertSanity(TObjectStoreAddParams);
        return (*(constptr_ObjectStoreAddParams()));
    }
    operator ObjectStoreAddParams&()
    {
        return get_ObjectStoreAddParams();
    }
    operator const ObjectStoreAddParams&() const
    {
        return get_ObjectStoreAddParams();
    }

    ObjectStorePutParams&
    get_ObjectStorePutParams()
    {
        AssertSanity(TObjectStorePutParams);
        return (*(ptr_ObjectStorePutParams()));
    }
    const ObjectStorePutParams&
    get_ObjectStorePutParams() const
    {
        AssertSanity(TObjectStorePutParams);
        return (*(constptr_ObjectStorePutParams()));
    }
    operator ObjectStorePutParams&()
    {
        return get_ObjectStorePutParams();
    }
    operator const ObjectStorePutParams&() const
    {
        return get_ObjectStorePutParams();
    }

    ObjectStoreGetParams&
    get_ObjectStoreGetParams()
    {
        AssertSanity(TObjectStoreGetParams);
        return (*(ptr_ObjectStoreGetParams()));
    }
    const ObjectStoreGetParams&
    get_ObjectStoreGetParams() const
    {
        AssertSanity(TObjectStoreGetParams);
        return (*(constptr_ObjectStoreGetParams()));
    }
    operator ObjectStoreGetParams&()
    {
        return get_ObjectStoreGetParams();
    }
    operator const ObjectStoreGetParams&() const
    {
        return get_ObjectStoreGetParams();
    }

    ObjectStoreGetAllParams&
    get_ObjectStoreGetAllParams()
    {
        AssertSanity(TObjectStoreGetAllParams);
        return (*(ptr_ObjectStoreGetAllParams()));
    }
    const ObjectStoreGetAllParams&
    get_ObjectStoreGetAllParams() const
    {
        AssertSanity(TObjectStoreGetAllParams);
        return (*(constptr_ObjectStoreGetAllParams()));
    }
    operator ObjectStoreGetAllParams&()
    {
        return get_ObjectStoreGetAllParams();
    }
    operator const ObjectStoreGetAllParams&() const
    {
        return get_ObjectStoreGetAllParams();
    }

    ObjectStoreGetAllKeysParams&
    get_ObjectStoreGetAllKeysParams()
    {
        AssertSanity(TObjectStoreGetAllKeysParams);
        return (*(ptr_ObjectStoreGetAllKeysParams()));
    }
    const ObjectStoreGetAllKeysParams&
    get_ObjectStoreGetAllKeysParams() const
    {
        AssertSanity(TObjectStoreGetAllKeysParams);
        return (*(constptr_ObjectStoreGetAllKeysParams()));
    }
    operator ObjectStoreGetAllKeysParams&()
    {
        return get_ObjectStoreGetAllKeysParams();
    }
    operator const ObjectStoreGetAllKeysParams&() const
    {
        return get_ObjectStoreGetAllKeysParams();
    }

    ObjectStoreDeleteParams&
    get_ObjectStoreDeleteParams()
    {
        AssertSanity(TObjectStoreDeleteParams);
        return (*(ptr_ObjectStoreDeleteParams()));
    }
    const ObjectStoreDeleteParams&
    get_ObjectStoreDeleteParams() const
    {
        AssertSanity(TObjectStoreDeleteParams);
        return (*(constptr_ObjectStoreDeleteParams()));
    }
    operator ObjectStoreDeleteParams&()
    {
        return get_ObjectStoreDeleteParams();
    }
    operator const ObjectStoreDeleteParams&() const
    {
        return get_ObjectStoreDeleteParams();
    }

    ObjectStoreClearParams&
    get_ObjectStoreClearParams()
    {
        AssertSanity(TObjectStoreClearParams);
        return (*(ptr_ObjectStoreClearParams()));
    }
    const ObjectStoreClearParams&
    get_ObjectStoreClearParams() const
    {
        AssertSanity(TObjectStoreClearParams);
        return (*(constptr_ObjectStoreClearParams()));
    }
    operator ObjectStoreClearParams&()
    {
        return get_ObjectStoreClearParams();
    }
    operator const ObjectStoreClearParams&() const
    {
        return get_ObjectStoreClearParams();
    }

    ObjectStoreCountParams&
    get_ObjectStoreCountParams()
    {
        AssertSanity(TObjectStoreCountParams);
        return (*(ptr_ObjectStoreCountParams()));
    }
    const ObjectStoreCountParams&
    get_ObjectStoreCountParams() const
    {
        AssertSanity(TObjectStoreCountParams);
        return (*(constptr_ObjectStoreCountParams()));
    }
    operator ObjectStoreCountParams&()
    {
        return get_ObjectStoreCountParams();
    }
    operator const ObjectStoreCountParams&() const
    {
        return get_ObjectStoreCountParams();
    }

    IndexGetParams&
    get_IndexGetParams()
    {
        AssertSanity(TIndexGetParams);
        return (*(ptr_IndexGetParams()));
    }
    const IndexGetParams&
    get_IndexGetParams() const
    {
        AssertSanity(TIndexGetParams);
        return (*(constptr_IndexGetParams()));
    }
    operator IndexGetParams&()
    {
        return get_IndexGetParams();
    }
    operator const IndexGetParams&() const
    {
        return get_IndexGetParams();
    }

    IndexGetKeyParams&
    get_IndexGetKeyParams()
    {
        AssertSanity(TIndexGetKeyParams);
        return (*(ptr_IndexGetKeyParams()));
    }
    const IndexGetKeyParams&
    get_IndexGetKeyParams() const
    {
        AssertSanity(TIndexGetKeyParams);
        return (*(constptr_IndexGetKeyParams()));
    }
    operator IndexGetKeyParams&()
    {
        return get_IndexGetKeyParams();
    }
    operator const IndexGetKeyParams&() const
    {
        return get_IndexGetKeyParams();
    }

    IndexGetAllParams&
    get_IndexGetAllParams()
    {
        AssertSanity(TIndexGetAllParams);
        return (*(ptr_IndexGetAllParams()));
    }
    const IndexGetAllParams&
    get_IndexGetAllParams() const
    {
        AssertSanity(TIndexGetAllParams);
        return (*(constptr_IndexGetAllParams()));
    }
    operator IndexGetAllParams&()
    {
        return get_IndexGetAllParams();
    }
    operator const IndexGetAllParams&() const
    {
        return get_IndexGetAllParams();
    }

    IndexGetAllKeysParams&
    get_IndexGetAllKeysParams()
    {
        AssertSanity(TIndexGetAllKeysParams);
        return (*(ptr_IndexGetAllKeysParams()));
    }
    const IndexGetAllKeysParams&
    get_IndexGetAllKeysParams() const
    {
        AssertSanity(TIndexGetAllKeysParams);
        return (*(constptr_IndexGetAllKeysParams()));
    }
    operator IndexGetAllKeysParams&()
    {
        return get_IndexGetAllKeysParams();
    }
    operator const IndexGetAllKeysParams&() const
    {
        return get_IndexGetAllKeysParams();
    }

    IndexCountParams&
    get_IndexCountParams()
    {
        AssertSanity(TIndexCountParams);
        return (*(ptr_IndexCountParams()));
    }
    const IndexCountParams&
    get_IndexCountParams() const
    {
        AssertSanity(TIndexCountParams);
        return (*(constptr_IndexCountParams()));
    }
    operator IndexCountParams&()
    {
        return get_IndexCountParams();
    }
    operator const IndexCountParams&() const
    {
        return get_IndexCountParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoggingInfo|
//
namespace mozilla {
namespace dom {
namespace indexedDB {
class LoggingInfo final
{
private:

public:
    MOZ_IMPLICIT LoggingInfo();

    MOZ_IMPLICIT LoggingInfo(
            const nsID& _backgroundChildLoggingId,
            const int64_t& _nextTransactionSerialNumber,
            const int64_t& _nextVersionChangeTransactionSerialNumber,
            const uint64_t& _nextRequestSerialNumber)
    {
        Init();
        Assign(_backgroundChildLoggingId, _nextTransactionSerialNumber, _nextVersionChangeTransactionSerialNumber, _nextRequestSerialNumber);
    }

    MOZ_IMPLICIT LoggingInfo(const LoggingInfo& _o)
    {
        Init();
        Assign((_o).backgroundChildLoggingId(), (_o).nextTransactionSerialNumber(), (_o).nextVersionChangeTransactionSerialNumber(), (_o).nextRequestSerialNumber());
    }

    ~LoggingInfo();

    void
    operator=(const LoggingInfo& _o)
    {
        Assign((_o).backgroundChildLoggingId(), (_o).nextTransactionSerialNumber(), (_o).nextVersionChangeTransactionSerialNumber(), (_o).nextRequestSerialNumber());
    }

    bool
    operator==(const LoggingInfo& _o) const;

    nsID&
    backgroundChildLoggingId()
    {
        return backgroundChildLoggingId_;
    }
    const nsID&
    backgroundChildLoggingId() const
    {
        return backgroundChildLoggingId_;
    }

    int64_t&
    nextTransactionSerialNumber()
    {
        return nextTransactionSerialNumber_;
    }
    const int64_t&
    nextTransactionSerialNumber() const
    {
        return nextTransactionSerialNumber_;
    }

    int64_t&
    nextVersionChangeTransactionSerialNumber()
    {
        return nextVersionChangeTransactionSerialNumber_;
    }
    const int64_t&
    nextVersionChangeTransactionSerialNumber() const
    {
        return nextVersionChangeTransactionSerialNumber_;
    }

    uint64_t&
    nextRequestSerialNumber()
    {
        return nextRequestSerialNumber_;
    }
    const uint64_t&
    nextRequestSerialNumber() const
    {
        return nextRequestSerialNumber_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _backgroundChildLoggingId,
            const int64_t& _nextTransactionSerialNumber,
            const int64_t& _nextVersionChangeTransactionSerialNumber,
            const uint64_t& _nextRequestSerialNumber);

    nsID backgroundChildLoggingId_;
    int64_t nextTransactionSerialNumber_;
    int64_t nextVersionChangeTransactionSerialNumber_;
    uint64_t nextRequestSerialNumber_;
};
} // namespace indexedDB
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundIDBSharedTypes_h
