//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTelephonyRequestChild_h
#define PTelephonyRequestChild_h

#include "mozilla/dom/telephony/PTelephonyRequest.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/dom/telephony/TelephonyIPCSerializer.h"

namespace mozilla {
namespace dom {
namespace telephony {
class PTelephonyChild;
} // namespace telephony
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace telephony {
class PTelephonyParent;
} // namespace telephony
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace telephony {
class PTelephonyChild;
} // namespace telephony
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace telephony {


class PTelephonyRequestChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::telephony::PTelephonyChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::telephony::AdditionalInformation AdditionalInformation;
    typedef mozilla::dom::telephony::DialResponseCallSuccess DialResponseCallSuccess;
    typedef mozilla::dom::telephony::DialResponseMMIError DialResponseMMIError;
    typedef mozilla::dom::telephony::DialResponseMMISuccess DialResponseMMISuccess;
    typedef mozilla::dom::telephony::EnumerateCallsResponse EnumerateCallsResponse;
    typedef mozilla::dom::telephony::ErrorResponse ErrorResponse;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::telephony::IPCCdmaWaitingCallData IPCCdmaWaitingCallData;
    typedef mozilla::dom::telephony::IPCTelephonyResponse IPCTelephonyResponse;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::telephony::SuccessResponse SuccessResponse;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::dom::telephony::PTelephonyChild PTelephonyChild;
    typedef mozilla::dom::telephony::PTelephonyParent PTelephonyParent;

    typedef PTelephonyRequest::State State;

    virtual bool
    RecvNotifyEnumerateCallState(const nsTelephonyCallInfo& aInfo) = 0;
    virtual bool
    RecvNotifyDialMMI(const nsString& aServiceCode) = 0;
    virtual bool
    Recv__delete__(const IPCTelephonyResponse& aResponse);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PTelephonyRequestChild();

    virtual ~PTelephonyRequestChild();

    PTelephonyChild*
    Manager() const;

    PTelephonyRequest::State
    state();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PTelephonyRequestChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PTelephonyRequestChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const AdditionalInformation& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            AdditionalInformation* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const DialResponseMMIError& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DialResponseMMIError* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const DialResponseCallSuccess& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DialResponseCallSuccess* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SuccessResponse& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SuccessResponse* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const IPCTelephonyResponse& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            IPCTelephonyResponse* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const EnumerateCallsResponse& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            EnumerateCallsResponse* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const ErrorResponse& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            ErrorResponse* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const DialResponseMMISuccess& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            DialResponseMMISuccess* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace telephony
} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
namespace telephony {
class TelephonyRequestChild :
    public PTelephonyRequestChild
{
    virtual bool
    RecvNotifyEnumerateCallState(const nsTelephonyCallInfo& aInfo);

    virtual bool
    RecvNotifyDialMMI(const nsString& aServiceCode);

    MOZ_IMPLICIT TelephonyRequestChild();
    virtual ~TelephonyRequestChild();
};
} // namespace telephony
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
namespace telephony {
bool
TelephonyRequestChild::RecvNotifyEnumerateCallState(const nsTelephonyCallInfo& aInfo)
{
    return false;
}

bool
TelephonyRequestChild::RecvNotifyDialMMI(const nsString& aServiceCode)
{
    return false;
}

MOZ_IMPLICIT TelephonyRequestChild::TelephonyRequestChild()
{
    MOZ_COUNT_CTOR(TelephonyRequestChild);
}

MOZ_IMPLICIT TelephonyRequestChild::~TelephonyRequestChild()
{
    MOZ_COUNT_DTOR(TelephonyRequestChild);
}

} // namespace telephony
} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PTelephonyRequestChild_h
