//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef GraphicsMessages_h
#define GraphicsMessages_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DxgiLUID|
//
namespace mozilla {
namespace gfx {
class DxgiLUID final
{
private:

public:
    MOZ_IMPLICIT DxgiLUID();

    MOZ_IMPLICIT DxgiLUID(
            const uint32_t& _LowPart,
            const int32_t& _HighPart)
    {
        Init();
        Assign(_LowPart, _HighPart);
    }

    MOZ_IMPLICIT DxgiLUID(const DxgiLUID& _o)
    {
        Init();
        Assign((_o).LowPart(), (_o).HighPart());
    }

    ~DxgiLUID();

    void
    operator=(const DxgiLUID& _o)
    {
        Assign((_o).LowPart(), (_o).HighPart());
    }

    bool
    operator==(const DxgiLUID& _o) const;

    uint32_t&
    LowPart()
    {
        return LowPart_;
    }
    const uint32_t&
    LowPart() const
    {
        return LowPart_;
    }

    int32_t&
    HighPart()
    {
        return HighPart_;
    }
    const int32_t&
    HighPart() const
    {
        return HighPart_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _LowPart,
            const int32_t& _HighPart);

    uint32_t LowPart_;
    int32_t HighPart_;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class DxgiLUID;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DxgiDesc|
//
namespace mozilla {
namespace gfx {
class DxgiDesc final
{
private:
    typedef mozilla::gfx::DxgiLUID DxgiLUID;

public:
    MOZ_IMPLICIT DxgiDesc();

    MOZ_IMPLICIT DxgiDesc(
            const uint32_t& _vendorID,
            const uint32_t& _deviceID,
            const uint32_t& _subSysID,
            const DxgiLUID& _luid)
    {
        Init();
        Assign(_vendorID, _deviceID, _subSysID, _luid);
    }

    MOZ_IMPLICIT DxgiDesc(const DxgiDesc& _o)
    {
        Init();
        Assign((_o).vendorID(), (_o).deviceID(), (_o).subSysID(), (_o).luid());
    }

    ~DxgiDesc();

    void
    operator=(const DxgiDesc& _o)
    {
        Assign((_o).vendorID(), (_o).deviceID(), (_o).subSysID(), (_o).luid());
    }

    bool
    operator==(const DxgiDesc& _o) const;

    uint32_t&
    vendorID()
    {
        return vendorID_;
    }
    const uint32_t&
    vendorID() const
    {
        return vendorID_;
    }

    uint32_t&
    deviceID()
    {
        return deviceID_;
    }
    const uint32_t&
    deviceID() const
    {
        return deviceID_;
    }

    uint32_t&
    subSysID()
    {
        return subSysID_;
    }
    const uint32_t&
    subSysID() const
    {
        return subSysID_;
    }

    DxgiLUID&
    luid()
    {
        return luid_;
    }
    const DxgiLUID&
    luid() const
    {
        return luid_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _vendorID,
            const uint32_t& _deviceID,
            const uint32_t& _subSysID,
            const DxgiLUID& _luid);

    uint32_t vendorID_;
    uint32_t deviceID_;
    uint32_t subSysID_;
    DxgiLUID luid_;
};
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class DxgiDesc;
} // namespace gfx
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DeviceInitData|
//
namespace mozilla {
namespace gfx {
class DeviceInitData final
{
private:
    typedef mozilla::gfx::DxgiDesc DxgiDesc;

public:
    MOZ_IMPLICIT DeviceInitData();

    MOZ_IMPLICIT DeviceInitData(
            const bool& _useAcceleration,
            const bool& _useD3D11,
            const bool& _useD3D11WARP,
            const bool& _useD3D11ImageBridge,
            const bool& _d3d11TextureSharingWorks,
            const bool& _useD2D,
            const bool& _useD2D1,
            const DxgiDesc& _dxgiDesc)
    {
        Init();
        Assign(_useAcceleration, _useD3D11, _useD3D11WARP, _useD3D11ImageBridge, _d3d11TextureSharingWorks, _useD2D, _useD2D1, _dxgiDesc);
    }

    MOZ_IMPLICIT DeviceInitData(const DeviceInitData& _o)
    {
        Init();
        Assign((_o).useAcceleration(), (_o).useD3D11(), (_o).useD3D11WARP(), (_o).useD3D11ImageBridge(), (_o).d3d11TextureSharingWorks(), (_o).useD2D(), (_o).useD2D1(), (_o).dxgiDesc());
    }

    ~DeviceInitData();

    void
    operator=(const DeviceInitData& _o)
    {
        Assign((_o).useAcceleration(), (_o).useD3D11(), (_o).useD3D11WARP(), (_o).useD3D11ImageBridge(), (_o).d3d11TextureSharingWorks(), (_o).useD2D(), (_o).useD2D1(), (_o).dxgiDesc());
    }

    bool
    operator==(const DeviceInitData& _o) const;

    bool&
    useAcceleration()
    {
        return useAcceleration_;
    }
    const bool&
    useAcceleration() const
    {
        return useAcceleration_;
    }

    bool&
    useD3D11()
    {
        return useD3D11_;
    }
    const bool&
    useD3D11() const
    {
        return useD3D11_;
    }

    bool&
    useD3D11WARP()
    {
        return useD3D11WARP_;
    }
    const bool&
    useD3D11WARP() const
    {
        return useD3D11WARP_;
    }

    bool&
    useD3D11ImageBridge()
    {
        return useD3D11ImageBridge_;
    }
    const bool&
    useD3D11ImageBridge() const
    {
        return useD3D11ImageBridge_;
    }

    bool&
    d3d11TextureSharingWorks()
    {
        return d3d11TextureSharingWorks_;
    }
    const bool&
    d3d11TextureSharingWorks() const
    {
        return d3d11TextureSharingWorks_;
    }

    bool&
    useD2D()
    {
        return useD2D_;
    }
    const bool&
    useD2D() const
    {
        return useD2D_;
    }

    bool&
    useD2D1()
    {
        return useD2D1_;
    }
    const bool&
    useD2D1() const
    {
        return useD2D1_;
    }

    DxgiDesc&
    dxgiDesc()
    {
        return dxgiDesc_;
    }
    const DxgiDesc&
    dxgiDesc() const
    {
        return dxgiDesc_;
    }

private:
    void
    Init();

    void
    Assign(
            const bool& _useAcceleration,
            const bool& _useD3D11,
            const bool& _useD3D11WARP,
            const bool& _useD3D11ImageBridge,
            const bool& _d3d11TextureSharingWorks,
            const bool& _useD2D,
            const bool& _useD2D1,
            const DxgiDesc& _dxgiDesc);

    bool useAcceleration_;
    bool useD3D11_;
    bool useD3D11WARP_;
    bool useD3D11ImageBridge_;
    bool d3d11TextureSharingWorks_;
    bool useD2D_;
    bool useD2D1_;
    DxgiDesc dxgiDesc_;
};
} // namespace gfx
} // namespace mozilla

#endif // ifndef GraphicsMessages_h
