//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPDecryptorChild_h
#define PGMPDecryptorChild_h

#include "mozilla/gmp/PGMPDecryptor.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-decryption.h"
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPDecryptorChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

    typedef PGMPDecryptor::State State;

    virtual bool
    RecvInit() = 0;
    virtual bool
    RecvCreateSession(
            const uint32_t& aCreateSessionToken,
            const uint32_t& aPromiseId,
            const nsCString& aInitDataType,
            nsTArray<uint8_t>&& aInitData,
            const GMPSessionType& aSessionType) = 0;
    virtual bool
    RecvLoadSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual bool
    RecvUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            nsTArray<uint8_t>&& aResponse) = 0;
    virtual bool
    RecvCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual bool
    RecvRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual bool
    RecvSetServerCertificate(
            const uint32_t& aPromiseId,
            nsTArray<uint8_t>&& aServerCert) = 0;
    virtual bool
    RecvDecrypt(
            const uint32_t& aId,
            nsTArray<uint8_t>&& aBuffer,
            const GMPDecryptionData& aMetadata) = 0;
    virtual bool
    RecvDecryptingComplete() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPDecryptorChild();

    virtual ~PGMPDecryptorChild();

    PGMPContentChild*
    Manager() const;

    PGMPDecryptor::State
    state();

    static bool
    Send__delete__(PGMPDecryptorChild* actor);

    bool
    SendSetSessionId(
            const uint32_t& aCreateSessionToken,
            const nsCString& aSessionId);

    bool
    SendResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccess);

    bool
    SendResolvePromise(const uint32_t& aPromiseId);

    bool
    SendRejectPromise(
            const uint32_t& aPromiseId,
            const GMPDOMException& aDOMExceptionCode,
            const nsCString& aMessage);

    bool
    SendSessionMessage(
            const nsCString& aSessionId,
            const GMPSessionMessageType& aMessageType,
            const nsTArray<uint8_t>& aMessage);

    bool
    SendExpirationChange(
            const nsCString& aSessionId,
            const double& aExpiryTime);

    bool
    SendSessionClosed(const nsCString& aSessionId);

    bool
    SendSessionError(
            const nsCString& aSessionId,
            const GMPDOMException& aDOMExceptionCode,
            const uint32_t& aSystemCode,
            const nsCString& aMessage);

    bool
    SendKeyStatusChanged(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aKey,
            const GMPMediaKeyStatus& aStatus);

    bool
    SendSetCaps(const uint64_t& aCaps);

    bool
    SendDecrypted(
            const uint32_t& aId,
            const GMPErr& aResult,
            const nsTArray<uint8_t>& aBuffer);

    bool
    SendShutdown();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPDecryptionData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            GMPDecryptionData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PGMPDecryptorChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PGMPDecryptorChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPDecryptorChild :
    public PGMPDecryptorChild
{
    virtual bool
    RecvInit();

    virtual bool
    RecvCreateSession(
            const uint32_t& aCreateSessionToken,
            const uint32_t& aPromiseId,
            const nsCString& aInitDataType,
            nsTArray<uint8_t>&& aInitData,
            const GMPSessionType& aSessionType);

    virtual bool
    RecvLoadSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual bool
    RecvUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            nsTArray<uint8_t>&& aResponse);

    virtual bool
    RecvCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual bool
    RecvRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual bool
    RecvSetServerCertificate(
            const uint32_t& aPromiseId,
            nsTArray<uint8_t>&& aServerCert);

    virtual bool
    RecvDecrypt(
            const uint32_t& aId,
            nsTArray<uint8_t>&& aBuffer,
            const GMPDecryptionData& aMetadata);

    virtual bool
    RecvDecryptingComplete();

    MOZ_IMPLICIT GMPDecryptorChild();
    virtual ~GMPDecryptorChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPDecryptorChild::RecvInit()
{
    return false;
}

bool
GMPDecryptorChild::RecvCreateSession(
        const uint32_t& aCreateSessionToken,
        const uint32_t& aPromiseId,
        const nsCString& aInitDataType,
        nsTArray<uint8_t>&& aInitData,
        const GMPSessionType& aSessionType)
{
    return false;
}

bool
GMPDecryptorChild::RecvLoadSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorChild::RecvUpdateSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId,
        nsTArray<uint8_t>&& aResponse)
{
    return false;
}

bool
GMPDecryptorChild::RecvCloseSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorChild::RecvRemoveSession(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorChild::RecvSetServerCertificate(
        const uint32_t& aPromiseId,
        nsTArray<uint8_t>&& aServerCert)
{
    return false;
}

bool
GMPDecryptorChild::RecvDecrypt(
        const uint32_t& aId,
        nsTArray<uint8_t>&& aBuffer,
        const GMPDecryptionData& aMetadata)
{
    return false;
}

bool
GMPDecryptorChild::RecvDecryptingComplete()
{
    return false;
}

MOZ_IMPLICIT GMPDecryptorChild::GMPDecryptorChild()
{
    MOZ_COUNT_CTOR(GMPDecryptorChild);
}

MOZ_IMPLICIT GMPDecryptorChild::~GMPDecryptorChild()
{
    MOZ_COUNT_DTOR(GMPDecryptorChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPDecryptorChild_h
