//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPStorageChild_h
#define PGMPStorageChild_h

#include "mozilla/gmp/PGMPStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPStorageChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPChild PGMPChild;
    typedef mozilla::gmp::PGMPParent PGMPParent;

    typedef PGMPStorage::State State;

    virtual bool
    RecvOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus) = 0;
    virtual bool
    RecvReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            nsTArray<uint8_t>&& aBytes) = 0;
    virtual bool
    RecvWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus) = 0;
    virtual bool
    RecvRecordNames(
            nsTArray<nsCString>&& aRecordNames,
            const GMPErr& aStatus) = 0;
    virtual bool
    RecvShutdown() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPStorageChild();

    virtual ~PGMPStorageChild();

    PGMPChild*
    Manager() const;

    PGMPStorage::State
    state();

    bool
    SendOpen(const nsCString& aRecordName);

    bool
    SendRead(const nsCString& aRecordName);

    bool
    SendWrite(
            const nsCString& aRecordName,
            const nsTArray<uint8_t>& aBytes);

    bool
    SendClose(const nsCString& aRecordName);

    bool
    SendGetRecordNames();

    static bool
    Send__delete__(PGMPStorageChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PGMPStorageChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PGMPStorageChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPStorageChild :
    public PGMPStorageChild
{
    virtual bool
    RecvOpenComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    virtual bool
    RecvReadComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus,
            nsTArray<uint8_t>&& aBytes);

    virtual bool
    RecvWriteComplete(
            const nsCString& aRecordName,
            const GMPErr& aStatus);

    virtual bool
    RecvRecordNames(
            nsTArray<nsCString>&& aRecordNames,
            const GMPErr& aStatus);

    virtual bool
    RecvShutdown();

    MOZ_IMPLICIT GMPStorageChild();
    virtual ~GMPStorageChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPStorageChild::RecvOpenComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus)
{
    return false;
}

bool
GMPStorageChild::RecvReadComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus,
        nsTArray<uint8_t>&& aBytes)
{
    return false;
}

bool
GMPStorageChild::RecvWriteComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus)
{
    return false;
}

bool
GMPStorageChild::RecvRecordNames(
        nsTArray<nsCString>&& aRecordNames,
        const GMPErr& aStatus)
{
    return false;
}

bool
GMPStorageChild::RecvShutdown()
{
    return false;
}

MOZ_IMPLICIT GMPStorageChild::GMPStorageChild()
{
    MOZ_COUNT_CTOR(GMPStorageChild);
}

MOZ_IMPLICIT GMPStorageChild::~GMPStorageChild()
{
    MOZ_COUNT_DTOR(GMPStorageChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPStorageChild_h
