//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoDecoderParent_h
#define PGMPVideoDecoderParent_h

#include "mozilla/gmp/PGMPVideoDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPVideoDecoderParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

    typedef PGMPVideoDecoder::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame) = 0;
    virtual bool
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId) = 0;
    virtual bool
    RecvReceivedDecodedFrame(const uint64_t& aPictureId) = 0;
    virtual bool
    RecvInputDataExhausted() = 0;
    virtual bool
    RecvDrainComplete() = 0;
    virtual bool
    RecvResetComplete() = 0;
    virtual bool
    RecvError(const GMPErr& aErr) = 0;
    virtual bool
    RecvShutdown() = 0;
    virtual bool
    RecvParentShmemForPool(Shmem&& aEncodedBuffer) = 0;
    virtual bool
    AnswerNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPVideoDecoderParent();

    virtual ~PGMPVideoDecoderParent();

    PGMPContentParent*
    Manager() const;

    PGMPVideoDecoder::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendInitDecode(
            const GMPVideoCodec& aCodecSettings,
            const nsTArray<uint8_t>& aCodecSpecific,
            const int32_t& aCoreCount);

    MOZ_WARN_UNUSED_RESULT bool
    SendDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            const nsTArray<uint8_t>& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs);

    MOZ_WARN_UNUSED_RESULT bool
    SendReset();

    MOZ_WARN_UNUSED_RESULT bool
    SendDrain();

    MOZ_WARN_UNUSED_RESULT bool
    SendDecodingComplete();

    MOZ_WARN_UNUSED_RESULT bool
    SendChildShmemForPool(Shmem& aFrameBuffer);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPDecryptionData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            GMPDecryptionData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            Shmem* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const GMPVideoi420FrameData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            GMPVideoi420FrameData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const GMPVideoEncodedFrameData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            GMPVideoEncodedFrameData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const GMPPlaneData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            GMPPlaneData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PGMPVideoDecoderParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PGMPVideoDecoderParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoDecoderParent :
    public PGMPVideoDecoderParent
{
    virtual bool
    RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame);

    virtual bool
    RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId);

    virtual bool
    RecvReceivedDecodedFrame(const uint64_t& aPictureId);

    virtual bool
    RecvInputDataExhausted();

    virtual bool
    RecvDrainComplete();

    virtual bool
    RecvResetComplete();

    virtual bool
    RecvError(const GMPErr& aErr);

    virtual bool
    RecvShutdown();

    virtual bool
    RecvParentShmemForPool(Shmem&& aEncodedBuffer);

    virtual bool
    AnswerNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPVideoDecoderParent();
    virtual ~GMPVideoDecoderParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPVideoDecoderParent::RecvDecoded(const GMPVideoi420FrameData& aDecodedFrame)
{
    return false;
}

bool
GMPVideoDecoderParent::RecvReceivedDecodedReferenceFrame(const uint64_t& aPictureId)
{
    return false;
}

bool
GMPVideoDecoderParent::RecvReceivedDecodedFrame(const uint64_t& aPictureId)
{
    return false;
}

bool
GMPVideoDecoderParent::RecvInputDataExhausted()
{
    return false;
}

bool
GMPVideoDecoderParent::RecvDrainComplete()
{
    return false;
}

bool
GMPVideoDecoderParent::RecvResetComplete()
{
    return false;
}

bool
GMPVideoDecoderParent::RecvError(const GMPErr& aErr)
{
    return false;
}

bool
GMPVideoDecoderParent::RecvShutdown()
{
    return false;
}

bool
GMPVideoDecoderParent::RecvParentShmemForPool(Shmem&& aEncodedBuffer)
{
    return false;
}

bool
GMPVideoDecoderParent::AnswerNeedShmem(
        const uint32_t& aFrameBufferSize,
        Shmem* aMem)
{
    return false;
}

void
GMPVideoDecoderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPVideoDecoderParent::GMPVideoDecoderParent()
{
    MOZ_COUNT_CTOR(GMPVideoDecoderParent);
}

MOZ_IMPLICIT GMPVideoDecoderParent::~GMPVideoDecoderParent()
{
    MOZ_COUNT_DTOR(GMPVideoDecoderParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoDecoderParent_h
