//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHal_h
#define PHal_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BatteryInformation|
//
namespace mozilla {
namespace hal {
class BatteryInformation final
{
private:

public:
    MOZ_IMPLICIT BatteryInformation();

    MOZ_IMPLICIT BatteryInformation(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime)
    {
        Init();
        Assign(_level, _charging, _remainingTime);
    }

    MOZ_IMPLICIT BatteryInformation(const BatteryInformation& _o)
    {
        Init();
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    ~BatteryInformation();

    void
    operator=(const BatteryInformation& _o)
    {
        Assign((_o).level(), (_o).charging(), (_o).remainingTime());
    }

    bool
    operator==(const BatteryInformation& _o) const;

    double&
    level()
    {
        return level_;
    }
    const double&
    level() const
    {
        return level_;
    }

    bool&
    charging()
    {
        return charging_;
    }
    const bool&
    charging() const
    {
        return charging_;
    }

    double&
    remainingTime()
    {
        return remainingTime_;
    }
    const double&
    remainingTime() const
    {
        return remainingTime_;
    }

private:
    void
    Init();

    void
    Assign(
            const double& _level,
            const bool& _charging,
            const double& _remainingTime);

    double level_;
    bool charging_;
    double remainingTime_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SensorData|
//
namespace mozilla {
namespace hal {
class SensorData final
{
private:
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;

public:
    MOZ_IMPLICIT SensorData();

    MOZ_IMPLICIT SensorData(
            const SensorType& _sensor,
            const PRTime& _timestamp,
            const nsTArray<float>& _values,
            const SensorAccuracyType& _accuracy)
    {
        Init();
        Assign(_sensor, _timestamp, _values, _accuracy);
    }

    MOZ_IMPLICIT SensorData(const SensorData& _o)
    {
        Init();
        Assign((_o).sensor(), (_o).timestamp(), (_o).values(), (_o).accuracy());
    }

    ~SensorData();

    void
    operator=(const SensorData& _o)
    {
        Assign((_o).sensor(), (_o).timestamp(), (_o).values(), (_o).accuracy());
    }

    bool
    operator==(const SensorData& _o) const;

    SensorType&
    sensor()
    {
        return sensor_;
    }
    const SensorType&
    sensor() const
    {
        return sensor_;
    }

    PRTime&
    timestamp()
    {
        return timestamp_;
    }
    const PRTime&
    timestamp() const
    {
        return timestamp_;
    }

    nsTArray<float>&
    values()
    {
        return values_;
    }
    const nsTArray<float>&
    values() const
    {
        return values_;
    }

    SensorAccuracyType&
    accuracy()
    {
        return accuracy_;
    }
    const SensorAccuracyType&
    accuracy() const
    {
        return accuracy_;
    }

private:
    void
    Init();

    void
    Assign(
            const SensorType& _sensor,
            const PRTime& _timestamp,
            const nsTArray<float>& _values,
            const SensorAccuracyType& _accuracy);

    SensorType sensor_;
    PRTime timestamp_;
    nsTArray<float> values_;
    SensorAccuracyType accuracy_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NetworkInformation|
//
namespace mozilla {
namespace hal {
class NetworkInformation final
{
private:

public:
    MOZ_IMPLICIT NetworkInformation();

    MOZ_IMPLICIT NetworkInformation(
            const uint32_t& _type,
            const bool& _isWifi,
            const uint32_t& _dhcpGateway)
    {
        Init();
        Assign(_type, _isWifi, _dhcpGateway);
    }

    MOZ_IMPLICIT NetworkInformation(const NetworkInformation& _o)
    {
        Init();
        Assign((_o).type(), (_o).isWifi(), (_o).dhcpGateway());
    }

    ~NetworkInformation();

    void
    operator=(const NetworkInformation& _o)
    {
        Assign((_o).type(), (_o).isWifi(), (_o).dhcpGateway());
    }

    bool
    operator==(const NetworkInformation& _o) const;

    uint32_t&
    type()
    {
        return type_;
    }
    const uint32_t&
    type() const
    {
        return type_;
    }

    bool&
    isWifi()
    {
        return isWifi_;
    }
    const bool&
    isWifi() const
    {
        return isWifi_;
    }

    uint32_t&
    dhcpGateway()
    {
        return dhcpGateway_;
    }
    const uint32_t&
    dhcpGateway() const
    {
        return dhcpGateway_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _type,
            const bool& _isWifi,
            const uint32_t& _dhcpGateway);

    uint32_t type_;
    bool isWifi_;
    uint32_t dhcpGateway_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SwitchEvent|
//
namespace mozilla {
namespace hal {
class SwitchEvent final
{
private:
    typedef mozilla::hal::SwitchDevice SwitchDevice;
    typedef mozilla::hal::SwitchState SwitchState;

public:
    MOZ_IMPLICIT SwitchEvent();

    MOZ_IMPLICIT SwitchEvent(
            const SwitchDevice& _device,
            const SwitchState& _status)
    {
        Init();
        Assign(_device, _status);
    }

    MOZ_IMPLICIT SwitchEvent(const SwitchEvent& _o)
    {
        Init();
        Assign((_o).device(), (_o).status());
    }

    ~SwitchEvent();

    void
    operator=(const SwitchEvent& _o)
    {
        Assign((_o).device(), (_o).status());
    }

    bool
    operator==(const SwitchEvent& _o) const;

    SwitchDevice&
    device()
    {
        return device_;
    }
    const SwitchDevice&
    device() const
    {
        return device_;
    }

    SwitchState&
    status()
    {
        return status_;
    }
    const SwitchState&
    status() const
    {
        return status_;
    }

private:
    void
    Init();

    void
    Assign(
            const SwitchDevice& _device,
            const SwitchState& _status);

    SwitchDevice device_;
    SwitchState status_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WakeLockInformation|
//
namespace mozilla {
namespace hal {
class WakeLockInformation final
{
private:

public:
    MOZ_IMPLICIT WakeLockInformation();

    MOZ_IMPLICIT WakeLockInformation(
            const nsString& _topic,
            const uint32_t& _numLocks,
            const uint32_t& _numHidden,
            const nsTArray<uint64_t>& _lockingProcesses)
    {
        Init();
        Assign(_topic, _numLocks, _numHidden, _lockingProcesses);
    }

    MOZ_IMPLICIT WakeLockInformation(const WakeLockInformation& _o)
    {
        Init();
        Assign((_o).topic(), (_o).numLocks(), (_o).numHidden(), (_o).lockingProcesses());
    }

    ~WakeLockInformation();

    void
    operator=(const WakeLockInformation& _o)
    {
        Assign((_o).topic(), (_o).numLocks(), (_o).numHidden(), (_o).lockingProcesses());
    }

    bool
    operator==(const WakeLockInformation& _o) const;

    nsString&
    topic()
    {
        return topic_;
    }
    const nsString&
    topic() const
    {
        return topic_;
    }

    uint32_t&
    numLocks()
    {
        return numLocks_;
    }
    const uint32_t&
    numLocks() const
    {
        return numLocks_;
    }

    uint32_t&
    numHidden()
    {
        return numHidden_;
    }
    const uint32_t&
    numHidden() const
    {
        return numHidden_;
    }

    nsTArray<uint64_t>&
    lockingProcesses()
    {
        return lockingProcesses_;
    }
    const nsTArray<uint64_t>&
    lockingProcesses() const
    {
        return lockingProcesses_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _topic,
            const uint32_t& _numLocks,
            const uint32_t& _numHidden,
            const nsTArray<uint64_t>& _lockingProcesses);

    nsString topic_;
    uint32_t numLocks_;
    uint32_t numHidden_;
    nsTArray<uint64_t> lockingProcesses_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenConfiguration|
//
namespace mozilla {
namespace hal {
class ScreenConfiguration final
{
private:
    typedef mozilla::dom::ScreenOrientation ScreenOrientation;

public:
    MOZ_IMPLICIT ScreenConfiguration();

    MOZ_IMPLICIT ScreenConfiguration(
            const nsIntRect& _rect,
            const ScreenOrientation& _orientation,
            const uint32_t& _colorDepth,
            const uint32_t& _pixelDepth)
    {
        Init();
        Assign(_rect, _orientation, _colorDepth, _pixelDepth);
    }

    MOZ_IMPLICIT ScreenConfiguration(const ScreenConfiguration& _o)
    {
        Init();
        Assign((_o).rect(), (_o).orientation(), (_o).colorDepth(), (_o).pixelDepth());
    }

    ~ScreenConfiguration();

    void
    operator=(const ScreenConfiguration& _o)
    {
        Assign((_o).rect(), (_o).orientation(), (_o).colorDepth(), (_o).pixelDepth());
    }

    bool
    operator==(const ScreenConfiguration& _o) const;

    nsIntRect&
    rect()
    {
        return rect_;
    }
    const nsIntRect&
    rect() const
    {
        return rect_;
    }

    ScreenOrientation&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientation&
    orientation() const
    {
        return orientation_;
    }

    uint32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const uint32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    uint32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const uint32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsIntRect& _rect,
            const ScreenOrientation& _orientation,
            const uint32_t& _colorDepth,
            const uint32_t& _pixelDepth);

    nsIntRect rect_;
    ScreenOrientation orientation_;
    uint32_t colorDepth_;
    uint32_t pixelDepth_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FMRadioOperationInformation|
//
namespace mozilla {
namespace hal {
class FMRadioOperationInformation final
{
private:
    typedef mozilla::hal::FMRadioOperation FMRadioOperation;
    typedef mozilla::hal::FMRadioOperationStatus FMRadioOperationStatus;

public:
    MOZ_IMPLICIT FMRadioOperationInformation();

    MOZ_IMPLICIT FMRadioOperationInformation(
            const FMRadioOperation& _operation,
            const FMRadioOperationStatus& _status,
            const uint32_t& _frequency)
    {
        Init();
        Assign(_operation, _status, _frequency);
    }

    MOZ_IMPLICIT FMRadioOperationInformation(const FMRadioOperationInformation& _o)
    {
        Init();
        Assign((_o).operation(), (_o).status(), (_o).frequency());
    }

    ~FMRadioOperationInformation();

    void
    operator=(const FMRadioOperationInformation& _o)
    {
        Assign((_o).operation(), (_o).status(), (_o).frequency());
    }

    bool
    operator==(const FMRadioOperationInformation& _o) const;

    FMRadioOperation&
    operation()
    {
        return operation_;
    }
    const FMRadioOperation&
    operation() const
    {
        return operation_;
    }

    FMRadioOperationStatus&
    status()
    {
        return status_;
    }
    const FMRadioOperationStatus&
    status() const
    {
        return status_;
    }

    uint32_t&
    frequency()
    {
        return frequency_;
    }
    const uint32_t&
    frequency() const
    {
        return frequency_;
    }

private:
    void
    Init();

    void
    Assign(
            const FMRadioOperation& _operation,
            const FMRadioOperationStatus& _status,
            const uint32_t& _frequency);

    FMRadioOperation operation_;
    FMRadioOperationStatus status_;
    uint32_t frequency_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FMRadioRDSGroup|
//
namespace mozilla {
namespace hal {
class FMRadioRDSGroup final
{
private:

public:
    MOZ_IMPLICIT FMRadioRDSGroup();

    MOZ_IMPLICIT FMRadioRDSGroup(
            const uint16_t& _blockA,
            const uint16_t& _blockB,
            const uint16_t& _blockC,
            const uint16_t& _blockD)
    {
        Init();
        Assign(_blockA, _blockB, _blockC, _blockD);
    }

    MOZ_IMPLICIT FMRadioRDSGroup(const FMRadioRDSGroup& _o)
    {
        Init();
        Assign((_o).blockA(), (_o).blockB(), (_o).blockC(), (_o).blockD());
    }

    ~FMRadioRDSGroup();

    void
    operator=(const FMRadioRDSGroup& _o)
    {
        Assign((_o).blockA(), (_o).blockB(), (_o).blockC(), (_o).blockD());
    }

    bool
    operator==(const FMRadioRDSGroup& _o) const;

    uint16_t&
    blockA()
    {
        return blockA_;
    }
    const uint16_t&
    blockA() const
    {
        return blockA_;
    }

    uint16_t&
    blockB()
    {
        return blockB_;
    }
    const uint16_t&
    blockB() const
    {
        return blockB_;
    }

    uint16_t&
    blockC()
    {
        return blockC_;
    }
    const uint16_t&
    blockC() const
    {
        return blockC_;
    }

    uint16_t&
    blockD()
    {
        return blockD_;
    }
    const uint16_t&
    blockD() const
    {
        return blockD_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint16_t& _blockA,
            const uint16_t& _blockB,
            const uint16_t& _blockC,
            const uint16_t& _blockD);

    uint16_t blockA_;
    uint16_t blockB_;
    uint16_t blockC_;
    uint16_t blockD_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FMRadioSettings|
//
namespace mozilla {
namespace hal {
class FMRadioSettings final
{
private:
    typedef mozilla::hal::FMRadioCountry FMRadioCountry;

public:
    MOZ_IMPLICIT FMRadioSettings();

    MOZ_IMPLICIT FMRadioSettings(
            const FMRadioCountry& _country,
            const uint32_t& _upperLimit,
            const uint32_t& _lowerLimit,
            const uint32_t& _spaceType,
            const uint32_t& _preEmphasis)
    {
        Init();
        Assign(_country, _upperLimit, _lowerLimit, _spaceType, _preEmphasis);
    }

    MOZ_IMPLICIT FMRadioSettings(const FMRadioSettings& _o)
    {
        Init();
        Assign((_o).country(), (_o).upperLimit(), (_o).lowerLimit(), (_o).spaceType(), (_o).preEmphasis());
    }

    ~FMRadioSettings();

    void
    operator=(const FMRadioSettings& _o)
    {
        Assign((_o).country(), (_o).upperLimit(), (_o).lowerLimit(), (_o).spaceType(), (_o).preEmphasis());
    }

    bool
    operator==(const FMRadioSettings& _o) const;

    FMRadioCountry&
    country()
    {
        return country_;
    }
    const FMRadioCountry&
    country() const
    {
        return country_;
    }

    uint32_t&
    upperLimit()
    {
        return upperLimit_;
    }
    const uint32_t&
    upperLimit() const
    {
        return upperLimit_;
    }

    uint32_t&
    lowerLimit()
    {
        return lowerLimit_;
    }
    const uint32_t&
    lowerLimit() const
    {
        return lowerLimit_;
    }

    uint32_t&
    spaceType()
    {
        return spaceType_;
    }
    const uint32_t&
    spaceType() const
    {
        return spaceType_;
    }

    uint32_t&
    preEmphasis()
    {
        return preEmphasis_;
    }
    const uint32_t&
    preEmphasis() const
    {
        return preEmphasis_;
    }

private:
    void
    Init();

    void
    Assign(
            const FMRadioCountry& _country,
            const uint32_t& _upperLimit,
            const uint32_t& _lowerLimit,
            const uint32_t& _spaceType,
            const uint32_t& _preEmphasis);

    FMRadioCountry country_;
    uint32_t upperLimit_;
    uint32_t lowerLimit_;
    uint32_t spaceType_;
    uint32_t preEmphasis_;
};
} // namespace hal
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SystemTimezoneChangeInformation|
//
namespace mozilla {
namespace hal {
class SystemTimezoneChangeInformation final
{
private:

public:
    MOZ_IMPLICIT SystemTimezoneChangeInformation();

    MOZ_IMPLICIT SystemTimezoneChangeInformation(
            const int32_t& _oldTimezoneOffsetMinutes,
            const int32_t& _newTimezoneOffsetMinutes)
    {
        Init();
        Assign(_oldTimezoneOffsetMinutes, _newTimezoneOffsetMinutes);
    }

    MOZ_IMPLICIT SystemTimezoneChangeInformation(const SystemTimezoneChangeInformation& _o)
    {
        Init();
        Assign((_o).oldTimezoneOffsetMinutes(), (_o).newTimezoneOffsetMinutes());
    }

    ~SystemTimezoneChangeInformation();

    void
    operator=(const SystemTimezoneChangeInformation& _o)
    {
        Assign((_o).oldTimezoneOffsetMinutes(), (_o).newTimezoneOffsetMinutes());
    }

    bool
    operator==(const SystemTimezoneChangeInformation& _o) const;

    int32_t&
    oldTimezoneOffsetMinutes()
    {
        return oldTimezoneOffsetMinutes_;
    }
    const int32_t&
    oldTimezoneOffsetMinutes() const
    {
        return oldTimezoneOffsetMinutes_;
    }

    int32_t&
    newTimezoneOffsetMinutes()
    {
        return newTimezoneOffsetMinutes_;
    }
    const int32_t&
    newTimezoneOffsetMinutes() const
    {
        return newTimezoneOffsetMinutes_;
    }

private:
    void
    Init();

    void
    Assign(
            const int32_t& _oldTimezoneOffsetMinutes,
            const int32_t& _newTimezoneOffsetMinutes);

    int32_t oldTimezoneOffsetMinutes_;
    int32_t newTimezoneOffsetMinutes_;
};
} // namespace hal
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PHalChild and PHalParent
//
namespace mozilla {
namespace hal_sandbox {
namespace PHal {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PHalStart = PHalMsgStart << 16,
    Msg_NotifyBatteryChange__ID,
    Msg_NotifyNetworkChange__ID,
    Msg_NotifyWakeLockChange__ID,
    Msg_NotifyScreenConfigurationChange__ID,
    Msg_NotifySwitchChange__ID,
    Msg_NotifySystemClockChange__ID,
    Msg_NotifySystemTimezoneChange__ID,
    Msg_Vibrate__ID,
    Msg_CancelVibrate__ID,
    Msg_EnableBatteryNotifications__ID,
    Msg_DisableBatteryNotifications__ID,
    Msg_GetCurrentBatteryInformation__ID,
    Reply_GetCurrentBatteryInformation__ID,
    Msg_EnableNetworkNotifications__ID,
    Msg_DisableNetworkNotifications__ID,
    Msg_GetCurrentNetworkInformation__ID,
    Reply_GetCurrentNetworkInformation__ID,
    Msg_GetScreenEnabled__ID,
    Reply_GetScreenEnabled__ID,
    Msg_SetScreenEnabled__ID,
    Msg_GetKeyLightEnabled__ID,
    Reply_GetKeyLightEnabled__ID,
    Msg_SetKeyLightEnabled__ID,
    Msg_GetCpuSleepAllowed__ID,
    Reply_GetCpuSleepAllowed__ID,
    Msg_SetCpuSleepAllowed__ID,
    Msg_GetScreenBrightness__ID,
    Reply_GetScreenBrightness__ID,
    Msg_SetScreenBrightness__ID,
    Msg_AdjustSystemClock__ID,
    Msg_SetTimezone__ID,
    Msg_GetTimezone__ID,
    Reply_GetTimezone__ID,
    Msg_GetTimezoneOffset__ID,
    Reply_GetTimezoneOffset__ID,
    Msg_EnableSystemClockChangeNotifications__ID,
    Msg_DisableSystemClockChangeNotifications__ID,
    Msg_EnableSystemTimezoneChangeNotifications__ID,
    Msg_DisableSystemTimezoneChangeNotifications__ID,
    Msg_ModifyWakeLock__ID,
    Msg_EnableWakeLockNotifications__ID,
    Msg_DisableWakeLockNotifications__ID,
    Msg_GetWakeLockInfo__ID,
    Reply_GetWakeLockInfo__ID,
    Msg_EnableScreenConfigurationNotifications__ID,
    Msg_DisableScreenConfigurationNotifications__ID,
    Msg_GetCurrentScreenConfiguration__ID,
    Reply_GetCurrentScreenConfiguration__ID,
    Msg_LockScreenOrientation__ID,
    Reply_LockScreenOrientation__ID,
    Msg_UnlockScreenOrientation__ID,
    Msg_EnableSwitchNotifications__ID,
    Msg_DisableSwitchNotifications__ID,
    Msg_GetCurrentSwitchState__ID,
    Reply_GetCurrentSwitchState__ID,
    Msg_FactoryReset__ID,
    Msg_NotifySensorChange__ID,
    Msg_EnableSensorNotifications__ID,
    Msg_DisableSensorNotifications__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PHalEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_NotifyBatteryChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyBatteryChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyBatteryChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifyBatteryChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyBatteryChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyNetworkChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyNetworkChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyNetworkChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifyNetworkChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyNetworkChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyWakeLockChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyWakeLockChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyWakeLockChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifyWakeLockChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyWakeLockChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifyScreenConfigurationChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyScreenConfigurationChange__ID
    };
    MOZ_IMPLICIT Msg_NotifyScreenConfigurationChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifyScreenConfigurationChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifyScreenConfigurationChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifySwitchChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifySwitchChange__ID
    };
    MOZ_IMPLICIT Msg_NotifySwitchChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifySwitchChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifySwitchChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifySystemClockChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifySystemClockChange__ID
    };
    MOZ_IMPLICIT Msg_NotifySystemClockChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifySystemClockChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifySystemClockChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifySystemTimezoneChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifySystemTimezoneChange__ID
    };
    MOZ_IMPLICIT Msg_NotifySystemTimezoneChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifySystemTimezoneChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifySystemTimezoneChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_Vibrate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Vibrate__ID
    };
    MOZ_IMPLICIT Msg_Vibrate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_Vibrate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_Vibrate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_CancelVibrate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CancelVibrate__ID
    };
    MOZ_IMPLICIT Msg_CancelVibrate(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_CancelVibrate")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_CancelVibrate(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableBatteryNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableBatteryNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableBatteryNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableBatteryNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableBatteryNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableBatteryNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableBatteryNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableBatteryNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableBatteryNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableBatteryNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetCurrentBatteryInformation :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetCurrentBatteryInformation__ID
    };
    MOZ_IMPLICIT Msg_GetCurrentBatteryInformation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetCurrentBatteryInformation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetCurrentBatteryInformation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetCurrentBatteryInformation :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetCurrentBatteryInformation__ID
    };
    MOZ_IMPLICIT Reply_GetCurrentBatteryInformation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetCurrentBatteryInformation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetCurrentBatteryInformation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableNetworkNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableNetworkNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableNetworkNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableNetworkNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableNetworkNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableNetworkNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableNetworkNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableNetworkNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableNetworkNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableNetworkNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetCurrentNetworkInformation :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetCurrentNetworkInformation__ID
    };
    MOZ_IMPLICIT Msg_GetCurrentNetworkInformation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetCurrentNetworkInformation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetCurrentNetworkInformation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetCurrentNetworkInformation :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetCurrentNetworkInformation__ID
    };
    MOZ_IMPLICIT Reply_GetCurrentNetworkInformation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetCurrentNetworkInformation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetCurrentNetworkInformation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetScreenEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetScreenEnabled__ID
    };
    MOZ_IMPLICIT Msg_GetScreenEnabled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetScreenEnabled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetScreenEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetScreenEnabled__ID
    };
    MOZ_IMPLICIT Reply_GetScreenEnabled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetScreenEnabled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetScreenEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetScreenEnabled__ID
    };
    MOZ_IMPLICIT Msg_SetScreenEnabled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_SetScreenEnabled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetScreenEnabled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetKeyLightEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetKeyLightEnabled__ID
    };
    MOZ_IMPLICIT Msg_GetKeyLightEnabled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetKeyLightEnabled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetKeyLightEnabled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetKeyLightEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetKeyLightEnabled__ID
    };
    MOZ_IMPLICIT Reply_GetKeyLightEnabled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetKeyLightEnabled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetKeyLightEnabled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetKeyLightEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetKeyLightEnabled__ID
    };
    MOZ_IMPLICIT Msg_SetKeyLightEnabled(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_SetKeyLightEnabled")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetKeyLightEnabled(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetCpuSleepAllowed :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetCpuSleepAllowed__ID
    };
    MOZ_IMPLICIT Msg_GetCpuSleepAllowed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetCpuSleepAllowed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetCpuSleepAllowed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetCpuSleepAllowed :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetCpuSleepAllowed__ID
    };
    MOZ_IMPLICIT Reply_GetCpuSleepAllowed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetCpuSleepAllowed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetCpuSleepAllowed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetCpuSleepAllowed :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetCpuSleepAllowed__ID
    };
    MOZ_IMPLICIT Msg_SetCpuSleepAllowed(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_SetCpuSleepAllowed")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetCpuSleepAllowed(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetScreenBrightness :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetScreenBrightness__ID
    };
    MOZ_IMPLICIT Msg_GetScreenBrightness(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetScreenBrightness(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetScreenBrightness :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetScreenBrightness__ID
    };
    MOZ_IMPLICIT Reply_GetScreenBrightness(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetScreenBrightness(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetScreenBrightness :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetScreenBrightness__ID
    };
    MOZ_IMPLICIT Msg_SetScreenBrightness(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_SetScreenBrightness")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetScreenBrightness(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_AdjustSystemClock :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AdjustSystemClock__ID
    };
    MOZ_IMPLICIT Msg_AdjustSystemClock(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_AdjustSystemClock")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_AdjustSystemClock(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_SetTimezone :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetTimezone__ID
    };
    MOZ_IMPLICIT Msg_SetTimezone(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_SetTimezone")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_SetTimezone(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetTimezone :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetTimezone__ID
    };
    MOZ_IMPLICIT Msg_GetTimezone(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetTimezone")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetTimezone(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetTimezone :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetTimezone__ID
    };
    MOZ_IMPLICIT Reply_GetTimezone(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetTimezone")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetTimezone(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetTimezoneOffset :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetTimezoneOffset__ID
    };
    MOZ_IMPLICIT Msg_GetTimezoneOffset(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetTimezoneOffset")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetTimezoneOffset(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetTimezoneOffset :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetTimezoneOffset__ID
    };
    MOZ_IMPLICIT Reply_GetTimezoneOffset(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetTimezoneOffset")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetTimezoneOffset(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableSystemClockChangeNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableSystemClockChangeNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableSystemClockChangeNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableSystemClockChangeNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableSystemClockChangeNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableSystemClockChangeNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableSystemClockChangeNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableSystemClockChangeNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableSystemClockChangeNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableSystemClockChangeNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableSystemTimezoneChangeNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableSystemTimezoneChangeNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableSystemTimezoneChangeNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableSystemTimezoneChangeNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableSystemTimezoneChangeNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableSystemTimezoneChangeNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableSystemTimezoneChangeNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableSystemTimezoneChangeNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableSystemTimezoneChangeNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableSystemTimezoneChangeNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_ModifyWakeLock :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ModifyWakeLock__ID
    };
    MOZ_IMPLICIT Msg_ModifyWakeLock(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_ModifyWakeLock")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_ModifyWakeLock(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableWakeLockNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableWakeLockNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableWakeLockNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableWakeLockNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableWakeLockNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableWakeLockNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableWakeLockNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableWakeLockNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableWakeLockNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableWakeLockNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetWakeLockInfo :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetWakeLockInfo__ID
    };
    MOZ_IMPLICIT Msg_GetWakeLockInfo(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetWakeLockInfo")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetWakeLockInfo(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetWakeLockInfo :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetWakeLockInfo__ID
    };
    MOZ_IMPLICIT Reply_GetWakeLockInfo(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetWakeLockInfo")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetWakeLockInfo(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableScreenConfigurationNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableScreenConfigurationNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableScreenConfigurationNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableScreenConfigurationNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableScreenConfigurationNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableScreenConfigurationNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableScreenConfigurationNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableScreenConfigurationNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableScreenConfigurationNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableScreenConfigurationNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetCurrentScreenConfiguration :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetCurrentScreenConfiguration__ID
    };
    MOZ_IMPLICIT Msg_GetCurrentScreenConfiguration(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PHal::Msg_GetCurrentScreenConfiguration")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetCurrentScreenConfiguration(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetCurrentScreenConfiguration :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetCurrentScreenConfiguration__ID
    };
    MOZ_IMPLICIT Reply_GetCurrentScreenConfiguration(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_URGENT, COMPRESSION_NONE, "PHal::Reply_GetCurrentScreenConfiguration")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetCurrentScreenConfiguration(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_LockScreenOrientation :
    public IPC::Message
{
public:
    enum {
        ID = Msg_LockScreenOrientation__ID
    };
    MOZ_IMPLICIT Msg_LockScreenOrientation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_LockScreenOrientation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_LockScreenOrientation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_LockScreenOrientation :
    public IPC::Message
{
public:
    enum {
        ID = Reply_LockScreenOrientation__ID
    };
    MOZ_IMPLICIT Reply_LockScreenOrientation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_LockScreenOrientation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_LockScreenOrientation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_UnlockScreenOrientation :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UnlockScreenOrientation__ID
    };
    MOZ_IMPLICIT Msg_UnlockScreenOrientation(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_UnlockScreenOrientation")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_UnlockScreenOrientation(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableSwitchNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableSwitchNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableSwitchNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableSwitchNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableSwitchNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableSwitchNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableSwitchNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableSwitchNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableSwitchNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableSwitchNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_GetCurrentSwitchState :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetCurrentSwitchState__ID
    };
    MOZ_IMPLICIT Msg_GetCurrentSwitchState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_GetCurrentSwitchState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_GetCurrentSwitchState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply_GetCurrentSwitchState :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetCurrentSwitchState__ID
    };
    MOZ_IMPLICIT Reply_GetCurrentSwitchState(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply_GetCurrentSwitchState")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply_GetCurrentSwitchState(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_FactoryReset :
    public IPC::Message
{
public:
    enum {
        ID = Msg_FactoryReset__ID
    };
    MOZ_IMPLICIT Msg_FactoryReset(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_FactoryReset")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_FactoryReset(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_NotifySensorChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifySensorChange__ID
    };
    MOZ_IMPLICIT Msg_NotifySensorChange(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_NotifySensorChange")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_NotifySensorChange(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_EnableSensorNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_EnableSensorNotifications__ID
    };
    MOZ_IMPLICIT Msg_EnableSensorNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_EnableSensorNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_EnableSensorNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg_DisableSensorNotifications :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DisableSensorNotifications__ID
    };
    MOZ_IMPLICIT Msg_DisableSensorNotifications(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg_DisableSensorNotifications")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg_DisableSensorNotifications(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Msg___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__(int32_t routingId) :
        IPC::Message(routingId, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PHal::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& pfx__,
            base::ProcessId otherPid__,
            bool receiving__) const
    {
        std::string logmsg__;
        StringAppendF((&(logmsg__)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (receiving__ ? "<-" : "->"), otherPid__);
        (logmsg__).append(pfx__);
        (logmsg__).append("Reply___delete__(");

        (logmsg__).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (logmsg__).c_str());
#endif
        fputs((logmsg__).c_str(), stderr);
    }
};



} // namespace PHal
} // namespace hal_sandbox
} // namespace mozilla

#endif // ifndef PHal_h
