//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PProcLoaderParent_h
#define PProcLoaderParent_h

#include "mozilla/ipc/PProcLoader.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

class nsIFile;

namespace mozilla {
namespace ipc {


class PProcLoaderParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>,
    public mozilla::ipc::IToplevelProtocol
{
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FDRemap FDRemap;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PProcLoader::State State;

    virtual bool
    RecvLoadComplete(
            const int32_t& pid,
            const int32_t& cookie) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PProcLoaderParent();

    virtual ~PProcLoaderParent();

    bool
    Open(
            Channel::Transport* aTransport,
            base::ProcessId aOtherPid,
            MessageLoop* aThread = nullptr,
            mozilla::ipc::Side aSide = mozilla::ipc::UnknownSide);

    bool
    Open(
            MessageChannel* aChannel,
            MessageLoop* aMessageLoop,
            mozilla::ipc::Side aSide = mozilla::ipc::UnknownSide);

    void
    Close();

    PProcLoader::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendLoad(
            const nsTArray<nsCString>& argv,
            const nsTArray<nsCString>& env,
            const nsTArray<FDRemap>& fdsRemap,
            const uint32_t& privs,
            const int32_t& cookie);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    void
    OnEnteredCxxStack();
    void
    OnExitedCxxStack();
    void
    OnEnteredCall();
    void
    OnExitedCall();
    bool
    IsOnCxxStack() const;
    void
    FlushPendingInterruptQueue();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

    void
    SetOtherProcessId(base::ProcessId aOtherPid);

protected:
    bool
    TakeMinidump(
            nsIFile** aDump,
            uint32_t* aSequence) const;

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    void
    DeallocShmems();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<FDRemap>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<FDRemap>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const FDRemap& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            FDRemap* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const FileDescriptor& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            FileDescriptor* v__,
            const Message* msg__,
            void** iter__);

    Channel mChannel;
    IDMap<ProtocolBase> mActorMap;
    int32_t mLastRouteId;
    base::ProcessId mOtherPid;
    IDMap<Shmem::SharedMemory> mShmemMap;
    Shmem::id_t mLastShmemId;
    State mState;
};


} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace ipc {
class ProcLoaderParent :
    public PProcLoaderParent
{
    virtual bool
    RecvLoadComplete(
            const int32_t& pid,
            const int32_t& cookie);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT ProcLoaderParent();
    virtual ~ProcLoaderParent();
};
} // namespace ipc
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace ipc {
bool
ProcLoaderParent::RecvLoadComplete(
        const int32_t& pid,
        const int32_t& cookie)
{
    return false;
}

void
ProcLoaderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT ProcLoaderParent::ProcLoaderParent()
{
    MOZ_COUNT_CTOR(ProcLoaderParent);
}

MOZ_IMPLICIT ProcLoaderParent::~ProcLoaderParent()
{
    MOZ_COUNT_DTOR(ProcLoaderParent);
}

} // namespace ipc
} // namespace mozilla
#endif // if 0

#endif // ifndef PProcLoaderParent_h
