//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LayersSurfaces_h
#define LayersSurfaces_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "gfxipc/ShadowLayerUtils.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/gfx/Types.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OverlayHandle|
//
namespace mozilla {
namespace layers {
class OverlayHandle final
{
public:
    enum Type {
        T__None,
        Tint32_t = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::null_t null_t;
    typedef int32_t int32_t__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char Vint32_t[sizeof(int32_t)];
        char Vnull_t[sizeof(null_t)];
    };

    int32_t*
    ptr_int32_t()
    {
        return reinterpret_cast<int32_t*>((&((mValue).Vint32_t)));
    }
    const int32_t* const
    constptr_int32_t() const
    {
        return reinterpret_cast<const int32_t* const>((&((mValue).Vint32_t)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OverlayHandle() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OverlayHandle(const int32_t& aOther);

    MOZ_IMPLICIT OverlayHandle(const null_t& aOther);

    MOZ_IMPLICIT OverlayHandle(const OverlayHandle& aOther);

    ~OverlayHandle();

    Type
    type() const
    {
        return mType;
    }

    OverlayHandle&
    operator=(const int32_t& aRhs);

    OverlayHandle&
    operator=(const null_t& aRhs);

    OverlayHandle&
    operator=(const OverlayHandle& aRhs);

    bool
    operator==(const int32_t& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const OverlayHandle& aRhs) const;

    int32_t&
    get_int32_t()
    {
        AssertSanity(Tint32_t);
        return (*(ptr_int32_t()));
    }
    const int32_t&
    get_int32_t() const
    {
        AssertSanity(Tint32_t);
        return (*(constptr_int32_t()));
    }
    operator int32_t&()
    {
        return get_int32_t();
    }
    operator const int32_t&() const
    {
        return get_int32_t();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OverlayHandle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OverlaySource|
//
namespace mozilla {
namespace layers {
class OverlaySource final
{
private:
    typedef mozilla::layers::OverlayHandle OverlayHandle;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT OverlaySource();

    MOZ_IMPLICIT OverlaySource(
            const OverlayHandle& _handle,
            const IntSize& _size)
    {
        Init();
        Assign(_handle, _size);
    }

    MOZ_IMPLICIT OverlaySource(const OverlaySource& _o)
    {
        Init();
        Assign((_o).handle(), (_o).size());
    }

    ~OverlaySource();

    void
    operator=(const OverlaySource& _o)
    {
        Assign((_o).handle(), (_o).size());
    }

    bool
    operator==(const OverlaySource& _o) const;

    OverlayHandle&
    handle()
    {
        return handle_;
    }
    const OverlayHandle&
    handle() const
    {
        return handle_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const OverlayHandle& _handle,
            const IntSize& _size);

    OverlayHandle handle_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeMagicGrallocBufferHandle|
//
namespace mozilla {
namespace layers {
class MaybeMagicGrallocBufferHandle final
{
public:
    enum Type {
        T__None,
        TMagicGrallocBufferHandle = 1,
        TGrallocBufferRef,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::MagicGrallocBufferHandle MagicGrallocBufferHandle;
    typedef mozilla::layers::GrallocBufferRef GrallocBufferRef;
    typedef mozilla::null_t null_t;
    typedef MagicGrallocBufferHandle MagicGrallocBufferHandle__tdef;
    typedef GrallocBufferRef GrallocBufferRef__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char VMagicGrallocBufferHandle[sizeof(MagicGrallocBufferHandle)];
        char VGrallocBufferRef[sizeof(GrallocBufferRef)];
        char Vnull_t[sizeof(null_t)];
    };

    MagicGrallocBufferHandle*
    ptr_MagicGrallocBufferHandle()
    {
        return reinterpret_cast<MagicGrallocBufferHandle*>((&((mValue).VMagicGrallocBufferHandle)));
    }
    const MagicGrallocBufferHandle* const
    constptr_MagicGrallocBufferHandle() const
    {
        return reinterpret_cast<const MagicGrallocBufferHandle* const>((&((mValue).VMagicGrallocBufferHandle)));
    }
    GrallocBufferRef*
    ptr_GrallocBufferRef()
    {
        return reinterpret_cast<GrallocBufferRef*>((&((mValue).VGrallocBufferRef)));
    }
    const GrallocBufferRef* const
    constptr_GrallocBufferRef() const
    {
        return reinterpret_cast<const GrallocBufferRef* const>((&((mValue).VGrallocBufferRef)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeMagicGrallocBufferHandle() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeMagicGrallocBufferHandle(const MagicGrallocBufferHandle& aOther);

    MOZ_IMPLICIT MaybeMagicGrallocBufferHandle(const GrallocBufferRef& aOther);

    MOZ_IMPLICIT MaybeMagicGrallocBufferHandle(const null_t& aOther);

    MOZ_IMPLICIT MaybeMagicGrallocBufferHandle(const MaybeMagicGrallocBufferHandle& aOther);

    ~MaybeMagicGrallocBufferHandle();

    Type
    type() const
    {
        return mType;
    }

    MaybeMagicGrallocBufferHandle&
    operator=(const MagicGrallocBufferHandle& aRhs);

    MaybeMagicGrallocBufferHandle&
    operator=(const GrallocBufferRef& aRhs);

    MaybeMagicGrallocBufferHandle&
    operator=(const null_t& aRhs);

    MaybeMagicGrallocBufferHandle&
    operator=(const MaybeMagicGrallocBufferHandle& aRhs);

    bool
    operator==(const MagicGrallocBufferHandle& aRhs) const;

    bool
    operator==(const GrallocBufferRef& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeMagicGrallocBufferHandle& aRhs) const;

    MagicGrallocBufferHandle&
    get_MagicGrallocBufferHandle()
    {
        AssertSanity(TMagicGrallocBufferHandle);
        return (*(ptr_MagicGrallocBufferHandle()));
    }
    const MagicGrallocBufferHandle&
    get_MagicGrallocBufferHandle() const
    {
        AssertSanity(TMagicGrallocBufferHandle);
        return (*(constptr_MagicGrallocBufferHandle()));
    }
    operator MagicGrallocBufferHandle&()
    {
        return get_MagicGrallocBufferHandle();
    }
    operator const MagicGrallocBufferHandle&() const
    {
        return get_MagicGrallocBufferHandle();
    }

    GrallocBufferRef&
    get_GrallocBufferRef()
    {
        AssertSanity(TGrallocBufferRef);
        return (*(ptr_GrallocBufferRef()));
    }
    const GrallocBufferRef&
    get_GrallocBufferRef() const
    {
        AssertSanity(TGrallocBufferRef);
        return (*(constptr_GrallocBufferRef()));
    }
    operator GrallocBufferRef&()
    {
        return get_GrallocBufferRef();
    }
    operator const GrallocBufferRef&() const
    {
        return get_GrallocBufferRef();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorD3D9|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D9 final
{
private:

public:
    MOZ_IMPLICIT SurfaceDescriptorD3D9();

    MOZ_IMPLICIT SurfaceDescriptorD3D9(const uintptr_t& _texture)
    {
        Init();
        Assign(_texture);
    }

    MOZ_IMPLICIT SurfaceDescriptorD3D9(const SurfaceDescriptorD3D9& _o)
    {
        Init();
        Assign((_o).texture());
    }

    ~SurfaceDescriptorD3D9();

    void
    operator=(const SurfaceDescriptorD3D9& _o)
    {
        Assign((_o).texture());
    }

    bool
    operator==(const SurfaceDescriptorD3D9& _o) const;

    uintptr_t&
    texture()
    {
        return texture_;
    }
    const uintptr_t&
    texture() const
    {
        return texture_;
    }

private:
    void
    Init();

    void
    Assign(const uintptr_t& _texture);

    uintptr_t texture_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorFileMapping|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorFileMapping final
{
private:
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorFileMapping();

    MOZ_IMPLICIT SurfaceDescriptorFileMapping(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size)
    {
        Init();
        Assign(_handle, _format, _size);
    }

    MOZ_IMPLICIT SurfaceDescriptorFileMapping(const SurfaceDescriptorFileMapping& _o)
    {
        Init();
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    ~SurfaceDescriptorFileMapping();

    void
    operator=(const SurfaceDescriptorFileMapping& _o)
    {
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    bool
    operator==(const SurfaceDescriptorFileMapping& _o) const;

    WindowsHandle&
    handle()
    {
        return handle_;
    }
    const WindowsHandle&
    handle() const
    {
        return handle_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size);

    WindowsHandle handle_;
    SurfaceFormat format_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorDIB|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorDIB final
{
private:

public:
    MOZ_IMPLICIT SurfaceDescriptorDIB();

    MOZ_IMPLICIT SurfaceDescriptorDIB(const uintptr_t& _surface)
    {
        Init();
        Assign(_surface);
    }

    MOZ_IMPLICIT SurfaceDescriptorDIB(const SurfaceDescriptorDIB& _o)
    {
        Init();
        Assign((_o).surface());
    }

    ~SurfaceDescriptorDIB();

    void
    operator=(const SurfaceDescriptorDIB& _o)
    {
        Assign((_o).surface());
    }

    bool
    operator==(const SurfaceDescriptorDIB& _o) const;

    uintptr_t&
    surface()
    {
        return surface_;
    }
    const uintptr_t&
    surface() const
    {
        return surface_;
    }

private:
    void
    Init();

    void
    Assign(const uintptr_t& _surface);

    uintptr_t surface_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorD3D10|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D10 final
{
private:
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorD3D10();

    MOZ_IMPLICIT SurfaceDescriptorD3D10(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size)
    {
        Init();
        Assign(_handle, _format, _size);
    }

    MOZ_IMPLICIT SurfaceDescriptorD3D10(const SurfaceDescriptorD3D10& _o)
    {
        Init();
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    ~SurfaceDescriptorD3D10();

    void
    operator=(const SurfaceDescriptorD3D10& _o)
    {
        Assign((_o).handle(), (_o).format(), (_o).size());
    }

    bool
    operator==(const SurfaceDescriptorD3D10& _o) const;

    WindowsHandle&
    handle()
    {
        return handle_;
    }
    const WindowsHandle&
    handle() const
    {
        return handle_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const WindowsHandle& _handle,
            const SurfaceFormat& _format,
            const IntSize& _size);

    WindowsHandle handle_;
    SurfaceFormat format_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorDXGIYCbCr|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorDXGIYCbCr final
{
private:
    typedef mozilla::WindowsHandle WindowsHandle;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr();

    MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr(
            const WindowsHandle& _handleY,
            const WindowsHandle& _handleCb,
            const WindowsHandle& _handleCr,
            const IntSize& _size,
            const IntSize& _sizeY,
            const IntSize& _sizeCbCr)
    {
        Init();
        Assign(_handleY, _handleCb, _handleCr, _size, _sizeY, _sizeCbCr);
    }

    MOZ_IMPLICIT SurfaceDescriptorDXGIYCbCr(const SurfaceDescriptorDXGIYCbCr& _o)
    {
        Init();
        Assign((_o).handleY(), (_o).handleCb(), (_o).handleCr(), (_o).size(), (_o).sizeY(), (_o).sizeCbCr());
    }

    ~SurfaceDescriptorDXGIYCbCr();

    void
    operator=(const SurfaceDescriptorDXGIYCbCr& _o)
    {
        Assign((_o).handleY(), (_o).handleCb(), (_o).handleCr(), (_o).size(), (_o).sizeY(), (_o).sizeCbCr());
    }

    bool
    operator==(const SurfaceDescriptorDXGIYCbCr& _o) const;

    WindowsHandle&
    handleY()
    {
        return handleY_;
    }
    const WindowsHandle&
    handleY() const
    {
        return handleY_;
    }

    WindowsHandle&
    handleCb()
    {
        return handleCb_;
    }
    const WindowsHandle&
    handleCb() const
    {
        return handleCb_;
    }

    WindowsHandle&
    handleCr()
    {
        return handleCr_;
    }
    const WindowsHandle&
    handleCr() const
    {
        return handleCr_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    IntSize&
    sizeY()
    {
        return sizeY_;
    }
    const IntSize&
    sizeY() const
    {
        return sizeY_;
    }

    IntSize&
    sizeCbCr()
    {
        return sizeCbCr_;
    }
    const IntSize&
    sizeCbCr() const
    {
        return sizeCbCr_;
    }

private:
    void
    Init();

    void
    Assign(
            const WindowsHandle& _handleY,
            const WindowsHandle& _handleCb,
            const WindowsHandle& _handleCr,
            const IntSize& _size,
            const IntSize& _sizeY,
            const IntSize& _sizeCbCr);

    WindowsHandle handleY_;
    WindowsHandle handleCb_;
    WindowsHandle handleCr_;
    IntSize size_;
    IntSize sizeY_;
    IntSize sizeCbCr_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorMacIOSurface|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorMacIOSurface final
{
private:

public:
    MOZ_IMPLICIT SurfaceDescriptorMacIOSurface();

    MOZ_IMPLICIT SurfaceDescriptorMacIOSurface(
            const uint32_t& _surfaceId,
            const double& _scaleFactor,
            const bool& _isOpaque)
    {
        Init();
        Assign(_surfaceId, _scaleFactor, _isOpaque);
    }

    MOZ_IMPLICIT SurfaceDescriptorMacIOSurface(const SurfaceDescriptorMacIOSurface& _o)
    {
        Init();
        Assign((_o).surfaceId(), (_o).scaleFactor(), (_o).isOpaque());
    }

    ~SurfaceDescriptorMacIOSurface();

    void
    operator=(const SurfaceDescriptorMacIOSurface& _o)
    {
        Assign((_o).surfaceId(), (_o).scaleFactor(), (_o).isOpaque());
    }

    bool
    operator==(const SurfaceDescriptorMacIOSurface& _o) const;

    uint32_t&
    surfaceId()
    {
        return surfaceId_;
    }
    const uint32_t&
    surfaceId() const
    {
        return surfaceId_;
    }

    double&
    scaleFactor()
    {
        return scaleFactor_;
    }
    const double&
    scaleFactor() const
    {
        return scaleFactor_;
    }

    bool&
    isOpaque()
    {
        return isOpaque_;
    }
    const bool&
    isOpaque() const
    {
        return isOpaque_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _surfaceId,
            const double& _scaleFactor,
            const bool& _isOpaque);

    uint32_t surfaceId_;
    double scaleFactor_;
    bool isOpaque_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceTextureDescriptor|
//
namespace mozilla {
namespace layers {
class SurfaceTextureDescriptor final
{
private:
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceTextureDescriptor();

    MOZ_IMPLICIT SurfaceTextureDescriptor(
            const uintptr_t& _surfTex,
            const IntSize& _size)
    {
        Init();
        Assign(_surfTex, _size);
    }

    MOZ_IMPLICIT SurfaceTextureDescriptor(const SurfaceTextureDescriptor& _o)
    {
        Init();
        Assign((_o).surfTex(), (_o).size());
    }

    ~SurfaceTextureDescriptor();

    void
    operator=(const SurfaceTextureDescriptor& _o)
    {
        Assign((_o).surfTex(), (_o).size());
    }

    bool
    operator==(const SurfaceTextureDescriptor& _o) const;

    uintptr_t&
    surfTex()
    {
        return surfTex_;
    }
    const uintptr_t&
    surfTex() const
    {
        return surfTex_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _surfTex,
            const IntSize& _size);

    uintptr_t surfTex_;
    IntSize size_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct EGLImageDescriptor|
//
namespace mozilla {
namespace layers {
class EGLImageDescriptor final
{
private:
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT EGLImageDescriptor();

    MOZ_IMPLICIT EGLImageDescriptor(
            const uintptr_t& _image,
            const uintptr_t& _fence,
            const IntSize& _size,
            const bool& _hasAlpha)
    {
        Init();
        Assign(_image, _fence, _size, _hasAlpha);
    }

    MOZ_IMPLICIT EGLImageDescriptor(const EGLImageDescriptor& _o)
    {
        Init();
        Assign((_o).image(), (_o).fence(), (_o).size(), (_o).hasAlpha());
    }

    ~EGLImageDescriptor();

    void
    operator=(const EGLImageDescriptor& _o)
    {
        Assign((_o).image(), (_o).fence(), (_o).size(), (_o).hasAlpha());
    }

    bool
    operator==(const EGLImageDescriptor& _o) const;

    uintptr_t&
    image()
    {
        return image_;
    }
    const uintptr_t&
    image() const
    {
        return image_;
    }

    uintptr_t&
    fence()
    {
        return fence_;
    }
    const uintptr_t&
    fence() const
    {
        return fence_;
    }

    IntSize&
    size()
    {
        return size_;
    }
    const IntSize&
    size() const
    {
        return size_;
    }

    bool&
    hasAlpha()
    {
        return hasAlpha_;
    }
    const bool&
    hasAlpha() const
    {
        return hasAlpha_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _image,
            const uintptr_t& _fence,
            const IntSize& _size,
            const bool& _hasAlpha);

    uintptr_t image_;
    uintptr_t fence_;
    IntSize size_;
    bool hasAlpha_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class MaybeMagicGrallocBufferHandle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NewSurfaceDescriptorGralloc|
//
namespace mozilla {
namespace layers {
class NewSurfaceDescriptorGralloc final
{
private:
    typedef mozilla::layers::MaybeMagicGrallocBufferHandle MaybeMagicGrallocBufferHandle;

public:
    MOZ_IMPLICIT NewSurfaceDescriptorGralloc();

    MOZ_IMPLICIT NewSurfaceDescriptorGralloc(
            const MaybeMagicGrallocBufferHandle& _buffer,
            const bool& _isOpaque)
    {
        Init();
        Assign(_buffer, _isOpaque);
    }

    MOZ_IMPLICIT NewSurfaceDescriptorGralloc(const NewSurfaceDescriptorGralloc& _o)
    {
        Init();
        Assign((_o).buffer(), (_o).isOpaque());
    }

    ~NewSurfaceDescriptorGralloc();

    void
    operator=(const NewSurfaceDescriptorGralloc& _o)
    {
        Assign((_o).buffer(), (_o).isOpaque());
    }

    bool
    operator==(const NewSurfaceDescriptorGralloc& _o) const;

    MaybeMagicGrallocBufferHandle&
    buffer()
    {
        return buffer_;
    }
    const MaybeMagicGrallocBufferHandle&
    buffer() const
    {
        return buffer_;
    }

    bool&
    isOpaque()
    {
        return isOpaque_;
    }
    const bool&
    isOpaque() const
    {
        return isOpaque_;
    }

private:
    void
    Init();

    void
    Assign(
            const MaybeMagicGrallocBufferHandle& _buffer,
            const bool& _isOpaque);

    MaybeMagicGrallocBufferHandle buffer_;
    bool isOpaque_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorShmem|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorShmem final
{
private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;

public:
    MOZ_IMPLICIT SurfaceDescriptorShmem();

    MOZ_IMPLICIT SurfaceDescriptorShmem(
            Shmem& _data,
            const SurfaceFormat& _format)
    {
        Init();
        Assign(_data, _format);
    }

    MOZ_IMPLICIT SurfaceDescriptorShmem(const SurfaceDescriptorShmem& _o)
    {
        Init();
        Assign((_o).data(), (_o).format());
    }

    ~SurfaceDescriptorShmem();

    void
    operator=(const SurfaceDescriptorShmem& _o)
    {
        Assign((_o).data(), (_o).format());
    }

    bool
    operator==(const SurfaceDescriptorShmem& _o) const;

    Shmem&
    data()
    {
        return data_;
    }
    Shmem&
    data() const
    {
        return const_cast<Shmem&>(data_);
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

private:
    void
    Init();

    void
    Assign(
            Shmem& _data,
            const SurfaceFormat& _format);

    Shmem data_;
    SurfaceFormat format_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorMemory|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorMemory final
{
private:
    typedef mozilla::gfx::SurfaceFormat SurfaceFormat;

public:
    MOZ_IMPLICIT SurfaceDescriptorMemory();

    MOZ_IMPLICIT SurfaceDescriptorMemory(
            const uintptr_t& _data,
            const SurfaceFormat& _format)
    {
        Init();
        Assign(_data, _format);
    }

    MOZ_IMPLICIT SurfaceDescriptorMemory(const SurfaceDescriptorMemory& _o)
    {
        Init();
        Assign((_o).data(), (_o).format());
    }

    ~SurfaceDescriptorMemory();

    void
    operator=(const SurfaceDescriptorMemory& _o)
    {
        Assign((_o).data(), (_o).format());
    }

    bool
    operator==(const SurfaceDescriptorMemory& _o) const;

    uintptr_t&
    data()
    {
        return data_;
    }
    const uintptr_t&
    data() const
    {
        return data_;
    }

    SurfaceFormat&
    format()
    {
        return format_;
    }
    const SurfaceFormat&
    format() const
    {
        return format_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _data,
            const SurfaceFormat& _format);

    uintptr_t data_;
    SurfaceFormat format_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class SurfaceDescriptorShmem;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorMemory;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D9;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorDIB;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorD3D10;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorFileMapping;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorDXGIYCbCr;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceTextureDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class EGLImageDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SurfaceDescriptorMacIOSurface;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class NewSurfaceDescriptorGralloc;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union SurfaceDescriptor|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptor final
{
public:
    enum Type {
        T__None,
        TSurfaceDescriptorShmem = 1,
        TSurfaceDescriptorMemory,
        TSurfaceDescriptorD3D9,
        TSurfaceDescriptorDIB,
        TSurfaceDescriptorD3D10,
        TSurfaceDescriptorFileMapping,
        TSurfaceDescriptorDXGIYCbCr,
        TSurfaceDescriptorX11,
        TSurfaceTextureDescriptor,
        TEGLImageDescriptor,
        TSurfaceDescriptorMacIOSurface,
        TNewSurfaceDescriptorGralloc,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::SurfaceDescriptorShmem SurfaceDescriptorShmem;
    typedef mozilla::layers::SurfaceDescriptorMemory SurfaceDescriptorMemory;
    typedef mozilla::layers::SurfaceDescriptorD3D9 SurfaceDescriptorD3D9;
    typedef mozilla::layers::SurfaceDescriptorDIB SurfaceDescriptorDIB;
    typedef mozilla::layers::SurfaceDescriptorD3D10 SurfaceDescriptorD3D10;
    typedef mozilla::layers::SurfaceDescriptorFileMapping SurfaceDescriptorFileMapping;
    typedef mozilla::layers::SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr;
    typedef mozilla::layers::SurfaceDescriptorX11 SurfaceDescriptorX11;
    typedef mozilla::layers::SurfaceTextureDescriptor SurfaceTextureDescriptor;
    typedef mozilla::layers::EGLImageDescriptor EGLImageDescriptor;
    typedef mozilla::layers::SurfaceDescriptorMacIOSurface SurfaceDescriptorMacIOSurface;
    typedef mozilla::layers::NewSurfaceDescriptorGralloc NewSurfaceDescriptorGralloc;
    typedef mozilla::null_t null_t;
    typedef SurfaceDescriptorShmem SurfaceDescriptorShmem__tdef;
    typedef SurfaceDescriptorMemory SurfaceDescriptorMemory__tdef;
    typedef SurfaceDescriptorD3D9 SurfaceDescriptorD3D9__tdef;
    typedef SurfaceDescriptorDIB SurfaceDescriptorDIB__tdef;
    typedef SurfaceDescriptorD3D10 SurfaceDescriptorD3D10__tdef;
    typedef SurfaceDescriptorFileMapping SurfaceDescriptorFileMapping__tdef;
    typedef SurfaceDescriptorDXGIYCbCr SurfaceDescriptorDXGIYCbCr__tdef;
    typedef SurfaceDescriptorX11 SurfaceDescriptorX11__tdef;
    typedef SurfaceTextureDescriptor SurfaceTextureDescriptor__tdef;
    typedef EGLImageDescriptor EGLImageDescriptor__tdef;
    typedef SurfaceDescriptorMacIOSurface SurfaceDescriptorMacIOSurface__tdef;
    typedef NewSurfaceDescriptorGralloc NewSurfaceDescriptorGralloc__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char VSurfaceDescriptorShmem[sizeof(SurfaceDescriptorShmem)];
        char VSurfaceDescriptorMemory[sizeof(SurfaceDescriptorMemory)];
        char VSurfaceDescriptorD3D9[sizeof(SurfaceDescriptorD3D9)];
        char VSurfaceDescriptorDIB[sizeof(SurfaceDescriptorDIB)];
        char VSurfaceDescriptorD3D10[sizeof(SurfaceDescriptorD3D10)];
        char VSurfaceDescriptorFileMapping[sizeof(SurfaceDescriptorFileMapping)];
        char VSurfaceDescriptorDXGIYCbCr[sizeof(SurfaceDescriptorDXGIYCbCr)];
        char VSurfaceDescriptorX11[sizeof(SurfaceDescriptorX11)];
        char VSurfaceTextureDescriptor[sizeof(SurfaceTextureDescriptor)];
        char VEGLImageDescriptor[sizeof(EGLImageDescriptor)];
        char VSurfaceDescriptorMacIOSurface[sizeof(SurfaceDescriptorMacIOSurface)];
        char VNewSurfaceDescriptorGralloc[sizeof(NewSurfaceDescriptorGralloc)];
        char Vnull_t[sizeof(null_t)];
    };

    SurfaceDescriptorShmem*
    ptr_SurfaceDescriptorShmem()
    {
        return reinterpret_cast<SurfaceDescriptorShmem*>((&((mValue).VSurfaceDescriptorShmem)));
    }
    const SurfaceDescriptorShmem* const
    constptr_SurfaceDescriptorShmem() const
    {
        return reinterpret_cast<const SurfaceDescriptorShmem* const>((&((mValue).VSurfaceDescriptorShmem)));
    }
    SurfaceDescriptorMemory*
    ptr_SurfaceDescriptorMemory()
    {
        return reinterpret_cast<SurfaceDescriptorMemory*>((&((mValue).VSurfaceDescriptorMemory)));
    }
    const SurfaceDescriptorMemory* const
    constptr_SurfaceDescriptorMemory() const
    {
        return reinterpret_cast<const SurfaceDescriptorMemory* const>((&((mValue).VSurfaceDescriptorMemory)));
    }
    SurfaceDescriptorD3D9*
    ptr_SurfaceDescriptorD3D9()
    {
        return reinterpret_cast<SurfaceDescriptorD3D9*>((&((mValue).VSurfaceDescriptorD3D9)));
    }
    const SurfaceDescriptorD3D9* const
    constptr_SurfaceDescriptorD3D9() const
    {
        return reinterpret_cast<const SurfaceDescriptorD3D9* const>((&((mValue).VSurfaceDescriptorD3D9)));
    }
    SurfaceDescriptorDIB*
    ptr_SurfaceDescriptorDIB()
    {
        return reinterpret_cast<SurfaceDescriptorDIB*>((&((mValue).VSurfaceDescriptorDIB)));
    }
    const SurfaceDescriptorDIB* const
    constptr_SurfaceDescriptorDIB() const
    {
        return reinterpret_cast<const SurfaceDescriptorDIB* const>((&((mValue).VSurfaceDescriptorDIB)));
    }
    SurfaceDescriptorD3D10*
    ptr_SurfaceDescriptorD3D10()
    {
        return reinterpret_cast<SurfaceDescriptorD3D10*>((&((mValue).VSurfaceDescriptorD3D10)));
    }
    const SurfaceDescriptorD3D10* const
    constptr_SurfaceDescriptorD3D10() const
    {
        return reinterpret_cast<const SurfaceDescriptorD3D10* const>((&((mValue).VSurfaceDescriptorD3D10)));
    }
    SurfaceDescriptorFileMapping*
    ptr_SurfaceDescriptorFileMapping()
    {
        return reinterpret_cast<SurfaceDescriptorFileMapping*>((&((mValue).VSurfaceDescriptorFileMapping)));
    }
    const SurfaceDescriptorFileMapping* const
    constptr_SurfaceDescriptorFileMapping() const
    {
        return reinterpret_cast<const SurfaceDescriptorFileMapping* const>((&((mValue).VSurfaceDescriptorFileMapping)));
    }
    SurfaceDescriptorDXGIYCbCr*
    ptr_SurfaceDescriptorDXGIYCbCr()
    {
        return reinterpret_cast<SurfaceDescriptorDXGIYCbCr*>((&((mValue).VSurfaceDescriptorDXGIYCbCr)));
    }
    const SurfaceDescriptorDXGIYCbCr* const
    constptr_SurfaceDescriptorDXGIYCbCr() const
    {
        return reinterpret_cast<const SurfaceDescriptorDXGIYCbCr* const>((&((mValue).VSurfaceDescriptorDXGIYCbCr)));
    }
    SurfaceDescriptorX11*
    ptr_SurfaceDescriptorX11()
    {
        return reinterpret_cast<SurfaceDescriptorX11*>((&((mValue).VSurfaceDescriptorX11)));
    }
    const SurfaceDescriptorX11* const
    constptr_SurfaceDescriptorX11() const
    {
        return reinterpret_cast<const SurfaceDescriptorX11* const>((&((mValue).VSurfaceDescriptorX11)));
    }
    SurfaceTextureDescriptor*
    ptr_SurfaceTextureDescriptor()
    {
        return reinterpret_cast<SurfaceTextureDescriptor*>((&((mValue).VSurfaceTextureDescriptor)));
    }
    const SurfaceTextureDescriptor* const
    constptr_SurfaceTextureDescriptor() const
    {
        return reinterpret_cast<const SurfaceTextureDescriptor* const>((&((mValue).VSurfaceTextureDescriptor)));
    }
    EGLImageDescriptor*
    ptr_EGLImageDescriptor()
    {
        return reinterpret_cast<EGLImageDescriptor*>((&((mValue).VEGLImageDescriptor)));
    }
    const EGLImageDescriptor* const
    constptr_EGLImageDescriptor() const
    {
        return reinterpret_cast<const EGLImageDescriptor* const>((&((mValue).VEGLImageDescriptor)));
    }
    SurfaceDescriptorMacIOSurface*
    ptr_SurfaceDescriptorMacIOSurface()
    {
        return reinterpret_cast<SurfaceDescriptorMacIOSurface*>((&((mValue).VSurfaceDescriptorMacIOSurface)));
    }
    const SurfaceDescriptorMacIOSurface* const
    constptr_SurfaceDescriptorMacIOSurface() const
    {
        return reinterpret_cast<const SurfaceDescriptorMacIOSurface* const>((&((mValue).VSurfaceDescriptorMacIOSurface)));
    }
    NewSurfaceDescriptorGralloc*
    ptr_NewSurfaceDescriptorGralloc()
    {
        return reinterpret_cast<NewSurfaceDescriptorGralloc*>((&((mValue).VNewSurfaceDescriptorGralloc)));
    }
    const NewSurfaceDescriptorGralloc* const
    constptr_NewSurfaceDescriptorGralloc() const
    {
        return reinterpret_cast<const NewSurfaceDescriptorGralloc* const>((&((mValue).VNewSurfaceDescriptorGralloc)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT SurfaceDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorShmem& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorMemory& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorD3D9& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorDIB& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorD3D10& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorFileMapping& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorDXGIYCbCr& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorX11& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceTextureDescriptor& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const EGLImageDescriptor& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptorMacIOSurface& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const NewSurfaceDescriptorGralloc& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const null_t& aOther);

    MOZ_IMPLICIT SurfaceDescriptor(const SurfaceDescriptor& aOther);

    ~SurfaceDescriptor();

    Type
    type() const
    {
        return mType;
    }

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorShmem& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorMemory& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorD3D9& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorDIB& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorD3D10& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorFileMapping& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorDXGIYCbCr& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorX11& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceTextureDescriptor& aRhs);

    SurfaceDescriptor&
    operator=(const EGLImageDescriptor& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptorMacIOSurface& aRhs);

    SurfaceDescriptor&
    operator=(const NewSurfaceDescriptorGralloc& aRhs);

    SurfaceDescriptor&
    operator=(const null_t& aRhs);

    SurfaceDescriptor&
    operator=(const SurfaceDescriptor& aRhs);

    bool
    operator==(const SurfaceDescriptorShmem& aRhs) const;

    bool
    operator==(const SurfaceDescriptorMemory& aRhs) const;

    bool
    operator==(const SurfaceDescriptorD3D9& aRhs) const;

    bool
    operator==(const SurfaceDescriptorDIB& aRhs) const;

    bool
    operator==(const SurfaceDescriptorD3D10& aRhs) const;

    bool
    operator==(const SurfaceDescriptorFileMapping& aRhs) const;

    bool
    operator==(const SurfaceDescriptorDXGIYCbCr& aRhs) const;

    bool
    operator==(const SurfaceDescriptorX11& aRhs) const;

    bool
    operator==(const SurfaceTextureDescriptor& aRhs) const;

    bool
    operator==(const EGLImageDescriptor& aRhs) const;

    bool
    operator==(const SurfaceDescriptorMacIOSurface& aRhs) const;

    bool
    operator==(const NewSurfaceDescriptorGralloc& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const SurfaceDescriptor& aRhs) const;

    SurfaceDescriptorShmem&
    get_SurfaceDescriptorShmem()
    {
        AssertSanity(TSurfaceDescriptorShmem);
        return (*(ptr_SurfaceDescriptorShmem()));
    }
    const SurfaceDescriptorShmem&
    get_SurfaceDescriptorShmem() const
    {
        AssertSanity(TSurfaceDescriptorShmem);
        return (*(constptr_SurfaceDescriptorShmem()));
    }
    operator SurfaceDescriptorShmem&()
    {
        return get_SurfaceDescriptorShmem();
    }
    operator const SurfaceDescriptorShmem&() const
    {
        return get_SurfaceDescriptorShmem();
    }

    SurfaceDescriptorMemory&
    get_SurfaceDescriptorMemory()
    {
        AssertSanity(TSurfaceDescriptorMemory);
        return (*(ptr_SurfaceDescriptorMemory()));
    }
    const SurfaceDescriptorMemory&
    get_SurfaceDescriptorMemory() const
    {
        AssertSanity(TSurfaceDescriptorMemory);
        return (*(constptr_SurfaceDescriptorMemory()));
    }
    operator SurfaceDescriptorMemory&()
    {
        return get_SurfaceDescriptorMemory();
    }
    operator const SurfaceDescriptorMemory&() const
    {
        return get_SurfaceDescriptorMemory();
    }

    SurfaceDescriptorD3D9&
    get_SurfaceDescriptorD3D9()
    {
        AssertSanity(TSurfaceDescriptorD3D9);
        return (*(ptr_SurfaceDescriptorD3D9()));
    }
    const SurfaceDescriptorD3D9&
    get_SurfaceDescriptorD3D9() const
    {
        AssertSanity(TSurfaceDescriptorD3D9);
        return (*(constptr_SurfaceDescriptorD3D9()));
    }
    operator SurfaceDescriptorD3D9&()
    {
        return get_SurfaceDescriptorD3D9();
    }
    operator const SurfaceDescriptorD3D9&() const
    {
        return get_SurfaceDescriptorD3D9();
    }

    SurfaceDescriptorDIB&
    get_SurfaceDescriptorDIB()
    {
        AssertSanity(TSurfaceDescriptorDIB);
        return (*(ptr_SurfaceDescriptorDIB()));
    }
    const SurfaceDescriptorDIB&
    get_SurfaceDescriptorDIB() const
    {
        AssertSanity(TSurfaceDescriptorDIB);
        return (*(constptr_SurfaceDescriptorDIB()));
    }
    operator SurfaceDescriptorDIB&()
    {
        return get_SurfaceDescriptorDIB();
    }
    operator const SurfaceDescriptorDIB&() const
    {
        return get_SurfaceDescriptorDIB();
    }

    SurfaceDescriptorD3D10&
    get_SurfaceDescriptorD3D10()
    {
        AssertSanity(TSurfaceDescriptorD3D10);
        return (*(ptr_SurfaceDescriptorD3D10()));
    }
    const SurfaceDescriptorD3D10&
    get_SurfaceDescriptorD3D10() const
    {
        AssertSanity(TSurfaceDescriptorD3D10);
        return (*(constptr_SurfaceDescriptorD3D10()));
    }
    operator SurfaceDescriptorD3D10&()
    {
        return get_SurfaceDescriptorD3D10();
    }
    operator const SurfaceDescriptorD3D10&() const
    {
        return get_SurfaceDescriptorD3D10();
    }

    SurfaceDescriptorFileMapping&
    get_SurfaceDescriptorFileMapping()
    {
        AssertSanity(TSurfaceDescriptorFileMapping);
        return (*(ptr_SurfaceDescriptorFileMapping()));
    }
    const SurfaceDescriptorFileMapping&
    get_SurfaceDescriptorFileMapping() const
    {
        AssertSanity(TSurfaceDescriptorFileMapping);
        return (*(constptr_SurfaceDescriptorFileMapping()));
    }
    operator SurfaceDescriptorFileMapping&()
    {
        return get_SurfaceDescriptorFileMapping();
    }
    operator const SurfaceDescriptorFileMapping&() const
    {
        return get_SurfaceDescriptorFileMapping();
    }

    SurfaceDescriptorDXGIYCbCr&
    get_SurfaceDescriptorDXGIYCbCr()
    {
        AssertSanity(TSurfaceDescriptorDXGIYCbCr);
        return (*(ptr_SurfaceDescriptorDXGIYCbCr()));
    }
    const SurfaceDescriptorDXGIYCbCr&
    get_SurfaceDescriptorDXGIYCbCr() const
    {
        AssertSanity(TSurfaceDescriptorDXGIYCbCr);
        return (*(constptr_SurfaceDescriptorDXGIYCbCr()));
    }
    operator SurfaceDescriptorDXGIYCbCr&()
    {
        return get_SurfaceDescriptorDXGIYCbCr();
    }
    operator const SurfaceDescriptorDXGIYCbCr&() const
    {
        return get_SurfaceDescriptorDXGIYCbCr();
    }

    SurfaceDescriptorX11&
    get_SurfaceDescriptorX11()
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(ptr_SurfaceDescriptorX11()));
    }
    const SurfaceDescriptorX11&
    get_SurfaceDescriptorX11() const
    {
        AssertSanity(TSurfaceDescriptorX11);
        return (*(constptr_SurfaceDescriptorX11()));
    }
    operator SurfaceDescriptorX11&()
    {
        return get_SurfaceDescriptorX11();
    }
    operator const SurfaceDescriptorX11&() const
    {
        return get_SurfaceDescriptorX11();
    }

    SurfaceTextureDescriptor&
    get_SurfaceTextureDescriptor()
    {
        AssertSanity(TSurfaceTextureDescriptor);
        return (*(ptr_SurfaceTextureDescriptor()));
    }
    const SurfaceTextureDescriptor&
    get_SurfaceTextureDescriptor() const
    {
        AssertSanity(TSurfaceTextureDescriptor);
        return (*(constptr_SurfaceTextureDescriptor()));
    }
    operator SurfaceTextureDescriptor&()
    {
        return get_SurfaceTextureDescriptor();
    }
    operator const SurfaceTextureDescriptor&() const
    {
        return get_SurfaceTextureDescriptor();
    }

    EGLImageDescriptor&
    get_EGLImageDescriptor()
    {
        AssertSanity(TEGLImageDescriptor);
        return (*(ptr_EGLImageDescriptor()));
    }
    const EGLImageDescriptor&
    get_EGLImageDescriptor() const
    {
        AssertSanity(TEGLImageDescriptor);
        return (*(constptr_EGLImageDescriptor()));
    }
    operator EGLImageDescriptor&()
    {
        return get_EGLImageDescriptor();
    }
    operator const EGLImageDescriptor&() const
    {
        return get_EGLImageDescriptor();
    }

    SurfaceDescriptorMacIOSurface&
    get_SurfaceDescriptorMacIOSurface()
    {
        AssertSanity(TSurfaceDescriptorMacIOSurface);
        return (*(ptr_SurfaceDescriptorMacIOSurface()));
    }
    const SurfaceDescriptorMacIOSurface&
    get_SurfaceDescriptorMacIOSurface() const
    {
        AssertSanity(TSurfaceDescriptorMacIOSurface);
        return (*(constptr_SurfaceDescriptorMacIOSurface()));
    }
    operator SurfaceDescriptorMacIOSurface&()
    {
        return get_SurfaceDescriptorMacIOSurface();
    }
    operator const SurfaceDescriptorMacIOSurface&() const
    {
        return get_SurfaceDescriptorMacIOSurface();
    }

    NewSurfaceDescriptorGralloc&
    get_NewSurfaceDescriptorGralloc()
    {
        AssertSanity(TNewSurfaceDescriptorGralloc);
        return (*(ptr_NewSurfaceDescriptorGralloc()));
    }
    const NewSurfaceDescriptorGralloc&
    get_NewSurfaceDescriptorGralloc() const
    {
        AssertSanity(TNewSurfaceDescriptorGralloc);
        return (*(constptr_NewSurfaceDescriptorGralloc()));
    }
    operator NewSurfaceDescriptorGralloc&()
    {
        return get_NewSurfaceDescriptorGralloc();
    }
    operator const NewSurfaceDescriptorGralloc&() const
    {
        return get_NewSurfaceDescriptorGralloc();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

#endif // ifndef LayersSurfaces_h
