//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef NeckoChannelParams_h
#define NeckoChannelParams_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/net/PHttpChannelParams.h"
#include "nsHttpResponseHead.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/ipc/InputStreamParams.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"

namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoadInfoArgs|
//
namespace mozilla {
namespace net {
class LoadInfoArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT LoadInfoArgs();

    MOZ_IMPLICIT LoadInfoArgs(
            const PrincipalInfo& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType,
            const bool& _upgradeInsecureRequests,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const bool& _enforceSecurity,
            const bool& _initialSecurityCheckDone,
            const nsTArray<PrincipalInfo>& _redirectChain)
    {
        Init();
        Assign(_requestingPrincipalInfo, _triggeringPrincipalInfo, _securityFlags, _contentPolicyType, _upgradeInsecureRequests, _innerWindowID, _outerWindowID, _parentOuterWindowID, _enforceSecurity, _initialSecurityCheckDone, _redirectChain);
    }

    MOZ_IMPLICIT LoadInfoArgs(const LoadInfoArgs& _o)
    {
        Init();
        Assign((_o).requestingPrincipalInfo(), (_o).triggeringPrincipalInfo(), (_o).securityFlags(), (_o).contentPolicyType(), (_o).upgradeInsecureRequests(), (_o).innerWindowID(), (_o).outerWindowID(), (_o).parentOuterWindowID(), (_o).enforceSecurity(), (_o).initialSecurityCheckDone(), (_o).redirectChain());
    }

    ~LoadInfoArgs();

    void
    operator=(const LoadInfoArgs& _o)
    {
        Assign((_o).requestingPrincipalInfo(), (_o).triggeringPrincipalInfo(), (_o).securityFlags(), (_o).contentPolicyType(), (_o).upgradeInsecureRequests(), (_o).innerWindowID(), (_o).outerWindowID(), (_o).parentOuterWindowID(), (_o).enforceSecurity(), (_o).initialSecurityCheckDone(), (_o).redirectChain());
    }

    bool
    operator==(const LoadInfoArgs& _o) const;

    PrincipalInfo&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const PrincipalInfo&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    PrincipalInfo&
    triggeringPrincipalInfo()
    {
        return triggeringPrincipalInfo_;
    }
    const PrincipalInfo&
    triggeringPrincipalInfo() const
    {
        return triggeringPrincipalInfo_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    bool&
    upgradeInsecureRequests()
    {
        return upgradeInsecureRequests_;
    }
    const bool&
    upgradeInsecureRequests() const
    {
        return upgradeInsecureRequests_;
    }

    uint64_t&
    innerWindowID()
    {
        return innerWindowID_;
    }
    const uint64_t&
    innerWindowID() const
    {
        return innerWindowID_;
    }

    uint64_t&
    outerWindowID()
    {
        return outerWindowID_;
    }
    const uint64_t&
    outerWindowID() const
    {
        return outerWindowID_;
    }

    uint64_t&
    parentOuterWindowID()
    {
        return parentOuterWindowID_;
    }
    const uint64_t&
    parentOuterWindowID() const
    {
        return parentOuterWindowID_;
    }

    bool&
    enforceSecurity()
    {
        return enforceSecurity_;
    }
    const bool&
    enforceSecurity() const
    {
        return enforceSecurity_;
    }

    bool&
    initialSecurityCheckDone()
    {
        return initialSecurityCheckDone_;
    }
    const bool&
    initialSecurityCheckDone() const
    {
        return initialSecurityCheckDone_;
    }

    nsTArray<PrincipalInfo>&
    redirectChain()
    {
        return redirectChain_;
    }
    const nsTArray<PrincipalInfo>&
    redirectChain() const
    {
        return redirectChain_;
    }

private:
    void
    Init();

    void
    Assign(
            const PrincipalInfo& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType,
            const bool& _upgradeInsecureRequests,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const bool& _enforceSecurity,
            const bool& _initialSecurityCheckDone,
            const nsTArray<PrincipalInfo>& _redirectChain);

    PrincipalInfo requestingPrincipalInfo_;
    PrincipalInfo triggeringPrincipalInfo_;
    uint32_t securityFlags_;
    uint32_t contentPolicyType_;
    bool upgradeInsecureRequests_;
    uint64_t innerWindowID_;
    uint64_t outerWindowID_;
    uint64_t parentOuterWindowID_;
    bool enforceSecurity_;
    bool initialSecurityCheckDone_;
    nsTArray<PrincipalInfo> redirectChain_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class LoadInfoArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalLoadInfoArgs|
//
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TLoadInfoArgs,
        T__Last = TLoadInfoArgs
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef void_t void_t__tdef;
    typedef LoadInfoArgs LoadInfoArgs__tdef;

    union Value {
        char Vvoid_t[sizeof(void_t)];
        char VLoadInfoArgs[sizeof(LoadInfoArgs)];
    };

    void_t*
    ptr_void_t()
    {
        return reinterpret_cast<void_t*>((&((mValue).Vvoid_t)));
    }
    const void_t* const
    constptr_void_t() const
    {
        return reinterpret_cast<const void_t* const>((&((mValue).Vvoid_t)));
    }
    LoadInfoArgs*
    ptr_LoadInfoArgs()
    {
        return reinterpret_cast<LoadInfoArgs*>((&((mValue).VLoadInfoArgs)));
    }
    const LoadInfoArgs* const
    constptr_LoadInfoArgs() const
    {
        return reinterpret_cast<const LoadInfoArgs* const>((&((mValue).VLoadInfoArgs)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalLoadInfoArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalLoadInfoArgs(const void_t& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(const LoadInfoArgs& aOther);

    MOZ_IMPLICIT OptionalLoadInfoArgs(const OptionalLoadInfoArgs& aOther);

    ~OptionalLoadInfoArgs();

    Type
    type() const
    {
        return mType;
    }

    OptionalLoadInfoArgs&
    operator=(const void_t& aRhs);

    OptionalLoadInfoArgs&
    operator=(const LoadInfoArgs& aRhs);

    OptionalLoadInfoArgs&
    operator=(const OptionalLoadInfoArgs& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const LoadInfoArgs& aRhs) const;

    bool
    operator==(const OptionalLoadInfoArgs& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    LoadInfoArgs&
    get_LoadInfoArgs()
    {
        AssertSanity(TLoadInfoArgs);
        return (*(ptr_LoadInfoArgs()));
    }
    const LoadInfoArgs&
    get_LoadInfoArgs() const
    {
        AssertSanity(TLoadInfoArgs);
        return (*(constptr_LoadInfoArgs()));
    }
    operator LoadInfoArgs&()
    {
        return get_LoadInfoArgs();
    }
    operator const LoadInfoArgs&() const
    {
        return get_LoadInfoArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalHttpResponseHead|
//
namespace mozilla {
namespace net {
class OptionalHttpResponseHead final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TnsHttpResponseHead,
        T__Last = TnsHttpResponseHead
    };

private:
    typedef mozilla::void_t void_t;
    typedef void_t void_t__tdef;
    typedef nsHttpResponseHead nsHttpResponseHead__tdef;

    union Value {
        char Vvoid_t[sizeof(void_t)];
        char VnsHttpResponseHead[sizeof(nsHttpResponseHead)];
    };

    void_t*
    ptr_void_t()
    {
        return reinterpret_cast<void_t*>((&((mValue).Vvoid_t)));
    }
    const void_t* const
    constptr_void_t() const
    {
        return reinterpret_cast<const void_t* const>((&((mValue).Vvoid_t)));
    }
    nsHttpResponseHead*
    ptr_nsHttpResponseHead()
    {
        return reinterpret_cast<nsHttpResponseHead*>((&((mValue).VnsHttpResponseHead)));
    }
    const nsHttpResponseHead* const
    constptr_nsHttpResponseHead() const
    {
        return reinterpret_cast<const nsHttpResponseHead* const>((&((mValue).VnsHttpResponseHead)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalHttpResponseHead() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalHttpResponseHead(const void_t& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(const nsHttpResponseHead& aOther);

    MOZ_IMPLICIT OptionalHttpResponseHead(const OptionalHttpResponseHead& aOther);

    ~OptionalHttpResponseHead();

    Type
    type() const
    {
        return mType;
    }

    OptionalHttpResponseHead&
    operator=(const void_t& aRhs);

    OptionalHttpResponseHead&
    operator=(const nsHttpResponseHead& aRhs);

    OptionalHttpResponseHead&
    operator=(const OptionalHttpResponseHead& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const nsHttpResponseHead& aRhs) const;

    bool
    operator==(const OptionalHttpResponseHead& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    nsHttpResponseHead&
    get_nsHttpResponseHead()
    {
        AssertSanity(TnsHttpResponseHead);
        return (*(ptr_nsHttpResponseHead()));
    }
    const nsHttpResponseHead&
    get_nsHttpResponseHead() const
    {
        AssertSanity(TnsHttpResponseHead);
        return (*(constptr_nsHttpResponseHead()));
    }
    operator nsHttpResponseHead&()
    {
        return get_nsHttpResponseHead();
    }
    operator const nsHttpResponseHead&() const
    {
        return get_nsHttpResponseHead();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalURIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalFileDescriptorSet;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalHttpResponseHead;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOpenArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;
    typedef mozilla::net::OptionalHttpResponseHead OptionalHttpResponseHead;

public:
    MOZ_IMPLICIT HttpChannelOpenArgs();

    MOZ_IMPLICIT HttpChannelOpenArgs(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const uint32_t& _referrerPolicy,
            const OptionalURIParams& _apiRedirectTo,
            const OptionalURIParams& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalInputStreamParams& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const uint16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowPipelining,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const OptionalFileDescriptorSet& _fds,
            const OptionalLoadInfoArgs& _loadInfo,
            const OptionalHttpResponseHead& _synthesizedResponseHead,
            const uint32_t& _cacheKey,
            const nsCString& _schedulingContextID)
    {
        Init();
        Assign(_uri, _original, _doc, _referrer, _referrerPolicy, _apiRedirectTo, _topWindowURI, _loadFlags, _requestHeaders, _requestMethod, _uploadStream, _uploadStreamHasHeaders, _priority, _classOfService, _redirectionLimit, _allowPipelining, _allowSTS, _thirdPartyFlags, _resumeAt, _startPos, _entityID, _chooseApplicationCache, _appCacheClientID, _allowSpdy, _allowAltSvc, _fds, _loadInfo, _synthesizedResponseHead, _cacheKey, _schedulingContextID);
    }

    MOZ_IMPLICIT HttpChannelOpenArgs(const HttpChannelOpenArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).original(), (_o).doc(), (_o).referrer(), (_o).referrerPolicy(), (_o).apiRedirectTo(), (_o).topWindowURI(), (_o).loadFlags(), (_o).requestHeaders(), (_o).requestMethod(), (_o).uploadStream(), (_o).uploadStreamHasHeaders(), (_o).priority(), (_o).classOfService(), (_o).redirectionLimit(), (_o).allowPipelining(), (_o).allowSTS(), (_o).thirdPartyFlags(), (_o).resumeAt(), (_o).startPos(), (_o).entityID(), (_o).chooseApplicationCache(), (_o).appCacheClientID(), (_o).allowSpdy(), (_o).allowAltSvc(), (_o).fds(), (_o).loadInfo(), (_o).synthesizedResponseHead(), (_o).cacheKey(), (_o).schedulingContextID());
    }

    ~HttpChannelOpenArgs();

    void
    operator=(const HttpChannelOpenArgs& _o)
    {
        Assign((_o).uri(), (_o).original(), (_o).doc(), (_o).referrer(), (_o).referrerPolicy(), (_o).apiRedirectTo(), (_o).topWindowURI(), (_o).loadFlags(), (_o).requestHeaders(), (_o).requestMethod(), (_o).uploadStream(), (_o).uploadStreamHasHeaders(), (_o).priority(), (_o).classOfService(), (_o).redirectionLimit(), (_o).allowPipelining(), (_o).allowSTS(), (_o).thirdPartyFlags(), (_o).resumeAt(), (_o).startPos(), (_o).entityID(), (_o).chooseApplicationCache(), (_o).appCacheClientID(), (_o).allowSpdy(), (_o).allowAltSvc(), (_o).fds(), (_o).loadInfo(), (_o).synthesizedResponseHead(), (_o).cacheKey(), (_o).schedulingContextID());
    }

    bool
    operator==(const HttpChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    OptionalURIParams&
    original()
    {
        return original_;
    }
    const OptionalURIParams&
    original() const
    {
        return original_;
    }

    OptionalURIParams&
    doc()
    {
        return doc_;
    }
    const OptionalURIParams&
    doc() const
    {
        return doc_;
    }

    OptionalURIParams&
    referrer()
    {
        return referrer_;
    }
    const OptionalURIParams&
    referrer() const
    {
        return referrer_;
    }

    uint32_t&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const uint32_t&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    OptionalURIParams&
    apiRedirectTo()
    {
        return apiRedirectTo_;
    }
    const OptionalURIParams&
    apiRedirectTo() const
    {
        return apiRedirectTo_;
    }

    OptionalURIParams&
    topWindowURI()
    {
        return topWindowURI_;
    }
    const OptionalURIParams&
    topWindowURI() const
    {
        return topWindowURI_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

    RequestHeaderTuples&
    requestHeaders()
    {
        return requestHeaders_;
    }
    const RequestHeaderTuples&
    requestHeaders() const
    {
        return requestHeaders_;
    }

    nsCString&
    requestMethod()
    {
        return requestMethod_;
    }
    const nsCString&
    requestMethod() const
    {
        return requestMethod_;
    }

    OptionalInputStreamParams&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalInputStreamParams&
    uploadStream() const
    {
        return uploadStream_;
    }

    bool&
    uploadStreamHasHeaders()
    {
        return uploadStreamHasHeaders_;
    }
    const bool&
    uploadStreamHasHeaders() const
    {
        return uploadStreamHasHeaders_;
    }

    uint16_t&
    priority()
    {
        return priority_;
    }
    const uint16_t&
    priority() const
    {
        return priority_;
    }

    uint32_t&
    classOfService()
    {
        return classOfService_;
    }
    const uint32_t&
    classOfService() const
    {
        return classOfService_;
    }

    uint8_t&
    redirectionLimit()
    {
        return redirectionLimit_;
    }
    const uint8_t&
    redirectionLimit() const
    {
        return redirectionLimit_;
    }

    bool&
    allowPipelining()
    {
        return allowPipelining_;
    }
    const bool&
    allowPipelining() const
    {
        return allowPipelining_;
    }

    bool&
    allowSTS()
    {
        return allowSTS_;
    }
    const bool&
    allowSTS() const
    {
        return allowSTS_;
    }

    uint32_t&
    thirdPartyFlags()
    {
        return thirdPartyFlags_;
    }
    const uint32_t&
    thirdPartyFlags() const
    {
        return thirdPartyFlags_;
    }

    bool&
    resumeAt()
    {
        return resumeAt_;
    }
    const bool&
    resumeAt() const
    {
        return resumeAt_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    bool&
    chooseApplicationCache()
    {
        return chooseApplicationCache_;
    }
    const bool&
    chooseApplicationCache() const
    {
        return chooseApplicationCache_;
    }

    nsCString&
    appCacheClientID()
    {
        return appCacheClientID_;
    }
    const nsCString&
    appCacheClientID() const
    {
        return appCacheClientID_;
    }

    bool&
    allowSpdy()
    {
        return allowSpdy_;
    }
    const bool&
    allowSpdy() const
    {
        return allowSpdy_;
    }

    bool&
    allowAltSvc()
    {
        return allowAltSvc_;
    }
    const bool&
    allowAltSvc() const
    {
        return allowAltSvc_;
    }

    OptionalFileDescriptorSet&
    fds()
    {
        return fds_;
    }
    const OptionalFileDescriptorSet&
    fds() const
    {
        return fds_;
    }

    OptionalLoadInfoArgs&
    loadInfo()
    {
        return loadInfo_;
    }
    const OptionalLoadInfoArgs&
    loadInfo() const
    {
        return loadInfo_;
    }

    OptionalHttpResponseHead&
    synthesizedResponseHead()
    {
        return synthesizedResponseHead_;
    }
    const OptionalHttpResponseHead&
    synthesizedResponseHead() const
    {
        return synthesizedResponseHead_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    nsCString&
    schedulingContextID()
    {
        return schedulingContextID_;
    }
    const nsCString&
    schedulingContextID() const
    {
        return schedulingContextID_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const uint32_t& _referrerPolicy,
            const OptionalURIParams& _apiRedirectTo,
            const OptionalURIParams& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalInputStreamParams& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const uint16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowPipelining,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const OptionalFileDescriptorSet& _fds,
            const OptionalLoadInfoArgs& _loadInfo,
            const OptionalHttpResponseHead& _synthesizedResponseHead,
            const uint32_t& _cacheKey,
            const nsCString& _schedulingContextID);

    URIParams uri_;
    OptionalURIParams original_;
    OptionalURIParams doc_;
    OptionalURIParams referrer_;
    uint32_t referrerPolicy_;
    OptionalURIParams apiRedirectTo_;
    OptionalURIParams topWindowURI_;
    uint32_t loadFlags_;
    RequestHeaderTuples requestHeaders_;
    nsCString requestMethod_;
    OptionalInputStreamParams uploadStream_;
    bool uploadStreamHasHeaders_;
    uint16_t priority_;
    uint32_t classOfService_;
    uint8_t redirectionLimit_;
    bool allowPipelining_;
    bool allowSTS_;
    uint32_t thirdPartyFlags_;
    bool resumeAt_;
    uint64_t startPos_;
    nsCString entityID_;
    bool chooseApplicationCache_;
    nsCString appCacheClientID_;
    bool allowSpdy_;
    bool allowAltSvc_;
    OptionalFileDescriptorSet fds_;
    OptionalLoadInfoArgs loadInfo_;
    OptionalHttpResponseHead synthesizedResponseHead_;
    uint32_t cacheKey_;
    nsCString schedulingContextID_;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelConnectArgs|
//
namespace mozilla {
namespace net {
class HttpChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT HttpChannelConnectArgs();

    MOZ_IMPLICIT HttpChannelConnectArgs(
            const uint32_t& _channelId,
            const bool& _shouldIntercept)
    {
        Init();
        Assign(_channelId, _shouldIntercept);
    }

    MOZ_IMPLICIT HttpChannelConnectArgs(const HttpChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).channelId(), (_o).shouldIntercept());
    }

    ~HttpChannelConnectArgs();

    void
    operator=(const HttpChannelConnectArgs& _o)
    {
        Assign((_o).channelId(), (_o).shouldIntercept());
    }

    bool
    operator==(const HttpChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

    bool&
    shouldIntercept()
    {
        return shouldIntercept_;
    }
    const bool&
    shouldIntercept() const
    {
        return shouldIntercept_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _channelId,
            const bool& _shouldIntercept);

    uint32_t channelId_;
    bool shouldIntercept_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class HttpChannelOpenArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class HttpChannelConnectArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpChannelCreationArgs|
//
namespace mozilla {
namespace net {
class HttpChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelOpenArgs = 1,
        THttpChannelConnectArgs,
        T__Last = THttpChannelConnectArgs
    };

private:
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef HttpChannelOpenArgs HttpChannelOpenArgs__tdef;
    typedef HttpChannelConnectArgs HttpChannelConnectArgs__tdef;

    union Value {
        char VHttpChannelOpenArgs[sizeof(HttpChannelOpenArgs)];
        char VHttpChannelConnectArgs[sizeof(HttpChannelConnectArgs)];
    };

    HttpChannelOpenArgs*
    ptr_HttpChannelOpenArgs()
    {
        return reinterpret_cast<HttpChannelOpenArgs*>((&((mValue).VHttpChannelOpenArgs)));
    }
    const HttpChannelOpenArgs* const
    constptr_HttpChannelOpenArgs() const
    {
        return reinterpret_cast<const HttpChannelOpenArgs* const>((&((mValue).VHttpChannelOpenArgs)));
    }
    HttpChannelConnectArgs*
    ptr_HttpChannelConnectArgs()
    {
        return reinterpret_cast<HttpChannelConnectArgs*>((&((mValue).VHttpChannelConnectArgs)));
    }
    const HttpChannelConnectArgs* const
    constptr_HttpChannelConnectArgs() const
    {
        return reinterpret_cast<const HttpChannelConnectArgs* const>((&((mValue).VHttpChannelConnectArgs)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelOpenArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelConnectArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelCreationArgs& aOther);

    ~HttpChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpChannelCreationArgs&
    operator=(const HttpChannelOpenArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelConnectArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelCreationArgs& aRhs);

    bool
    operator==(const HttpChannelOpenArgs& aRhs) const;

    bool
    operator==(const HttpChannelConnectArgs& aRhs) const;

    bool
    operator==(const HttpChannelCreationArgs& aRhs) const;

    HttpChannelOpenArgs&
    get_HttpChannelOpenArgs()
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(ptr_HttpChannelOpenArgs()));
    }
    const HttpChannelOpenArgs&
    get_HttpChannelOpenArgs() const
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(constptr_HttpChannelOpenArgs()));
    }
    operator HttpChannelOpenArgs&()
    {
        return get_HttpChannelOpenArgs();
    }
    operator const HttpChannelOpenArgs&() const
    {
        return get_HttpChannelOpenArgs();
    }

    HttpChannelConnectArgs&
    get_HttpChannelConnectArgs()
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(ptr_HttpChannelConnectArgs()));
    }
    const HttpChannelConnectArgs&
    get_HttpChannelConnectArgs() const
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(constptr_HttpChannelConnectArgs()));
    }
    operator HttpChannelConnectArgs&()
    {
        return get_HttpChannelConnectArgs();
    }
    operator const HttpChannelConnectArgs&() const
    {
        return get_HttpChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace net {
class OptionalLoadInfoArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelOpenArgs|
//
namespace mozilla {
namespace net {
class FTPChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;

public:
    MOZ_IMPLICIT FTPChannelOpenArgs();

    MOZ_IMPLICIT FTPChannelOpenArgs(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalInputStreamParams& _uploadStream,
            const OptionalLoadInfoArgs& _loadInfo)
    {
        Init();
        Assign(_uri, _startPos, _entityID, _uploadStream, _loadInfo);
    }

    MOZ_IMPLICIT FTPChannelOpenArgs(const FTPChannelOpenArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).startPos(), (_o).entityID(), (_o).uploadStream(), (_o).loadInfo());
    }

    ~FTPChannelOpenArgs();

    void
    operator=(const FTPChannelOpenArgs& _o)
    {
        Assign((_o).uri(), (_o).startPos(), (_o).entityID(), (_o).uploadStream(), (_o).loadInfo());
    }

    bool
    operator==(const FTPChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    OptionalInputStreamParams&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalInputStreamParams&
    uploadStream() const
    {
        return uploadStream_;
    }

    OptionalLoadInfoArgs&
    loadInfo()
    {
        return loadInfo_;
    }
    const OptionalLoadInfoArgs&
    loadInfo() const
    {
        return loadInfo_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalInputStreamParams& _uploadStream,
            const OptionalLoadInfoArgs& _loadInfo);

    URIParams uri_;
    uint64_t startPos_;
    nsCString entityID_;
    OptionalInputStreamParams uploadStream_;
    OptionalLoadInfoArgs loadInfo_;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelConnectArgs|
//
namespace mozilla {
namespace net {
class FTPChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT FTPChannelConnectArgs();

    MOZ_IMPLICIT FTPChannelConnectArgs(const uint32_t& _channelId)
    {
        Init();
        Assign(_channelId);
    }

    MOZ_IMPLICIT FTPChannelConnectArgs(const FTPChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).channelId());
    }

    ~FTPChannelConnectArgs();

    void
    operator=(const FTPChannelConnectArgs& _o)
    {
        Assign((_o).channelId());
    }

    bool
    operator==(const FTPChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    void
    Init();

    void
    Assign(const uint32_t& _channelId);

    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class FTPChannelOpenArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class FTPChannelConnectArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FTPChannelCreationArgs|
//
namespace mozilla {
namespace net {
class FTPChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        TFTPChannelOpenArgs = 1,
        TFTPChannelConnectArgs,
        T__Last = TFTPChannelConnectArgs
    };

private:
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef FTPChannelOpenArgs FTPChannelOpenArgs__tdef;
    typedef FTPChannelConnectArgs FTPChannelConnectArgs__tdef;

    union Value {
        char VFTPChannelOpenArgs[sizeof(FTPChannelOpenArgs)];
        char VFTPChannelConnectArgs[sizeof(FTPChannelConnectArgs)];
    };

    FTPChannelOpenArgs*
    ptr_FTPChannelOpenArgs()
    {
        return reinterpret_cast<FTPChannelOpenArgs*>((&((mValue).VFTPChannelOpenArgs)));
    }
    const FTPChannelOpenArgs* const
    constptr_FTPChannelOpenArgs() const
    {
        return reinterpret_cast<const FTPChannelOpenArgs* const>((&((mValue).VFTPChannelOpenArgs)));
    }
    FTPChannelConnectArgs*
    ptr_FTPChannelConnectArgs()
    {
        return reinterpret_cast<FTPChannelConnectArgs*>((&((mValue).VFTPChannelConnectArgs)));
    }
    const FTPChannelConnectArgs* const
    constptr_FTPChannelConnectArgs() const
    {
        return reinterpret_cast<const FTPChannelConnectArgs* const>((&((mValue).VFTPChannelConnectArgs)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FTPChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelOpenArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelConnectArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelCreationArgs& aOther);

    ~FTPChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    FTPChannelCreationArgs&
    operator=(const FTPChannelOpenArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelConnectArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelCreationArgs& aRhs);

    bool
    operator==(const FTPChannelOpenArgs& aRhs) const;

    bool
    operator==(const FTPChannelConnectArgs& aRhs) const;

    bool
    operator==(const FTPChannelCreationArgs& aRhs) const;

    FTPChannelOpenArgs&
    get_FTPChannelOpenArgs()
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(ptr_FTPChannelOpenArgs()));
    }
    const FTPChannelOpenArgs&
    get_FTPChannelOpenArgs() const
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(constptr_FTPChannelOpenArgs()));
    }
    operator FTPChannelOpenArgs&()
    {
        return get_FTPChannelOpenArgs();
    }
    operator const FTPChannelOpenArgs&() const
    {
        return get_FTPChannelOpenArgs();
    }

    FTPChannelConnectArgs&
    get_FTPChannelConnectArgs()
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(ptr_FTPChannelConnectArgs()));
    }
    const FTPChannelConnectArgs&
    get_FTPChannelConnectArgs() const
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(constptr_FTPChannelConnectArgs()));
    }
    operator FTPChannelConnectArgs&()
    {
        return get_FTPChannelConnectArgs();
    }
    operator const FTPChannelConnectArgs&() const
    {
        return get_FTPChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class HttpChannelDiverterArgs final
{
private:
    typedef mozilla::net::PHttpChannelParent PHttpChannelParent;
    typedef mozilla::net::PHttpChannelChild PHttpChannelChild;

public:
    MOZ_IMPLICIT HttpChannelDiverterArgs();

    MOZ_IMPLICIT HttpChannelDiverterArgs(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion)
    {
        Init();
        Assign(_mChannelParent, _mChannelChild, _mApplyConversion);
    }

    MOZ_IMPLICIT HttpChannelDiverterArgs(const HttpChannelDiverterArgs& _o)
    {
        Init();
        Assign(const_cast<PHttpChannelParent*>((_o).mChannelParent()), const_cast<PHttpChannelChild*>((_o).mChannelChild()), (_o).mApplyConversion());
    }

    ~HttpChannelDiverterArgs();

    void
    operator=(const HttpChannelDiverterArgs& _o)
    {
        Assign(const_cast<PHttpChannelParent*>((_o).mChannelParent()), const_cast<PHttpChannelChild*>((_o).mChannelChild()), (_o).mApplyConversion());
    }

    bool
    operator==(const HttpChannelDiverterArgs& _o) const;

    PHttpChannelParent*&
    mChannelParent()
    {
        return mChannelParent_;
    }
    PHttpChannelParent*
    mChannelParent() const
    {
        return mChannelParent_;
    }

    PHttpChannelChild*&
    mChannelChild()
    {
        return mChannelChild_;
    }
    PHttpChannelChild*
    mChannelChild() const
    {
        return mChannelChild_;
    }

    bool&
    mApplyConversion()
    {
        return mApplyConversion_;
    }
    const bool&
    mApplyConversion() const
    {
        return mApplyConversion_;
    }

private:
    void
    Init();

    void
    Assign(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion);

    PHttpChannelParent* mChannelParent_;
    PHttpChannelChild* mChannelChild_;
    bool mApplyConversion_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class HttpChannelDiverterArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PFTPChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class ChannelDiverterArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelDiverterArgs = 1,
        TPFTPChannelParent,
        TPFTPChannelChild,
        T__Last = TPFTPChannelChild
    };

private:
    typedef mozilla::net::HttpChannelDiverterArgs HttpChannelDiverterArgs;
    typedef mozilla::net::PFTPChannelParent PFTPChannelParent;
    typedef mozilla::net::PFTPChannelChild PFTPChannelChild;
    typedef HttpChannelDiverterArgs HttpChannelDiverterArgs__tdef;
    typedef PFTPChannelParent* PFTPChannelParent__tdef;
    typedef PFTPChannelChild* PFTPChannelChild__tdef;

    union Value {
        char VHttpChannelDiverterArgs[sizeof(HttpChannelDiverterArgs)];
        char VPFTPChannelParent[sizeof(PFTPChannelParent*)];
        char VPFTPChannelChild[sizeof(PFTPChannelChild*)];
    };

    HttpChannelDiverterArgs*
    ptr_HttpChannelDiverterArgs()
    {
        return reinterpret_cast<HttpChannelDiverterArgs*>((&((mValue).VHttpChannelDiverterArgs)));
    }
    const HttpChannelDiverterArgs* const
    constptr_HttpChannelDiverterArgs() const
    {
        return reinterpret_cast<const HttpChannelDiverterArgs* const>((&((mValue).VHttpChannelDiverterArgs)));
    }
    PFTPChannelParent**
    ptr_PFTPChannelParent()
    {
        return reinterpret_cast<PFTPChannelParent**>((&((mValue).VPFTPChannelParent)));
    }
    PFTPChannelParent* const*
    constptr_PFTPChannelParent() const
    {
        return reinterpret_cast<PFTPChannelParent* const*>((&((mValue).VPFTPChannelParent)));
    }
    PFTPChannelChild**
    ptr_PFTPChannelChild()
    {
        return reinterpret_cast<PFTPChannelChild**>((&((mValue).VPFTPChannelChild)));
    }
    PFTPChannelChild* const*
    constptr_PFTPChannelChild() const
    {
        return reinterpret_cast<PFTPChannelChild* const*>((&((mValue).VPFTPChannelChild)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ChannelDiverterArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ChannelDiverterArgs(const HttpChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(const ChannelDiverterArgs& aOther);

    ~ChannelDiverterArgs();

    Type
    type() const
    {
        return mType;
    }

    ChannelDiverterArgs&
    operator=(const HttpChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(const ChannelDiverterArgs& aRhs);

    bool
    operator==(const HttpChannelDiverterArgs& aRhs) const;

    bool
    operator==(PFTPChannelParent* aRhs) const;

    bool
    operator==(PFTPChannelChild* aRhs) const;

    bool
    operator==(const ChannelDiverterArgs& aRhs) const;

    HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs()
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(ptr_HttpChannelDiverterArgs()));
    }
    const HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs() const
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(constptr_HttpChannelDiverterArgs()));
    }
    operator HttpChannelDiverterArgs&()
    {
        return get_HttpChannelDiverterArgs();
    }
    operator const HttpChannelDiverterArgs&() const
    {
        return get_HttpChannelDiverterArgs();
    }

    PFTPChannelParent*&
    get_PFTPChannelParent()
    {
        AssertSanity(TPFTPChannelParent);
        return (*(ptr_PFTPChannelParent()));
    }
    PFTPChannelParent*
    get_PFTPChannelParent() const
    {
        AssertSanity(TPFTPChannelParent);
        return (*(constptr_PFTPChannelParent()));
    }
    operator PFTPChannelParent*&()
    {
        return get_PFTPChannelParent();
    }
    operator PFTPChannelParent*() const
    {
        return get_PFTPChannelParent();
    }

    PFTPChannelChild*&
    get_PFTPChannelChild()
    {
        AssertSanity(TPFTPChannelChild);
        return (*(ptr_PFTPChannelChild()));
    }
    PFTPChannelChild*
    get_PFTPChannelChild() const
    {
        AssertSanity(TPFTPChannelChild);
        return (*(constptr_PFTPChannelChild()));
    }
    operator PFTPChannelChild*&()
    {
        return get_PFTPChannelChild();
    }
    operator PFTPChannelChild*() const
    {
        return get_PFTPChannelChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RtspChannelConnectArgs|
//
namespace mozilla {
namespace net {
class RtspChannelConnectArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;

public:
    MOZ_IMPLICIT RtspChannelConnectArgs();

    MOZ_IMPLICIT RtspChannelConnectArgs(
            const URIParams& _uri,
            const uint32_t& _channelId)
    {
        Init();
        Assign(_uri, _channelId);
    }

    MOZ_IMPLICIT RtspChannelConnectArgs(const RtspChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).channelId());
    }

    ~RtspChannelConnectArgs();

    void
    operator=(const RtspChannelConnectArgs& _o)
    {
        Assign((_o).uri(), (_o).channelId());
    }

    bool
    operator==(const RtspChannelConnectArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const uint32_t& _channelId);

    URIParams uri_;
    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

#endif // ifndef NeckoChannelParams_h
