//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCookieServiceParent_h
#define PCookieServiceParent_h

#include "mozilla/net/PCookieService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace IPC {
class SerializedLoadContext;
} // namespace IPC

namespace mozilla {
namespace net {


class PCookieServiceParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::HostObjectURIParams HostObjectURIParams;
    typedef mozilla::ipc::IconURIParams IconURIParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::JSURIParams JSURIParams;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::NullPrincipalURIParams NullPrincipalURIParams;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef IPC::SerializedLoadContext SerializedLoadContext;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleNestedURIParams SimpleNestedURIParams;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PCookieService::State State;

    virtual bool
    RecvGetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const bool& fromHttp,
            const SerializedLoadContext& loadContext,
            nsCString* result) = 0;
    virtual bool
    RecvSetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const nsCString& cookieString,
            const nsCString& serverTime,
            const bool& fromHttp,
            const SerializedLoadContext& loadContext) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PCookieServiceParent();

    virtual ~PCookieServiceParent();

    PNeckoParent*
    Manager() const;

    PCookieService::State
    state();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SystemPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SystemPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<PrincipalInfo>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<PrincipalInfo>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const NullPrincipalURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            NullPrincipalURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const IconURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            IconURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const ExpandedPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            ExpandedPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const StandardURLParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            StandardURLParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SimpleNestedURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SimpleNestedURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const OptionalURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            OptionalURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const PrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const OptionalPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            OptionalPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const JARURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            JARURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const ContentPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            ContentPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const JSURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            JSURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const NullPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            NullPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const StandardURLSegment& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            StandardURLSegment* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const URIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            URIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const HostObjectURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            HostObjectURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SimpleURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SimpleURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PCookieServiceParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PCookieServiceParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class CookieServiceParent :
    public PCookieServiceParent
{
    virtual bool
    RecvGetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const bool& fromHttp,
            const SerializedLoadContext& loadContext,
            nsCString* result);

    virtual bool
    RecvSetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const nsCString& cookieString,
            const nsCString& serverTime,
            const bool& fromHttp,
            const SerializedLoadContext& loadContext);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT CookieServiceParent();
    virtual ~CookieServiceParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
CookieServiceParent::RecvGetCookieString(
        const URIParams& host,
        const bool& isForeign,
        const bool& fromHttp,
        const SerializedLoadContext& loadContext,
        nsCString* result)
{
    return false;
}

bool
CookieServiceParent::RecvSetCookieString(
        const URIParams& host,
        const bool& isForeign,
        const nsCString& cookieString,
        const nsCString& serverTime,
        const bool& fromHttp,
        const SerializedLoadContext& loadContext)
{
    return false;
}

void
CookieServiceParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT CookieServiceParent::CookieServiceParent()
{
    MOZ_COUNT_CTOR(CookieServiceParent);
}

MOZ_IMPLICIT CookieServiceParent::~CookieServiceParent()
{
    MOZ_COUNT_DTOR(CookieServiceParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PCookieServiceParent_h
