//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRtspControllerChild_h
#define PRtspControllerChild_h

#include "mozilla/net/PRtspController.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class PRtspControllerChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::HostObjectURIParams HostObjectURIParams;
    typedef mozilla::ipc::IconURIParams IconURIParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::JSURIParams JSURIParams;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::NullPrincipalURIParams NullPrincipalURIParams;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::net::RtspMetaValue RtspMetaValue;
    typedef mozilla::net::RtspMetadataParam RtspMetadataParam;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleNestedURIParams SimpleNestedURIParams;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::net::PNeckoParent PNeckoParent;

    typedef PRtspController::State State;

    virtual bool
    RecvOnMediaDataAvailable(
            const uint8_t& index,
            const nsCString& data,
            const uint32_t& length,
            const uint32_t& offset,
            nsTArray<RtspMetadataParam>&& meta) = 0;
    virtual bool
    RecvOnConnected(
            const uint8_t& index,
            nsTArray<RtspMetadataParam>&& meta) = 0;
    virtual bool
    RecvOnDisconnected(
            const uint8_t& index,
            const nsresult& reason) = 0;
    virtual bool
    RecvAsyncOpenFailed(const nsresult& reason) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PRtspControllerChild();

    virtual ~PRtspControllerChild();

    PNeckoChild*
    Manager() const;

    PRtspController::State
    state();

    bool
    SendAsyncOpen(const URIParams& aURI);

    bool
    SendPlay();

    bool
    SendPause();

    bool
    SendResume();

    bool
    SendSuspend();

    bool
    SendSeek(const uint64_t& offset);

    bool
    SendStop();

    bool
    SendPlaybackEnded();

    static bool
    Send__delete__(PRtspControllerChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SystemPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SystemPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<PrincipalInfo>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<PrincipalInfo>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const OptionalURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            OptionalURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const StandardURLParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            StandardURLParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const URIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            URIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const RtspMetaValue& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            RtspMetaValue* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<RtspMetadataParam>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<RtspMetadataParam>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SimpleNestedURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SimpleNestedURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const OptionalPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            OptionalPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const ExpandedPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            ExpandedPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const HostObjectURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            HostObjectURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const PrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PRtspControllerChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PRtspControllerChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const ContentPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            ContentPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const SimpleURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SimpleURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const NullPrincipalURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            NullPrincipalURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const IconURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            IconURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const JARURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            JARURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const RtspMetadataParam& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            RtspMetadataParam* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const JSURIParams& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            JSURIParams* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const NullPrincipalInfo& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            NullPrincipalInfo* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const StandardURLSegment& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            StandardURLSegment* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class RtspControllerChild :
    public PRtspControllerChild
{
    virtual bool
    RecvOnMediaDataAvailable(
            const uint8_t& index,
            const nsCString& data,
            const uint32_t& length,
            const uint32_t& offset,
            nsTArray<RtspMetadataParam>&& meta);

    virtual bool
    RecvOnConnected(
            const uint8_t& index,
            nsTArray<RtspMetadataParam>&& meta);

    virtual bool
    RecvOnDisconnected(
            const uint8_t& index,
            const nsresult& reason);

    virtual bool
    RecvAsyncOpenFailed(const nsresult& reason);

    MOZ_IMPLICIT RtspControllerChild();
    virtual ~RtspControllerChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
RtspControllerChild::RecvOnMediaDataAvailable(
        const uint8_t& index,
        const nsCString& data,
        const uint32_t& length,
        const uint32_t& offset,
        nsTArray<RtspMetadataParam>&& meta)
{
    return false;
}

bool
RtspControllerChild::RecvOnConnected(
        const uint8_t& index,
        nsTArray<RtspMetadataParam>&& meta)
{
    return false;
}

bool
RtspControllerChild::RecvOnDisconnected(
        const uint8_t& index,
        const nsresult& reason)
{
    return false;
}

bool
RtspControllerChild::RecvAsyncOpenFailed(const nsresult& reason)
{
    return false;
}

MOZ_IMPLICIT RtspControllerChild::RtspControllerChild()
{
    MOZ_COUNT_CTOR(RtspControllerChild);
}

MOZ_IMPLICIT RtspControllerChild::~RtspControllerChild()
{
    MOZ_COUNT_DTOR(RtspControllerChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PRtspControllerChild_h
