//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTCPSocketParent_h
#define PTCPSocketParent_h

#include "mozilla/net/PTCPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/NeckoMessageUtils.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PTCPServerSocketParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class PTCPSocketParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PTCPServerSocketParent;

    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PTCPSocket::State State;

    virtual bool
    RecvOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const nsString& binaryType) = 0;
    virtual bool
    RecvData(
            const SendableData& data,
            const uint32_t& trackingNumber) = 0;
    virtual bool
    RecvStartTLS() = 0;
    virtual bool
    RecvSuspend() = 0;
    virtual bool
    RecvResume() = 0;
    virtual bool
    RecvClose() = 0;
    virtual bool
    RecvRequestDelete() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PTCPSocketParent();

    virtual ~PTCPSocketParent();

    PNeckoParent*
    Manager() const;

    PTCPSocket::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendCallback(
            const nsString& type,
            const CallbackData& data,
            const nsString& readyState);

    MOZ_WARN_UNUSED_RESULT bool
    SendUpdateBufferedAmount(
            const uint32_t& bufferedAmount,
            const uint32_t& trackingNumber);

    MOZ_WARN_UNUSED_RESULT bool
    SendRequestDelete();

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(PTCPSocketParent* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SendableData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            SendableData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PTCPSocketParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PTCPSocketParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const CallbackData& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            CallbackData* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const TCPError& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            TCPError* v__,
            const Message* msg__,
            void** iter__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class TCPSocketParent :
    public PTCPSocketParent
{
    virtual bool
    RecvOpen(
            const nsString& host,
            const uint16_t& port,
            const bool& useSSL,
            const nsString& binaryType);

    virtual bool
    RecvData(
            const SendableData& data,
            const uint32_t& trackingNumber);

    virtual bool
    RecvStartTLS();

    virtual bool
    RecvSuspend();

    virtual bool
    RecvResume();

    virtual bool
    RecvClose();

    virtual bool
    RecvRequestDelete();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT TCPSocketParent();
    virtual ~TCPSocketParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
TCPSocketParent::RecvOpen(
        const nsString& host,
        const uint16_t& port,
        const bool& useSSL,
        const nsString& binaryType)
{
    return false;
}

bool
TCPSocketParent::RecvData(
        const SendableData& data,
        const uint32_t& trackingNumber)
{
    return false;
}

bool
TCPSocketParent::RecvStartTLS()
{
    return false;
}

bool
TCPSocketParent::RecvSuspend()
{
    return false;
}

bool
TCPSocketParent::RecvResume()
{
    return false;
}

bool
TCPSocketParent::RecvClose()
{
    return false;
}

bool
TCPSocketParent::RecvRequestDelete()
{
    return false;
}

void
TCPSocketParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT TCPSocketParent::TCPSocketParent()
{
    MOZ_COUNT_CTOR(TCPSocketParent);
}

MOZ_IMPLICIT TCPSocketParent::~TCPSocketParent()
{
    MOZ_COUNT_DTOR(TCPSocketParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PTCPSocketParent_h
