//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPSMContentDownloaderParent_h
#define PPSMContentDownloaderParent_h

#include "mozilla/psm/PPSMContentDownloader.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PChannelDiverterParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PChannelDiverterChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace psm {


class PPSMContentDownloaderParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::net::PChannelDiverterParent PChannelDiverterParent;
    typedef mozilla::net::PChannelDiverterChild PChannelDiverterChild;

    typedef PPSMContentDownloader::State State;

    virtual bool
    RecvOnStartRequest(const uint32_t& contentLength) = 0;
    virtual bool
    RecvOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) = 0;
    virtual bool
    RecvOnStopRequest(const nsresult& code) = 0;
    virtual bool
    RecvDivertToParentUsing(PChannelDiverterParent* diverter) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PPSMContentDownloaderParent();

    virtual ~PPSMContentDownloaderParent();

    PContentParent*
    Manager() const;

    PPSMContentDownloader::State
    state();

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(PPSMContentDownloaderParent* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PPSMContentDownloaderParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PPSMContentDownloaderParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            PChannelDiverterParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PChannelDiverterParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace psm
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace psm {
class PSMContentDownloaderParent :
    public PPSMContentDownloaderParent
{
    virtual bool
    RecvOnStartRequest(const uint32_t& contentLength);

    virtual bool
    RecvOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count);

    virtual bool
    RecvOnStopRequest(const nsresult& code);

    virtual bool
    RecvDivertToParentUsing(PChannelDiverterParent* diverter);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT PSMContentDownloaderParent();
    virtual ~PSMContentDownloaderParent();
};
} // namespace psm
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace psm {
bool
PSMContentDownloaderParent::RecvOnStartRequest(const uint32_t& contentLength)
{
    return false;
}

bool
PSMContentDownloaderParent::RecvOnDataAvailable(
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count)
{
    return false;
}

bool
PSMContentDownloaderParent::RecvOnStopRequest(const nsresult& code)
{
    return false;
}

bool
PSMContentDownloaderParent::RecvDivertToParentUsing(PChannelDiverterParent* diverter)
{
    return false;
}

void
PSMContentDownloaderParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT PSMContentDownloaderParent::PSMContentDownloaderParent()
{
    MOZ_COUNT_CTOR(PSMContentDownloaderParent);
}

MOZ_IMPLICIT PSMContentDownloaderParent::~PSMContentDownloaderParent()
{
    MOZ_COUNT_DTOR(PSMContentDownloaderParent);
}

} // namespace psm
} // namespace mozilla
#endif // if 0

#endif // ifndef PPSMContentDownloaderParent_h
