//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LayersMessages_h
#define LayersMessages_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/nsRefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "FrameMetrics.h"
#include "Units.h"
#include "gfxColor.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/WidgetUtils.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "mozilla/gfx/Matrix.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/layers/CompositorTypes.h"
#include "mozilla/layers/FenceUtils.h"
#include "mozilla/layers/LayersTypes.h"
#include "nsCSSProperty.h"
#include "nsCoord.h"
#include "nsPoint.h"
#include "nsRect.h"
#include "string"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TargetConfig|
//
namespace mozilla {
namespace layers {
class TargetConfig final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::ScreenRotation ScreenRotation;
    typedef mozilla::dom::ScreenOrientation ScreenOrientation;

public:
    MOZ_IMPLICIT TargetConfig();

    MOZ_IMPLICIT TargetConfig(
            const IntRect& _naturalBounds,
            const ScreenRotation& _rotation,
            const ScreenOrientation& _orientation,
            const nsIntRegion& _clearRegion)
    {
        Init();
        Assign(_naturalBounds, _rotation, _orientation, _clearRegion);
    }

    MOZ_IMPLICIT TargetConfig(const TargetConfig& _o)
    {
        Init();
        Assign((_o).naturalBounds(), (_o).rotation(), (_o).orientation(), (_o).clearRegion());
    }

    ~TargetConfig();

    void
    operator=(const TargetConfig& _o)
    {
        Assign((_o).naturalBounds(), (_o).rotation(), (_o).orientation(), (_o).clearRegion());
    }

    bool
    operator==(const TargetConfig& _o) const;

    IntRect&
    naturalBounds()
    {
        return naturalBounds_;
    }
    const IntRect&
    naturalBounds() const
    {
        return naturalBounds_;
    }

    ScreenRotation&
    rotation()
    {
        return rotation_;
    }
    const ScreenRotation&
    rotation() const
    {
        return rotation_;
    }

    ScreenOrientation&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientation&
    orientation() const
    {
        return orientation_;
    }

    nsIntRegion&
    clearRegion()
    {
        return clearRegion_;
    }
    const nsIntRegion&
    clearRegion() const
    {
        return clearRegion_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntRect& _naturalBounds,
            const ScreenRotation& _rotation,
            const ScreenOrientation& _orientation,
            const nsIntRegion& _clearRegion);

    IntRect naturalBounds_;
    ScreenRotation rotation_;
    ScreenOrientation orientation_;
    nsIntRegion clearRegion_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreatePaintedLayer|
//
namespace mozilla {
namespace layers {
class OpCreatePaintedLayer final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpCreatePaintedLayer();

    MOZ_IMPLICIT OpCreatePaintedLayer(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild)
    {
        Init();
        Assign(_layerParent, _layerChild);
    }

    MOZ_IMPLICIT OpCreatePaintedLayer(const OpCreatePaintedLayer& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    ~OpCreatePaintedLayer();

    void
    operator=(const OpCreatePaintedLayer& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    bool
    operator==(const OpCreatePaintedLayer& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateContainerLayer|
//
namespace mozilla {
namespace layers {
class OpCreateContainerLayer final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpCreateContainerLayer();

    MOZ_IMPLICIT OpCreateContainerLayer(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild)
    {
        Init();
        Assign(_layerParent, _layerChild);
    }

    MOZ_IMPLICIT OpCreateContainerLayer(const OpCreateContainerLayer& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    ~OpCreateContainerLayer();

    void
    operator=(const OpCreateContainerLayer& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    bool
    operator==(const OpCreateContainerLayer& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateImageLayer|
//
namespace mozilla {
namespace layers {
class OpCreateImageLayer final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpCreateImageLayer();

    MOZ_IMPLICIT OpCreateImageLayer(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild)
    {
        Init();
        Assign(_layerParent, _layerChild);
    }

    MOZ_IMPLICIT OpCreateImageLayer(const OpCreateImageLayer& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    ~OpCreateImageLayer();

    void
    operator=(const OpCreateImageLayer& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    bool
    operator==(const OpCreateImageLayer& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateColorLayer|
//
namespace mozilla {
namespace layers {
class OpCreateColorLayer final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpCreateColorLayer();

    MOZ_IMPLICIT OpCreateColorLayer(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild)
    {
        Init();
        Assign(_layerParent, _layerChild);
    }

    MOZ_IMPLICIT OpCreateColorLayer(const OpCreateColorLayer& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    ~OpCreateColorLayer();

    void
    operator=(const OpCreateColorLayer& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    bool
    operator==(const OpCreateColorLayer& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateCanvasLayer|
//
namespace mozilla {
namespace layers {
class OpCreateCanvasLayer final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpCreateCanvasLayer();

    MOZ_IMPLICIT OpCreateCanvasLayer(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild)
    {
        Init();
        Assign(_layerParent, _layerChild);
    }

    MOZ_IMPLICIT OpCreateCanvasLayer(const OpCreateCanvasLayer& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    ~OpCreateCanvasLayer();

    void
    operator=(const OpCreateCanvasLayer& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    bool
    operator==(const OpCreateCanvasLayer& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpCreateRefLayer|
//
namespace mozilla {
namespace layers {
class OpCreateRefLayer final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpCreateRefLayer();

    MOZ_IMPLICIT OpCreateRefLayer(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild)
    {
        Init();
        Assign(_layerParent, _layerChild);
    }

    MOZ_IMPLICIT OpCreateRefLayer(const OpCreateRefLayer& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    ~OpCreateRefLayer();

    void
    operator=(const OpCreateRefLayer& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()));
    }

    bool
    operator==(const OpCreateRefLayer& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAttachCompositable|
//
namespace mozilla {
namespace layers {
class OpAttachCompositable final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;

public:
    MOZ_IMPLICIT OpAttachCompositable();

    MOZ_IMPLICIT OpAttachCompositable(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild,
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild)
    {
        Init();
        Assign(_layerParent, _layerChild, _compositableParent, _compositableChild);
    }

    MOZ_IMPLICIT OpAttachCompositable(const OpAttachCompositable& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()), const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()));
    }

    ~OpAttachCompositable();

    void
    operator=(const OpAttachCompositable& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()), const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()));
    }

    bool
    operator==(const OpAttachCompositable& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild,
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAttachAsyncCompositable|
//
namespace mozilla {
namespace layers {
class OpAttachAsyncCompositable final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpAttachAsyncCompositable();

    MOZ_IMPLICIT OpAttachAsyncCompositable(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild,
            const uint64_t& _containerID)
    {
        Init();
        Assign(_layerParent, _layerChild, _containerID);
    }

    MOZ_IMPLICIT OpAttachAsyncCompositable(const OpAttachAsyncCompositable& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()), (_o).containerID());
    }

    ~OpAttachAsyncCompositable();

    void
    operator=(const OpAttachAsyncCompositable& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()), (_o).containerID());
    }

    bool
    operator==(const OpAttachAsyncCompositable& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

    uint64_t&
    containerID()
    {
        return containerID_;
    }
    const uint64_t&
    containerID() const
    {
        return containerID_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild,
            const uint64_t& _containerID);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
    uint64_t containerID_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ThebesBufferData|
//
namespace mozilla {
namespace layers {
class ThebesBufferData final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::gfx::IntPoint IntPoint;

public:
    MOZ_IMPLICIT ThebesBufferData();

    MOZ_IMPLICIT ThebesBufferData(
            const IntRect& _rect,
            const IntPoint& _rotation)
    {
        Init();
        Assign(_rect, _rotation);
    }

    MOZ_IMPLICIT ThebesBufferData(const ThebesBufferData& _o)
    {
        Init();
        Assign((_o).rect(), (_o).rotation());
    }

    ~ThebesBufferData();

    void
    operator=(const ThebesBufferData& _o)
    {
        Assign((_o).rect(), (_o).rotation());
    }

    bool
    operator==(const ThebesBufferData& _o) const;

    IntRect&
    rect()
    {
        return rect_;
    }
    const IntRect&
    rect() const
    {
        return rect_;
    }

    IntPoint&
    rotation()
    {
        return rotation_;
    }
    const IntPoint&
    rotation() const
    {
        return rotation_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntRect& _rect,
            const IntPoint& _rotation);

    IntRect rect_;
    IntPoint rotation_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CubicBezierFunction|
//
namespace mozilla {
namespace layers {
class CubicBezierFunction final
{
private:

public:
    MOZ_IMPLICIT CubicBezierFunction();

    MOZ_IMPLICIT CubicBezierFunction(
            const float& _x1,
            const float& _y1,
            const float& _x2,
            const float& _y2)
    {
        Init();
        Assign(_x1, _y1, _x2, _y2);
    }

    MOZ_IMPLICIT CubicBezierFunction(const CubicBezierFunction& _o)
    {
        Init();
        Assign((_o).x1(), (_o).y1(), (_o).x2(), (_o).y2());
    }

    ~CubicBezierFunction();

    void
    operator=(const CubicBezierFunction& _o)
    {
        Assign((_o).x1(), (_o).y1(), (_o).x2(), (_o).y2());
    }

    bool
    operator==(const CubicBezierFunction& _o) const;

    float&
    x1()
    {
        return x1_;
    }
    const float&
    x1() const
    {
        return x1_;
    }

    float&
    y1()
    {
        return y1_;
    }
    const float&
    y1() const
    {
        return y1_;
    }

    float&
    x2()
    {
        return x2_;
    }
    const float&
    x2() const
    {
        return x2_;
    }

    float&
    y2()
    {
        return y2_;
    }
    const float&
    y2() const
    {
        return y2_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x1,
            const float& _y1,
            const float& _x2,
            const float& _y2);

    float x1_;
    float y1_;
    float x2_;
    float y2_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StepFunction|
//
namespace mozilla {
namespace layers {
class StepFunction final
{
private:

public:
    MOZ_IMPLICIT StepFunction();

    MOZ_IMPLICIT StepFunction(
            const int& _steps,
            const int& _type)
    {
        Init();
        Assign(_steps, _type);
    }

    MOZ_IMPLICIT StepFunction(const StepFunction& _o)
    {
        Init();
        Assign((_o).steps(), (_o).type());
    }

    ~StepFunction();

    void
    operator=(const StepFunction& _o)
    {
        Assign((_o).steps(), (_o).type());
    }

    bool
    operator==(const StepFunction& _o) const;

    int&
    steps()
    {
        return steps_;
    }
    const int&
    steps() const
    {
        return steps_;
    }

    int&
    type()
    {
        return type_;
    }
    const int&
    type() const
    {
        return type_;
    }

private:
    void
    Init();

    void
    Assign(
            const int& _steps,
            const int& _type);

    int steps_;
    int type_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CubicBezierFunction;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class StepFunction;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TimingFunction|
//
namespace mozilla {
namespace layers {
class TimingFunction final
{
public:
    enum Type {
        T__None,
        TCubicBezierFunction = 1,
        TStepFunction,
        T__Last = TStepFunction
    };

private:
    typedef mozilla::layers::CubicBezierFunction CubicBezierFunction;
    typedef mozilla::layers::StepFunction StepFunction;
    typedef CubicBezierFunction CubicBezierFunction__tdef;
    typedef StepFunction StepFunction__tdef;

    union Value {
        char VCubicBezierFunction[sizeof(CubicBezierFunction)];
        char VStepFunction[sizeof(StepFunction)];
    };

    CubicBezierFunction*
    ptr_CubicBezierFunction()
    {
        return reinterpret_cast<CubicBezierFunction*>((&((mValue).VCubicBezierFunction)));
    }
    const CubicBezierFunction* const
    constptr_CubicBezierFunction() const
    {
        return reinterpret_cast<const CubicBezierFunction* const>((&((mValue).VCubicBezierFunction)));
    }
    StepFunction*
    ptr_StepFunction()
    {
        return reinterpret_cast<StepFunction*>((&((mValue).VStepFunction)));
    }
    const StepFunction* const
    constptr_StepFunction() const
    {
        return reinterpret_cast<const StepFunction* const>((&((mValue).VStepFunction)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TimingFunction() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TimingFunction(const CubicBezierFunction& aOther);

    MOZ_IMPLICIT TimingFunction(const StepFunction& aOther);

    MOZ_IMPLICIT TimingFunction(const TimingFunction& aOther);

    ~TimingFunction();

    Type
    type() const
    {
        return mType;
    }

    TimingFunction&
    operator=(const CubicBezierFunction& aRhs);

    TimingFunction&
    operator=(const StepFunction& aRhs);

    TimingFunction&
    operator=(const TimingFunction& aRhs);

    bool
    operator==(const CubicBezierFunction& aRhs) const;

    bool
    operator==(const StepFunction& aRhs) const;

    bool
    operator==(const TimingFunction& aRhs) const;

    CubicBezierFunction&
    get_CubicBezierFunction()
    {
        AssertSanity(TCubicBezierFunction);
        return (*(ptr_CubicBezierFunction()));
    }
    const CubicBezierFunction&
    get_CubicBezierFunction() const
    {
        AssertSanity(TCubicBezierFunction);
        return (*(constptr_CubicBezierFunction()));
    }
    operator CubicBezierFunction&()
    {
        return get_CubicBezierFunction();
    }
    operator const CubicBezierFunction&() const
    {
        return get_CubicBezierFunction();
    }

    StepFunction&
    get_StepFunction()
    {
        AssertSanity(TStepFunction);
        return (*(ptr_StepFunction()));
    }
    const StepFunction&
    get_StepFunction() const
    {
        AssertSanity(TStepFunction);
        return (*(constptr_StepFunction()));
    }
    operator StepFunction&()
    {
        return get_StepFunction();
    }
    operator const StepFunction&() const
    {
        return get_StepFunction();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CSSAngle|
//
namespace mozilla {
namespace layers {
class CSSAngle final
{
private:

public:
    MOZ_IMPLICIT CSSAngle();

    MOZ_IMPLICIT CSSAngle(
            const float& _value,
            const int& _unit)
    {
        Init();
        Assign(_value, _unit);
    }

    MOZ_IMPLICIT CSSAngle(const CSSAngle& _o)
    {
        Init();
        Assign((_o).value(), (_o).unit());
    }

    ~CSSAngle();

    void
    operator=(const CSSAngle& _o)
    {
        Assign((_o).value(), (_o).unit());
    }

    bool
    operator==(const CSSAngle& _o) const;

    float&
    value()
    {
        return value_;
    }
    const float&
    value() const
    {
        return value_;
    }

    int&
    unit()
    {
        return unit_;
    }
    const int&
    unit() const
    {
        return unit_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _value,
            const int& _unit);

    float value_;
    int unit_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LayerColor|
//
namespace mozilla {
namespace layers {
class LayerColor final
{
private:

public:
    MOZ_IMPLICIT LayerColor();

    MOZ_IMPLICIT LayerColor(const gfxRGBA& _value)
    {
        Init();
        Assign(_value);
    }

    MOZ_IMPLICIT LayerColor(const LayerColor& _o)
    {
        Init();
        Assign((_o).value());
    }

    ~LayerColor();

    void
    operator=(const LayerColor& _o)
    {
        Assign((_o).value());
    }

    bool
    operator==(const LayerColor& _o) const;

    gfxRGBA&
    value()
    {
        return value_;
    }
    const gfxRGBA&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(const gfxRGBA& _value);

    gfxRGBA value_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Perspective|
//
namespace mozilla {
namespace layers {
class Perspective final
{
private:

public:
    MOZ_IMPLICIT Perspective();

    MOZ_IMPLICIT Perspective(const float& _value)
    {
        Init();
        Assign(_value);
    }

    MOZ_IMPLICIT Perspective(const Perspective& _o)
    {
        Init();
        Assign((_o).value());
    }

    ~Perspective();

    void
    operator=(const Perspective& _o)
    {
        Assign((_o).value());
    }

    bool
    operator==(const Perspective& _o) const;

    float&
    value()
    {
        return value_;
    }
    const float&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(const float& _value);

    float value_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RotationX|
//
namespace mozilla {
namespace layers {
class RotationX final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT RotationX();

    MOZ_IMPLICIT RotationX(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT RotationX(const RotationX& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~RotationX();

    void
    operator=(const RotationX& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const RotationX& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RotationY|
//
namespace mozilla {
namespace layers {
class RotationY final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT RotationY();

    MOZ_IMPLICIT RotationY(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT RotationY(const RotationY& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~RotationY();

    void
    operator=(const RotationY& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const RotationY& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RotationZ|
//
namespace mozilla {
namespace layers {
class RotationZ final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT RotationZ();

    MOZ_IMPLICIT RotationZ(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT RotationZ(const RotationZ& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~RotationZ();

    void
    operator=(const RotationZ& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const RotationZ& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Rotation|
//
namespace mozilla {
namespace layers {
class Rotation final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT Rotation();

    MOZ_IMPLICIT Rotation(const CSSAngle& _angle)
    {
        Init();
        Assign(_angle);
    }

    MOZ_IMPLICIT Rotation(const Rotation& _o)
    {
        Init();
        Assign((_o).angle());
    }

    ~Rotation();

    void
    operator=(const Rotation& _o)
    {
        Assign((_o).angle());
    }

    bool
    operator==(const Rotation& _o) const;

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _angle);

    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Rotation3D|
//
namespace mozilla {
namespace layers {
class Rotation3D final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT Rotation3D();

    MOZ_IMPLICIT Rotation3D(
            const float& _x,
            const float& _y,
            const float& _z,
            const CSSAngle& _angle)
    {
        Init();
        Assign(_x, _y, _z, _angle);
    }

    MOZ_IMPLICIT Rotation3D(const Rotation3D& _o)
    {
        Init();
        Assign((_o).x(), (_o).y(), (_o).z(), (_o).angle());
    }

    ~Rotation3D();

    void
    operator=(const Rotation3D& _o)
    {
        Assign((_o).x(), (_o).y(), (_o).z(), (_o).angle());
    }

    bool
    operator==(const Rotation3D& _o) const;

    float&
    x()
    {
        return x_;
    }
    const float&
    x() const
    {
        return x_;
    }

    float&
    y()
    {
        return y_;
    }
    const float&
    y() const
    {
        return y_;
    }

    float&
    z()
    {
        return z_;
    }
    const float&
    z() const
    {
        return z_;
    }

    CSSAngle&
    angle()
    {
        return angle_;
    }
    const CSSAngle&
    angle() const
    {
        return angle_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x,
            const float& _y,
            const float& _z,
            const CSSAngle& _angle);

    float x_;
    float y_;
    float z_;
    CSSAngle angle_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Scale|
//
namespace mozilla {
namespace layers {
class Scale final
{
private:

public:
    MOZ_IMPLICIT Scale();

    MOZ_IMPLICIT Scale(
            const float& _x,
            const float& _y,
            const float& _z)
    {
        Init();
        Assign(_x, _y, _z);
    }

    MOZ_IMPLICIT Scale(const Scale& _o)
    {
        Init();
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    ~Scale();

    void
    operator=(const Scale& _o)
    {
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    bool
    operator==(const Scale& _o) const;

    float&
    x()
    {
        return x_;
    }
    const float&
    x() const
    {
        return x_;
    }

    float&
    y()
    {
        return y_;
    }
    const float&
    y() const
    {
        return y_;
    }

    float&
    z()
    {
        return z_;
    }
    const float&
    z() const
    {
        return z_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x,
            const float& _y,
            const float& _z);

    float x_;
    float y_;
    float z_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Skew|
//
namespace mozilla {
namespace layers {
class Skew final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT Skew();

    MOZ_IMPLICIT Skew(
            const CSSAngle& _x,
            const CSSAngle& _y)
    {
        Init();
        Assign(_x, _y);
    }

    MOZ_IMPLICIT Skew(const Skew& _o)
    {
        Init();
        Assign((_o).x(), (_o).y());
    }

    ~Skew();

    void
    operator=(const Skew& _o)
    {
        Assign((_o).x(), (_o).y());
    }

    bool
    operator==(const Skew& _o) const;

    CSSAngle&
    x()
    {
        return x_;
    }
    const CSSAngle&
    x() const
    {
        return x_;
    }

    CSSAngle&
    y()
    {
        return y_;
    }
    const CSSAngle&
    y() const
    {
        return y_;
    }

private:
    void
    Init();

    void
    Assign(
            const CSSAngle& _x,
            const CSSAngle& _y);

    CSSAngle x_;
    CSSAngle y_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SkewX|
//
namespace mozilla {
namespace layers {
class SkewX final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT SkewX();

    MOZ_IMPLICIT SkewX(const CSSAngle& _x)
    {
        Init();
        Assign(_x);
    }

    MOZ_IMPLICIT SkewX(const SkewX& _o)
    {
        Init();
        Assign((_o).x());
    }

    ~SkewX();

    void
    operator=(const SkewX& _o)
    {
        Assign((_o).x());
    }

    bool
    operator==(const SkewX& _o) const;

    CSSAngle&
    x()
    {
        return x_;
    }
    const CSSAngle&
    x() const
    {
        return x_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _x);

    CSSAngle x_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CSSAngle;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SkewY|
//
namespace mozilla {
namespace layers {
class SkewY final
{
private:
    typedef mozilla::layers::CSSAngle CSSAngle;

public:
    MOZ_IMPLICIT SkewY();

    MOZ_IMPLICIT SkewY(const CSSAngle& _y)
    {
        Init();
        Assign(_y);
    }

    MOZ_IMPLICIT SkewY(const SkewY& _o)
    {
        Init();
        Assign((_o).y());
    }

    ~SkewY();

    void
    operator=(const SkewY& _o)
    {
        Assign((_o).y());
    }

    bool
    operator==(const SkewY& _o) const;

    CSSAngle&
    y()
    {
        return y_;
    }
    const CSSAngle&
    y() const
    {
        return y_;
    }

private:
    void
    Init();

    void
    Assign(const CSSAngle& _y);

    CSSAngle y_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransformMatrix|
//
namespace mozilla {
namespace layers {
class TransformMatrix final
{
private:
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;

public:
    MOZ_IMPLICIT TransformMatrix();

    MOZ_IMPLICIT TransformMatrix(const Matrix4x4& _value)
    {
        Init();
        Assign(_value);
    }

    MOZ_IMPLICIT TransformMatrix(const TransformMatrix& _o)
    {
        Init();
        Assign((_o).value());
    }

    ~TransformMatrix();

    void
    operator=(const TransformMatrix& _o)
    {
        Assign((_o).value());
    }

    bool
    operator==(const TransformMatrix& _o) const;

    Matrix4x4&
    value()
    {
        return value_;
    }
    const Matrix4x4&
    value() const
    {
        return value_;
    }

private:
    void
    Init();

    void
    Assign(const Matrix4x4& _value);

    Matrix4x4 value_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Translation|
//
namespace mozilla {
namespace layers {
class Translation final
{
private:

public:
    MOZ_IMPLICIT Translation();

    MOZ_IMPLICIT Translation(
            const float& _x,
            const float& _y,
            const float& _z)
    {
        Init();
        Assign(_x, _y, _z);
    }

    MOZ_IMPLICIT Translation(const Translation& _o)
    {
        Init();
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    ~Translation();

    void
    operator=(const Translation& _o)
    {
        Assign((_o).x(), (_o).y(), (_o).z());
    }

    bool
    operator==(const Translation& _o) const;

    float&
    x()
    {
        return x_;
    }
    const float&
    x() const
    {
        return x_;
    }

    float&
    y()
    {
        return y_;
    }
    const float&
    y() const
    {
        return y_;
    }

    float&
    z()
    {
        return z_;
    }
    const float&
    z() const
    {
        return z_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _x,
            const float& _y,
            const float& _z);

    float x_;
    float y_;
    float z_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Perspective;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RotationX;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RotationY;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RotationZ;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Rotation;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Rotation3D;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Scale;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Skew;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SkewX;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SkewY;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class Translation;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TransformMatrix;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TransformFunction|
//
namespace mozilla {
namespace layers {
class TransformFunction final
{
public:
    enum Type {
        T__None,
        TPerspective = 1,
        TRotationX,
        TRotationY,
        TRotationZ,
        TRotation,
        TRotation3D,
        TScale,
        TSkew,
        TSkewX,
        TSkewY,
        TTranslation,
        TTransformMatrix,
        T__Last = TTransformMatrix
    };

private:
    typedef mozilla::layers::Perspective Perspective;
    typedef mozilla::layers::RotationX RotationX;
    typedef mozilla::layers::RotationY RotationY;
    typedef mozilla::layers::RotationZ RotationZ;
    typedef mozilla::layers::Rotation Rotation;
    typedef mozilla::layers::Rotation3D Rotation3D;
    typedef mozilla::layers::Scale Scale;
    typedef mozilla::layers::Skew Skew;
    typedef mozilla::layers::SkewX SkewX;
    typedef mozilla::layers::SkewY SkewY;
    typedef mozilla::layers::Translation Translation;
    typedef mozilla::layers::TransformMatrix TransformMatrix;
    typedef Perspective Perspective__tdef;
    typedef RotationX RotationX__tdef;
    typedef RotationY RotationY__tdef;
    typedef RotationZ RotationZ__tdef;
    typedef Rotation Rotation__tdef;
    typedef Rotation3D Rotation3D__tdef;
    typedef Scale Scale__tdef;
    typedef Skew Skew__tdef;
    typedef SkewX SkewX__tdef;
    typedef SkewY SkewY__tdef;
    typedef Translation Translation__tdef;
    typedef TransformMatrix TransformMatrix__tdef;

    union Value {
        char VPerspective[sizeof(Perspective)];
        char VRotationX[sizeof(RotationX)];
        char VRotationY[sizeof(RotationY)];
        char VRotationZ[sizeof(RotationZ)];
        char VRotation[sizeof(Rotation)];
        char VRotation3D[sizeof(Rotation3D)];
        char VScale[sizeof(Scale)];
        char VSkew[sizeof(Skew)];
        char VSkewX[sizeof(SkewX)];
        char VSkewY[sizeof(SkewY)];
        char VTranslation[sizeof(Translation)];
        char VTransformMatrix[sizeof(TransformMatrix)];
    };

    Perspective*
    ptr_Perspective()
    {
        return reinterpret_cast<Perspective*>((&((mValue).VPerspective)));
    }
    const Perspective* const
    constptr_Perspective() const
    {
        return reinterpret_cast<const Perspective* const>((&((mValue).VPerspective)));
    }
    RotationX*
    ptr_RotationX()
    {
        return reinterpret_cast<RotationX*>((&((mValue).VRotationX)));
    }
    const RotationX* const
    constptr_RotationX() const
    {
        return reinterpret_cast<const RotationX* const>((&((mValue).VRotationX)));
    }
    RotationY*
    ptr_RotationY()
    {
        return reinterpret_cast<RotationY*>((&((mValue).VRotationY)));
    }
    const RotationY* const
    constptr_RotationY() const
    {
        return reinterpret_cast<const RotationY* const>((&((mValue).VRotationY)));
    }
    RotationZ*
    ptr_RotationZ()
    {
        return reinterpret_cast<RotationZ*>((&((mValue).VRotationZ)));
    }
    const RotationZ* const
    constptr_RotationZ() const
    {
        return reinterpret_cast<const RotationZ* const>((&((mValue).VRotationZ)));
    }
    Rotation*
    ptr_Rotation()
    {
        return reinterpret_cast<Rotation*>((&((mValue).VRotation)));
    }
    const Rotation* const
    constptr_Rotation() const
    {
        return reinterpret_cast<const Rotation* const>((&((mValue).VRotation)));
    }
    Rotation3D*
    ptr_Rotation3D()
    {
        return reinterpret_cast<Rotation3D*>((&((mValue).VRotation3D)));
    }
    const Rotation3D* const
    constptr_Rotation3D() const
    {
        return reinterpret_cast<const Rotation3D* const>((&((mValue).VRotation3D)));
    }
    Scale*
    ptr_Scale()
    {
        return reinterpret_cast<Scale*>((&((mValue).VScale)));
    }
    const Scale* const
    constptr_Scale() const
    {
        return reinterpret_cast<const Scale* const>((&((mValue).VScale)));
    }
    Skew*
    ptr_Skew()
    {
        return reinterpret_cast<Skew*>((&((mValue).VSkew)));
    }
    const Skew* const
    constptr_Skew() const
    {
        return reinterpret_cast<const Skew* const>((&((mValue).VSkew)));
    }
    SkewX*
    ptr_SkewX()
    {
        return reinterpret_cast<SkewX*>((&((mValue).VSkewX)));
    }
    const SkewX* const
    constptr_SkewX() const
    {
        return reinterpret_cast<const SkewX* const>((&((mValue).VSkewX)));
    }
    SkewY*
    ptr_SkewY()
    {
        return reinterpret_cast<SkewY*>((&((mValue).VSkewY)));
    }
    const SkewY* const
    constptr_SkewY() const
    {
        return reinterpret_cast<const SkewY* const>((&((mValue).VSkewY)));
    }
    Translation*
    ptr_Translation()
    {
        return reinterpret_cast<Translation*>((&((mValue).VTranslation)));
    }
    const Translation* const
    constptr_Translation() const
    {
        return reinterpret_cast<const Translation* const>((&((mValue).VTranslation)));
    }
    TransformMatrix*
    ptr_TransformMatrix()
    {
        return reinterpret_cast<TransformMatrix*>((&((mValue).VTransformMatrix)));
    }
    const TransformMatrix* const
    constptr_TransformMatrix() const
    {
        return reinterpret_cast<const TransformMatrix* const>((&((mValue).VTransformMatrix)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TransformFunction() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TransformFunction(const Perspective& aOther);

    MOZ_IMPLICIT TransformFunction(const RotationX& aOther);

    MOZ_IMPLICIT TransformFunction(const RotationY& aOther);

    MOZ_IMPLICIT TransformFunction(const RotationZ& aOther);

    MOZ_IMPLICIT TransformFunction(const Rotation& aOther);

    MOZ_IMPLICIT TransformFunction(const Rotation3D& aOther);

    MOZ_IMPLICIT TransformFunction(const Scale& aOther);

    MOZ_IMPLICIT TransformFunction(const Skew& aOther);

    MOZ_IMPLICIT TransformFunction(const SkewX& aOther);

    MOZ_IMPLICIT TransformFunction(const SkewY& aOther);

    MOZ_IMPLICIT TransformFunction(const Translation& aOther);

    MOZ_IMPLICIT TransformFunction(const TransformMatrix& aOther);

    MOZ_IMPLICIT TransformFunction(const TransformFunction& aOther);

    ~TransformFunction();

    Type
    type() const
    {
        return mType;
    }

    TransformFunction&
    operator=(const Perspective& aRhs);

    TransformFunction&
    operator=(const RotationX& aRhs);

    TransformFunction&
    operator=(const RotationY& aRhs);

    TransformFunction&
    operator=(const RotationZ& aRhs);

    TransformFunction&
    operator=(const Rotation& aRhs);

    TransformFunction&
    operator=(const Rotation3D& aRhs);

    TransformFunction&
    operator=(const Scale& aRhs);

    TransformFunction&
    operator=(const Skew& aRhs);

    TransformFunction&
    operator=(const SkewX& aRhs);

    TransformFunction&
    operator=(const SkewY& aRhs);

    TransformFunction&
    operator=(const Translation& aRhs);

    TransformFunction&
    operator=(const TransformMatrix& aRhs);

    TransformFunction&
    operator=(const TransformFunction& aRhs);

    bool
    operator==(const Perspective& aRhs) const;

    bool
    operator==(const RotationX& aRhs) const;

    bool
    operator==(const RotationY& aRhs) const;

    bool
    operator==(const RotationZ& aRhs) const;

    bool
    operator==(const Rotation& aRhs) const;

    bool
    operator==(const Rotation3D& aRhs) const;

    bool
    operator==(const Scale& aRhs) const;

    bool
    operator==(const Skew& aRhs) const;

    bool
    operator==(const SkewX& aRhs) const;

    bool
    operator==(const SkewY& aRhs) const;

    bool
    operator==(const Translation& aRhs) const;

    bool
    operator==(const TransformMatrix& aRhs) const;

    bool
    operator==(const TransformFunction& aRhs) const;

    Perspective&
    get_Perspective()
    {
        AssertSanity(TPerspective);
        return (*(ptr_Perspective()));
    }
    const Perspective&
    get_Perspective() const
    {
        AssertSanity(TPerspective);
        return (*(constptr_Perspective()));
    }
    operator Perspective&()
    {
        return get_Perspective();
    }
    operator const Perspective&() const
    {
        return get_Perspective();
    }

    RotationX&
    get_RotationX()
    {
        AssertSanity(TRotationX);
        return (*(ptr_RotationX()));
    }
    const RotationX&
    get_RotationX() const
    {
        AssertSanity(TRotationX);
        return (*(constptr_RotationX()));
    }
    operator RotationX&()
    {
        return get_RotationX();
    }
    operator const RotationX&() const
    {
        return get_RotationX();
    }

    RotationY&
    get_RotationY()
    {
        AssertSanity(TRotationY);
        return (*(ptr_RotationY()));
    }
    const RotationY&
    get_RotationY() const
    {
        AssertSanity(TRotationY);
        return (*(constptr_RotationY()));
    }
    operator RotationY&()
    {
        return get_RotationY();
    }
    operator const RotationY&() const
    {
        return get_RotationY();
    }

    RotationZ&
    get_RotationZ()
    {
        AssertSanity(TRotationZ);
        return (*(ptr_RotationZ()));
    }
    const RotationZ&
    get_RotationZ() const
    {
        AssertSanity(TRotationZ);
        return (*(constptr_RotationZ()));
    }
    operator RotationZ&()
    {
        return get_RotationZ();
    }
    operator const RotationZ&() const
    {
        return get_RotationZ();
    }

    Rotation&
    get_Rotation()
    {
        AssertSanity(TRotation);
        return (*(ptr_Rotation()));
    }
    const Rotation&
    get_Rotation() const
    {
        AssertSanity(TRotation);
        return (*(constptr_Rotation()));
    }
    operator Rotation&()
    {
        return get_Rotation();
    }
    operator const Rotation&() const
    {
        return get_Rotation();
    }

    Rotation3D&
    get_Rotation3D()
    {
        AssertSanity(TRotation3D);
        return (*(ptr_Rotation3D()));
    }
    const Rotation3D&
    get_Rotation3D() const
    {
        AssertSanity(TRotation3D);
        return (*(constptr_Rotation3D()));
    }
    operator Rotation3D&()
    {
        return get_Rotation3D();
    }
    operator const Rotation3D&() const
    {
        return get_Rotation3D();
    }

    Scale&
    get_Scale()
    {
        AssertSanity(TScale);
        return (*(ptr_Scale()));
    }
    const Scale&
    get_Scale() const
    {
        AssertSanity(TScale);
        return (*(constptr_Scale()));
    }
    operator Scale&()
    {
        return get_Scale();
    }
    operator const Scale&() const
    {
        return get_Scale();
    }

    Skew&
    get_Skew()
    {
        AssertSanity(TSkew);
        return (*(ptr_Skew()));
    }
    const Skew&
    get_Skew() const
    {
        AssertSanity(TSkew);
        return (*(constptr_Skew()));
    }
    operator Skew&()
    {
        return get_Skew();
    }
    operator const Skew&() const
    {
        return get_Skew();
    }

    SkewX&
    get_SkewX()
    {
        AssertSanity(TSkewX);
        return (*(ptr_SkewX()));
    }
    const SkewX&
    get_SkewX() const
    {
        AssertSanity(TSkewX);
        return (*(constptr_SkewX()));
    }
    operator SkewX&()
    {
        return get_SkewX();
    }
    operator const SkewX&() const
    {
        return get_SkewX();
    }

    SkewY&
    get_SkewY()
    {
        AssertSanity(TSkewY);
        return (*(ptr_SkewY()));
    }
    const SkewY&
    get_SkewY() const
    {
        AssertSanity(TSkewY);
        return (*(constptr_SkewY()));
    }
    operator SkewY&()
    {
        return get_SkewY();
    }
    operator const SkewY&() const
    {
        return get_SkewY();
    }

    Translation&
    get_Translation()
    {
        AssertSanity(TTranslation);
        return (*(ptr_Translation()));
    }
    const Translation&
    get_Translation() const
    {
        AssertSanity(TTranslation);
        return (*(constptr_Translation()));
    }
    operator Translation&()
    {
        return get_Translation();
    }
    operator const Translation&() const
    {
        return get_Translation();
    }

    TransformMatrix&
    get_TransformMatrix()
    {
        AssertSanity(TTransformMatrix);
        return (*(ptr_TransformMatrix()));
    }
    const TransformMatrix&
    get_TransformMatrix() const
    {
        AssertSanity(TTransformMatrix);
        return (*(constptr_TransformMatrix()));
    }
    operator TransformMatrix&()
    {
        return get_TransformMatrix();
    }
    operator const TransformMatrix&() const
    {
        return get_TransformMatrix();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TransformFunction;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union Animatable|
//
namespace mozilla {
namespace layers {
class Animatable final
{
public:
    enum Type {
        T__None,
        Tfloat = 1,
        TArrayOfTransformFunction,
        T__Last = TArrayOfTransformFunction
    };

private:
    typedef mozilla::layers::TransformFunction TransformFunction;
    typedef float float__tdef;
    typedef nsTArray<TransformFunction> ArrayOfTransformFunction__tdef;

    union Value {
        char Vfloat[sizeof(float)];
        char VArrayOfTransformFunction[sizeof(nsTArray<TransformFunction>)];
    };

    float*
    ptr_float()
    {
        return reinterpret_cast<float*>((&((mValue).Vfloat)));
    }
    const float* const
    constptr_float() const
    {
        return reinterpret_cast<const float* const>((&((mValue).Vfloat)));
    }
    nsTArray<TransformFunction>*
    ptr_ArrayOfTransformFunction()
    {
        return reinterpret_cast<nsTArray<TransformFunction>*>((&((mValue).VArrayOfTransformFunction)));
    }
    const nsTArray<TransformFunction>* const
    constptr_ArrayOfTransformFunction() const
    {
        return reinterpret_cast<const nsTArray<TransformFunction>* const>((&((mValue).VArrayOfTransformFunction)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT Animatable() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT Animatable(const float& aOther);

    MOZ_IMPLICIT Animatable(const nsTArray<TransformFunction>& aOther);

    MOZ_IMPLICIT Animatable(const Animatable& aOther);

    ~Animatable();

    Type
    type() const
    {
        return mType;
    }

    Animatable&
    operator=(const float& aRhs);

    Animatable&
    operator=(const nsTArray<TransformFunction>& aRhs);

    Animatable&
    operator=(const Animatable& aRhs);

    bool
    operator==(const float& aRhs) const;

    bool
    operator==(const nsTArray<TransformFunction>& aRhs) const;

    bool
    operator==(const Animatable& aRhs) const;

    float&
    get_float()
    {
        AssertSanity(Tfloat);
        return (*(ptr_float()));
    }
    const float&
    get_float() const
    {
        AssertSanity(Tfloat);
        return (*(constptr_float()));
    }
    operator float&()
    {
        return get_float();
    }
    operator const float&() const
    {
        return get_float();
    }

    nsTArray<TransformFunction>&
    get_ArrayOfTransformFunction()
    {
        AssertSanity(TArrayOfTransformFunction);
        return (*(ptr_ArrayOfTransformFunction()));
    }
    const nsTArray<TransformFunction>&
    get_ArrayOfTransformFunction() const
    {
        AssertSanity(TArrayOfTransformFunction);
        return (*(constptr_ArrayOfTransformFunction()));
    }
    operator nsTArray<TransformFunction>&()
    {
        return get_ArrayOfTransformFunction();
    }
    operator const nsTArray<TransformFunction>&() const
    {
        return get_ArrayOfTransformFunction();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Animatable;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TimingFunction;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AnimationSegment|
//
namespace mozilla {
namespace layers {
class AnimationSegment final
{
private:
    typedef mozilla::layers::Animatable Animatable;
    typedef mozilla::layers::TimingFunction TimingFunction;

public:
    MOZ_IMPLICIT AnimationSegment();

    MOZ_IMPLICIT AnimationSegment(
            const Animatable& _startState,
            const Animatable& _endState,
            const float& _startPortion,
            const float& _endPortion,
            const TimingFunction& _sampleFn)
    {
        Init();
        Assign(_startState, _endState, _startPortion, _endPortion, _sampleFn);
    }

    MOZ_IMPLICIT AnimationSegment(const AnimationSegment& _o)
    {
        Init();
        Assign((_o).startState(), (_o).endState(), (_o).startPortion(), (_o).endPortion(), (_o).sampleFn());
    }

    ~AnimationSegment();

    void
    operator=(const AnimationSegment& _o)
    {
        Assign((_o).startState(), (_o).endState(), (_o).startPortion(), (_o).endPortion(), (_o).sampleFn());
    }

    bool
    operator==(const AnimationSegment& _o) const;

    Animatable&
    startState()
    {
        return startState_;
    }
    const Animatable&
    startState() const
    {
        return startState_;
    }

    Animatable&
    endState()
    {
        return endState_;
    }
    const Animatable&
    endState() const
    {
        return endState_;
    }

    float&
    startPortion()
    {
        return startPortion_;
    }
    const float&
    startPortion() const
    {
        return startPortion_;
    }

    float&
    endPortion()
    {
        return endPortion_;
    }
    const float&
    endPortion() const
    {
        return endPortion_;
    }

    TimingFunction&
    sampleFn()
    {
        return sampleFn_;
    }
    const TimingFunction&
    sampleFn() const
    {
        return sampleFn_;
    }

private:
    void
    Init();

    void
    Assign(
            const Animatable& _startState,
            const Animatable& _endState,
            const float& _startPortion,
            const float& _endPortion,
            const TimingFunction& _sampleFn);

    Animatable startState_;
    Animatable endState_;
    float startPortion_;
    float endPortion_;
    TimingFunction sampleFn_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransformData|
//
namespace mozilla {
namespace layers {
class TransformData final
{
private:
    typedef mozilla::gfx::Point3D Point3D;

public:
    MOZ_IMPLICIT TransformData();

    MOZ_IMPLICIT TransformData(
            const nsPoint& _origin,
            const Point3D& _transformOrigin,
            const Point3D& _perspectiveOrigin,
            const nsRect& _bounds,
            const nscoord& _perspective,
            const int32_t& _appUnitsPerDevPixel)
    {
        Init();
        Assign(_origin, _transformOrigin, _perspectiveOrigin, _bounds, _perspective, _appUnitsPerDevPixel);
    }

    MOZ_IMPLICIT TransformData(const TransformData& _o)
    {
        Init();
        Assign((_o).origin(), (_o).transformOrigin(), (_o).perspectiveOrigin(), (_o).bounds(), (_o).perspective(), (_o).appUnitsPerDevPixel());
    }

    ~TransformData();

    void
    operator=(const TransformData& _o)
    {
        Assign((_o).origin(), (_o).transformOrigin(), (_o).perspectiveOrigin(), (_o).bounds(), (_o).perspective(), (_o).appUnitsPerDevPixel());
    }

    bool
    operator==(const TransformData& _o) const;

    nsPoint&
    origin()
    {
        return origin_;
    }
    const nsPoint&
    origin() const
    {
        return origin_;
    }

    Point3D&
    transformOrigin()
    {
        return transformOrigin_;
    }
    const Point3D&
    transformOrigin() const
    {
        return transformOrigin_;
    }

    Point3D&
    perspectiveOrigin()
    {
        return perspectiveOrigin_;
    }
    const Point3D&
    perspectiveOrigin() const
    {
        return perspectiveOrigin_;
    }

    nsRect&
    bounds()
    {
        return bounds_;
    }
    const nsRect&
    bounds() const
    {
        return bounds_;
    }

    nscoord&
    perspective()
    {
        return perspective_;
    }
    const nscoord&
    perspective() const
    {
        return perspective_;
    }

    int32_t&
    appUnitsPerDevPixel()
    {
        return appUnitsPerDevPixel_;
    }
    const int32_t&
    appUnitsPerDevPixel() const
    {
        return appUnitsPerDevPixel_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsPoint& _origin,
            const Point3D& _transformOrigin,
            const Point3D& _perspectiveOrigin,
            const nsRect& _bounds,
            const nscoord& _perspective,
            const int32_t& _appUnitsPerDevPixel);

    nsPoint origin_;
    Point3D transformOrigin_;
    Point3D perspectiveOrigin_;
    nsRect bounds_;
    nscoord perspective_;
    int32_t appUnitsPerDevPixel_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TransformData;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AnimationData|
//
namespace mozilla {
namespace layers {
class AnimationData final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TTransformData,
        T__Last = TTransformData
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::TransformData TransformData;
    typedef null_t null_t__tdef;
    typedef TransformData TransformData__tdef;

    union Value {
        char Vnull_t[sizeof(null_t)];
        char VTransformData[sizeof(TransformData)];
    };

    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }
    TransformData*
    ptr_TransformData()
    {
        return reinterpret_cast<TransformData*>((&((mValue).VTransformData)));
    }
    const TransformData* const
    constptr_TransformData() const
    {
        return reinterpret_cast<const TransformData* const>((&((mValue).VTransformData)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AnimationData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AnimationData(const null_t& aOther);

    MOZ_IMPLICIT AnimationData(const TransformData& aOther);

    MOZ_IMPLICIT AnimationData(const AnimationData& aOther);

    ~AnimationData();

    Type
    type() const
    {
        return mType;
    }

    AnimationData&
    operator=(const null_t& aRhs);

    AnimationData&
    operator=(const TransformData& aRhs);

    AnimationData&
    operator=(const AnimationData& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const TransformData& aRhs) const;

    bool
    operator==(const AnimationData& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    TransformData&
    get_TransformData()
    {
        AssertSanity(TTransformData);
        return (*(ptr_TransformData()));
    }
    const TransformData&
    get_TransformData() const
    {
        AssertSanity(TTransformData);
        return (*(constptr_TransformData()));
    }
    operator TransformData&()
    {
        return get_TransformData();
    }
    operator const TransformData&() const
    {
        return get_TransformData();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class AnimationSegment;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class AnimationData;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Animation|
//
namespace mozilla {
namespace layers {
class Animation final
{
private:
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::TimeDuration TimeDuration;
    typedef mozilla::layers::AnimationSegment AnimationSegment;
    typedef mozilla::layers::AnimationData AnimationData;

public:
    MOZ_IMPLICIT Animation();

    MOZ_IMPLICIT Animation(
            const TimeStamp& _startTime,
            const TimeDuration& _initialCurrentTime,
            const TimeDuration& _duration,
            const nsTArray<AnimationSegment>& _segments,
            const float& _iterationCount,
            const int32_t& _direction,
            const nsCSSProperty& _property,
            const AnimationData& _data,
            const float& _playbackRate)
    {
        Init();
        Assign(_startTime, _initialCurrentTime, _duration, _segments, _iterationCount, _direction, _property, _data, _playbackRate);
    }

    MOZ_IMPLICIT Animation(const Animation& _o)
    {
        Init();
        Assign((_o).startTime(), (_o).initialCurrentTime(), (_o).duration(), (_o).segments(), (_o).iterationCount(), (_o).direction(), (_o).property(), (_o).data(), (_o).playbackRate());
    }

    ~Animation();

    void
    operator=(const Animation& _o)
    {
        Assign((_o).startTime(), (_o).initialCurrentTime(), (_o).duration(), (_o).segments(), (_o).iterationCount(), (_o).direction(), (_o).property(), (_o).data(), (_o).playbackRate());
    }

    bool
    operator==(const Animation& _o) const;

    TimeStamp&
    startTime()
    {
        return startTime_;
    }
    const TimeStamp&
    startTime() const
    {
        return startTime_;
    }

    TimeDuration&
    initialCurrentTime()
    {
        return initialCurrentTime_;
    }
    const TimeDuration&
    initialCurrentTime() const
    {
        return initialCurrentTime_;
    }

    TimeDuration&
    duration()
    {
        return duration_;
    }
    const TimeDuration&
    duration() const
    {
        return duration_;
    }

    nsTArray<AnimationSegment>&
    segments()
    {
        return segments_;
    }
    const nsTArray<AnimationSegment>&
    segments() const
    {
        return segments_;
    }

    float&
    iterationCount()
    {
        return iterationCount_;
    }
    const float&
    iterationCount() const
    {
        return iterationCount_;
    }

    int32_t&
    direction()
    {
        return direction_;
    }
    const int32_t&
    direction() const
    {
        return direction_;
    }

    nsCSSProperty&
    property()
    {
        return property_;
    }
    const nsCSSProperty&
    property() const
    {
        return property_;
    }

    AnimationData&
    data()
    {
        return data_;
    }
    const AnimationData&
    data() const
    {
        return data_;
    }

    float&
    playbackRate()
    {
        return playbackRate_;
    }
    const float&
    playbackRate() const
    {
        return playbackRate_;
    }

private:
    void
    Init();

    void
    Assign(
            const TimeStamp& _startTime,
            const TimeDuration& _initialCurrentTime,
            const TimeDuration& _duration,
            const nsTArray<AnimationSegment>& _segments,
            const float& _iterationCount,
            const int32_t& _direction,
            const nsCSSProperty& _property,
            const AnimationData& _data,
            const float& _playbackRate);

    TimeStamp startTime_;
    TimeDuration initialCurrentTime_;
    TimeDuration duration_;
    nsTArray<AnimationSegment> segments_;
    float iterationCount_;
    int32_t direction_;
    nsCSSProperty property_;
    AnimationData data_;
    float playbackRate_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TransformMatrix;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class Animation;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CommonLayerAttributes|
//
namespace mozilla {
namespace layers {
class CommonLayerAttributes final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::layers::EventRegions EventRegions;
    typedef mozilla::layers::TransformMatrix TransformMatrix;
    typedef mozilla::ParentLayerIntRect ParentLayerIntRect;
    typedef mozilla::LayerPoint LayerPoint;
    typedef mozilla::LayerMargin LayerMargin;
    typedef mozilla::LayerRect LayerRect;
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;
    typedef mozilla::layers::Animation Animation;
    typedef mozilla::layers::FrameMetrics FrameMetrics;
    typedef std::string string;

public:
    MOZ_IMPLICIT CommonLayerAttributes();

    MOZ_IMPLICIT CommonLayerAttributes(
            const IntRect& _layerBounds,
            const nsIntRegion& _visibleRegion,
            const EventRegions& _eventRegions,
            const TransformMatrix& _transform,
            const float& _postXScale,
            const float& _postYScale,
            const uint32_t& _contentFlags,
            const float& _opacity,
            const bool& _useClipRect,
            const ParentLayerIntRect& _clipRect,
            const bool& _isFixedPosition,
            const LayerPoint& _fixedPositionAnchor,
            const LayerMargin& _fixedPositionMargin,
            const bool& _isStickyPosition,
            const uint64_t& _stickyScrollContainerId,
            const LayerRect& _stickyScrollRangeOuter,
            const LayerRect& _stickyScrollRangeInner,
            const uint64_t& _scrollbarTargetContainerId,
            const uint32_t& _scrollbarDirection,
            const float& _scrollbarThumbRatio,
            const int8_t& _mixBlendMode,
            const bool& _forceIsolatedGroup,
            PLayerParent* _maskLayerParent,
            PLayerChild* _maskLayerChild,
            const nsTArray<PLayerParent*>& _ancestorMaskLayersParent,
            const nsTArray<PLayerChild*>& _ancestorMaskLayersChild,
            const nsTArray<Animation>& _animations,
            const nsIntRegion& _invalidRegion,
            const nsTArray<FrameMetrics>& _metrics,
            const string& _contentDescription,
            const nsCString& _displayListLog)
    {
        Init();
        Assign(_layerBounds, _visibleRegion, _eventRegions, _transform, _postXScale, _postYScale, _contentFlags, _opacity, _useClipRect, _clipRect, _isFixedPosition, _fixedPositionAnchor, _fixedPositionMargin, _isStickyPosition, _stickyScrollContainerId, _stickyScrollRangeOuter, _stickyScrollRangeInner, _scrollbarTargetContainerId, _scrollbarDirection, _scrollbarThumbRatio, _mixBlendMode, _forceIsolatedGroup, _maskLayerParent, _maskLayerChild, _ancestorMaskLayersParent, _ancestorMaskLayersChild, _animations, _invalidRegion, _metrics, _contentDescription, _displayListLog);
    }

    MOZ_IMPLICIT CommonLayerAttributes(const CommonLayerAttributes& _o)
    {
        Init();
        Assign((_o).layerBounds(), (_o).visibleRegion(), (_o).eventRegions(), (_o).transform(), (_o).postXScale(), (_o).postYScale(), (_o).contentFlags(), (_o).opacity(), (_o).useClipRect(), (_o).clipRect(), (_o).isFixedPosition(), (_o).fixedPositionAnchor(), (_o).fixedPositionMargin(), (_o).isStickyPosition(), (_o).stickyScrollContainerId(), (_o).stickyScrollRangeOuter(), (_o).stickyScrollRangeInner(), (_o).scrollbarTargetContainerId(), (_o).scrollbarDirection(), (_o).scrollbarThumbRatio(), (_o).mixBlendMode(), (_o).forceIsolatedGroup(), const_cast<PLayerParent*>((_o).maskLayerParent()), const_cast<PLayerChild*>((_o).maskLayerChild()), (_o).ancestorMaskLayersParent(), (_o).ancestorMaskLayersChild(), (_o).animations(), (_o).invalidRegion(), (_o).metrics(), (_o).contentDescription(), (_o).displayListLog());
    }

    ~CommonLayerAttributes();

    void
    operator=(const CommonLayerAttributes& _o)
    {
        Assign((_o).layerBounds(), (_o).visibleRegion(), (_o).eventRegions(), (_o).transform(), (_o).postXScale(), (_o).postYScale(), (_o).contentFlags(), (_o).opacity(), (_o).useClipRect(), (_o).clipRect(), (_o).isFixedPosition(), (_o).fixedPositionAnchor(), (_o).fixedPositionMargin(), (_o).isStickyPosition(), (_o).stickyScrollContainerId(), (_o).stickyScrollRangeOuter(), (_o).stickyScrollRangeInner(), (_o).scrollbarTargetContainerId(), (_o).scrollbarDirection(), (_o).scrollbarThumbRatio(), (_o).mixBlendMode(), (_o).forceIsolatedGroup(), const_cast<PLayerParent*>((_o).maskLayerParent()), const_cast<PLayerChild*>((_o).maskLayerChild()), (_o).ancestorMaskLayersParent(), (_o).ancestorMaskLayersChild(), (_o).animations(), (_o).invalidRegion(), (_o).metrics(), (_o).contentDescription(), (_o).displayListLog());
    }

    bool
    operator==(const CommonLayerAttributes& _o) const;

    IntRect&
    layerBounds()
    {
        return layerBounds_;
    }
    const IntRect&
    layerBounds() const
    {
        return layerBounds_;
    }

    nsIntRegion&
    visibleRegion()
    {
        return visibleRegion_;
    }
    const nsIntRegion&
    visibleRegion() const
    {
        return visibleRegion_;
    }

    EventRegions&
    eventRegions()
    {
        return eventRegions_;
    }
    const EventRegions&
    eventRegions() const
    {
        return eventRegions_;
    }

    TransformMatrix&
    transform()
    {
        return transform_;
    }
    const TransformMatrix&
    transform() const
    {
        return transform_;
    }

    float&
    postXScale()
    {
        return postXScale_;
    }
    const float&
    postXScale() const
    {
        return postXScale_;
    }

    float&
    postYScale()
    {
        return postYScale_;
    }
    const float&
    postYScale() const
    {
        return postYScale_;
    }

    uint32_t&
    contentFlags()
    {
        return contentFlags_;
    }
    const uint32_t&
    contentFlags() const
    {
        return contentFlags_;
    }

    float&
    opacity()
    {
        return opacity_;
    }
    const float&
    opacity() const
    {
        return opacity_;
    }

    bool&
    useClipRect()
    {
        return useClipRect_;
    }
    const bool&
    useClipRect() const
    {
        return useClipRect_;
    }

    ParentLayerIntRect&
    clipRect()
    {
        return clipRect_;
    }
    const ParentLayerIntRect&
    clipRect() const
    {
        return clipRect_;
    }

    bool&
    isFixedPosition()
    {
        return isFixedPosition_;
    }
    const bool&
    isFixedPosition() const
    {
        return isFixedPosition_;
    }

    LayerPoint&
    fixedPositionAnchor()
    {
        return fixedPositionAnchor_;
    }
    const LayerPoint&
    fixedPositionAnchor() const
    {
        return fixedPositionAnchor_;
    }

    LayerMargin&
    fixedPositionMargin()
    {
        return fixedPositionMargin_;
    }
    const LayerMargin&
    fixedPositionMargin() const
    {
        return fixedPositionMargin_;
    }

    bool&
    isStickyPosition()
    {
        return isStickyPosition_;
    }
    const bool&
    isStickyPosition() const
    {
        return isStickyPosition_;
    }

    uint64_t&
    stickyScrollContainerId()
    {
        return stickyScrollContainerId_;
    }
    const uint64_t&
    stickyScrollContainerId() const
    {
        return stickyScrollContainerId_;
    }

    LayerRect&
    stickyScrollRangeOuter()
    {
        return stickyScrollRangeOuter_;
    }
    const LayerRect&
    stickyScrollRangeOuter() const
    {
        return stickyScrollRangeOuter_;
    }

    LayerRect&
    stickyScrollRangeInner()
    {
        return stickyScrollRangeInner_;
    }
    const LayerRect&
    stickyScrollRangeInner() const
    {
        return stickyScrollRangeInner_;
    }

    uint64_t&
    scrollbarTargetContainerId()
    {
        return scrollbarTargetContainerId_;
    }
    const uint64_t&
    scrollbarTargetContainerId() const
    {
        return scrollbarTargetContainerId_;
    }

    uint32_t&
    scrollbarDirection()
    {
        return scrollbarDirection_;
    }
    const uint32_t&
    scrollbarDirection() const
    {
        return scrollbarDirection_;
    }

    float&
    scrollbarThumbRatio()
    {
        return scrollbarThumbRatio_;
    }
    const float&
    scrollbarThumbRatio() const
    {
        return scrollbarThumbRatio_;
    }

    int8_t&
    mixBlendMode()
    {
        return mixBlendMode_;
    }
    const int8_t&
    mixBlendMode() const
    {
        return mixBlendMode_;
    }

    bool&
    forceIsolatedGroup()
    {
        return forceIsolatedGroup_;
    }
    const bool&
    forceIsolatedGroup() const
    {
        return forceIsolatedGroup_;
    }

    PLayerParent*&
    maskLayerParent()
    {
        return maskLayerParent_;
    }
    PLayerParent*
    maskLayerParent() const
    {
        return maskLayerParent_;
    }

    PLayerChild*&
    maskLayerChild()
    {
        return maskLayerChild_;
    }
    PLayerChild*
    maskLayerChild() const
    {
        return maskLayerChild_;
    }

    nsTArray<PLayerParent*>&
    ancestorMaskLayersParent()
    {
        return ancestorMaskLayersParent_;
    }
    const nsTArray<PLayerParent*>&
    ancestorMaskLayersParent() const
    {
        return ancestorMaskLayersParent_;
    }

    nsTArray<PLayerChild*>&
    ancestorMaskLayersChild()
    {
        return ancestorMaskLayersChild_;
    }
    const nsTArray<PLayerChild*>&
    ancestorMaskLayersChild() const
    {
        return ancestorMaskLayersChild_;
    }

    nsTArray<Animation>&
    animations()
    {
        return animations_;
    }
    const nsTArray<Animation>&
    animations() const
    {
        return animations_;
    }

    nsIntRegion&
    invalidRegion()
    {
        return invalidRegion_;
    }
    const nsIntRegion&
    invalidRegion() const
    {
        return invalidRegion_;
    }

    nsTArray<FrameMetrics>&
    metrics()
    {
        return metrics_;
    }
    const nsTArray<FrameMetrics>&
    metrics() const
    {
        return metrics_;
    }

    string&
    contentDescription()
    {
        return contentDescription_;
    }
    const string&
    contentDescription() const
    {
        return contentDescription_;
    }

    nsCString&
    displayListLog()
    {
        return displayListLog_;
    }
    const nsCString&
    displayListLog() const
    {
        return displayListLog_;
    }

private:
    void
    Init();

    void
    Assign(
            const IntRect& _layerBounds,
            const nsIntRegion& _visibleRegion,
            const EventRegions& _eventRegions,
            const TransformMatrix& _transform,
            const float& _postXScale,
            const float& _postYScale,
            const uint32_t& _contentFlags,
            const float& _opacity,
            const bool& _useClipRect,
            const ParentLayerIntRect& _clipRect,
            const bool& _isFixedPosition,
            const LayerPoint& _fixedPositionAnchor,
            const LayerMargin& _fixedPositionMargin,
            const bool& _isStickyPosition,
            const uint64_t& _stickyScrollContainerId,
            const LayerRect& _stickyScrollRangeOuter,
            const LayerRect& _stickyScrollRangeInner,
            const uint64_t& _scrollbarTargetContainerId,
            const uint32_t& _scrollbarDirection,
            const float& _scrollbarThumbRatio,
            const int8_t& _mixBlendMode,
            const bool& _forceIsolatedGroup,
            PLayerParent* _maskLayerParent,
            PLayerChild* _maskLayerChild,
            const nsTArray<PLayerParent*>& _ancestorMaskLayersParent,
            const nsTArray<PLayerChild*>& _ancestorMaskLayersChild,
            const nsTArray<Animation>& _animations,
            const nsIntRegion& _invalidRegion,
            const nsTArray<FrameMetrics>& _metrics,
            const string& _contentDescription,
            const nsCString& _displayListLog);

    IntRect layerBounds_;
    nsIntRegion visibleRegion_;
    EventRegions eventRegions_;
    TransformMatrix transform_;
    float postXScale_;
    float postYScale_;
    uint32_t contentFlags_;
    float opacity_;
    bool useClipRect_;
    ParentLayerIntRect clipRect_;
    bool isFixedPosition_;
    LayerPoint fixedPositionAnchor_;
    LayerMargin fixedPositionMargin_;
    bool isStickyPosition_;
    uint64_t stickyScrollContainerId_;
    LayerRect stickyScrollRangeOuter_;
    LayerRect stickyScrollRangeInner_;
    uint64_t scrollbarTargetContainerId_;
    uint32_t scrollbarDirection_;
    float scrollbarThumbRatio_;
    int8_t mixBlendMode_;
    bool forceIsolatedGroup_;
    PLayerParent* maskLayerParent_;
    PLayerChild* maskLayerChild_;
    nsTArray<PLayerParent*> ancestorMaskLayersParent_;
    nsTArray<PLayerChild*> ancestorMaskLayersChild_;
    nsTArray<Animation> animations_;
    nsIntRegion invalidRegion_;
    nsTArray<FrameMetrics> metrics_;
    string contentDescription_;
    nsCString displayListLog_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PaintedLayerAttributes|
//
namespace mozilla {
namespace layers {
class PaintedLayerAttributes final
{
private:

public:
    MOZ_IMPLICIT PaintedLayerAttributes();

    MOZ_IMPLICIT PaintedLayerAttributes(const nsIntRegion& _validRegion)
    {
        Init();
        Assign(_validRegion);
    }

    MOZ_IMPLICIT PaintedLayerAttributes(const PaintedLayerAttributes& _o)
    {
        Init();
        Assign((_o).validRegion());
    }

    ~PaintedLayerAttributes();

    void
    operator=(const PaintedLayerAttributes& _o)
    {
        Assign((_o).validRegion());
    }

    bool
    operator==(const PaintedLayerAttributes& _o) const;

    nsIntRegion&
    validRegion()
    {
        return validRegion_;
    }
    const nsIntRegion&
    validRegion() const
    {
        return validRegion_;
    }

private:
    void
    Init();

    void
    Assign(const nsIntRegion& _validRegion);

    nsIntRegion validRegion_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ContainerLayerAttributes|
//
namespace mozilla {
namespace layers {
class ContainerLayerAttributes final
{
private:
    typedef mozilla::layers::EventRegionsOverride EventRegionsOverride;

public:
    MOZ_IMPLICIT ContainerLayerAttributes();

    MOZ_IMPLICIT ContainerLayerAttributes(
            const float& _preXScale,
            const float& _preYScale,
            const float& _inheritedXScale,
            const float& _inheritedYScale,
            const float& _presShellResolution,
            const bool& _scaleToResolution,
            const EventRegionsOverride& _eventRegionsOverride,
            const uint64_t& _hmdInfo)
    {
        Init();
        Assign(_preXScale, _preYScale, _inheritedXScale, _inheritedYScale, _presShellResolution, _scaleToResolution, _eventRegionsOverride, _hmdInfo);
    }

    MOZ_IMPLICIT ContainerLayerAttributes(const ContainerLayerAttributes& _o)
    {
        Init();
        Assign((_o).preXScale(), (_o).preYScale(), (_o).inheritedXScale(), (_o).inheritedYScale(), (_o).presShellResolution(), (_o).scaleToResolution(), (_o).eventRegionsOverride(), (_o).hmdInfo());
    }

    ~ContainerLayerAttributes();

    void
    operator=(const ContainerLayerAttributes& _o)
    {
        Assign((_o).preXScale(), (_o).preYScale(), (_o).inheritedXScale(), (_o).inheritedYScale(), (_o).presShellResolution(), (_o).scaleToResolution(), (_o).eventRegionsOverride(), (_o).hmdInfo());
    }

    bool
    operator==(const ContainerLayerAttributes& _o) const;

    float&
    preXScale()
    {
        return preXScale_;
    }
    const float&
    preXScale() const
    {
        return preXScale_;
    }

    float&
    preYScale()
    {
        return preYScale_;
    }
    const float&
    preYScale() const
    {
        return preYScale_;
    }

    float&
    inheritedXScale()
    {
        return inheritedXScale_;
    }
    const float&
    inheritedXScale() const
    {
        return inheritedXScale_;
    }

    float&
    inheritedYScale()
    {
        return inheritedYScale_;
    }
    const float&
    inheritedYScale() const
    {
        return inheritedYScale_;
    }

    float&
    presShellResolution()
    {
        return presShellResolution_;
    }
    const float&
    presShellResolution() const
    {
        return presShellResolution_;
    }

    bool&
    scaleToResolution()
    {
        return scaleToResolution_;
    }
    const bool&
    scaleToResolution() const
    {
        return scaleToResolution_;
    }

    EventRegionsOverride&
    eventRegionsOverride()
    {
        return eventRegionsOverride_;
    }
    const EventRegionsOverride&
    eventRegionsOverride() const
    {
        return eventRegionsOverride_;
    }

    uint64_t&
    hmdInfo()
    {
        return hmdInfo_;
    }
    const uint64_t&
    hmdInfo() const
    {
        return hmdInfo_;
    }

private:
    void
    Init();

    void
    Assign(
            const float& _preXScale,
            const float& _preYScale,
            const float& _inheritedXScale,
            const float& _inheritedYScale,
            const float& _presShellResolution,
            const bool& _scaleToResolution,
            const EventRegionsOverride& _eventRegionsOverride,
            const uint64_t& _hmdInfo);

    float preXScale_;
    float preYScale_;
    float inheritedXScale_;
    float inheritedYScale_;
    float presShellResolution_;
    bool scaleToResolution_;
    EventRegionsOverride eventRegionsOverride_;
    uint64_t hmdInfo_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class LayerColor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ColorLayerAttributes|
//
namespace mozilla {
namespace layers {
class ColorLayerAttributes final
{
private:
    typedef mozilla::layers::LayerColor LayerColor;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT ColorLayerAttributes();

    MOZ_IMPLICIT ColorLayerAttributes(
            const LayerColor& _color,
            const IntRect& _bounds)
    {
        Init();
        Assign(_color, _bounds);
    }

    MOZ_IMPLICIT ColorLayerAttributes(const ColorLayerAttributes& _o)
    {
        Init();
        Assign((_o).color(), (_o).bounds());
    }

    ~ColorLayerAttributes();

    void
    operator=(const ColorLayerAttributes& _o)
    {
        Assign((_o).color(), (_o).bounds());
    }

    bool
    operator==(const ColorLayerAttributes& _o) const;

    LayerColor&
    color()
    {
        return color_;
    }
    const LayerColor&
    color() const
    {
        return color_;
    }

    IntRect&
    bounds()
    {
        return bounds_;
    }
    const IntRect&
    bounds() const
    {
        return bounds_;
    }

private:
    void
    Init();

    void
    Assign(
            const LayerColor& _color,
            const IntRect& _bounds);

    LayerColor color_;
    IntRect bounds_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CanvasLayerAttributes|
//
namespace mozilla {
namespace layers {
class CanvasLayerAttributes final
{
private:
    typedef mozilla::GraphicsFilterType GraphicsFilterType;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT CanvasLayerAttributes();

    MOZ_IMPLICIT CanvasLayerAttributes(
            const GraphicsFilterType& _filter,
            const IntRect& _bounds)
    {
        Init();
        Assign(_filter, _bounds);
    }

    MOZ_IMPLICIT CanvasLayerAttributes(const CanvasLayerAttributes& _o)
    {
        Init();
        Assign((_o).filter(), (_o).bounds());
    }

    ~CanvasLayerAttributes();

    void
    operator=(const CanvasLayerAttributes& _o)
    {
        Assign((_o).filter(), (_o).bounds());
    }

    bool
    operator==(const CanvasLayerAttributes& _o) const;

    GraphicsFilterType&
    filter()
    {
        return filter_;
    }
    const GraphicsFilterType&
    filter() const
    {
        return filter_;
    }

    IntRect&
    bounds()
    {
        return bounds_;
    }
    const IntRect&
    bounds() const
    {
        return bounds_;
    }

private:
    void
    Init();

    void
    Assign(
            const GraphicsFilterType& _filter,
            const IntRect& _bounds);

    GraphicsFilterType filter_;
    IntRect bounds_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RefLayerAttributes|
//
namespace mozilla {
namespace layers {
class RefLayerAttributes final
{
private:
    typedef mozilla::layers::EventRegionsOverride EventRegionsOverride;

public:
    MOZ_IMPLICIT RefLayerAttributes();

    MOZ_IMPLICIT RefLayerAttributes(
            const int64_t& _id,
            const EventRegionsOverride& _eventRegionsOverride)
    {
        Init();
        Assign(_id, _eventRegionsOverride);
    }

    MOZ_IMPLICIT RefLayerAttributes(const RefLayerAttributes& _o)
    {
        Init();
        Assign((_o).id(), (_o).eventRegionsOverride());
    }

    ~RefLayerAttributes();

    void
    operator=(const RefLayerAttributes& _o)
    {
        Assign((_o).id(), (_o).eventRegionsOverride());
    }

    bool
    operator==(const RefLayerAttributes& _o) const;

    int64_t&
    id()
    {
        return id_;
    }
    const int64_t&
    id() const
    {
        return id_;
    }

    EventRegionsOverride&
    eventRegionsOverride()
    {
        return eventRegionsOverride_;
    }
    const EventRegionsOverride&
    eventRegionsOverride() const
    {
        return eventRegionsOverride_;
    }

private:
    void
    Init();

    void
    Assign(
            const int64_t& _id,
            const EventRegionsOverride& _eventRegionsOverride);

    int64_t id_;
    EventRegionsOverride eventRegionsOverride_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ImageLayerAttributes|
//
namespace mozilla {
namespace layers {
class ImageLayerAttributes final
{
private:
    typedef mozilla::GraphicsFilterType GraphicsFilterType;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::ScaleMode ScaleMode;

public:
    MOZ_IMPLICIT ImageLayerAttributes();

    MOZ_IMPLICIT ImageLayerAttributes(
            const GraphicsFilterType& _filter,
            const IntSize& _scaleToSize,
            const ScaleMode& _scaleMode)
    {
        Init();
        Assign(_filter, _scaleToSize, _scaleMode);
    }

    MOZ_IMPLICIT ImageLayerAttributes(const ImageLayerAttributes& _o)
    {
        Init();
        Assign((_o).filter(), (_o).scaleToSize(), (_o).scaleMode());
    }

    ~ImageLayerAttributes();

    void
    operator=(const ImageLayerAttributes& _o)
    {
        Assign((_o).filter(), (_o).scaleToSize(), (_o).scaleMode());
    }

    bool
    operator==(const ImageLayerAttributes& _o) const;

    GraphicsFilterType&
    filter()
    {
        return filter_;
    }
    const GraphicsFilterType&
    filter() const
    {
        return filter_;
    }

    IntSize&
    scaleToSize()
    {
        return scaleToSize_;
    }
    const IntSize&
    scaleToSize() const
    {
        return scaleToSize_;
    }

    ScaleMode&
    scaleMode()
    {
        return scaleMode_;
    }
    const ScaleMode&
    scaleMode() const
    {
        return scaleMode_;
    }

private:
    void
    Init();

    void
    Assign(
            const GraphicsFilterType& _filter,
            const IntSize& _scaleToSize,
            const ScaleMode& _scaleMode);

    GraphicsFilterType filter_;
    IntSize scaleToSize_;
    ScaleMode scaleMode_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PaintedLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ContainerLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ColorLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CanvasLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class RefLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class ImageLayerAttributes;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union SpecificLayerAttributes|
//
namespace mozilla {
namespace layers {
class SpecificLayerAttributes final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TPaintedLayerAttributes,
        TContainerLayerAttributes,
        TColorLayerAttributes,
        TCanvasLayerAttributes,
        TRefLayerAttributes,
        TImageLayerAttributes,
        T__Last = TImageLayerAttributes
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::PaintedLayerAttributes PaintedLayerAttributes;
    typedef mozilla::layers::ContainerLayerAttributes ContainerLayerAttributes;
    typedef mozilla::layers::ColorLayerAttributes ColorLayerAttributes;
    typedef mozilla::layers::CanvasLayerAttributes CanvasLayerAttributes;
    typedef mozilla::layers::RefLayerAttributes RefLayerAttributes;
    typedef mozilla::layers::ImageLayerAttributes ImageLayerAttributes;
    typedef null_t null_t__tdef;
    typedef PaintedLayerAttributes PaintedLayerAttributes__tdef;
    typedef ContainerLayerAttributes ContainerLayerAttributes__tdef;
    typedef ColorLayerAttributes ColorLayerAttributes__tdef;
    typedef CanvasLayerAttributes CanvasLayerAttributes__tdef;
    typedef RefLayerAttributes RefLayerAttributes__tdef;
    typedef ImageLayerAttributes ImageLayerAttributes__tdef;

    union Value {
        char Vnull_t[sizeof(null_t)];
        char VPaintedLayerAttributes[sizeof(PaintedLayerAttributes)];
        char VContainerLayerAttributes[sizeof(ContainerLayerAttributes)];
        char VColorLayerAttributes[sizeof(ColorLayerAttributes)];
        char VCanvasLayerAttributes[sizeof(CanvasLayerAttributes)];
        char VRefLayerAttributes[sizeof(RefLayerAttributes)];
        char VImageLayerAttributes[sizeof(ImageLayerAttributes)];
    };

    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }
    PaintedLayerAttributes*
    ptr_PaintedLayerAttributes()
    {
        return reinterpret_cast<PaintedLayerAttributes*>((&((mValue).VPaintedLayerAttributes)));
    }
    const PaintedLayerAttributes* const
    constptr_PaintedLayerAttributes() const
    {
        return reinterpret_cast<const PaintedLayerAttributes* const>((&((mValue).VPaintedLayerAttributes)));
    }
    ContainerLayerAttributes*
    ptr_ContainerLayerAttributes()
    {
        return reinterpret_cast<ContainerLayerAttributes*>((&((mValue).VContainerLayerAttributes)));
    }
    const ContainerLayerAttributes* const
    constptr_ContainerLayerAttributes() const
    {
        return reinterpret_cast<const ContainerLayerAttributes* const>((&((mValue).VContainerLayerAttributes)));
    }
    ColorLayerAttributes*
    ptr_ColorLayerAttributes()
    {
        return reinterpret_cast<ColorLayerAttributes*>((&((mValue).VColorLayerAttributes)));
    }
    const ColorLayerAttributes* const
    constptr_ColorLayerAttributes() const
    {
        return reinterpret_cast<const ColorLayerAttributes* const>((&((mValue).VColorLayerAttributes)));
    }
    CanvasLayerAttributes*
    ptr_CanvasLayerAttributes()
    {
        return reinterpret_cast<CanvasLayerAttributes*>((&((mValue).VCanvasLayerAttributes)));
    }
    const CanvasLayerAttributes* const
    constptr_CanvasLayerAttributes() const
    {
        return reinterpret_cast<const CanvasLayerAttributes* const>((&((mValue).VCanvasLayerAttributes)));
    }
    RefLayerAttributes*
    ptr_RefLayerAttributes()
    {
        return reinterpret_cast<RefLayerAttributes*>((&((mValue).VRefLayerAttributes)));
    }
    const RefLayerAttributes* const
    constptr_RefLayerAttributes() const
    {
        return reinterpret_cast<const RefLayerAttributes* const>((&((mValue).VRefLayerAttributes)));
    }
    ImageLayerAttributes*
    ptr_ImageLayerAttributes()
    {
        return reinterpret_cast<ImageLayerAttributes*>((&((mValue).VImageLayerAttributes)));
    }
    const ImageLayerAttributes* const
    constptr_ImageLayerAttributes() const
    {
        return reinterpret_cast<const ImageLayerAttributes* const>((&((mValue).VImageLayerAttributes)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT SpecificLayerAttributes() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT SpecificLayerAttributes(const null_t& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const PaintedLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const ContainerLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const ColorLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const CanvasLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const RefLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const ImageLayerAttributes& aOther);

    MOZ_IMPLICIT SpecificLayerAttributes(const SpecificLayerAttributes& aOther);

    ~SpecificLayerAttributes();

    Type
    type() const
    {
        return mType;
    }

    SpecificLayerAttributes&
    operator=(const null_t& aRhs);

    SpecificLayerAttributes&
    operator=(const PaintedLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const ContainerLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const ColorLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const CanvasLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const RefLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const ImageLayerAttributes& aRhs);

    SpecificLayerAttributes&
    operator=(const SpecificLayerAttributes& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const PaintedLayerAttributes& aRhs) const;

    bool
    operator==(const ContainerLayerAttributes& aRhs) const;

    bool
    operator==(const ColorLayerAttributes& aRhs) const;

    bool
    operator==(const CanvasLayerAttributes& aRhs) const;

    bool
    operator==(const RefLayerAttributes& aRhs) const;

    bool
    operator==(const ImageLayerAttributes& aRhs) const;

    bool
    operator==(const SpecificLayerAttributes& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    PaintedLayerAttributes&
    get_PaintedLayerAttributes()
    {
        AssertSanity(TPaintedLayerAttributes);
        return (*(ptr_PaintedLayerAttributes()));
    }
    const PaintedLayerAttributes&
    get_PaintedLayerAttributes() const
    {
        AssertSanity(TPaintedLayerAttributes);
        return (*(constptr_PaintedLayerAttributes()));
    }
    operator PaintedLayerAttributes&()
    {
        return get_PaintedLayerAttributes();
    }
    operator const PaintedLayerAttributes&() const
    {
        return get_PaintedLayerAttributes();
    }

    ContainerLayerAttributes&
    get_ContainerLayerAttributes()
    {
        AssertSanity(TContainerLayerAttributes);
        return (*(ptr_ContainerLayerAttributes()));
    }
    const ContainerLayerAttributes&
    get_ContainerLayerAttributes() const
    {
        AssertSanity(TContainerLayerAttributes);
        return (*(constptr_ContainerLayerAttributes()));
    }
    operator ContainerLayerAttributes&()
    {
        return get_ContainerLayerAttributes();
    }
    operator const ContainerLayerAttributes&() const
    {
        return get_ContainerLayerAttributes();
    }

    ColorLayerAttributes&
    get_ColorLayerAttributes()
    {
        AssertSanity(TColorLayerAttributes);
        return (*(ptr_ColorLayerAttributes()));
    }
    const ColorLayerAttributes&
    get_ColorLayerAttributes() const
    {
        AssertSanity(TColorLayerAttributes);
        return (*(constptr_ColorLayerAttributes()));
    }
    operator ColorLayerAttributes&()
    {
        return get_ColorLayerAttributes();
    }
    operator const ColorLayerAttributes&() const
    {
        return get_ColorLayerAttributes();
    }

    CanvasLayerAttributes&
    get_CanvasLayerAttributes()
    {
        AssertSanity(TCanvasLayerAttributes);
        return (*(ptr_CanvasLayerAttributes()));
    }
    const CanvasLayerAttributes&
    get_CanvasLayerAttributes() const
    {
        AssertSanity(TCanvasLayerAttributes);
        return (*(constptr_CanvasLayerAttributes()));
    }
    operator CanvasLayerAttributes&()
    {
        return get_CanvasLayerAttributes();
    }
    operator const CanvasLayerAttributes&() const
    {
        return get_CanvasLayerAttributes();
    }

    RefLayerAttributes&
    get_RefLayerAttributes()
    {
        AssertSanity(TRefLayerAttributes);
        return (*(ptr_RefLayerAttributes()));
    }
    const RefLayerAttributes&
    get_RefLayerAttributes() const
    {
        AssertSanity(TRefLayerAttributes);
        return (*(constptr_RefLayerAttributes()));
    }
    operator RefLayerAttributes&()
    {
        return get_RefLayerAttributes();
    }
    operator const RefLayerAttributes&() const
    {
        return get_RefLayerAttributes();
    }

    ImageLayerAttributes&
    get_ImageLayerAttributes()
    {
        AssertSanity(TImageLayerAttributes);
        return (*(ptr_ImageLayerAttributes()));
    }
    const ImageLayerAttributes&
    get_ImageLayerAttributes() const
    {
        AssertSanity(TImageLayerAttributes);
        return (*(constptr_ImageLayerAttributes()));
    }
    operator ImageLayerAttributes&()
    {
        return get_ImageLayerAttributes();
    }
    operator const ImageLayerAttributes&() const
    {
        return get_ImageLayerAttributes();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class CommonLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class SpecificLayerAttributes;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LayerAttributes|
//
namespace mozilla {
namespace layers {
class LayerAttributes final
{
private:
    typedef mozilla::layers::CommonLayerAttributes CommonLayerAttributes;
    typedef mozilla::layers::SpecificLayerAttributes SpecificLayerAttributes;

public:
    MOZ_IMPLICIT LayerAttributes();

    MOZ_IMPLICIT LayerAttributes(
            const CommonLayerAttributes& _common,
            const SpecificLayerAttributes& _specific)
    {
        Init();
        Assign(_common, _specific);
    }

    MOZ_IMPLICIT LayerAttributes(const LayerAttributes& _o)
    {
        Init();
        Assign((_o).common(), (_o).specific());
    }

    ~LayerAttributes();

    void
    operator=(const LayerAttributes& _o)
    {
        Assign((_o).common(), (_o).specific());
    }

    bool
    operator==(const LayerAttributes& _o) const;

    CommonLayerAttributes&
    common()
    {
        return common_;
    }
    const CommonLayerAttributes&
    common() const
    {
        return common_;
    }

    SpecificLayerAttributes&
    specific()
    {
        return specific_;
    }
    const SpecificLayerAttributes&
    specific() const
    {
        return specific_;
    }

private:
    void
    Init();

    void
    Assign(
            const CommonLayerAttributes& _common,
            const SpecificLayerAttributes& _specific);

    CommonLayerAttributes common_;
    SpecificLayerAttributes specific_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PluginWindowData|
//
namespace mozilla {
namespace layers {
class PluginWindowData final
{
private:
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT PluginWindowData();

    MOZ_IMPLICIT PluginWindowData(
            const uintptr_t& _windowId,
            const nsTArray<IntRect>& _clip,
            const IntRect& _bounds,
            const bool& _visible)
    {
        Init();
        Assign(_windowId, _clip, _bounds, _visible);
    }

    MOZ_IMPLICIT PluginWindowData(const PluginWindowData& _o)
    {
        Init();
        Assign((_o).windowId(), (_o).clip(), (_o).bounds(), (_o).visible());
    }

    ~PluginWindowData();

    void
    operator=(const PluginWindowData& _o)
    {
        Assign((_o).windowId(), (_o).clip(), (_o).bounds(), (_o).visible());
    }

    bool
    operator==(const PluginWindowData& _o) const;

    uintptr_t&
    windowId()
    {
        return windowId_;
    }
    const uintptr_t&
    windowId() const
    {
        return windowId_;
    }

    nsTArray<IntRect>&
    clip()
    {
        return clip_;
    }
    const nsTArray<IntRect>&
    clip() const
    {
        return clip_;
    }

    IntRect&
    bounds()
    {
        return bounds_;
    }
    const IntRect&
    bounds() const
    {
        return bounds_;
    }

    bool&
    visible()
    {
        return visible_;
    }
    const bool&
    visible() const
    {
        return visible_;
    }

private:
    void
    Init();

    void
    Assign(
            const uintptr_t& _windowId,
            const nsTArray<IntRect>& _clip,
            const IntRect& _bounds,
            const bool& _visible);

    uintptr_t windowId_;
    nsTArray<IntRect> clip_;
    IntRect bounds_;
    bool visible_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class LayerAttributes;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetLayerAttributes|
//
namespace mozilla {
namespace layers {
class OpSetLayerAttributes final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;
    typedef mozilla::layers::LayerAttributes LayerAttributes;

public:
    MOZ_IMPLICIT OpSetLayerAttributes();

    MOZ_IMPLICIT OpSetLayerAttributes(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild,
            const LayerAttributes& _attrs)
    {
        Init();
        Assign(_layerParent, _layerChild, _attrs);
    }

    MOZ_IMPLICIT OpSetLayerAttributes(const OpSetLayerAttributes& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()), (_o).attrs());
    }

    ~OpSetLayerAttributes();

    void
    operator=(const OpSetLayerAttributes& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).layerParent()), const_cast<PLayerChild*>((_o).layerChild()), (_o).attrs());
    }

    bool
    operator==(const OpSetLayerAttributes& _o) const;

    PLayerParent*&
    layerParent()
    {
        return layerParent_;
    }
    PLayerParent*
    layerParent() const
    {
        return layerParent_;
    }

    PLayerChild*&
    layerChild()
    {
        return layerChild_;
    }
    PLayerChild*
    layerChild() const
    {
        return layerChild_;
    }

    LayerAttributes&
    attrs()
    {
        return attrs_;
    }
    const LayerAttributes&
    attrs() const
    {
        return attrs_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _layerParent,
            PLayerChild* _layerChild,
            const LayerAttributes& _attrs);

    PLayerParent* layerParent_;
    PLayerChild* layerChild_;
    LayerAttributes attrs_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetRoot|
//
namespace mozilla {
namespace layers {
class OpSetRoot final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpSetRoot();

    MOZ_IMPLICIT OpSetRoot(
            PLayerParent* _rootParent,
            PLayerChild* _rootChild)
    {
        Init();
        Assign(_rootParent, _rootChild);
    }

    MOZ_IMPLICIT OpSetRoot(const OpSetRoot& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).rootParent()), const_cast<PLayerChild*>((_o).rootChild()));
    }

    ~OpSetRoot();

    void
    operator=(const OpSetRoot& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).rootParent()), const_cast<PLayerChild*>((_o).rootChild()));
    }

    bool
    operator==(const OpSetRoot& _o) const;

    PLayerParent*&
    rootParent()
    {
        return rootParent_;
    }
    PLayerParent*
    rootParent() const
    {
        return rootParent_;
    }

    PLayerChild*&
    rootChild()
    {
        return rootChild_;
    }
    PLayerChild*
    rootChild() const
    {
        return rootChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _rootParent,
            PLayerChild* _rootChild);

    PLayerParent* rootParent_;
    PLayerChild* rootChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpInsertAfter|
//
namespace mozilla {
namespace layers {
class OpInsertAfter final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpInsertAfter();

    MOZ_IMPLICIT OpInsertAfter(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild,
            PLayerParent* _afterParent,
            PLayerChild* _afterChild)
    {
        Init();
        Assign(_containerParent, _containerChild, _childLayerParent, _childLayerChild, _afterParent, _afterChild);
    }

    MOZ_IMPLICIT OpInsertAfter(const OpInsertAfter& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()), const_cast<PLayerParent*>((_o).afterParent()), const_cast<PLayerChild*>((_o).afterChild()));
    }

    ~OpInsertAfter();

    void
    operator=(const OpInsertAfter& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()), const_cast<PLayerParent*>((_o).afterParent()), const_cast<PLayerChild*>((_o).afterChild()));
    }

    bool
    operator==(const OpInsertAfter& _o) const;

    PLayerParent*&
    containerParent()
    {
        return containerParent_;
    }
    PLayerParent*
    containerParent() const
    {
        return containerParent_;
    }

    PLayerChild*&
    containerChild()
    {
        return containerChild_;
    }
    PLayerChild*
    containerChild() const
    {
        return containerChild_;
    }

    PLayerParent*&
    childLayerParent()
    {
        return childLayerParent_;
    }
    PLayerParent*
    childLayerParent() const
    {
        return childLayerParent_;
    }

    PLayerChild*&
    childLayerChild()
    {
        return childLayerChild_;
    }
    PLayerChild*
    childLayerChild() const
    {
        return childLayerChild_;
    }

    PLayerParent*&
    afterParent()
    {
        return afterParent_;
    }
    PLayerParent*
    afterParent() const
    {
        return afterParent_;
    }

    PLayerChild*&
    afterChild()
    {
        return afterChild_;
    }
    PLayerChild*
    afterChild() const
    {
        return afterChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild,
            PLayerParent* _afterParent,
            PLayerChild* _afterChild);

    PLayerParent* containerParent_;
    PLayerChild* containerChild_;
    PLayerParent* childLayerParent_;
    PLayerChild* childLayerChild_;
    PLayerParent* afterParent_;
    PLayerChild* afterChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpPrependChild|
//
namespace mozilla {
namespace layers {
class OpPrependChild final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpPrependChild();

    MOZ_IMPLICIT OpPrependChild(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild)
    {
        Init();
        Assign(_containerParent, _containerChild, _childLayerParent, _childLayerChild);
    }

    MOZ_IMPLICIT OpPrependChild(const OpPrependChild& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()));
    }

    ~OpPrependChild();

    void
    operator=(const OpPrependChild& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()));
    }

    bool
    operator==(const OpPrependChild& _o) const;

    PLayerParent*&
    containerParent()
    {
        return containerParent_;
    }
    PLayerParent*
    containerParent() const
    {
        return containerParent_;
    }

    PLayerChild*&
    containerChild()
    {
        return containerChild_;
    }
    PLayerChild*
    containerChild() const
    {
        return containerChild_;
    }

    PLayerParent*&
    childLayerParent()
    {
        return childLayerParent_;
    }
    PLayerParent*
    childLayerParent() const
    {
        return childLayerParent_;
    }

    PLayerChild*&
    childLayerChild()
    {
        return childLayerChild_;
    }
    PLayerChild*
    childLayerChild() const
    {
        return childLayerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild);

    PLayerParent* containerParent_;
    PLayerChild* containerChild_;
    PLayerParent* childLayerParent_;
    PLayerChild* childLayerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRemoveChild|
//
namespace mozilla {
namespace layers {
class OpRemoveChild final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpRemoveChild();

    MOZ_IMPLICIT OpRemoveChild(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild)
    {
        Init();
        Assign(_containerParent, _containerChild, _childLayerParent, _childLayerChild);
    }

    MOZ_IMPLICIT OpRemoveChild(const OpRemoveChild& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()));
    }

    ~OpRemoveChild();

    void
    operator=(const OpRemoveChild& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()));
    }

    bool
    operator==(const OpRemoveChild& _o) const;

    PLayerParent*&
    containerParent()
    {
        return containerParent_;
    }
    PLayerParent*
    containerParent() const
    {
        return containerParent_;
    }

    PLayerChild*&
    containerChild()
    {
        return containerChild_;
    }
    PLayerChild*
    containerChild() const
    {
        return containerChild_;
    }

    PLayerParent*&
    childLayerParent()
    {
        return childLayerParent_;
    }
    PLayerParent*
    childLayerParent() const
    {
        return childLayerParent_;
    }

    PLayerChild*&
    childLayerChild()
    {
        return childLayerChild_;
    }
    PLayerChild*
    childLayerChild() const
    {
        return childLayerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild);

    PLayerParent* containerParent_;
    PLayerChild* containerChild_;
    PLayerParent* childLayerParent_;
    PLayerChild* childLayerChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRepositionChild|
//
namespace mozilla {
namespace layers {
class OpRepositionChild final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpRepositionChild();

    MOZ_IMPLICIT OpRepositionChild(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild,
            PLayerParent* _afterParent,
            PLayerChild* _afterChild)
    {
        Init();
        Assign(_containerParent, _containerChild, _childLayerParent, _childLayerChild, _afterParent, _afterChild);
    }

    MOZ_IMPLICIT OpRepositionChild(const OpRepositionChild& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()), const_cast<PLayerParent*>((_o).afterParent()), const_cast<PLayerChild*>((_o).afterChild()));
    }

    ~OpRepositionChild();

    void
    operator=(const OpRepositionChild& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()), const_cast<PLayerParent*>((_o).afterParent()), const_cast<PLayerChild*>((_o).afterChild()));
    }

    bool
    operator==(const OpRepositionChild& _o) const;

    PLayerParent*&
    containerParent()
    {
        return containerParent_;
    }
    PLayerParent*
    containerParent() const
    {
        return containerParent_;
    }

    PLayerChild*&
    containerChild()
    {
        return containerChild_;
    }
    PLayerChild*
    containerChild() const
    {
        return containerChild_;
    }

    PLayerParent*&
    childLayerParent()
    {
        return childLayerParent_;
    }
    PLayerParent*
    childLayerParent() const
    {
        return childLayerParent_;
    }

    PLayerChild*&
    childLayerChild()
    {
        return childLayerChild_;
    }
    PLayerChild*
    childLayerChild() const
    {
        return childLayerChild_;
    }

    PLayerParent*&
    afterParent()
    {
        return afterParent_;
    }
    PLayerParent*
    afterParent() const
    {
        return afterParent_;
    }

    PLayerChild*&
    afterChild()
    {
        return afterChild_;
    }
    PLayerChild*
    afterChild() const
    {
        return afterChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild,
            PLayerParent* _afterParent,
            PLayerChild* _afterChild);

    PLayerParent* containerParent_;
    PLayerChild* containerChild_;
    PLayerParent* childLayerParent_;
    PLayerChild* childLayerChild_;
    PLayerParent* afterParent_;
    PLayerChild* afterChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRaiseToTopChild|
//
namespace mozilla {
namespace layers {
class OpRaiseToTopChild final
{
private:
    typedef mozilla::layers::PLayerParent PLayerParent;
    typedef mozilla::layers::PLayerChild PLayerChild;

public:
    MOZ_IMPLICIT OpRaiseToTopChild();

    MOZ_IMPLICIT OpRaiseToTopChild(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild)
    {
        Init();
        Assign(_containerParent, _containerChild, _childLayerParent, _childLayerChild);
    }

    MOZ_IMPLICIT OpRaiseToTopChild(const OpRaiseToTopChild& _o)
    {
        Init();
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()));
    }

    ~OpRaiseToTopChild();

    void
    operator=(const OpRaiseToTopChild& _o)
    {
        Assign(const_cast<PLayerParent*>((_o).containerParent()), const_cast<PLayerChild*>((_o).containerChild()), const_cast<PLayerParent*>((_o).childLayerParent()), const_cast<PLayerChild*>((_o).childLayerChild()));
    }

    bool
    operator==(const OpRaiseToTopChild& _o) const;

    PLayerParent*&
    containerParent()
    {
        return containerParent_;
    }
    PLayerParent*
    containerParent() const
    {
        return containerParent_;
    }

    PLayerChild*&
    containerChild()
    {
        return containerChild_;
    }
    PLayerChild*
    containerChild() const
    {
        return containerChild_;
    }

    PLayerParent*&
    childLayerParent()
    {
        return childLayerParent_;
    }
    PLayerParent*
    childLayerParent() const
    {
        return childLayerParent_;
    }

    PLayerChild*&
    childLayerChild()
    {
        return childLayerChild_;
    }
    PLayerChild*
    childLayerChild() const
    {
        return childLayerChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PLayerParent* _containerParent,
            PLayerChild* _containerChild,
            PLayerParent* _childLayerParent,
            PLayerChild* _childLayerChild);

    PLayerParent* containerParent_;
    PLayerChild* containerChild_;
    PLayerParent* childLayerParent_;
    PLayerChild* childLayerChild_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpSetDiagnosticTypes|
//
namespace mozilla {
namespace layers {
class OpSetDiagnosticTypes final
{
private:
    typedef mozilla::layers::DiagnosticTypes DiagnosticTypes;

public:
    MOZ_IMPLICIT OpSetDiagnosticTypes();

    MOZ_IMPLICIT OpSetDiagnosticTypes(const DiagnosticTypes& _diagnostics)
    {
        Init();
        Assign(_diagnostics);
    }

    MOZ_IMPLICIT OpSetDiagnosticTypes(const OpSetDiagnosticTypes& _o)
    {
        Init();
        Assign((_o).diagnostics());
    }

    ~OpSetDiagnosticTypes();

    void
    operator=(const OpSetDiagnosticTypes& _o)
    {
        Assign((_o).diagnostics());
    }

    bool
    operator==(const OpSetDiagnosticTypes& _o) const;

    DiagnosticTypes&
    diagnostics()
    {
        return diagnostics_;
    }
    const DiagnosticTypes&
    diagnostics() const
    {
        return diagnostics_;
    }

private:
    void
    Init();

    void
    Assign(const DiagnosticTypes& _diagnostics);

    DiagnosticTypes diagnostics_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ShmemSection|
//
namespace mozilla {
namespace layers {
class ShmemSection final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT ShmemSection();

    MOZ_IMPLICIT ShmemSection(
            Shmem& _shmem,
            const uint32_t& _offset,
            const size_t& _size)
    {
        Init();
        Assign(_shmem, _offset, _size);
    }

    MOZ_IMPLICIT ShmemSection(const ShmemSection& _o)
    {
        Init();
        Assign((_o).shmem(), (_o).offset(), (_o).size());
    }

    ~ShmemSection();

    void
    operator=(const ShmemSection& _o)
    {
        Assign((_o).shmem(), (_o).offset(), (_o).size());
    }

    bool
    operator==(const ShmemSection& _o) const;

    Shmem&
    shmem()
    {
        return shmem_;
    }
    Shmem&
    shmem() const
    {
        return const_cast<Shmem&>(shmem_);
    }

    uint32_t&
    offset()
    {
        return offset_;
    }
    const uint32_t&
    offset() const
    {
        return offset_;
    }

    size_t&
    size()
    {
        return size_;
    }
    const size_t&
    size() const
    {
        return size_;
    }

private:
    void
    Init();

    void
    Assign(
            Shmem& _shmem,
            const uint32_t& _offset,
            const size_t& _size);

    Shmem shmem_;
    uint32_t offset_;
    size_t size_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class ShmemSection;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TileLock|
//
namespace mozilla {
namespace layers {
class TileLock final
{
public:
    enum Type {
        T__None,
        TShmemSection = 1,
        Tuintptr_t,
        T__Last = Tuintptr_t
    };

private:
    typedef mozilla::layers::ShmemSection ShmemSection;
    typedef ShmemSection ShmemSection__tdef;
    typedef uintptr_t uintptr_t__tdef;

    union Value {
        char VShmemSection[sizeof(ShmemSection)];
        char Vuintptr_t[sizeof(uintptr_t)];
    };

    ShmemSection*
    ptr_ShmemSection()
    {
        return reinterpret_cast<ShmemSection*>((&((mValue).VShmemSection)));
    }
    const ShmemSection* const
    constptr_ShmemSection() const
    {
        return reinterpret_cast<const ShmemSection* const>((&((mValue).VShmemSection)));
    }
    uintptr_t*
    ptr_uintptr_t()
    {
        return reinterpret_cast<uintptr_t*>((&((mValue).Vuintptr_t)));
    }
    const uintptr_t* const
    constptr_uintptr_t() const
    {
        return reinterpret_cast<const uintptr_t* const>((&((mValue).Vuintptr_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TileLock() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TileLock(const ShmemSection& aOther);

    MOZ_IMPLICIT TileLock(const uintptr_t& aOther);

    MOZ_IMPLICIT TileLock(const TileLock& aOther);

    ~TileLock();

    Type
    type() const
    {
        return mType;
    }

    TileLock&
    operator=(const ShmemSection& aRhs);

    TileLock&
    operator=(const uintptr_t& aRhs);

    TileLock&
    operator=(const TileLock& aRhs);

    bool
    operator==(const ShmemSection& aRhs) const;

    bool
    operator==(const uintptr_t& aRhs) const;

    bool
    operator==(const TileLock& aRhs) const;

    ShmemSection&
    get_ShmemSection()
    {
        AssertSanity(TShmemSection);
        return (*(ptr_ShmemSection()));
    }
    const ShmemSection&
    get_ShmemSection() const
    {
        AssertSanity(TShmemSection);
        return (*(constptr_ShmemSection()));
    }
    operator ShmemSection&()
    {
        return get_ShmemSection();
    }
    operator const ShmemSection&() const
    {
        return get_ShmemSection();
    }

    uintptr_t&
    get_uintptr_t()
    {
        AssertSanity(Tuintptr_t);
        return (*(ptr_uintptr_t()));
    }
    const uintptr_t&
    get_uintptr_t() const
    {
        AssertSanity(Tuintptr_t);
        return (*(constptr_uintptr_t()));
    }
    operator uintptr_t&()
    {
        return get_uintptr_t();
    }
    operator const uintptr_t&() const
    {
        return get_uintptr_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeTexture|
//
namespace mozilla {
namespace layers {
class MaybeTexture final
{
public:
    enum Type {
        T__None,
        TPTextureParent = 1,
        TPTextureChild,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::null_t null_t;
    typedef PTextureParent* PTextureParent__tdef;
    typedef PTextureChild* PTextureChild__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char VPTextureParent[sizeof(PTextureParent*)];
        char VPTextureChild[sizeof(PTextureChild*)];
        char Vnull_t[sizeof(null_t)];
    };

    PTextureParent**
    ptr_PTextureParent()
    {
        return reinterpret_cast<PTextureParent**>((&((mValue).VPTextureParent)));
    }
    PTextureParent* const*
    constptr_PTextureParent() const
    {
        return reinterpret_cast<PTextureParent* const*>((&((mValue).VPTextureParent)));
    }
    PTextureChild**
    ptr_PTextureChild()
    {
        return reinterpret_cast<PTextureChild**>((&((mValue).VPTextureChild)));
    }
    PTextureChild* const*
    constptr_PTextureChild() const
    {
        return reinterpret_cast<PTextureChild* const*>((&((mValue).VPTextureChild)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeTexture() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeTexture(PTextureParent* aOther);

    MOZ_IMPLICIT MaybeTexture(PTextureChild* aOther);

    MOZ_IMPLICIT MaybeTexture(const null_t& aOther);

    MOZ_IMPLICIT MaybeTexture(const MaybeTexture& aOther);

    ~MaybeTexture();

    Type
    type() const
    {
        return mType;
    }

    MaybeTexture&
    operator=(PTextureParent* aRhs);

    MaybeTexture&
    operator=(PTextureChild* aRhs);

    MaybeTexture&
    operator=(const null_t& aRhs);

    MaybeTexture&
    operator=(const MaybeTexture& aRhs);

    bool
    operator==(PTextureParent* aRhs) const;

    bool
    operator==(PTextureChild* aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeTexture& aRhs) const;

    PTextureParent*&
    get_PTextureParent()
    {
        AssertSanity(TPTextureParent);
        return (*(ptr_PTextureParent()));
    }
    PTextureParent*
    get_PTextureParent() const
    {
        AssertSanity(TPTextureParent);
        return (*(constptr_PTextureParent()));
    }
    operator PTextureParent*&()
    {
        return get_PTextureParent();
    }
    operator PTextureParent*() const
    {
        return get_PTextureParent();
    }

    PTextureChild*&
    get_PTextureChild()
    {
        AssertSanity(TPTextureChild);
        return (*(ptr_PTextureChild()));
    }
    PTextureChild*
    get_PTextureChild() const
    {
        AssertSanity(TPTextureChild);
        return (*(constptr_PTextureChild()));
    }
    operator PTextureChild*&()
    {
        return get_PTextureChild();
    }
    operator PTextureChild*() const
    {
        return get_PTextureChild();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class MaybeTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class TileLock;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TexturedTileDescriptor|
//
namespace mozilla {
namespace layers {
class TexturedTileDescriptor final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::MaybeTexture MaybeTexture;
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::layers::TileLock TileLock;

public:
    MOZ_IMPLICIT TexturedTileDescriptor();

    MOZ_IMPLICIT TexturedTileDescriptor(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const MaybeTexture& _textureOnWhite,
            const IntRect& _updateRect,
            const TileLock& _sharedLock)
    {
        Init();
        Assign(_textureParent, _textureChild, _textureOnWhite, _updateRect, _sharedLock);
    }

    MOZ_IMPLICIT TexturedTileDescriptor(const TexturedTileDescriptor& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).textureOnWhite(), (_o).updateRect(), (_o).sharedLock());
    }

    ~TexturedTileDescriptor();

    void
    operator=(const TexturedTileDescriptor& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).textureOnWhite(), (_o).updateRect(), (_o).sharedLock());
    }

    bool
    operator==(const TexturedTileDescriptor& _o) const;

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    MaybeTexture&
    textureOnWhite()
    {
        return textureOnWhite_;
    }
    const MaybeTexture&
    textureOnWhite() const
    {
        return textureOnWhite_;
    }

    IntRect&
    updateRect()
    {
        return updateRect_;
    }
    const IntRect&
    updateRect() const
    {
        return updateRect_;
    }

    TileLock&
    sharedLock()
    {
        return sharedLock_;
    }
    const TileLock&
    sharedLock() const
    {
        return sharedLock_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const MaybeTexture& _textureOnWhite,
            const IntRect& _updateRect,
            const TileLock& _sharedLock);

    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    MaybeTexture textureOnWhite_;
    IntRect updateRect_;
    TileLock sharedLock_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PlaceholderTileDescriptor|
//
namespace mozilla {
namespace layers {
class PlaceholderTileDescriptor final
{
private:

public:
    MOZ_IMPLICIT PlaceholderTileDescriptor()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT PlaceholderTileDescriptor(const PlaceholderTileDescriptor& _o)
    {
        Init();
        Assign();
    }

    ~PlaceholderTileDescriptor();

    void
    operator=(const PlaceholderTileDescriptor& _o)
    {
        Assign();
    }

    bool
    operator==(const PlaceholderTileDescriptor& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TexturedTileDescriptor;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PlaceholderTileDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TileDescriptor|
//
namespace mozilla {
namespace layers {
class TileDescriptor final
{
public:
    enum Type {
        T__None,
        TTexturedTileDescriptor = 1,
        TPlaceholderTileDescriptor,
        T__Last = TPlaceholderTileDescriptor
    };

private:
    typedef mozilla::layers::TexturedTileDescriptor TexturedTileDescriptor;
    typedef mozilla::layers::PlaceholderTileDescriptor PlaceholderTileDescriptor;
    typedef TexturedTileDescriptor TexturedTileDescriptor__tdef;
    typedef PlaceholderTileDescriptor PlaceholderTileDescriptor__tdef;

    union Value {
        char VTexturedTileDescriptor[sizeof(TexturedTileDescriptor)];
        char VPlaceholderTileDescriptor[sizeof(PlaceholderTileDescriptor)];
    };

    TexturedTileDescriptor*
    ptr_TexturedTileDescriptor()
    {
        return reinterpret_cast<TexturedTileDescriptor*>((&((mValue).VTexturedTileDescriptor)));
    }
    const TexturedTileDescriptor* const
    constptr_TexturedTileDescriptor() const
    {
        return reinterpret_cast<const TexturedTileDescriptor* const>((&((mValue).VTexturedTileDescriptor)));
    }
    PlaceholderTileDescriptor*
    ptr_PlaceholderTileDescriptor()
    {
        return reinterpret_cast<PlaceholderTileDescriptor*>((&((mValue).VPlaceholderTileDescriptor)));
    }
    const PlaceholderTileDescriptor* const
    constptr_PlaceholderTileDescriptor() const
    {
        return reinterpret_cast<const PlaceholderTileDescriptor* const>((&((mValue).VPlaceholderTileDescriptor)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TileDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TileDescriptor(const TexturedTileDescriptor& aOther);

    MOZ_IMPLICIT TileDescriptor(const PlaceholderTileDescriptor& aOther);

    MOZ_IMPLICIT TileDescriptor(const TileDescriptor& aOther);

    ~TileDescriptor();

    Type
    type() const
    {
        return mType;
    }

    TileDescriptor&
    operator=(const TexturedTileDescriptor& aRhs);

    TileDescriptor&
    operator=(const PlaceholderTileDescriptor& aRhs);

    TileDescriptor&
    operator=(const TileDescriptor& aRhs);

    bool
    operator==(const TexturedTileDescriptor& aRhs) const;

    bool
    operator==(const PlaceholderTileDescriptor& aRhs) const;

    bool
    operator==(const TileDescriptor& aRhs) const;

    TexturedTileDescriptor&
    get_TexturedTileDescriptor()
    {
        AssertSanity(TTexturedTileDescriptor);
        return (*(ptr_TexturedTileDescriptor()));
    }
    const TexturedTileDescriptor&
    get_TexturedTileDescriptor() const
    {
        AssertSanity(TTexturedTileDescriptor);
        return (*(constptr_TexturedTileDescriptor()));
    }
    operator TexturedTileDescriptor&()
    {
        return get_TexturedTileDescriptor();
    }
    operator const TexturedTileDescriptor&() const
    {
        return get_TexturedTileDescriptor();
    }

    PlaceholderTileDescriptor&
    get_PlaceholderTileDescriptor()
    {
        AssertSanity(TPlaceholderTileDescriptor);
        return (*(ptr_PlaceholderTileDescriptor()));
    }
    const PlaceholderTileDescriptor&
    get_PlaceholderTileDescriptor() const
    {
        AssertSanity(TPlaceholderTileDescriptor);
        return (*(constptr_PlaceholderTileDescriptor()));
    }
    operator PlaceholderTileDescriptor&()
    {
        return get_PlaceholderTileDescriptor();
    }
    operator const PlaceholderTileDescriptor&() const
    {
        return get_PlaceholderTileDescriptor();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TileDescriptor;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SurfaceDescriptorTiles|
//
namespace mozilla {
namespace layers {
class SurfaceDescriptorTiles final
{
private:
    typedef mozilla::layers::TileDescriptor TileDescriptor;
    typedef mozilla::gfx::IntPoint IntPoint;
    typedef mozilla::gfx::IntSize IntSize;

public:
    MOZ_IMPLICIT SurfaceDescriptorTiles();

    MOZ_IMPLICIT SurfaceDescriptorTiles(
            const nsIntRegion& _validRegion,
            const nsTArray<TileDescriptor>& _tiles,
            const IntPoint& _tileOrigin,
            const IntSize& _tileSize,
            const int& _firstTileX,
            const int& _firstTileY,
            const int& _retainedWidth,
            const int& _retainedHeight,
            const float& _resolution,
            const float& _frameXResolution,
            const float& _frameYResolution)
    {
        Init();
        Assign(_validRegion, _tiles, _tileOrigin, _tileSize, _firstTileX, _firstTileY, _retainedWidth, _retainedHeight, _resolution, _frameXResolution, _frameYResolution);
    }

    MOZ_IMPLICIT SurfaceDescriptorTiles(const SurfaceDescriptorTiles& _o)
    {
        Init();
        Assign((_o).validRegion(), (_o).tiles(), (_o).tileOrigin(), (_o).tileSize(), (_o).firstTileX(), (_o).firstTileY(), (_o).retainedWidth(), (_o).retainedHeight(), (_o).resolution(), (_o).frameXResolution(), (_o).frameYResolution());
    }

    ~SurfaceDescriptorTiles();

    void
    operator=(const SurfaceDescriptorTiles& _o)
    {
        Assign((_o).validRegion(), (_o).tiles(), (_o).tileOrigin(), (_o).tileSize(), (_o).firstTileX(), (_o).firstTileY(), (_o).retainedWidth(), (_o).retainedHeight(), (_o).resolution(), (_o).frameXResolution(), (_o).frameYResolution());
    }

    bool
    operator==(const SurfaceDescriptorTiles& _o) const;

    nsIntRegion&
    validRegion()
    {
        return validRegion_;
    }
    const nsIntRegion&
    validRegion() const
    {
        return validRegion_;
    }

    nsTArray<TileDescriptor>&
    tiles()
    {
        return tiles_;
    }
    const nsTArray<TileDescriptor>&
    tiles() const
    {
        return tiles_;
    }

    IntPoint&
    tileOrigin()
    {
        return tileOrigin_;
    }
    const IntPoint&
    tileOrigin() const
    {
        return tileOrigin_;
    }

    IntSize&
    tileSize()
    {
        return tileSize_;
    }
    const IntSize&
    tileSize() const
    {
        return tileSize_;
    }

    int&
    firstTileX()
    {
        return firstTileX_;
    }
    const int&
    firstTileX() const
    {
        return firstTileX_;
    }

    int&
    firstTileY()
    {
        return firstTileY_;
    }
    const int&
    firstTileY() const
    {
        return firstTileY_;
    }

    int&
    retainedWidth()
    {
        return retainedWidth_;
    }
    const int&
    retainedWidth() const
    {
        return retainedWidth_;
    }

    int&
    retainedHeight()
    {
        return retainedHeight_;
    }
    const int&
    retainedHeight() const
    {
        return retainedHeight_;
    }

    float&
    resolution()
    {
        return resolution_;
    }
    const float&
    resolution() const
    {
        return resolution_;
    }

    float&
    frameXResolution()
    {
        return frameXResolution_;
    }
    const float&
    frameXResolution() const
    {
        return frameXResolution_;
    }

    float&
    frameYResolution()
    {
        return frameYResolution_;
    }
    const float&
    frameYResolution() const
    {
        return frameYResolution_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsIntRegion& _validRegion,
            const nsTArray<TileDescriptor>& _tiles,
            const IntPoint& _tileOrigin,
            const IntSize& _tileSize,
            const int& _firstTileX,
            const int& _firstTileY,
            const int& _retainedWidth,
            const int& _retainedHeight,
            const float& _resolution,
            const float& _frameXResolution,
            const float& _frameYResolution);

    nsIntRegion validRegion_;
    nsTArray<TileDescriptor> tiles_;
    IntPoint tileOrigin_;
    IntSize tileSize_;
    int firstTileX_;
    int firstTileY_;
    int retainedWidth_;
    int retainedHeight_;
    float resolution_;
    float frameXResolution_;
    float frameYResolution_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class SurfaceDescriptorTiles;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseTiledLayerBuffer|
//
namespace mozilla {
namespace layers {
class OpUseTiledLayerBuffer final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::SurfaceDescriptorTiles SurfaceDescriptorTiles;

public:
    MOZ_IMPLICIT OpUseTiledLayerBuffer();

    MOZ_IMPLICIT OpUseTiledLayerBuffer(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const SurfaceDescriptorTiles& _tileLayerDescriptor)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _tileLayerDescriptor);
    }

    MOZ_IMPLICIT OpUseTiledLayerBuffer(const OpUseTiledLayerBuffer& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).tileLayerDescriptor());
    }

    ~OpUseTiledLayerBuffer();

    void
    operator=(const OpUseTiledLayerBuffer& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).tileLayerDescriptor());
    }

    bool
    operator==(const OpUseTiledLayerBuffer& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    SurfaceDescriptorTiles&
    tileLayerDescriptor()
    {
        return tileLayerDescriptor_;
    }
    const SurfaceDescriptorTiles&
    tileLayerDescriptor() const
    {
        return tileLayerDescriptor_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const SurfaceDescriptorTiles& _tileLayerDescriptor);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    SurfaceDescriptorTiles tileLayerDescriptor_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OverlaySource;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseOverlaySource|
//
namespace mozilla {
namespace layers {
class OpUseOverlaySource final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::OverlaySource OverlaySource;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT OpUseOverlaySource();

    MOZ_IMPLICIT OpUseOverlaySource(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const OverlaySource& _overlay,
            const IntRect& _picture)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _overlay, _picture);
    }

    MOZ_IMPLICIT OpUseOverlaySource(const OpUseOverlaySource& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).overlay(), (_o).picture());
    }

    ~OpUseOverlaySource();

    void
    operator=(const OpUseOverlaySource& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).overlay(), (_o).picture());
    }

    bool
    operator==(const OpUseOverlaySource& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    OverlaySource&
    overlay()
    {
        return overlay_;
    }
    const OverlaySource&
    overlay() const
    {
        return overlay_;
    }

    IntRect&
    picture()
    {
        return picture_;
    }
    const IntRect&
    picture() const
    {
        return picture_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const OverlaySource& _overlay,
            const IntRect& _picture);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    OverlaySource overlay_;
    IntRect picture_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class ThebesBufferData;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpPaintTextureRegion|
//
namespace mozilla {
namespace layers {
class OpPaintTextureRegion final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::ThebesBufferData ThebesBufferData;

public:
    MOZ_IMPLICIT OpPaintTextureRegion();

    MOZ_IMPLICIT OpPaintTextureRegion(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const ThebesBufferData& _bufferData,
            const nsIntRegion& _updatedRegion)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _bufferData, _updatedRegion);
    }

    MOZ_IMPLICIT OpPaintTextureRegion(const OpPaintTextureRegion& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).bufferData(), (_o).updatedRegion());
    }

    ~OpPaintTextureRegion();

    void
    operator=(const OpPaintTextureRegion& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).bufferData(), (_o).updatedRegion());
    }

    bool
    operator==(const OpPaintTextureRegion& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    ThebesBufferData&
    bufferData()
    {
        return bufferData_;
    }
    const ThebesBufferData&
    bufferData() const
    {
        return bufferData_;
    }

    nsIntRegion&
    updatedRegion()
    {
        return updatedRegion_;
    }
    const nsIntRegion&
    updatedRegion() const
    {
        return updatedRegion_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const ThebesBufferData& _bufferData,
            const nsIntRegion& _updatedRegion);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    ThebesBufferData bufferData_;
    nsIntRegion updatedRegion_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRemoveTexture|
//
namespace mozilla {
namespace layers {
class OpRemoveTexture final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;

public:
    MOZ_IMPLICIT OpRemoveTexture();

    MOZ_IMPLICIT OpRemoveTexture(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            PTextureParent* _textureParent,
            PTextureChild* _textureChild)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _textureParent, _textureChild);
    }

    MOZ_IMPLICIT OpRemoveTexture(const OpRemoveTexture& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()));
    }

    ~OpRemoveTexture();

    void
    operator=(const OpRemoveTexture& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()));
    }

    bool
    operator==(const OpRemoveTexture& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            PTextureParent* _textureParent,
            PTextureChild* _textureChild);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRemoveTextureAsync|
//
namespace mozilla {
namespace layers {
class OpRemoveTextureAsync final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;

public:
    MOZ_IMPLICIT OpRemoveTextureAsync();

    MOZ_IMPLICIT OpRemoveTextureAsync(
            const uint64_t& _holderId,
            const uint64_t& _transactionId,
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            PTextureParent* _textureParent,
            PTextureChild* _textureChild)
    {
        Init();
        Assign(_holderId, _transactionId, _compositableParent, _compositableChild, _textureParent, _textureChild);
    }

    MOZ_IMPLICIT OpRemoveTextureAsync(const OpRemoveTextureAsync& _o)
    {
        Init();
        Assign((_o).holderId(), (_o).transactionId(), const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()));
    }

    ~OpRemoveTextureAsync();

    void
    operator=(const OpRemoveTextureAsync& _o)
    {
        Assign((_o).holderId(), (_o).transactionId(), const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()));
    }

    bool
    operator==(const OpRemoveTextureAsync& _o) const;

    uint64_t&
    holderId()
    {
        return holderId_;
    }
    const uint64_t&
    holderId() const
    {
        return holderId_;
    }

    uint64_t&
    transactionId()
    {
        return transactionId_;
    }
    const uint64_t&
    transactionId() const
    {
        return transactionId_;
    }

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _holderId,
            const uint64_t& _transactionId,
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            PTextureParent* _textureParent,
            PTextureChild* _textureChild);

    uint64_t holderId_;
    uint64_t transactionId_;
    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpReplyRemoveTexture|
//
namespace mozilla {
namespace layers {
class OpReplyRemoveTexture final
{
private:

public:
    MOZ_IMPLICIT OpReplyRemoveTexture();

    MOZ_IMPLICIT OpReplyRemoveTexture(
            const uint64_t& _holderId,
            const uint64_t& _transactionId)
    {
        Init();
        Assign(_holderId, _transactionId);
    }

    MOZ_IMPLICIT OpReplyRemoveTexture(const OpReplyRemoveTexture& _o)
    {
        Init();
        Assign((_o).holderId(), (_o).transactionId());
    }

    ~OpReplyRemoveTexture();

    void
    operator=(const OpReplyRemoveTexture& _o)
    {
        Assign((_o).holderId(), (_o).transactionId());
    }

    bool
    operator==(const OpReplyRemoveTexture& _o) const;

    uint64_t&
    holderId()
    {
        return holderId_;
    }
    const uint64_t&
    holderId() const
    {
        return holderId_;
    }

    uint64_t&
    transactionId()
    {
        return transactionId_;
    }
    const uint64_t&
    transactionId() const
    {
        return transactionId_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _holderId,
            const uint64_t& _transactionId);

    uint64_t holderId_;
    uint64_t transactionId_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeFence|
//
namespace mozilla {
namespace layers {
class MaybeFence final
{
public:
    enum Type {
        T__None,
        TFenceHandle = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::FenceHandle FenceHandle;
    typedef mozilla::null_t null_t;
    typedef FenceHandle FenceHandle__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char VFenceHandle[sizeof(FenceHandle)];
        char Vnull_t[sizeof(null_t)];
    };

    FenceHandle*
    ptr_FenceHandle()
    {
        return reinterpret_cast<FenceHandle*>((&((mValue).VFenceHandle)));
    }
    const FenceHandle* const
    constptr_FenceHandle() const
    {
        return reinterpret_cast<const FenceHandle* const>((&((mValue).VFenceHandle)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeFence() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeFence(const FenceHandle& aOther);

    MOZ_IMPLICIT MaybeFence(const null_t& aOther);

    MOZ_IMPLICIT MaybeFence(const MaybeFence& aOther);

    ~MaybeFence();

    Type
    type() const
    {
        return mType;
    }

    MaybeFence&
    operator=(const FenceHandle& aRhs);

    MaybeFence&
    operator=(const null_t& aRhs);

    MaybeFence&
    operator=(const MaybeFence& aRhs);

    bool
    operator==(const FenceHandle& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeFence& aRhs) const;

    FenceHandle&
    get_FenceHandle()
    {
        AssertSanity(TFenceHandle);
        return (*(ptr_FenceHandle()));
    }
    const FenceHandle&
    get_FenceHandle() const
    {
        AssertSanity(TFenceHandle);
        return (*(constptr_FenceHandle()));
    }
    operator FenceHandle&()
    {
        return get_FenceHandle();
    }
    operator const FenceHandle&() const
    {
        return get_FenceHandle();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class MaybeFence;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TimedTexture|
//
namespace mozilla {
namespace layers {
class TimedTexture final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::MaybeFence MaybeFence;
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT TimedTexture();

    MOZ_IMPLICIT TimedTexture(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const MaybeFence& _fence,
            const TimeStamp& _timeStamp,
            const IntRect& _picture,
            const int32_t& _frameID,
            const int32_t& _producerID)
    {
        Init();
        Assign(_textureParent, _textureChild, _fence, _timeStamp, _picture, _frameID, _producerID);
    }

    MOZ_IMPLICIT TimedTexture(const TimedTexture& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).fence(), (_o).timeStamp(), (_o).picture(), (_o).frameID(), (_o).producerID());
    }

    ~TimedTexture();

    void
    operator=(const TimedTexture& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).fence(), (_o).timeStamp(), (_o).picture(), (_o).frameID(), (_o).producerID());
    }

    bool
    operator==(const TimedTexture& _o) const;

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    MaybeFence&
    fence()
    {
        return fence_;
    }
    const MaybeFence&
    fence() const
    {
        return fence_;
    }

    TimeStamp&
    timeStamp()
    {
        return timeStamp_;
    }
    const TimeStamp&
    timeStamp() const
    {
        return timeStamp_;
    }

    IntRect&
    picture()
    {
        return picture_;
    }
    const IntRect&
    picture() const
    {
        return picture_;
    }

    int32_t&
    frameID()
    {
        return frameID_;
    }
    const int32_t&
    frameID() const
    {
        return frameID_;
    }

    int32_t&
    producerID()
    {
        return producerID_;
    }
    const int32_t&
    producerID() const
    {
        return producerID_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const MaybeFence& _fence,
            const TimeStamp& _timeStamp,
            const IntRect& _picture,
            const int32_t& _frameID,
            const int32_t& _producerID);

    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    MaybeFence fence_;
    TimeStamp timeStamp_;
    IntRect picture_;
    int32_t frameID_;
    int32_t producerID_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class TimedTexture;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseTexture|
//
namespace mozilla {
namespace layers {
class OpUseTexture final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::TimedTexture TimedTexture;

public:
    MOZ_IMPLICIT OpUseTexture();

    MOZ_IMPLICIT OpUseTexture(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const nsTArray<TimedTexture>& _textures)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _textures);
    }

    MOZ_IMPLICIT OpUseTexture(const OpUseTexture& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).textures());
    }

    ~OpUseTexture();

    void
    operator=(const OpUseTexture& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).textures());
    }

    bool
    operator==(const OpUseTexture& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    nsTArray<TimedTexture>&
    textures()
    {
        return textures_;
    }
    const nsTArray<TimedTexture>&
    textures() const
    {
        return textures_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const nsTArray<TimedTexture>& _textures);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    nsTArray<TimedTexture> textures_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseComponentAlphaTextures|
//
namespace mozilla {
namespace layers {
class OpUseComponentAlphaTextures final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;

public:
    MOZ_IMPLICIT OpUseComponentAlphaTextures();

    MOZ_IMPLICIT OpUseComponentAlphaTextures(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            PTextureParent* _textureOnBlackParent,
            PTextureChild* _textureOnBlackChild,
            PTextureParent* _textureOnWhiteParent,
            PTextureChild* _textureOnWhiteChild)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _textureOnBlackParent, _textureOnBlackChild, _textureOnWhiteParent, _textureOnWhiteChild);
    }

    MOZ_IMPLICIT OpUseComponentAlphaTextures(const OpUseComponentAlphaTextures& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), const_cast<PTextureParent*>((_o).textureOnBlackParent()), const_cast<PTextureChild*>((_o).textureOnBlackChild()), const_cast<PTextureParent*>((_o).textureOnWhiteParent()), const_cast<PTextureChild*>((_o).textureOnWhiteChild()));
    }

    ~OpUseComponentAlphaTextures();

    void
    operator=(const OpUseComponentAlphaTextures& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), const_cast<PTextureParent*>((_o).textureOnBlackParent()), const_cast<PTextureChild*>((_o).textureOnBlackChild()), const_cast<PTextureParent*>((_o).textureOnWhiteParent()), const_cast<PTextureChild*>((_o).textureOnWhiteChild()));
    }

    bool
    operator==(const OpUseComponentAlphaTextures& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    PTextureParent*&
    textureOnBlackParent()
    {
        return textureOnBlackParent_;
    }
    PTextureParent*
    textureOnBlackParent() const
    {
        return textureOnBlackParent_;
    }

    PTextureChild*&
    textureOnBlackChild()
    {
        return textureOnBlackChild_;
    }
    PTextureChild*
    textureOnBlackChild() const
    {
        return textureOnBlackChild_;
    }

    PTextureParent*&
    textureOnWhiteParent()
    {
        return textureOnWhiteParent_;
    }
    PTextureParent*
    textureOnWhiteParent() const
    {
        return textureOnWhiteParent_;
    }

    PTextureChild*&
    textureOnWhiteChild()
    {
        return textureOnWhiteChild_;
    }
    PTextureChild*
    textureOnWhiteChild() const
    {
        return textureOnWhiteChild_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            PTextureParent* _textureOnBlackParent,
            PTextureChild* _textureOnBlackChild,
            PTextureParent* _textureOnWhiteParent,
            PTextureChild* _textureOnWhiteChild);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    PTextureParent* textureOnBlackParent_;
    PTextureChild* textureOnBlackChild_;
    PTextureParent* textureOnWhiteParent_;
    PTextureChild* textureOnWhiteChild_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeRegion|
//
namespace mozilla {
namespace layers {
class MaybeRegion final
{
public:
    enum Type {
        T__None,
        TnsIntRegion = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::null_t null_t;
    typedef nsIntRegion nsIntRegion__tdef;
    typedef null_t null_t__tdef;

    union Value {
        char VnsIntRegion[sizeof(nsIntRegion)];
        char Vnull_t[sizeof(null_t)];
    };

    nsIntRegion*
    ptr_nsIntRegion()
    {
        return reinterpret_cast<nsIntRegion*>((&((mValue).VnsIntRegion)));
    }
    const nsIntRegion* const
    constptr_nsIntRegion() const
    {
        return reinterpret_cast<const nsIntRegion* const>((&((mValue).VnsIntRegion)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeRegion() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeRegion(const nsIntRegion& aOther);

    MOZ_IMPLICIT MaybeRegion(const null_t& aOther);

    MOZ_IMPLICIT MaybeRegion(const MaybeRegion& aOther);

    ~MaybeRegion();

    Type
    type() const
    {
        return mType;
    }

    MaybeRegion&
    operator=(const nsIntRegion& aRhs);

    MaybeRegion&
    operator=(const null_t& aRhs);

    MaybeRegion&
    operator=(const MaybeRegion& aRhs);

    bool
    operator==(const nsIntRegion& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeRegion& aRhs) const;

    nsIntRegion&
    get_nsIntRegion()
    {
        AssertSanity(TnsIntRegion);
        return (*(ptr_nsIntRegion()));
    }
    const nsIntRegion&
    get_nsIntRegion() const
    {
        AssertSanity(TnsIntRegion);
        return (*(constptr_nsIntRegion()));
    }
    operator nsIntRegion&()
    {
        return get_nsIntRegion();
    }
    operator const nsIntRegion&() const
    {
        return get_nsIntRegion();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeliverFence|
//
namespace mozilla {
namespace layers {
class OpDeliverFence final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::FenceHandle FenceHandle;

public:
    MOZ_IMPLICIT OpDeliverFence();

    MOZ_IMPLICIT OpDeliverFence(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const FenceHandle& _fence)
    {
        Init();
        Assign(_textureParent, _textureChild, _fence);
    }

    MOZ_IMPLICIT OpDeliverFence(const OpDeliverFence& _o)
    {
        Init();
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).fence());
    }

    ~OpDeliverFence();

    void
    operator=(const OpDeliverFence& _o)
    {
        Assign(const_cast<PTextureParent*>((_o).textureParent()), const_cast<PTextureChild*>((_o).textureChild()), (_o).fence());
    }

    bool
    operator==(const OpDeliverFence& _o) const;

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    FenceHandle&
    fence()
    {
        return fence_;
    }
    const FenceHandle&
    fence() const
    {
        return fence_;
    }

private:
    void
    Init();

    void
    Assign(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const FenceHandle& _fence);

    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    FenceHandle fence_;
};
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeliverFenceToTracker|
//
namespace mozilla {
namespace layers {
class OpDeliverFenceToTracker final
{
private:
    typedef mozilla::layers::FenceHandle FenceHandle;

public:
    MOZ_IMPLICIT OpDeliverFenceToTracker();

    MOZ_IMPLICIT OpDeliverFenceToTracker(
            const uint64_t& _destHolderId,
            const uint64_t& _destTransactionId,
            const FenceHandle& _fence)
    {
        Init();
        Assign(_destHolderId, _destTransactionId, _fence);
    }

    MOZ_IMPLICIT OpDeliverFenceToTracker(const OpDeliverFenceToTracker& _o)
    {
        Init();
        Assign((_o).destHolderId(), (_o).destTransactionId(), (_o).fence());
    }

    ~OpDeliverFenceToTracker();

    void
    operator=(const OpDeliverFenceToTracker& _o)
    {
        Assign((_o).destHolderId(), (_o).destTransactionId(), (_o).fence());
    }

    bool
    operator==(const OpDeliverFenceToTracker& _o) const;

    uint64_t&
    destHolderId()
    {
        return destHolderId_;
    }
    const uint64_t&
    destHolderId() const
    {
        return destHolderId_;
    }

    uint64_t&
    destTransactionId()
    {
        return destTransactionId_;
    }
    const uint64_t&
    destTransactionId() const
    {
        return destTransactionId_;
    }

    FenceHandle&
    fence()
    {
        return fence_;
    }
    const FenceHandle&
    fence() const
    {
        return fence_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint64_t& _destHolderId,
            const uint64_t& _destTransactionId,
            const FenceHandle& _fence);

    uint64_t destHolderId_;
    uint64_t destTransactionId_;
    FenceHandle fence_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpPaintTextureRegion;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseTiledLayerBuffer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRemoveTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRemoveTextureAsync;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseTexture;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseComponentAlphaTextures;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpUseOverlaySource;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union CompositableOperation|
//
namespace mozilla {
namespace layers {
class CompositableOperation final
{
public:
    enum Type {
        T__None,
        TOpPaintTextureRegion = 1,
        TOpUseTiledLayerBuffer,
        TOpRemoveTexture,
        TOpRemoveTextureAsync,
        TOpUseTexture,
        TOpUseComponentAlphaTextures,
        TOpUseOverlaySource,
        T__Last = TOpUseOverlaySource
    };

private:
    typedef mozilla::layers::OpPaintTextureRegion OpPaintTextureRegion;
    typedef mozilla::layers::OpUseTiledLayerBuffer OpUseTiledLayerBuffer;
    typedef mozilla::layers::OpRemoveTexture OpRemoveTexture;
    typedef mozilla::layers::OpRemoveTextureAsync OpRemoveTextureAsync;
    typedef mozilla::layers::OpUseTexture OpUseTexture;
    typedef mozilla::layers::OpUseComponentAlphaTextures OpUseComponentAlphaTextures;
    typedef mozilla::layers::OpUseOverlaySource OpUseOverlaySource;
    typedef OpPaintTextureRegion OpPaintTextureRegion__tdef;
    typedef OpUseTiledLayerBuffer OpUseTiledLayerBuffer__tdef;
    typedef OpRemoveTexture OpRemoveTexture__tdef;
    typedef OpRemoveTextureAsync OpRemoveTextureAsync__tdef;
    typedef OpUseTexture OpUseTexture__tdef;
    typedef OpUseComponentAlphaTextures OpUseComponentAlphaTextures__tdef;
    typedef OpUseOverlaySource OpUseOverlaySource__tdef;

    union Value {
        char VOpPaintTextureRegion[sizeof(OpPaintTextureRegion)];
        char VOpUseTiledLayerBuffer[sizeof(OpUseTiledLayerBuffer)];
        char VOpRemoveTexture[sizeof(OpRemoveTexture)];
        char VOpRemoveTextureAsync[sizeof(OpRemoveTextureAsync)];
        char VOpUseTexture[sizeof(OpUseTexture)];
        char VOpUseComponentAlphaTextures[sizeof(OpUseComponentAlphaTextures)];
        char VOpUseOverlaySource[sizeof(OpUseOverlaySource)];
    };

    OpPaintTextureRegion*
    ptr_OpPaintTextureRegion()
    {
        return reinterpret_cast<OpPaintTextureRegion*>((&((mValue).VOpPaintTextureRegion)));
    }
    const OpPaintTextureRegion* const
    constptr_OpPaintTextureRegion() const
    {
        return reinterpret_cast<const OpPaintTextureRegion* const>((&((mValue).VOpPaintTextureRegion)));
    }
    OpUseTiledLayerBuffer*
    ptr_OpUseTiledLayerBuffer()
    {
        return reinterpret_cast<OpUseTiledLayerBuffer*>((&((mValue).VOpUseTiledLayerBuffer)));
    }
    const OpUseTiledLayerBuffer* const
    constptr_OpUseTiledLayerBuffer() const
    {
        return reinterpret_cast<const OpUseTiledLayerBuffer* const>((&((mValue).VOpUseTiledLayerBuffer)));
    }
    OpRemoveTexture*
    ptr_OpRemoveTexture()
    {
        return reinterpret_cast<OpRemoveTexture*>((&((mValue).VOpRemoveTexture)));
    }
    const OpRemoveTexture* const
    constptr_OpRemoveTexture() const
    {
        return reinterpret_cast<const OpRemoveTexture* const>((&((mValue).VOpRemoveTexture)));
    }
    OpRemoveTextureAsync*
    ptr_OpRemoveTextureAsync()
    {
        return reinterpret_cast<OpRemoveTextureAsync*>((&((mValue).VOpRemoveTextureAsync)));
    }
    const OpRemoveTextureAsync* const
    constptr_OpRemoveTextureAsync() const
    {
        return reinterpret_cast<const OpRemoveTextureAsync* const>((&((mValue).VOpRemoveTextureAsync)));
    }
    OpUseTexture*
    ptr_OpUseTexture()
    {
        return reinterpret_cast<OpUseTexture*>((&((mValue).VOpUseTexture)));
    }
    const OpUseTexture* const
    constptr_OpUseTexture() const
    {
        return reinterpret_cast<const OpUseTexture* const>((&((mValue).VOpUseTexture)));
    }
    OpUseComponentAlphaTextures*
    ptr_OpUseComponentAlphaTextures()
    {
        return reinterpret_cast<OpUseComponentAlphaTextures*>((&((mValue).VOpUseComponentAlphaTextures)));
    }
    const OpUseComponentAlphaTextures* const
    constptr_OpUseComponentAlphaTextures() const
    {
        return reinterpret_cast<const OpUseComponentAlphaTextures* const>((&((mValue).VOpUseComponentAlphaTextures)));
    }
    OpUseOverlaySource*
    ptr_OpUseOverlaySource()
    {
        return reinterpret_cast<OpUseOverlaySource*>((&((mValue).VOpUseOverlaySource)));
    }
    const OpUseOverlaySource* const
    constptr_OpUseOverlaySource() const
    {
        return reinterpret_cast<const OpUseOverlaySource* const>((&((mValue).VOpUseOverlaySource)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT CompositableOperation() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT CompositableOperation(const OpPaintTextureRegion& aOther);

    MOZ_IMPLICIT CompositableOperation(const OpUseTiledLayerBuffer& aOther);

    MOZ_IMPLICIT CompositableOperation(const OpRemoveTexture& aOther);

    MOZ_IMPLICIT CompositableOperation(const OpRemoveTextureAsync& aOther);

    MOZ_IMPLICIT CompositableOperation(const OpUseTexture& aOther);

    MOZ_IMPLICIT CompositableOperation(const OpUseComponentAlphaTextures& aOther);

    MOZ_IMPLICIT CompositableOperation(const OpUseOverlaySource& aOther);

    MOZ_IMPLICIT CompositableOperation(const CompositableOperation& aOther);

    ~CompositableOperation();

    Type
    type() const
    {
        return mType;
    }

    CompositableOperation&
    operator=(const OpPaintTextureRegion& aRhs);

    CompositableOperation&
    operator=(const OpUseTiledLayerBuffer& aRhs);

    CompositableOperation&
    operator=(const OpRemoveTexture& aRhs);

    CompositableOperation&
    operator=(const OpRemoveTextureAsync& aRhs);

    CompositableOperation&
    operator=(const OpUseTexture& aRhs);

    CompositableOperation&
    operator=(const OpUseComponentAlphaTextures& aRhs);

    CompositableOperation&
    operator=(const OpUseOverlaySource& aRhs);

    CompositableOperation&
    operator=(const CompositableOperation& aRhs);

    bool
    operator==(const OpPaintTextureRegion& aRhs) const;

    bool
    operator==(const OpUseTiledLayerBuffer& aRhs) const;

    bool
    operator==(const OpRemoveTexture& aRhs) const;

    bool
    operator==(const OpRemoveTextureAsync& aRhs) const;

    bool
    operator==(const OpUseTexture& aRhs) const;

    bool
    operator==(const OpUseComponentAlphaTextures& aRhs) const;

    bool
    operator==(const OpUseOverlaySource& aRhs) const;

    bool
    operator==(const CompositableOperation& aRhs) const;

    OpPaintTextureRegion&
    get_OpPaintTextureRegion()
    {
        AssertSanity(TOpPaintTextureRegion);
        return (*(ptr_OpPaintTextureRegion()));
    }
    const OpPaintTextureRegion&
    get_OpPaintTextureRegion() const
    {
        AssertSanity(TOpPaintTextureRegion);
        return (*(constptr_OpPaintTextureRegion()));
    }
    operator OpPaintTextureRegion&()
    {
        return get_OpPaintTextureRegion();
    }
    operator const OpPaintTextureRegion&() const
    {
        return get_OpPaintTextureRegion();
    }

    OpUseTiledLayerBuffer&
    get_OpUseTiledLayerBuffer()
    {
        AssertSanity(TOpUseTiledLayerBuffer);
        return (*(ptr_OpUseTiledLayerBuffer()));
    }
    const OpUseTiledLayerBuffer&
    get_OpUseTiledLayerBuffer() const
    {
        AssertSanity(TOpUseTiledLayerBuffer);
        return (*(constptr_OpUseTiledLayerBuffer()));
    }
    operator OpUseTiledLayerBuffer&()
    {
        return get_OpUseTiledLayerBuffer();
    }
    operator const OpUseTiledLayerBuffer&() const
    {
        return get_OpUseTiledLayerBuffer();
    }

    OpRemoveTexture&
    get_OpRemoveTexture()
    {
        AssertSanity(TOpRemoveTexture);
        return (*(ptr_OpRemoveTexture()));
    }
    const OpRemoveTexture&
    get_OpRemoveTexture() const
    {
        AssertSanity(TOpRemoveTexture);
        return (*(constptr_OpRemoveTexture()));
    }
    operator OpRemoveTexture&()
    {
        return get_OpRemoveTexture();
    }
    operator const OpRemoveTexture&() const
    {
        return get_OpRemoveTexture();
    }

    OpRemoveTextureAsync&
    get_OpRemoveTextureAsync()
    {
        AssertSanity(TOpRemoveTextureAsync);
        return (*(ptr_OpRemoveTextureAsync()));
    }
    const OpRemoveTextureAsync&
    get_OpRemoveTextureAsync() const
    {
        AssertSanity(TOpRemoveTextureAsync);
        return (*(constptr_OpRemoveTextureAsync()));
    }
    operator OpRemoveTextureAsync&()
    {
        return get_OpRemoveTextureAsync();
    }
    operator const OpRemoveTextureAsync&() const
    {
        return get_OpRemoveTextureAsync();
    }

    OpUseTexture&
    get_OpUseTexture()
    {
        AssertSanity(TOpUseTexture);
        return (*(ptr_OpUseTexture()));
    }
    const OpUseTexture&
    get_OpUseTexture() const
    {
        AssertSanity(TOpUseTexture);
        return (*(constptr_OpUseTexture()));
    }
    operator OpUseTexture&()
    {
        return get_OpUseTexture();
    }
    operator const OpUseTexture&() const
    {
        return get_OpUseTexture();
    }

    OpUseComponentAlphaTextures&
    get_OpUseComponentAlphaTextures()
    {
        AssertSanity(TOpUseComponentAlphaTextures);
        return (*(ptr_OpUseComponentAlphaTextures()));
    }
    const OpUseComponentAlphaTextures&
    get_OpUseComponentAlphaTextures() const
    {
        AssertSanity(TOpUseComponentAlphaTextures);
        return (*(constptr_OpUseComponentAlphaTextures()));
    }
    operator OpUseComponentAlphaTextures&()
    {
        return get_OpUseComponentAlphaTextures();
    }
    operator const OpUseComponentAlphaTextures&() const
    {
        return get_OpUseComponentAlphaTextures();
    }

    OpUseOverlaySource&
    get_OpUseOverlaySource()
    {
        AssertSanity(TOpUseOverlaySource);
        return (*(ptr_OpUseOverlaySource()));
    }
    const OpUseOverlaySource&
    get_OpUseOverlaySource() const
    {
        AssertSanity(TOpUseOverlaySource);
        return (*(constptr_OpUseOverlaySource()));
    }
    operator OpUseOverlaySource&()
    {
        return get_OpUseOverlaySource();
    }
    operator const OpUseOverlaySource&() const
    {
        return get_OpUseOverlaySource();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpCreatePaintedLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateContainerLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateImageLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateColorLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateCanvasLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpCreateRefLayer;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetLayerAttributes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetDiagnosticTypes;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpSetRoot;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpInsertAfter;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpPrependChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRemoveChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRepositionChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpRaiseToTopChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAttachCompositable;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpAttachAsyncCompositable;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class CompositableOperation;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union Edit|
//
namespace mozilla {
namespace layers {
class Edit final
{
public:
    enum Type {
        T__None,
        TOpCreatePaintedLayer = 1,
        TOpCreateContainerLayer,
        TOpCreateImageLayer,
        TOpCreateColorLayer,
        TOpCreateCanvasLayer,
        TOpCreateRefLayer,
        TOpSetLayerAttributes,
        TOpSetDiagnosticTypes,
        TOpSetRoot,
        TOpInsertAfter,
        TOpPrependChild,
        TOpRemoveChild,
        TOpRepositionChild,
        TOpRaiseToTopChild,
        TOpAttachCompositable,
        TOpAttachAsyncCompositable,
        TCompositableOperation,
        T__Last = TCompositableOperation
    };

private:
    typedef mozilla::layers::OpCreatePaintedLayer OpCreatePaintedLayer;
    typedef mozilla::layers::OpCreateContainerLayer OpCreateContainerLayer;
    typedef mozilla::layers::OpCreateImageLayer OpCreateImageLayer;
    typedef mozilla::layers::OpCreateColorLayer OpCreateColorLayer;
    typedef mozilla::layers::OpCreateCanvasLayer OpCreateCanvasLayer;
    typedef mozilla::layers::OpCreateRefLayer OpCreateRefLayer;
    typedef mozilla::layers::OpSetLayerAttributes OpSetLayerAttributes;
    typedef mozilla::layers::OpSetDiagnosticTypes OpSetDiagnosticTypes;
    typedef mozilla::layers::OpSetRoot OpSetRoot;
    typedef mozilla::layers::OpInsertAfter OpInsertAfter;
    typedef mozilla::layers::OpPrependChild OpPrependChild;
    typedef mozilla::layers::OpRemoveChild OpRemoveChild;
    typedef mozilla::layers::OpRepositionChild OpRepositionChild;
    typedef mozilla::layers::OpRaiseToTopChild OpRaiseToTopChild;
    typedef mozilla::layers::OpAttachCompositable OpAttachCompositable;
    typedef mozilla::layers::OpAttachAsyncCompositable OpAttachAsyncCompositable;
    typedef mozilla::layers::CompositableOperation CompositableOperation;
    typedef OpCreatePaintedLayer OpCreatePaintedLayer__tdef;
    typedef OpCreateContainerLayer OpCreateContainerLayer__tdef;
    typedef OpCreateImageLayer OpCreateImageLayer__tdef;
    typedef OpCreateColorLayer OpCreateColorLayer__tdef;
    typedef OpCreateCanvasLayer OpCreateCanvasLayer__tdef;
    typedef OpCreateRefLayer OpCreateRefLayer__tdef;
    typedef OpSetLayerAttributes OpSetLayerAttributes__tdef;
    typedef OpSetDiagnosticTypes OpSetDiagnosticTypes__tdef;
    typedef OpSetRoot OpSetRoot__tdef;
    typedef OpInsertAfter OpInsertAfter__tdef;
    typedef OpPrependChild OpPrependChild__tdef;
    typedef OpRemoveChild OpRemoveChild__tdef;
    typedef OpRepositionChild OpRepositionChild__tdef;
    typedef OpRaiseToTopChild OpRaiseToTopChild__tdef;
    typedef OpAttachCompositable OpAttachCompositable__tdef;
    typedef OpAttachAsyncCompositable OpAttachAsyncCompositable__tdef;
    typedef CompositableOperation CompositableOperation__tdef;

    union Value {
        char VOpCreatePaintedLayer[sizeof(OpCreatePaintedLayer)];
        char VOpCreateContainerLayer[sizeof(OpCreateContainerLayer)];
        char VOpCreateImageLayer[sizeof(OpCreateImageLayer)];
        char VOpCreateColorLayer[sizeof(OpCreateColorLayer)];
        char VOpCreateCanvasLayer[sizeof(OpCreateCanvasLayer)];
        char VOpCreateRefLayer[sizeof(OpCreateRefLayer)];
        char VOpSetLayerAttributes[sizeof(OpSetLayerAttributes)];
        char VOpSetDiagnosticTypes[sizeof(OpSetDiagnosticTypes)];
        char VOpSetRoot[sizeof(OpSetRoot)];
        char VOpInsertAfter[sizeof(OpInsertAfter)];
        char VOpPrependChild[sizeof(OpPrependChild)];
        char VOpRemoveChild[sizeof(OpRemoveChild)];
        char VOpRepositionChild[sizeof(OpRepositionChild)];
        char VOpRaiseToTopChild[sizeof(OpRaiseToTopChild)];
        char VOpAttachCompositable[sizeof(OpAttachCompositable)];
        char VOpAttachAsyncCompositable[sizeof(OpAttachAsyncCompositable)];
        char VCompositableOperation[sizeof(CompositableOperation)];
    };

    OpCreatePaintedLayer*
    ptr_OpCreatePaintedLayer()
    {
        return reinterpret_cast<OpCreatePaintedLayer*>((&((mValue).VOpCreatePaintedLayer)));
    }
    const OpCreatePaintedLayer* const
    constptr_OpCreatePaintedLayer() const
    {
        return reinterpret_cast<const OpCreatePaintedLayer* const>((&((mValue).VOpCreatePaintedLayer)));
    }
    OpCreateContainerLayer*
    ptr_OpCreateContainerLayer()
    {
        return reinterpret_cast<OpCreateContainerLayer*>((&((mValue).VOpCreateContainerLayer)));
    }
    const OpCreateContainerLayer* const
    constptr_OpCreateContainerLayer() const
    {
        return reinterpret_cast<const OpCreateContainerLayer* const>((&((mValue).VOpCreateContainerLayer)));
    }
    OpCreateImageLayer*
    ptr_OpCreateImageLayer()
    {
        return reinterpret_cast<OpCreateImageLayer*>((&((mValue).VOpCreateImageLayer)));
    }
    const OpCreateImageLayer* const
    constptr_OpCreateImageLayer() const
    {
        return reinterpret_cast<const OpCreateImageLayer* const>((&((mValue).VOpCreateImageLayer)));
    }
    OpCreateColorLayer*
    ptr_OpCreateColorLayer()
    {
        return reinterpret_cast<OpCreateColorLayer*>((&((mValue).VOpCreateColorLayer)));
    }
    const OpCreateColorLayer* const
    constptr_OpCreateColorLayer() const
    {
        return reinterpret_cast<const OpCreateColorLayer* const>((&((mValue).VOpCreateColorLayer)));
    }
    OpCreateCanvasLayer*
    ptr_OpCreateCanvasLayer()
    {
        return reinterpret_cast<OpCreateCanvasLayer*>((&((mValue).VOpCreateCanvasLayer)));
    }
    const OpCreateCanvasLayer* const
    constptr_OpCreateCanvasLayer() const
    {
        return reinterpret_cast<const OpCreateCanvasLayer* const>((&((mValue).VOpCreateCanvasLayer)));
    }
    OpCreateRefLayer*
    ptr_OpCreateRefLayer()
    {
        return reinterpret_cast<OpCreateRefLayer*>((&((mValue).VOpCreateRefLayer)));
    }
    const OpCreateRefLayer* const
    constptr_OpCreateRefLayer() const
    {
        return reinterpret_cast<const OpCreateRefLayer* const>((&((mValue).VOpCreateRefLayer)));
    }
    OpSetLayerAttributes*
    ptr_OpSetLayerAttributes()
    {
        return reinterpret_cast<OpSetLayerAttributes*>((&((mValue).VOpSetLayerAttributes)));
    }
    const OpSetLayerAttributes* const
    constptr_OpSetLayerAttributes() const
    {
        return reinterpret_cast<const OpSetLayerAttributes* const>((&((mValue).VOpSetLayerAttributes)));
    }
    OpSetDiagnosticTypes*
    ptr_OpSetDiagnosticTypes()
    {
        return reinterpret_cast<OpSetDiagnosticTypes*>((&((mValue).VOpSetDiagnosticTypes)));
    }
    const OpSetDiagnosticTypes* const
    constptr_OpSetDiagnosticTypes() const
    {
        return reinterpret_cast<const OpSetDiagnosticTypes* const>((&((mValue).VOpSetDiagnosticTypes)));
    }
    OpSetRoot*
    ptr_OpSetRoot()
    {
        return reinterpret_cast<OpSetRoot*>((&((mValue).VOpSetRoot)));
    }
    const OpSetRoot* const
    constptr_OpSetRoot() const
    {
        return reinterpret_cast<const OpSetRoot* const>((&((mValue).VOpSetRoot)));
    }
    OpInsertAfter*
    ptr_OpInsertAfter()
    {
        return reinterpret_cast<OpInsertAfter*>((&((mValue).VOpInsertAfter)));
    }
    const OpInsertAfter* const
    constptr_OpInsertAfter() const
    {
        return reinterpret_cast<const OpInsertAfter* const>((&((mValue).VOpInsertAfter)));
    }
    OpPrependChild*
    ptr_OpPrependChild()
    {
        return reinterpret_cast<OpPrependChild*>((&((mValue).VOpPrependChild)));
    }
    const OpPrependChild* const
    constptr_OpPrependChild() const
    {
        return reinterpret_cast<const OpPrependChild* const>((&((mValue).VOpPrependChild)));
    }
    OpRemoveChild*
    ptr_OpRemoveChild()
    {
        return reinterpret_cast<OpRemoveChild*>((&((mValue).VOpRemoveChild)));
    }
    const OpRemoveChild* const
    constptr_OpRemoveChild() const
    {
        return reinterpret_cast<const OpRemoveChild* const>((&((mValue).VOpRemoveChild)));
    }
    OpRepositionChild*
    ptr_OpRepositionChild()
    {
        return reinterpret_cast<OpRepositionChild*>((&((mValue).VOpRepositionChild)));
    }
    const OpRepositionChild* const
    constptr_OpRepositionChild() const
    {
        return reinterpret_cast<const OpRepositionChild* const>((&((mValue).VOpRepositionChild)));
    }
    OpRaiseToTopChild*
    ptr_OpRaiseToTopChild()
    {
        return reinterpret_cast<OpRaiseToTopChild*>((&((mValue).VOpRaiseToTopChild)));
    }
    const OpRaiseToTopChild* const
    constptr_OpRaiseToTopChild() const
    {
        return reinterpret_cast<const OpRaiseToTopChild* const>((&((mValue).VOpRaiseToTopChild)));
    }
    OpAttachCompositable*
    ptr_OpAttachCompositable()
    {
        return reinterpret_cast<OpAttachCompositable*>((&((mValue).VOpAttachCompositable)));
    }
    const OpAttachCompositable* const
    constptr_OpAttachCompositable() const
    {
        return reinterpret_cast<const OpAttachCompositable* const>((&((mValue).VOpAttachCompositable)));
    }
    OpAttachAsyncCompositable*
    ptr_OpAttachAsyncCompositable()
    {
        return reinterpret_cast<OpAttachAsyncCompositable*>((&((mValue).VOpAttachAsyncCompositable)));
    }
    const OpAttachAsyncCompositable* const
    constptr_OpAttachAsyncCompositable() const
    {
        return reinterpret_cast<const OpAttachAsyncCompositable* const>((&((mValue).VOpAttachAsyncCompositable)));
    }
    CompositableOperation*
    ptr_CompositableOperation()
    {
        return reinterpret_cast<CompositableOperation*>((&((mValue).VCompositableOperation)));
    }
    const CompositableOperation* const
    constptr_CompositableOperation() const
    {
        return reinterpret_cast<const CompositableOperation* const>((&((mValue).VCompositableOperation)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT Edit() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT Edit(const OpCreatePaintedLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateContainerLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateImageLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateColorLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateCanvasLayer& aOther);

    MOZ_IMPLICIT Edit(const OpCreateRefLayer& aOther);

    MOZ_IMPLICIT Edit(const OpSetLayerAttributes& aOther);

    MOZ_IMPLICIT Edit(const OpSetDiagnosticTypes& aOther);

    MOZ_IMPLICIT Edit(const OpSetRoot& aOther);

    MOZ_IMPLICIT Edit(const OpInsertAfter& aOther);

    MOZ_IMPLICIT Edit(const OpPrependChild& aOther);

    MOZ_IMPLICIT Edit(const OpRemoveChild& aOther);

    MOZ_IMPLICIT Edit(const OpRepositionChild& aOther);

    MOZ_IMPLICIT Edit(const OpRaiseToTopChild& aOther);

    MOZ_IMPLICIT Edit(const OpAttachCompositable& aOther);

    MOZ_IMPLICIT Edit(const OpAttachAsyncCompositable& aOther);

    MOZ_IMPLICIT Edit(const CompositableOperation& aOther);

    MOZ_IMPLICIT Edit(const Edit& aOther);

    ~Edit();

    Type
    type() const
    {
        return mType;
    }

    Edit&
    operator=(const OpCreatePaintedLayer& aRhs);

    Edit&
    operator=(const OpCreateContainerLayer& aRhs);

    Edit&
    operator=(const OpCreateImageLayer& aRhs);

    Edit&
    operator=(const OpCreateColorLayer& aRhs);

    Edit&
    operator=(const OpCreateCanvasLayer& aRhs);

    Edit&
    operator=(const OpCreateRefLayer& aRhs);

    Edit&
    operator=(const OpSetLayerAttributes& aRhs);

    Edit&
    operator=(const OpSetDiagnosticTypes& aRhs);

    Edit&
    operator=(const OpSetRoot& aRhs);

    Edit&
    operator=(const OpInsertAfter& aRhs);

    Edit&
    operator=(const OpPrependChild& aRhs);

    Edit&
    operator=(const OpRemoveChild& aRhs);

    Edit&
    operator=(const OpRepositionChild& aRhs);

    Edit&
    operator=(const OpRaiseToTopChild& aRhs);

    Edit&
    operator=(const OpAttachCompositable& aRhs);

    Edit&
    operator=(const OpAttachAsyncCompositable& aRhs);

    Edit&
    operator=(const CompositableOperation& aRhs);

    Edit&
    operator=(const Edit& aRhs);

    bool
    operator==(const OpCreatePaintedLayer& aRhs) const;

    bool
    operator==(const OpCreateContainerLayer& aRhs) const;

    bool
    operator==(const OpCreateImageLayer& aRhs) const;

    bool
    operator==(const OpCreateColorLayer& aRhs) const;

    bool
    operator==(const OpCreateCanvasLayer& aRhs) const;

    bool
    operator==(const OpCreateRefLayer& aRhs) const;

    bool
    operator==(const OpSetLayerAttributes& aRhs) const;

    bool
    operator==(const OpSetDiagnosticTypes& aRhs) const;

    bool
    operator==(const OpSetRoot& aRhs) const;

    bool
    operator==(const OpInsertAfter& aRhs) const;

    bool
    operator==(const OpPrependChild& aRhs) const;

    bool
    operator==(const OpRemoveChild& aRhs) const;

    bool
    operator==(const OpRepositionChild& aRhs) const;

    bool
    operator==(const OpRaiseToTopChild& aRhs) const;

    bool
    operator==(const OpAttachCompositable& aRhs) const;

    bool
    operator==(const OpAttachAsyncCompositable& aRhs) const;

    bool
    operator==(const CompositableOperation& aRhs) const;

    bool
    operator==(const Edit& aRhs) const;

    OpCreatePaintedLayer&
    get_OpCreatePaintedLayer()
    {
        AssertSanity(TOpCreatePaintedLayer);
        return (*(ptr_OpCreatePaintedLayer()));
    }
    const OpCreatePaintedLayer&
    get_OpCreatePaintedLayer() const
    {
        AssertSanity(TOpCreatePaintedLayer);
        return (*(constptr_OpCreatePaintedLayer()));
    }
    operator OpCreatePaintedLayer&()
    {
        return get_OpCreatePaintedLayer();
    }
    operator const OpCreatePaintedLayer&() const
    {
        return get_OpCreatePaintedLayer();
    }

    OpCreateContainerLayer&
    get_OpCreateContainerLayer()
    {
        AssertSanity(TOpCreateContainerLayer);
        return (*(ptr_OpCreateContainerLayer()));
    }
    const OpCreateContainerLayer&
    get_OpCreateContainerLayer() const
    {
        AssertSanity(TOpCreateContainerLayer);
        return (*(constptr_OpCreateContainerLayer()));
    }
    operator OpCreateContainerLayer&()
    {
        return get_OpCreateContainerLayer();
    }
    operator const OpCreateContainerLayer&() const
    {
        return get_OpCreateContainerLayer();
    }

    OpCreateImageLayer&
    get_OpCreateImageLayer()
    {
        AssertSanity(TOpCreateImageLayer);
        return (*(ptr_OpCreateImageLayer()));
    }
    const OpCreateImageLayer&
    get_OpCreateImageLayer() const
    {
        AssertSanity(TOpCreateImageLayer);
        return (*(constptr_OpCreateImageLayer()));
    }
    operator OpCreateImageLayer&()
    {
        return get_OpCreateImageLayer();
    }
    operator const OpCreateImageLayer&() const
    {
        return get_OpCreateImageLayer();
    }

    OpCreateColorLayer&
    get_OpCreateColorLayer()
    {
        AssertSanity(TOpCreateColorLayer);
        return (*(ptr_OpCreateColorLayer()));
    }
    const OpCreateColorLayer&
    get_OpCreateColorLayer() const
    {
        AssertSanity(TOpCreateColorLayer);
        return (*(constptr_OpCreateColorLayer()));
    }
    operator OpCreateColorLayer&()
    {
        return get_OpCreateColorLayer();
    }
    operator const OpCreateColorLayer&() const
    {
        return get_OpCreateColorLayer();
    }

    OpCreateCanvasLayer&
    get_OpCreateCanvasLayer()
    {
        AssertSanity(TOpCreateCanvasLayer);
        return (*(ptr_OpCreateCanvasLayer()));
    }
    const OpCreateCanvasLayer&
    get_OpCreateCanvasLayer() const
    {
        AssertSanity(TOpCreateCanvasLayer);
        return (*(constptr_OpCreateCanvasLayer()));
    }
    operator OpCreateCanvasLayer&()
    {
        return get_OpCreateCanvasLayer();
    }
    operator const OpCreateCanvasLayer&() const
    {
        return get_OpCreateCanvasLayer();
    }

    OpCreateRefLayer&
    get_OpCreateRefLayer()
    {
        AssertSanity(TOpCreateRefLayer);
        return (*(ptr_OpCreateRefLayer()));
    }
    const OpCreateRefLayer&
    get_OpCreateRefLayer() const
    {
        AssertSanity(TOpCreateRefLayer);
        return (*(constptr_OpCreateRefLayer()));
    }
    operator OpCreateRefLayer&()
    {
        return get_OpCreateRefLayer();
    }
    operator const OpCreateRefLayer&() const
    {
        return get_OpCreateRefLayer();
    }

    OpSetLayerAttributes&
    get_OpSetLayerAttributes()
    {
        AssertSanity(TOpSetLayerAttributes);
        return (*(ptr_OpSetLayerAttributes()));
    }
    const OpSetLayerAttributes&
    get_OpSetLayerAttributes() const
    {
        AssertSanity(TOpSetLayerAttributes);
        return (*(constptr_OpSetLayerAttributes()));
    }
    operator OpSetLayerAttributes&()
    {
        return get_OpSetLayerAttributes();
    }
    operator const OpSetLayerAttributes&() const
    {
        return get_OpSetLayerAttributes();
    }

    OpSetDiagnosticTypes&
    get_OpSetDiagnosticTypes()
    {
        AssertSanity(TOpSetDiagnosticTypes);
        return (*(ptr_OpSetDiagnosticTypes()));
    }
    const OpSetDiagnosticTypes&
    get_OpSetDiagnosticTypes() const
    {
        AssertSanity(TOpSetDiagnosticTypes);
        return (*(constptr_OpSetDiagnosticTypes()));
    }
    operator OpSetDiagnosticTypes&()
    {
        return get_OpSetDiagnosticTypes();
    }
    operator const OpSetDiagnosticTypes&() const
    {
        return get_OpSetDiagnosticTypes();
    }

    OpSetRoot&
    get_OpSetRoot()
    {
        AssertSanity(TOpSetRoot);
        return (*(ptr_OpSetRoot()));
    }
    const OpSetRoot&
    get_OpSetRoot() const
    {
        AssertSanity(TOpSetRoot);
        return (*(constptr_OpSetRoot()));
    }
    operator OpSetRoot&()
    {
        return get_OpSetRoot();
    }
    operator const OpSetRoot&() const
    {
        return get_OpSetRoot();
    }

    OpInsertAfter&
    get_OpInsertAfter()
    {
        AssertSanity(TOpInsertAfter);
        return (*(ptr_OpInsertAfter()));
    }
    const OpInsertAfter&
    get_OpInsertAfter() const
    {
        AssertSanity(TOpInsertAfter);
        return (*(constptr_OpInsertAfter()));
    }
    operator OpInsertAfter&()
    {
        return get_OpInsertAfter();
    }
    operator const OpInsertAfter&() const
    {
        return get_OpInsertAfter();
    }

    OpPrependChild&
    get_OpPrependChild()
    {
        AssertSanity(TOpPrependChild);
        return (*(ptr_OpPrependChild()));
    }
    const OpPrependChild&
    get_OpPrependChild() const
    {
        AssertSanity(TOpPrependChild);
        return (*(constptr_OpPrependChild()));
    }
    operator OpPrependChild&()
    {
        return get_OpPrependChild();
    }
    operator const OpPrependChild&() const
    {
        return get_OpPrependChild();
    }

    OpRemoveChild&
    get_OpRemoveChild()
    {
        AssertSanity(TOpRemoveChild);
        return (*(ptr_OpRemoveChild()));
    }
    const OpRemoveChild&
    get_OpRemoveChild() const
    {
        AssertSanity(TOpRemoveChild);
        return (*(constptr_OpRemoveChild()));
    }
    operator OpRemoveChild&()
    {
        return get_OpRemoveChild();
    }
    operator const OpRemoveChild&() const
    {
        return get_OpRemoveChild();
    }

    OpRepositionChild&
    get_OpRepositionChild()
    {
        AssertSanity(TOpRepositionChild);
        return (*(ptr_OpRepositionChild()));
    }
    const OpRepositionChild&
    get_OpRepositionChild() const
    {
        AssertSanity(TOpRepositionChild);
        return (*(constptr_OpRepositionChild()));
    }
    operator OpRepositionChild&()
    {
        return get_OpRepositionChild();
    }
    operator const OpRepositionChild&() const
    {
        return get_OpRepositionChild();
    }

    OpRaiseToTopChild&
    get_OpRaiseToTopChild()
    {
        AssertSanity(TOpRaiseToTopChild);
        return (*(ptr_OpRaiseToTopChild()));
    }
    const OpRaiseToTopChild&
    get_OpRaiseToTopChild() const
    {
        AssertSanity(TOpRaiseToTopChild);
        return (*(constptr_OpRaiseToTopChild()));
    }
    operator OpRaiseToTopChild&()
    {
        return get_OpRaiseToTopChild();
    }
    operator const OpRaiseToTopChild&() const
    {
        return get_OpRaiseToTopChild();
    }

    OpAttachCompositable&
    get_OpAttachCompositable()
    {
        AssertSanity(TOpAttachCompositable);
        return (*(ptr_OpAttachCompositable()));
    }
    const OpAttachCompositable&
    get_OpAttachCompositable() const
    {
        AssertSanity(TOpAttachCompositable);
        return (*(constptr_OpAttachCompositable()));
    }
    operator OpAttachCompositable&()
    {
        return get_OpAttachCompositable();
    }
    operator const OpAttachCompositable&() const
    {
        return get_OpAttachCompositable();
    }

    OpAttachAsyncCompositable&
    get_OpAttachAsyncCompositable()
    {
        AssertSanity(TOpAttachAsyncCompositable);
        return (*(ptr_OpAttachAsyncCompositable()));
    }
    const OpAttachAsyncCompositable&
    get_OpAttachAsyncCompositable() const
    {
        AssertSanity(TOpAttachAsyncCompositable);
        return (*(constptr_OpAttachAsyncCompositable()));
    }
    operator OpAttachAsyncCompositable&()
    {
        return get_OpAttachAsyncCompositable();
    }
    operator const OpAttachAsyncCompositable&() const
    {
        return get_OpAttachAsyncCompositable();
    }

    CompositableOperation&
    get_CompositableOperation()
    {
        AssertSanity(TCompositableOperation);
        return (*(ptr_CompositableOperation()));
    }
    const CompositableOperation&
    get_CompositableOperation() const
    {
        AssertSanity(TCompositableOperation);
        return (*(constptr_CompositableOperation()));
    }
    operator CompositableOperation&()
    {
        return get_CompositableOperation();
    }
    operator const CompositableOperation&() const
    {
        return get_CompositableOperation();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositableChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpContentBufferSwap|
//
namespace mozilla {
namespace layers {
class OpContentBufferSwap final
{
private:
    typedef mozilla::layers::PCompositableParent PCompositableParent;
    typedef mozilla::layers::PCompositableChild PCompositableChild;

public:
    MOZ_IMPLICIT OpContentBufferSwap();

    MOZ_IMPLICIT OpContentBufferSwap(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const nsIntRegion& _frontUpdatedRegion)
    {
        Init();
        Assign(_compositableParent, _compositableChild, _frontUpdatedRegion);
    }

    MOZ_IMPLICIT OpContentBufferSwap(const OpContentBufferSwap& _o)
    {
        Init();
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).frontUpdatedRegion());
    }

    ~OpContentBufferSwap();

    void
    operator=(const OpContentBufferSwap& _o)
    {
        Assign(const_cast<PCompositableParent*>((_o).compositableParent()), const_cast<PCompositableChild*>((_o).compositableChild()), (_o).frontUpdatedRegion());
    }

    bool
    operator==(const OpContentBufferSwap& _o) const;

    PCompositableParent*&
    compositableParent()
    {
        return compositableParent_;
    }
    PCompositableParent*
    compositableParent() const
    {
        return compositableParent_;
    }

    PCompositableChild*&
    compositableChild()
    {
        return compositableChild_;
    }
    PCompositableChild*
    compositableChild() const
    {
        return compositableChild_;
    }

    nsIntRegion&
    frontUpdatedRegion()
    {
        return frontUpdatedRegion_;
    }
    const nsIntRegion&
    frontUpdatedRegion() const
    {
        return frontUpdatedRegion_;
    }

private:
    void
    Init();

    void
    Assign(
            PCompositableParent* _compositableParent,
            PCompositableChild* _compositableChild,
            const nsIntRegion& _frontUpdatedRegion);

    PCompositableParent* compositableParent_;
    PCompositableChild* compositableChild_;
    nsIntRegion frontUpdatedRegion_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PImageContainerParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PImageContainerChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ImageCompositeNotification|
//
namespace mozilla {
namespace layers {
class ImageCompositeNotification final
{
private:
    typedef mozilla::layers::PImageContainerParent PImageContainerParent;
    typedef mozilla::layers::PImageContainerChild PImageContainerChild;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ImageCompositeNotification();

    MOZ_IMPLICIT ImageCompositeNotification(
            PImageContainerParent* _imageContainerParent,
            PImageContainerChild* _imageContainerChild,
            const TimeStamp& _imageTimeStamp,
            const TimeStamp& _firstCompositeTimeStamp,
            const int32_t& _frameID,
            const int32_t& _producerID)
    {
        Init();
        Assign(_imageContainerParent, _imageContainerChild, _imageTimeStamp, _firstCompositeTimeStamp, _frameID, _producerID);
    }

    MOZ_IMPLICIT ImageCompositeNotification(const ImageCompositeNotification& _o)
    {
        Init();
        Assign(const_cast<PImageContainerParent*>((_o).imageContainerParent()), const_cast<PImageContainerChild*>((_o).imageContainerChild()), (_o).imageTimeStamp(), (_o).firstCompositeTimeStamp(), (_o).frameID(), (_o).producerID());
    }

    ~ImageCompositeNotification();

    void
    operator=(const ImageCompositeNotification& _o)
    {
        Assign(const_cast<PImageContainerParent*>((_o).imageContainerParent()), const_cast<PImageContainerChild*>((_o).imageContainerChild()), (_o).imageTimeStamp(), (_o).firstCompositeTimeStamp(), (_o).frameID(), (_o).producerID());
    }

    bool
    operator==(const ImageCompositeNotification& _o) const;

    PImageContainerParent*&
    imageContainerParent()
    {
        return imageContainerParent_;
    }
    PImageContainerParent*
    imageContainerParent() const
    {
        return imageContainerParent_;
    }

    PImageContainerChild*&
    imageContainerChild()
    {
        return imageContainerChild_;
    }
    PImageContainerChild*
    imageContainerChild() const
    {
        return imageContainerChild_;
    }

    TimeStamp&
    imageTimeStamp()
    {
        return imageTimeStamp_;
    }
    const TimeStamp&
    imageTimeStamp() const
    {
        return imageTimeStamp_;
    }

    TimeStamp&
    firstCompositeTimeStamp()
    {
        return firstCompositeTimeStamp_;
    }
    const TimeStamp&
    firstCompositeTimeStamp() const
    {
        return firstCompositeTimeStamp_;
    }

    int32_t&
    frameID()
    {
        return frameID_;
    }
    const int32_t&
    frameID() const
    {
        return frameID_;
    }

    int32_t&
    producerID()
    {
        return producerID_;
    }
    const int32_t&
    producerID() const
    {
        return producerID_;
    }

private:
    void
    Init();

    void
    Assign(
            PImageContainerParent* _imageContainerParent,
            PImageContainerChild* _imageContainerChild,
            const TimeStamp& _imageTimeStamp,
            const TimeStamp& _firstCompositeTimeStamp,
            const int32_t& _frameID,
            const int32_t& _producerID);

    PImageContainerParent* imageContainerParent_;
    PImageContainerChild* imageContainerChild_;
    TimeStamp imageTimeStamp_;
    TimeStamp firstCompositeTimeStamp_;
    int32_t frameID_;
    int32_t producerID_;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpContentBufferSwap;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union EditReply|
//
namespace mozilla {
namespace layers {
class EditReply final
{
public:
    enum Type {
        T__None,
        TOpContentBufferSwap = 1,
        T__Last = TOpContentBufferSwap
    };

private:
    typedef mozilla::layers::OpContentBufferSwap OpContentBufferSwap;
    typedef OpContentBufferSwap OpContentBufferSwap__tdef;

    union Value {
        char VOpContentBufferSwap[sizeof(OpContentBufferSwap)];
    };

    OpContentBufferSwap*
    ptr_OpContentBufferSwap()
    {
        return reinterpret_cast<OpContentBufferSwap*>((&((mValue).VOpContentBufferSwap)));
    }
    const OpContentBufferSwap* const
    constptr_OpContentBufferSwap() const
    {
        return reinterpret_cast<const OpContentBufferSwap* const>((&((mValue).VOpContentBufferSwap)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT EditReply() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT EditReply(const OpContentBufferSwap& aOther);

    MOZ_IMPLICIT EditReply(const EditReply& aOther);

    ~EditReply();

    Type
    type() const
    {
        return mType;
    }

    EditReply&
    operator=(const OpContentBufferSwap& aRhs);

    EditReply&
    operator=(const EditReply& aRhs);

    bool
    operator==(const OpContentBufferSwap& aRhs) const;

    bool
    operator==(const EditReply& aRhs) const;

    OpContentBufferSwap&
    get_OpContentBufferSwap()
    {
        AssertSanity(TOpContentBufferSwap);
        return (*(ptr_OpContentBufferSwap()));
    }
    const OpContentBufferSwap&
    get_OpContentBufferSwap() const
    {
        AssertSanity(TOpContentBufferSwap);
        return (*(constptr_OpContentBufferSwap()));
    }
    operator OpContentBufferSwap&()
    {
        return get_OpContentBufferSwap();
    }
    operator const OpContentBufferSwap&() const
    {
        return get_OpContentBufferSwap();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpDeliverFence;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpDeliverFenceToTracker;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class OpReplyRemoveTexture;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AsyncParentMessageData|
//
namespace mozilla {
namespace layers {
class AsyncParentMessageData final
{
public:
    enum Type {
        T__None,
        TOpDeliverFence = 1,
        TOpDeliverFenceToTracker,
        TOpReplyRemoveTexture,
        T__Last = TOpReplyRemoveTexture
    };

private:
    typedef mozilla::layers::OpDeliverFence OpDeliverFence;
    typedef mozilla::layers::OpDeliverFenceToTracker OpDeliverFenceToTracker;
    typedef mozilla::layers::OpReplyRemoveTexture OpReplyRemoveTexture;
    typedef OpDeliverFence OpDeliverFence__tdef;
    typedef OpDeliverFenceToTracker OpDeliverFenceToTracker__tdef;
    typedef OpReplyRemoveTexture OpReplyRemoveTexture__tdef;

    union Value {
        char VOpDeliverFence[sizeof(OpDeliverFence)];
        char VOpDeliverFenceToTracker[sizeof(OpDeliverFenceToTracker)];
        char VOpReplyRemoveTexture[sizeof(OpReplyRemoveTexture)];
    };

    OpDeliverFence*
    ptr_OpDeliverFence()
    {
        return reinterpret_cast<OpDeliverFence*>((&((mValue).VOpDeliverFence)));
    }
    const OpDeliverFence* const
    constptr_OpDeliverFence() const
    {
        return reinterpret_cast<const OpDeliverFence* const>((&((mValue).VOpDeliverFence)));
    }
    OpDeliverFenceToTracker*
    ptr_OpDeliverFenceToTracker()
    {
        return reinterpret_cast<OpDeliverFenceToTracker*>((&((mValue).VOpDeliverFenceToTracker)));
    }
    const OpDeliverFenceToTracker* const
    constptr_OpDeliverFenceToTracker() const
    {
        return reinterpret_cast<const OpDeliverFenceToTracker* const>((&((mValue).VOpDeliverFenceToTracker)));
    }
    OpReplyRemoveTexture*
    ptr_OpReplyRemoveTexture()
    {
        return reinterpret_cast<OpReplyRemoveTexture*>((&((mValue).VOpReplyRemoveTexture)));
    }
    const OpReplyRemoveTexture* const
    constptr_OpReplyRemoveTexture() const
    {
        return reinterpret_cast<const OpReplyRemoveTexture* const>((&((mValue).VOpReplyRemoveTexture)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AsyncParentMessageData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AsyncParentMessageData(const OpDeliverFence& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(const OpDeliverFenceToTracker& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(const OpReplyRemoveTexture& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(const AsyncParentMessageData& aOther);

    ~AsyncParentMessageData();

    Type
    type() const
    {
        return mType;
    }

    AsyncParentMessageData&
    operator=(const OpDeliverFence& aRhs);

    AsyncParentMessageData&
    operator=(const OpDeliverFenceToTracker& aRhs);

    AsyncParentMessageData&
    operator=(const OpReplyRemoveTexture& aRhs);

    AsyncParentMessageData&
    operator=(const AsyncParentMessageData& aRhs);

    bool
    operator==(const OpDeliverFence& aRhs) const;

    bool
    operator==(const OpDeliverFenceToTracker& aRhs) const;

    bool
    operator==(const OpReplyRemoveTexture& aRhs) const;

    bool
    operator==(const AsyncParentMessageData& aRhs) const;

    OpDeliverFence&
    get_OpDeliverFence()
    {
        AssertSanity(TOpDeliverFence);
        return (*(ptr_OpDeliverFence()));
    }
    const OpDeliverFence&
    get_OpDeliverFence() const
    {
        AssertSanity(TOpDeliverFence);
        return (*(constptr_OpDeliverFence()));
    }
    operator OpDeliverFence&()
    {
        return get_OpDeliverFence();
    }
    operator const OpDeliverFence&() const
    {
        return get_OpDeliverFence();
    }

    OpDeliverFenceToTracker&
    get_OpDeliverFenceToTracker()
    {
        AssertSanity(TOpDeliverFenceToTracker);
        return (*(ptr_OpDeliverFenceToTracker()));
    }
    const OpDeliverFenceToTracker&
    get_OpDeliverFenceToTracker() const
    {
        AssertSanity(TOpDeliverFenceToTracker);
        return (*(constptr_OpDeliverFenceToTracker()));
    }
    operator OpDeliverFenceToTracker&()
    {
        return get_OpDeliverFenceToTracker();
    }
    operator const OpDeliverFenceToTracker&() const
    {
        return get_OpDeliverFenceToTracker();
    }

    OpReplyRemoveTexture&
    get_OpReplyRemoveTexture()
    {
        AssertSanity(TOpReplyRemoveTexture);
        return (*(ptr_OpReplyRemoveTexture()));
    }
    const OpReplyRemoveTexture&
    get_OpReplyRemoveTexture() const
    {
        AssertSanity(TOpReplyRemoveTexture);
        return (*(constptr_OpReplyRemoveTexture()));
    }
    operator OpReplyRemoveTexture&()
    {
        return get_OpReplyRemoveTexture();
    }
    operator const OpReplyRemoveTexture&() const
    {
        return get_OpReplyRemoveTexture();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class OpRemoveTextureAsync;
} // namespace layers
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AsyncChildMessageData|
//
namespace mozilla {
namespace layers {
class AsyncChildMessageData final
{
public:
    enum Type {
        T__None,
        TOpRemoveTextureAsync = 1,
        T__Last = TOpRemoveTextureAsync
    };

private:
    typedef mozilla::layers::OpRemoveTextureAsync OpRemoveTextureAsync;
    typedef OpRemoveTextureAsync OpRemoveTextureAsync__tdef;

    union Value {
        char VOpRemoveTextureAsync[sizeof(OpRemoveTextureAsync)];
    };

    OpRemoveTextureAsync*
    ptr_OpRemoveTextureAsync()
    {
        return reinterpret_cast<OpRemoveTextureAsync*>((&((mValue).VOpRemoveTextureAsync)));
    }
    const OpRemoveTextureAsync* const
    constptr_OpRemoveTextureAsync() const
    {
        return reinterpret_cast<const OpRemoveTextureAsync* const>((&((mValue).VOpRemoveTextureAsync)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AsyncChildMessageData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AsyncChildMessageData(const OpRemoveTextureAsync& aOther);

    MOZ_IMPLICIT AsyncChildMessageData(const AsyncChildMessageData& aOther);

    ~AsyncChildMessageData();

    Type
    type() const
    {
        return mType;
    }

    AsyncChildMessageData&
    operator=(const OpRemoveTextureAsync& aRhs);

    AsyncChildMessageData&
    operator=(const AsyncChildMessageData& aRhs);

    bool
    operator==(const OpRemoveTextureAsync& aRhs) const;

    bool
    operator==(const AsyncChildMessageData& aRhs) const;

    OpRemoveTextureAsync&
    get_OpRemoveTextureAsync()
    {
        AssertSanity(TOpRemoveTextureAsync);
        return (*(ptr_OpRemoveTextureAsync()));
    }
    const OpRemoveTextureAsync&
    get_OpRemoveTextureAsync() const
    {
        AssertSanity(TOpRemoveTextureAsync);
        return (*(constptr_OpRemoveTextureAsync()));
    }
    operator OpRemoveTextureAsync&()
    {
        return get_OpRemoveTextureAsync();
    }
    operator const OpRemoveTextureAsync&() const
    {
        return get_OpRemoveTextureAsync();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

#endif // ifndef LayersMessages_h
